#ifdef CHASTE_CVODE
//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: beeler_reuter_model_1977
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24172, pycml: 23797, optimize: 23343)
//! on Fri May 29 17:43:56 2015
//! 
//! <autogenerated>

#include "beeler_reuter_model_1977_data_clampCvodeOpt.hpp"
#include <cmath>
#include <cassert>
#include <memory>
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"
#include "RegularStimulus.hpp"
#include "HeartConfig.hpp"
#include "IsNan.hpp"
#include "MathsCustomFunctions.hpp"

class Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables : public AbstractLookupTableCollection
{
public:
    static Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables* Instance()
    {
        if (mpInstance.get() == NULL)
        {
            mpInstance.reset(new Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables);
        }
        return mpInstance.get();
    }
    
    void FreeMemory()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
        mNeedsRegeneration.assign(mNeedsRegeneration.size(), true);
    }
    
    // Row lookup methods
    // using linear-interpolation
    double* _lookup_0_row(unsigned i, double _factor_)
    {
        for (unsigned j=0; j<44; j++)
        {
            const double y1 = _lookup_table_0[i][j];
            const double y2 = _lookup_table_0[i+1][j];
            _lookup_table_0_row[j] = y1 + (y2-y1)*_factor_;
        }
        return _lookup_table_0_row;
    }
    
    
    const double * IndexTable0(double var_chaste_interface__membrane__V)
    {
        const double _offset_0 = var_chaste_interface__membrane__V - mTableMins[0];
        const double _offset_0_over_table_step = _offset_0 * mTableStepInverses[0];
        const unsigned _table_index_0 = (unsigned)(_offset_0_over_table_step);
        const double _factor_0 = _offset_0_over_table_step - _table_index_0;
        const double* const _lt_0_row = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->_lookup_0_row(_table_index_0, _factor_0);
        return _lt_0_row;
    }
    
#define COVERAGE_IGNORE
    bool CheckIndex0(double& var_chaste_interface__membrane__V)
    {
        bool _oob_0 = false;
        if (var_chaste_interface__membrane__V>mTableMaxs[0] || var_chaste_interface__membrane__V<mTableMins[0])
        {
#define COVERAGE_IGNORE
            _oob_0 = true;
#undef COVERAGE_IGNORE
        }
        return _oob_0;
    }
#undef COVERAGE_IGNORE

    ~Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
    }
    
protected:
    Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables(const Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables& operator= (const Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        assert(mpInstance.get() == NULL);
        mKeyingVariableNames.resize(1);
        mNumberOfTables.resize(1);
        mTableMins.resize(1);
        mTableSteps.resize(1);
        mTableStepInverses.resize(1);
        mTableMaxs.resize(1);
        mNeedsRegeneration.resize(1);
        mKeyingVariableNames[0] = "membrane_voltage";
        mNumberOfTables[0] = 44;
        mTableMins[0] = -120.0001;
        mTableSteps[0] = 0.001;
        mTableStepInverses[0] = 1000.0;
        mTableMaxs[0] = 99.9999;
        mNeedsRegeneration[0] = true;
        _lookup_table_0 = NULL;
        Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::RegenerateTables();
    }
    
    void RegenerateTables()
    {
        AbstractLookupTableCollection::EventHandler::BeginEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
        if (mNeedsRegeneration[0])
        {
            if (_lookup_table_0)
            {
                delete[] _lookup_table_0;
                _lookup_table_0 = NULL;
            }
            const unsigned _table_size_0 = 1 + (unsigned)((mTableMaxs[0]-mTableMins[0])/mTableSteps[0]+0.5);
            _lookup_table_0 = new double[_table_size_0][44];
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][0] = exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.0800000000000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][1] = 1.0 / exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 1.3999999999999999);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][2] = exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.0800000000000001) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][3] = (0.00055999999999999995 * exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.3999999999999999)) / (exp((0.080000000000000002 * var_chaste_interface__membrane__V) + 4.2400000000000002) + exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 2.1200000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][4] = ((0.014 * (exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.3999999999999999) - 1.0)) / pow(exp((0.080000000000000002 * var_chaste_interface__membrane__V) + 4.2400000000000002) + exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 2.1200000000000001), 2.0)) * ((0.080000000000000002 * exp((0.080000000000000002 * var_chaste_interface__membrane__V) + 4.2400000000000002)) + (0.040000000000000001 * exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 2.1200000000000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][5] = 0.00069999999999999999 / (1.0 - exp(( -0.040000000000000001 * var_chaste_interface__membrane__V) - 0.92000000000000004));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][6] = ((2.8e-05 * (var_chaste_interface__membrane__V + 23.0)) / pow(1.0 - exp(( -0.040000000000000001 * var_chaste_interface__membrane__V) - 0.92000000000000004), 2.0)) * exp(( -0.040000000000000001 * var_chaste_interface__membrane__V) - 0.92000000000000004);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][7] =  -0.00095 * (exp(( -0.01 * var_chaste_interface__membrane__V) + 0.050000000000000003) / (1.0 + exp(( -0.071994240459999997 * var_chaste_interface__membrane__V) + 0.35997120230000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][8] = (0.0068394528440000003 * exp(( -0.01 * var_chaste_interface__membrane__V) + 0.050000000000000003)) / pow(1.0 + exp(( -0.071994240459999997 * var_chaste_interface__membrane__V) + 0.35997120230000001), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][9] = exp(( -0.071994240459999997 * var_chaste_interface__membrane__V) + 0.35997120230000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][10] = 0.0011864406780000001 * (exp(( -0.016949152542372881 * var_chaste_interface__membrane__V) - 0.74576271186440679) / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][11] = (0.0035000000000000001 * exp(( -0.016949152542372881 * var_chaste_interface__membrane__V) - 0.74576271186440679)) / pow(1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][12] = exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][13] = ( -0.095000000000000001 * (exp(( -0.01 * var_chaste_interface__membrane__V) + 0.050000000000000003) / (1.0 + exp(( -0.071994240459999997 * var_chaste_interface__membrane__V) + 0.35997120230000001)))) - (0.070000000000000007 * (exp(( -0.016949152542372881 * var_chaste_interface__membrane__V) - 0.74576271186440679) / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][14] =  -9.6000000000000002e-05 * (exp(( -0.0080000000000000002 * var_chaste_interface__membrane__V) - 0.224) / (1.0 + exp((0.1499250375 * var_chaste_interface__membrane__V) + 4.1979010499999996)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][15] = (0.00179910045 * exp(( -0.0080000000000000002 * var_chaste_interface__membrane__V) - 0.224)) / pow(1.0 + exp((0.1499250375 * var_chaste_interface__membrane__V) + 4.1979010499999996), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][16] = exp((0.1499250375 * var_chaste_interface__membrane__V) + 4.1979010499999996);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][17] = 0.00012999999999999999 * (exp(( -0.02 * var_chaste_interface__membrane__V) - 0.59999999999999998) / (1.0 + exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][18] = (0.0012999999999999999 * exp(( -0.02 * var_chaste_interface__membrane__V) - 0.59999999999999998)) / pow(1.0 + exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][19] = exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][20] = ( -0.012 * (exp(( -0.0080000000000000002 * var_chaste_interface__membrane__V) - 0.224) / (1.0 + exp((0.1499250375 * var_chaste_interface__membrane__V) + 4.1979010499999996)))) - (0.0064999999999999997 * (exp(( -0.02 * var_chaste_interface__membrane__V) - 0.59999999999999998) / (1.0 + exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][21] = -(1.0 / (exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7000000000000002) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][22] = (0.10000000000000001 * (var_chaste_interface__membrane__V + 47.0)) / pow(exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7000000000000002) - 1.0, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][23] = exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7000000000000002);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][24] = 2.2400000000000002 * exp(( -0.056000000000000001 * var_chaste_interface__membrane__V) - 4.032);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][25] = ((var_chaste_interface__membrane__V + 47.0) * (1.0 / (exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7000000000000002) - 1.0))) - (40.0 * exp(( -0.056000000000000001 * var_chaste_interface__membrane__V) - 4.032));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][26] = 4.1322314050000003e-05 * (exp((0.082644628100000006 * var_chaste_interface__membrane__V) + 4.1322314049999997) / (1.0 + exp((0.057142857140000003 * var_chaste_interface__membrane__V) + 2.8571428569999999)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][27] = (2.8571428569999999e-05 * exp((0.082644628100000006 * var_chaste_interface__membrane__V) + 4.1322314049999997)) / pow(1.0 + exp((0.057142857140000003 * var_chaste_interface__membrane__V) + 2.8571428569999999), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][28] = exp((0.057142857140000003 * var_chaste_interface__membrane__V) + 2.8571428569999999);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][29] = 7.7984403120000004e-05 * (exp(( -0.059988002399999997 * var_chaste_interface__membrane__V) - 1.1997600479999999) / (1.0 + exp(( -0.040000000000000001 * var_chaste_interface__membrane__V) - 0.80000000000000004)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][30] = (5.1999999999999997e-05 * exp(( -0.059988002399999997 * var_chaste_interface__membrane__V) - 1.1997600479999999)) / pow(1.0 + exp(( -0.040000000000000001 * var_chaste_interface__membrane__V) - 0.80000000000000004), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][31] = exp(( -0.040000000000000001 * var_chaste_interface__membrane__V) - 0.80000000000000004);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][32] = ( -0.00050000000000000001 * (exp((0.082644628100000006 * var_chaste_interface__membrane__V) + 4.1322314049999997) / (1.0 + exp((0.057142857140000003 * var_chaste_interface__membrane__V) + 2.8571428569999999)))) - (0.0012999999999999999 * (exp(( -0.059988002399999997 * var_chaste_interface__membrane__V) - 1.1997600479999999) / (1.0 + exp(( -0.040000000000000001 * var_chaste_interface__membrane__V) - 0.80000000000000004))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][33] = exp(0.040000000000000001 * (var_chaste_interface__membrane__V + 77.0)) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][34] = exp(0.040000000000000001 * (var_chaste_interface__membrane__V + 35.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][35] = ((4.0 * (exp(0.040000000000000001 * (var_chaste_interface__membrane__V + 85.0)) - 1.0)) / (exp(0.080000000000000002 * (var_chaste_interface__membrane__V + 53.0)) + exp(0.040000000000000001 * (var_chaste_interface__membrane__V + 53.0)))) + ((0.20000000000000001 * (var_chaste_interface__membrane__V + 23.0)) / (1.0 - exp( -0.040000000000000001 * (var_chaste_interface__membrane__V + 23.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][36] = ( -1.0 * (var_chaste_interface__membrane__V + 47.0)) / (exp( -0.10000000000000001 * (var_chaste_interface__membrane__V + 47.0)) - 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][37] = 40.0 * exp( -0.056000000000000001 * (var_chaste_interface__membrane__V + 72.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][38] = (0.095000000000000001 * exp((-(var_chaste_interface__membrane__V - 5.0)) * 0.01)) / (1.0 + exp((-(var_chaste_interface__membrane__V - 5.0)) * 0.071994240460763137));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][39] = (0.070000000000000007 * exp((-(var_chaste_interface__membrane__V + 44.0)) * 0.016949152542372881)) / (1.0 + exp((var_chaste_interface__membrane__V + 44.0) * 0.050000000000000003));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][40] = (0.012 * exp((-(var_chaste_interface__membrane__V + 28.0)) * 0.0080000000000000002)) / (1.0 + exp((var_chaste_interface__membrane__V + 28.0) * 0.14992503748125938));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][41] = (0.0064999999999999997 * exp((-(var_chaste_interface__membrane__V + 30.0)) * 0.02)) / (1.0 + exp((-(var_chaste_interface__membrane__V + 30.0)) * 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][42] = (0.00050000000000000001 * exp((var_chaste_interface__membrane__V + 50.0) * 0.082644628099173556)) / (1.0 + exp((var_chaste_interface__membrane__V + 50.0) * 0.057142857142857141));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][43] = (0.0012999999999999999 * exp((-(var_chaste_interface__membrane__V + 20.0)) * 0.059988002399520089)) / (1.0 + exp((-(var_chaste_interface__membrane__V + 20.0)) * 0.040000000000000001));
            }
            
            mNeedsRegeneration[0] = false;
        }
        
        AbstractLookupTableCollection::EventHandler::EndEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
    }
    
private:
    /** The single instance of the class */
    static std::auto_ptr<Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables> mpInstance;

    // Row lookup methods memory
    double _lookup_table_0_row[44];
    
    // Lookup tables
    double (*_lookup_table_0)[44];
    
};

std::auto_ptr<Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables> Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::mpInstance;

    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_inward_current__Cai()
    {
        return var_chaste_interface__slow_inward_current__Cai;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__fake_dt()
    {
        return var_chaste_interface__environment__fake_dt;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__i_ionic()
    {
        return var_chaste_interface__i_ionic;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_inward_current__i_s()
    {
        return var_chaste_interface__slow_inward_current__i_s;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_inward_current_d_gate__d()
    {
        return var_chaste_interface__slow_inward_current_d_gate__d;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_inward_current_f_gate__f()
    {
        return var_chaste_interface__slow_inward_current_f_gate__f;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_current__i_Na()
    {
        return var_chaste_interface__sodium_current__i_Na;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_current_h_gate__h()
    {
        return var_chaste_interface__sodium_current_h_gate__h;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_sodium_current_h_gate__tau_h()
    {
        return var_sodium_current_h_gate__tau_h;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_current_j_gate__j()
    {
        return var_chaste_interface__sodium_current_j_gate__j;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_sodium_current_j_gate__tau_j()
    {
        return var_sodium_current_j_gate__tau_j;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_current_m_gate__m()
    {
        return var_chaste_interface__sodium_current_m_gate__m;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__time_independent_outward_current__i_K1()
    {
        return var_chaste_interface__time_independent_outward_current__i_K1;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__time_dependent_outward_current__i_x1()
    {
        return var_chaste_interface__time_dependent_outward_current__i_x1;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__stimulus_protocol__Istim()
    {
        return var_chaste_interface__stimulus_protocol__Istim;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__stimulus_protocol__IstimAmplitude()
    {
        return var_chaste_interface__stimulus_protocol__IstimAmplitude;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__stimulus_protocol__IstimPulseDuration()
    {
        return var_chaste_interface__stimulus_protocol__IstimPulseDuration;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__stimulus_protocol__IstimStart()
    {
        return var_chaste_interface__stimulus_protocol__IstimStart;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__stimulus_protocol__IstimPeriod()
    {
        return var_chaste_interface__stimulus_protocol__IstimPeriod;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__V()
    {
        return var_chaste_interface__membrane__V;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__time()
    {
        return var_chaste_interface__environment__time;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_L_type_calcium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 0);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_capacitance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 1);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 2);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_reduced_inactivation_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 3);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_shift_inactivation_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 4);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_inward_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 5);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_rapid_delayed_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 6);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_amplitude_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__stimulus_protocol__IstimAmplitude = 50.0; // uA_per_cm2
        return var_chaste_interface__stimulus_protocol__IstimAmplitude;
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_duration_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__stimulus_protocol__IstimPulseDuration = 1.0; // ___units_12
        return var_chaste_interface__stimulus_protocol__IstimPulseDuration;
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_offset_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__stimulus_protocol__IstimStart = 10.0; // ___units_12
        return var_chaste_interface__stimulus_protocol__IstimStart;
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_period_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__stimulus_protocol__IstimPeriod = 1000.0; // ___units_12
        return var_chaste_interface__stimulus_protocol__IstimPeriod;
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_sodium_reversal_potential_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 7);
    }
    
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Get_membrane_data_clamp_current_conductance_constant() // RJ
    {
		// Constant value given in CellML
		return NV_Ith_S(mParameters, 8);
    }


    boost::shared_ptr<RegularStimulus> Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::UseCellMLDefaultStimulus()
    {
        // Use the default stimulus specified by CellML metadata
        var_chaste_interface__stimulus_protocol__IstimStart = 10.0; // ___units_12
        var_chaste_interface__stimulus_protocol__IstimPeriod = 1000.0; // ___units_12
        var_chaste_interface__stimulus_protocol__IstimPulseDuration = 1.0; // ___units_12
        var_chaste_interface__stimulus_protocol__IstimAmplitude = 50.0; // uA_per_cm2
        boost::shared_ptr<RegularStimulus> p_cellml_stim(new RegularStimulus(
                -fabs(var_chaste_interface__stimulus_protocol__IstimAmplitude),
                var_chaste_interface__stimulus_protocol__IstimPulseDuration,
                var_chaste_interface__stimulus_protocol__IstimPeriod,
                var_chaste_interface__stimulus_protocol__IstimStart
                ));
        mpIntracellularStimulus = p_cellml_stim;
        return p_cellml_stim;
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::GetIntracellularCalciumConcentration()
    {
        return NV_Ith_S(mStateVariables, 4);
    }
    
    Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
        : AbstractCvodeCellWithDataClamp(
                pOdeSolver,
                8,
                0,
                pIntracellularStimulus)
    {
        // Time units: ___units_12
        // 
        this->mpSystemInfo = OdeSystemInformation<Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt>::Instance();
        Init();

        // We have a default stimulus specified in the CellML file metadata
        this->mHasDefaultStimulusFromCellML = true;
        NV_Ith_S(this->mParameters, 0) = 9e-4; // (c,slow_inward_current__g_s) [mS_per_mm2]
        NV_Ith_S(this->mParameters, 1) = 0.01; // (c,membrane__C) [uF_per_mm2]
        NV_Ith_S(this->mParameters, 2) = 4e-2; // (c,sodium_current__g_Na) [mS_per_mm2]
        NV_Ith_S(this->mParameters, 3) = 0; // (c,sodium_current__perc_reduced_inact_for_IpNa) [dimensionless]
        NV_Ith_S(this->mParameters, 4) = 0; // (c,sodium_current__shift_INa_inact) [mV]
        NV_Ith_S(this->mParameters, 5) = 0.0035; // (c,time_independent_outward_current__G_K1) [uA_per_mm2]
        NV_Ith_S(this->mParameters, 6) = 0.008; // (c,time_dependent_outward_current__G_Kr) [uA_per_mm2]
        NV_Ith_S(this->mParameters, 7) = 50; // (c,sodium_current__E_Na) [mV]

        NV_Ith_S(this->mParameters, 8) = 0; // (c,data_clamp_current__g_data) [mS_per_mm2] RJ - start at 0 to generate data

        mUseAnalyticJacobian = true;
        mHasAnalyticJacobian = true;
    }
    
    Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::~Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt()
    {
    }
    
    AbstractLookupTableCollection* Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::GetLookupTableCollection()
    {
        return Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance();
    }
    
    double Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::GetIIonic(const std::vector<double>* pStateVariables)
    {
        // For state variable interpolation (SVI) we read in interpolated state variables,
        // otherwise for ionic current interpolation (ICI) we use the state variables of this model (node).
        N_Vector rY;
        bool made_new_cvode_vector = false;
        if (!pStateVariables)
        {
            rY = rGetStateVariables();
        }
        else
        {
            made_new_cvode_vector = true;
            rY = MakeNVector(*pStateVariables);
        }
        
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -84.624
        double var_chaste_interface__sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.011
        double var_chaste_interface__sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.988
        double var_chaste_interface__sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.975
        double var_chaste_interface__slow_inward_current__Cai = NV_Ith_S(rY, 4);
        // Units: concentration_units; Initial value: 1e-4
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.003
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.994
        double var_chaste_interface__time_dependent_outward_current_x1_gate__x1 = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.0001
        
        // Lookup table indexing
        const bool _oob_0 = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        const double var_sodium_current__i_Na = ((NV_Ith_S(mParameters, 2) * pow(var_chaste_interface__sodium_current_m_gate__m, 3.0) * var_chaste_interface__sodium_current_h_gate__h * var_chaste_interface__sodium_current_j_gate__j) + 3.0000000000000001e-05) * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 7)); // uA_per_mm2
        const double var_slow_inward_current__i_s = NV_Ith_S(mParameters, 0) * var_chaste_interface__slow_inward_current_d_gate__d * var_chaste_interface__slow_inward_current_f_gate__f * (var_chaste_interface__membrane__V - ( -82.299999999999997 - (13.028700000000001 * log(var_chaste_interface__slow_inward_current__Cai * 0.001)))); // uA_per_mm2
        const double var_time_dependent_outward_current__i_x1 = (var_chaste_interface__time_dependent_outward_current_x1_gate__x1 * NV_Ith_S(mParameters, 6) * _lt_0_row[33]) / _lt_0_row[34]; // uA_per_mm2
        const double var_time_independent_outward_current__i_K1 = NV_Ith_S(mParameters, 5) * _lt_0_row[35]; // uA_per_mm2
        const double var_chaste_interface__time_dependent_outward_current__i_x1 = var_time_dependent_outward_current__i_x1; // uA_per_mm2
        const double var_chaste_interface__sodium_current__i_Na = var_sodium_current__i_Na; // uA_per_mm2
        const double var_chaste_interface__slow_inward_current__i_s = var_slow_inward_current__i_s; // uA_per_mm2
        const double var_chaste_interface__time_independent_outward_current__i_K1 = var_time_independent_outward_current__i_K1; // uA_per_mm2
        var_chaste_interface__i_ionic = (100.0 * var_chaste_interface__sodium_current__i_Na) + (100.0 * var_chaste_interface__slow_inward_current__i_s) + (100.0 * var_chaste_interface__time_dependent_outward_current__i_x1) + (100.0 * var_chaste_interface__time_independent_outward_current__i_K1); // uA_per_cm2
        
        const double i_ionic = var_chaste_interface__i_ionic;
        if (made_new_cvode_vector)
        {
            DeleteVector(rY);
        }
        EXCEPT_IF_NOT(!std::isnan(i_ionic));
        return i_ionic;
    }
    
    void Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY)
    {
        // Inputs:
        // Time units: ___units_12
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -84.624
        double var_chaste_interface__sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.011
        double var_chaste_interface__sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.988
        double var_chaste_interface__sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.975
        double var_chaste_interface__slow_inward_current__Cai = NV_Ith_S(rY, 4);
        // Units: concentration_units; Initial value: 1e-4
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.003
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.994
        double var_chaste_interface__time_dependent_outward_current_x1_gate__x1 = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.0001
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        // Mathematics
        double d_dt_chaste_interface__membrane__V;
        const double var_slow_inward_current__i_s = NV_Ith_S(mParameters, 0) * var_chaste_interface__slow_inward_current_d_gate__d * var_chaste_interface__slow_inward_current_f_gate__f * (var_chaste_interface__membrane__V - ( -82.299999999999997 - (13.028700000000001 * log(var_chaste_interface__slow_inward_current__Cai * 0.001)))); // uA_per_mm2
        const double var_sodium_current_h_gate__beta_h = 1.7 / (exp( -0.082000000000000003 * ((var_chaste_interface__membrane__V + 22.5) - NV_Ith_S(mParameters, 4))) + 1.0); // per_ms
        const double var_sodium_current_h_gate__alpha_h = 0.126 * exp( -0.25 * ((var_chaste_interface__membrane__V + 77.0) - NV_Ith_S(mParameters, 4))); // per_ms
        const double var_sodium_current_h_gate__tau_h = 1.0 / (var_sodium_current_h_gate__alpha_h + var_sodium_current_h_gate__beta_h); // ms
        const double var_sodium_current_j_gate__beta_j = 0.29999999999999999 / (exp( -0.10000000000000001 * ((var_chaste_interface__membrane__V + 32.0) - NV_Ith_S(mParameters, 4))) + 1.0); // per_ms
        const double var_sodium_current_j_gate__alpha_j = (0.055 * exp( -0.25 * ((var_chaste_interface__membrane__V + 78.0) - NV_Ith_S(mParameters, 4)))) / (exp( -0.20000000000000001 * ((var_chaste_interface__membrane__V + 78.0) - NV_Ith_S(mParameters, 4))) + 1.0); // per_ms
        const double var_sodium_current_j_gate__tau_j = 1.0 / (var_sodium_current_j_gate__alpha_j + var_sodium_current_j_gate__beta_j); // ms
        const double d_dt_chaste_interface__sodium_current_m_gate__m = (_lt_0_row[36] * (1.0 - var_chaste_interface__sodium_current_m_gate__m)) - (_lt_0_row[37] * var_chaste_interface__sodium_current_m_gate__m); // 'per millisecond'
        const double d_dt_chaste_interface__sodium_current_h_gate__h = ((((var_sodium_current_h_gate__alpha_h * (1.0 - (NV_Ith_S(mParameters, 3) * 0.01))) / (var_sodium_current_h_gate__alpha_h + var_sodium_current_h_gate__beta_h)) + (NV_Ith_S(mParameters, 3) * 0.01)) - var_chaste_interface__sodium_current_h_gate__h) / var_sodium_current_h_gate__tau_h; // 'per millisecond'
        const double d_dt_chaste_interface__sodium_current_j_gate__j = ((((var_sodium_current_j_gate__alpha_j * (1.0 - (NV_Ith_S(mParameters, 3) * 0.01))) / (var_sodium_current_j_gate__alpha_j + var_sodium_current_j_gate__beta_j)) + (NV_Ith_S(mParameters, 3) * 0.01)) - var_chaste_interface__sodium_current_j_gate__j) / var_sodium_current_j_gate__tau_j; // 'per millisecond'
        const double d_dt_chaste_interface__slow_inward_current__Cai = (( -0.01 * var_slow_inward_current__i_s) * 1.0) + (0.070000000000000007 * (0.0001 - var_chaste_interface__slow_inward_current__Cai)); // 'nanomole per millimetre^3 per millisecond'
        const double d_dt_chaste_interface__slow_inward_current_d_gate__d = (_lt_0_row[38] * (1.0 - var_chaste_interface__slow_inward_current_d_gate__d)) - (_lt_0_row[39] * var_chaste_interface__slow_inward_current_d_gate__d); // 'per millisecond'
        const double d_dt_chaste_interface__slow_inward_current_f_gate__f = (_lt_0_row[40] * (1.0 - var_chaste_interface__slow_inward_current_f_gate__f)) - (_lt_0_row[41] * var_chaste_interface__slow_inward_current_f_gate__f); // 'per millisecond'
        const double d_dt_chaste_interface__time_dependent_outward_current_x1_gate__x1 = (_lt_0_row[42] * (1.0 - var_chaste_interface__time_dependent_outward_current_x1_gate__x1)) - (_lt_0_row[43] * var_chaste_interface__time_dependent_outward_current_x1_gate__x1); // 'per millisecond'

        double var_data_clamp_current__i_data = 0; // RJ
        if (mDataClampIsOn)
        {
            double interpolated_data_voltage = GetExperimentalVoltageAtTimeT(var_chaste_interface__environment__time);
            var_data_clamp_current__i_data = NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__V - interpolated_data_voltage);
        }

        if (mSetVoltageDerivativeToZero)
        {
            d_dt_chaste_interface__membrane__V = 0.0;
        }
        else
        {
            const double var_sodium_current__i_Na = ((NV_Ith_S(mParameters, 2) * pow(var_chaste_interface__sodium_current_m_gate__m, 3.0) * var_chaste_interface__sodium_current_h_gate__h * var_chaste_interface__sodium_current_j_gate__j) + 3.0000000000000001e-05) * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 7)); // uA_per_mm2
            const double var_time_dependent_outward_current__i_x1 = (var_chaste_interface__time_dependent_outward_current_x1_gate__x1 * NV_Ith_S(mParameters, 6) * _lt_0_row[33]) / _lt_0_row[34]; // uA_per_mm2
            const double var_time_independent_outward_current__i_K1 = NV_Ith_S(mParameters, 5) * _lt_0_row[35]; // uA_per_mm2
            var_chaste_interface__stimulus_protocol__Istim = -GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
            d_dt_chaste_interface__membrane__V = ((0.01 * var_chaste_interface__stimulus_protocol__Istim) - (var_sodium_current__i_Na + var_slow_inward_current__i_s + var_time_dependent_outward_current__i_x1 + var_time_independent_outward_current__i_K1 + var_data_clamp_current__i_data)) / NV_Ith_S(mParameters, 1); // 'millivolt per millisecond'
        }
        
        NV_Ith_S(rDY, 0) = d_dt_chaste_interface__membrane__V;
        NV_Ith_S(rDY, 1) = d_dt_chaste_interface__sodium_current_m_gate__m;
        NV_Ith_S(rDY, 2) = d_dt_chaste_interface__sodium_current_h_gate__h;
        NV_Ith_S(rDY, 3) = d_dt_chaste_interface__sodium_current_j_gate__j;
        NV_Ith_S(rDY, 4) = d_dt_chaste_interface__slow_inward_current__Cai;
        NV_Ith_S(rDY, 5) = d_dt_chaste_interface__slow_inward_current_d_gate__d;
        NV_Ith_S(rDY, 6) = d_dt_chaste_interface__slow_inward_current_f_gate__f;
        NV_Ith_S(rDY, 7) = d_dt_chaste_interface__time_dependent_outward_current_x1_gate__x1;
    }
    
    void Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::EvaluateAnalyticJacobian(long int N, double var_chaste_interface__environment__time, N_Vector rY, N_Vector rDY, CHASTE_CVODE_DENSE_MATRIX rJacobian, N_Vector rTmp1, N_Vector rTmp2, N_Vector rTmp3)
    {
        assert(false);
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -84.624
        double var_chaste_interface__sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.011
        double var_chaste_interface__sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.988
        double var_chaste_interface__sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.975
        double var_chaste_interface__slow_inward_current__Cai = NV_Ith_S(rY, 4);
        // Units: concentration_units; Initial value: 1e-4
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.003
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.994
        double var_chaste_interface__time_dependent_outward_current_x1_gate__x1 = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.0001
        
        // Lookup table indexing
        const bool _oob_0 = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        var_chaste_interface__environment__fake_dt = 1.0; // ms
        const double var_t1 = pow(var_chaste_interface__sodium_current_m_gate__m, 2.0); // dimensionless
        const double var_t3 = (NV_Ith_S(mParameters, 2) * var_t1) * var_chaste_interface__sodium_current_m_gate__m; // dimensionless
        const double var_t6 = NV_Ith_S(mParameters, 0) * var_chaste_interface__slow_inward_current_d_gate__d; // dimensionless
        const double var_t7 = var_t6 * var_chaste_interface__slow_inward_current_f_gate__f; // dimensionless
        const double var_t8 = var_chaste_interface__time_dependent_outward_current_x1_gate__x1 * NV_Ith_S(mParameters, 6); // dimensionless
        const double var_t55 = 1.0 / NV_Ith_S(mParameters, 1); // dimensionless
        const double var_t59 = var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 7); // dimensionless
        const double var_t61 = (var_chaste_interface__sodium_current_j_gate__j * var_t59) * var_t55; // dimensionless
        const double var_t69 = var_chaste_interface__slow_inward_current_f_gate__f / var_chaste_interface__slow_inward_current__Cai; // dimensionless
        const double var_t73 = NV_Ith_S(mParameters, 0) * var_chaste_interface__slow_inward_current_f_gate__f; // dimensionless
        const double var_t77 = (var_chaste_interface__membrane__V + 82.299999999999997) + (13.028700000000001 * log(0.001 * var_chaste_interface__slow_inward_current__Cai)); // dimensionless
        const double var_t78 = var_t77 * var_t55; // dimensionless
        const double var_t89 = 1.0 - var_chaste_interface__sodium_current_m_gate__m; // dimensionless
        const double var_t108 = 0.25 * NV_Ith_S(mParameters, 4); // dimensionless
        const double var_t110 = exp(((-(0.25 * var_chaste_interface__membrane__V)) - 19.25) + var_t108); // dimensionless
        const double var_t111 = 0.01 * NV_Ith_S(mParameters, 3); // dimensionless
        const double var_t112 = 1.0 - var_t111; // dimensionless
        const double var_t113 = var_t110 * var_t112; // dimensionless
        const double var_t118 = exp((( -0.082000000000000003 * var_chaste_interface__membrane__V) - 1.845) + (0.082000000000000003 * NV_Ith_S(mParameters, 4))); // dimensionless
        const double var_t119 = var_t118 + 1.0; // dimensionless
        const double var_t122 = (0.126 * var_t110) + (1.7 / var_t119); // dimensionless
        const double var_t124 = var_t113 / var_t122; // dimensionless
        const double var_t133 = ( -0.0315 * var_t110) + ((0.1394 / pow(var_t119, 2.0)) * var_t118); // dimensionless
        const double var_t144 = exp(((-(0.25 * var_chaste_interface__membrane__V)) - 19.5) + var_t108); // dimensionless
        const double var_t148 = exp((( -0.20000000000000001 * var_chaste_interface__membrane__V) - 15.6) + (0.20000000000000001 * NV_Ith_S(mParameters, 4))); // dimensionless
        const double var_t149 = var_t148 + 1.0; // dimensionless
        const double var_t151 = var_t144 / var_t149; // dimensionless
        const double var_t155 = exp(((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 3.2000000000000002) + (0.10000000000000001 * NV_Ith_S(mParameters, 4))); // dimensionless
        const double var_t156 = var_t155 + 1.0; // dimensionless
        const double var_t159 = (0.055 * var_t151) + (0.29999999999999999 / var_t156); // dimensionless
        const double var_t161 = var_t112 / var_t159; // dimensionless
        const double var_t162 = var_t151 * var_t161; // dimensionless
        const double var_t166 = var_t144 / pow(var_t149, 2.0); // dimensionless
        const double var_t180 = (( -0.01375 * var_t151) + ((0.010999999999999999 * var_t166) * var_t148)) + ((0.029999999999999999 / pow(var_t156, 2.0)) * var_t155); // dimensionless
        const double var_t207 = 1.0 - var_chaste_interface__slow_inward_current_d_gate__d; // dimensionless
        const double var_t246 = 1.0 - var_chaste_interface__slow_inward_current_f_gate__f; // dimensionless
        const double var_t285 = 1.0 - var_chaste_interface__time_dependent_outward_current_x1_gate__x1; // dimensionless
        
        // Matrix entries
        DENSE_ELEM(rJacobian, 0, 0) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((((((((-var_t3) * var_chaste_interface__sodium_current_h_gate__h) * var_chaste_interface__sodium_current_j_gate__j) - 3.0000000000000001e-05) - var_t7) - (((0.040000000000000001 * var_t8) * _lt_0_row[0]) * _lt_0_row[1])) + (((0.040000000000000001 * var_t8) * _lt_0_row[2]) * _lt_0_row[1])) - _lt_0_row[3]) + _lt_0_row[4]) - _lt_0_row[5]) + _lt_0_row[6]) * var_t55));
        DENSE_ELEM(rJacobian, 1, 0) = var_chaste_interface__environment__fake_dt * (((_lt_0_row[21] * var_t89) - ((_lt_0_row[22] * var_t89) * _lt_0_row[23])) + (_lt_0_row[24] * var_chaste_interface__sodium_current_m_gate__m));
        DENSE_ELEM(rJacobian, 2, 0) = var_chaste_interface__environment__fake_dt * (((( -0.0315 * var_t124) - (((0.126 * var_t113) / pow(var_t122, 2.0)) * var_t133)) * var_t122) + ((((0.126 * var_t124) + var_t111) - var_chaste_interface__sodium_current_h_gate__h) * var_t133));
        DENSE_ELEM(rJacobian, 3, 0) = var_chaste_interface__environment__fake_dt * ((((( -0.01375 * var_t162) + (((0.010999999999999999 * var_t166) * var_t161) * var_t148)) - ((((0.055 * var_t151) * var_t112) / pow(var_t159, 2.0)) * var_t180)) * var_t159) + ((((0.055 * var_t162) + var_t111) - var_chaste_interface__sodium_current_j_gate__j) * var_t180));
        DENSE_ELEM(rJacobian, 4, 0) = var_chaste_interface__environment__fake_dt * ( -0.01 * var_t7);
        DENSE_ELEM(rJacobian, 5, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[7] * var_t207) + ((_lt_0_row[8] * var_t207) * _lt_0_row[9])) + (_lt_0_row[10] * var_chaste_interface__slow_inward_current_d_gate__d)) + ((_lt_0_row[11] * var_chaste_interface__slow_inward_current_d_gate__d) * _lt_0_row[12]));
        DENSE_ELEM(rJacobian, 6, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[14] * var_t246) - ((_lt_0_row[15] * var_t246) * _lt_0_row[16])) + (_lt_0_row[17] * var_chaste_interface__slow_inward_current_f_gate__f)) - ((_lt_0_row[18] * var_chaste_interface__slow_inward_current_f_gate__f) * _lt_0_row[19]));
        DENSE_ELEM(rJacobian, 7, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[26] * var_t285) - ((_lt_0_row[27] * var_t285) * _lt_0_row[28])) + (_lt_0_row[29] * var_chaste_interface__time_dependent_outward_current_x1_gate__x1)) - ((_lt_0_row[30] * var_chaste_interface__time_dependent_outward_current_x1_gate__x1) * _lt_0_row[31]));
        DENSE_ELEM(rJacobian, 0, 1) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -3.0 * NV_Ith_S(mParameters, 2)) * var_t1) * var_chaste_interface__sodium_current_h_gate__h) * var_t61));
        DENSE_ELEM(rJacobian, 1, 1) = var_chaste_interface__environment__fake_dt * (_lt_0_row[25]);
        DENSE_ELEM(rJacobian, 0, 2) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((-var_t3) * var_t61));
        DENSE_ELEM(rJacobian, 2, 2) = var_chaste_interface__environment__fake_dt * (-var_t122);
        DENSE_ELEM(rJacobian, 0, 3) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((-var_t3) * var_chaste_interface__sodium_current_h_gate__h) * var_t59) * var_t55));
        DENSE_ELEM(rJacobian, 3, 3) = var_chaste_interface__environment__fake_dt * (-var_t159);
        DENSE_ELEM(rJacobian, 0, 4) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -13.028700000000001 * var_t6) * var_t69) * var_t55));
        DENSE_ELEM(rJacobian, 4, 4) = var_chaste_interface__environment__fake_dt * ((( -0.13028699999999999 * var_t6) * var_t69) - 0.070000000000000007);
        DENSE_ELEM(rJacobian, 0, 5) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((-var_t73) * var_t78));
        DENSE_ELEM(rJacobian, 4, 5) = var_chaste_interface__environment__fake_dt * (( -0.01 * var_t73) * var_t77);
        DENSE_ELEM(rJacobian, 5, 5) = var_chaste_interface__environment__fake_dt * (_lt_0_row[13]);
        DENSE_ELEM(rJacobian, 0, 6) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((-var_t6) * var_t78));
        DENSE_ELEM(rJacobian, 4, 6) = var_chaste_interface__environment__fake_dt * (( -0.01 * var_t6) * var_t77);
        DENSE_ELEM(rJacobian, 6, 6) = var_chaste_interface__environment__fake_dt * (_lt_0_row[20]);
        DENSE_ELEM(rJacobian, 0, 7) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((-NV_Ith_S(mParameters, 6)) * _lt_0_row[2]) * _lt_0_row[1]) * var_t55));
        DENSE_ELEM(rJacobian, 7, 7) = var_chaste_interface__environment__fake_dt * (_lt_0_row[32]);
    }
    
    N_Vector Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt::ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY)
    {
        // Inputs:
        // Time units: ___units_12
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -84.624
        double var_chaste_interface__sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.011
        double var_chaste_interface__sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.988
        double var_chaste_interface__sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.975
        double var_chaste_interface__slow_inward_current__Cai = NV_Ith_S(rY, 4);
        // Units: concentration_units; Initial value: 1e-4
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.003
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.994
        double var_chaste_interface__time_dependent_outward_current_x1_gate__x1 = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.0001
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        // Mathematics
        const double var_sodium_current__i_Na = ((NV_Ith_S(mParameters, 2) * pow(var_chaste_interface__sodium_current_m_gate__m, 3.0) * var_chaste_interface__sodium_current_h_gate__h * var_chaste_interface__sodium_current_j_gate__j) + 3.0000000000000001e-05) * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 7)); // uA_per_mm2
        const double var_slow_inward_current__i_s = NV_Ith_S(mParameters, 0) * var_chaste_interface__slow_inward_current_d_gate__d * var_chaste_interface__slow_inward_current_f_gate__f * (var_chaste_interface__membrane__V - ( -82.299999999999997 - (13.028700000000001 * log(var_chaste_interface__slow_inward_current__Cai * 0.001)))); // uA_per_mm2
        const double var_time_dependent_outward_current__i_x1 = (var_chaste_interface__time_dependent_outward_current_x1_gate__x1 * NV_Ith_S(mParameters, 6) * _lt_0_row[33]) / _lt_0_row[34]; // uA_per_mm2
        const double var_time_independent_outward_current__i_K1 = NV_Ith_S(mParameters, 5) * _lt_0_row[35]; // uA_per_mm2
        var_chaste_interface__stimulus_protocol__Istim = -GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_sodium_current_h_gate__beta_h = 1.7 / (exp( -0.082000000000000003 * ((var_chaste_interface__membrane__V + 22.5) - NV_Ith_S(mParameters, 4))) + 1.0); // per_ms
        const double var_sodium_current_h_gate__alpha_h = 0.126 * exp( -0.25 * ((var_chaste_interface__membrane__V + 77.0) - NV_Ith_S(mParameters, 4))); // per_ms
        const double var_sodium_current_h_gate__tau_h = 1.0 / (var_sodium_current_h_gate__alpha_h + var_sodium_current_h_gate__beta_h); // ms
        const double var_sodium_current_j_gate__beta_j = 0.29999999999999999 / (exp( -0.10000000000000001 * ((var_chaste_interface__membrane__V + 32.0) - NV_Ith_S(mParameters, 4))) + 1.0); // per_ms
        const double var_sodium_current_j_gate__alpha_j = (0.055 * exp( -0.25 * ((var_chaste_interface__membrane__V + 78.0) - NV_Ith_S(mParameters, 4)))) / (exp( -0.20000000000000001 * ((var_chaste_interface__membrane__V + 78.0) - NV_Ith_S(mParameters, 4))) + 1.0); // per_ms
        const double var_sodium_current_j_gate__tau_j = 1.0 / (var_sodium_current_j_gate__alpha_j + var_sodium_current_j_gate__beta_j); // ms
        const double var_chaste_interface__time_dependent_outward_current__i_x1 = var_time_dependent_outward_current__i_x1; // uA_per_mm2
        const double var_chaste_interface__sodium_current__i_Na = var_sodium_current__i_Na; // uA_per_mm2
        const double var_chaste_interface__slow_inward_current__i_s = var_slow_inward_current__i_s; // uA_per_mm2
        const double var_chaste_interface__time_independent_outward_current__i_K1 = var_time_independent_outward_current__i_K1; // uA_per_mm2
        
        N_Vector dqs = N_VNew_Serial(8);
        NV_Ith_S(dqs, 0) = var_chaste_interface__slow_inward_current__i_s;
        NV_Ith_S(dqs, 1) = var_chaste_interface__sodium_current__i_Na;
        NV_Ith_S(dqs, 2) = var_sodium_current_h_gate__tau_h;
        NV_Ith_S(dqs, 3) = var_sodium_current_j_gate__tau_j;
        NV_Ith_S(dqs, 4) = var_chaste_interface__time_independent_outward_current__i_K1;
        NV_Ith_S(dqs, 5) = var_chaste_interface__time_dependent_outward_current__i_x1;
        NV_Ith_S(dqs, 6) = var_chaste_interface__stimulus_protocol__Istim;
        NV_Ith_S(dqs, 7) = var_chaste_interface__environment__time;
        return dqs;
    }
    
template<>
void OdeSystemInformation<Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt>::Initialise(void)
{
    this->mSystemName = "beeler_reuter_model_1977";
    this->mFreeVariableName = "time";
    this->mFreeVariableUnits = "___units_12";
    
    this->mVariableNames.push_back("membrane_voltage");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-84.624);

    this->mVariableNames.push_back("membrane_fast_sodium_current_m_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.011);

    this->mVariableNames.push_back("membrane_fast_sodium_current_h_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.988);

    this->mVariableNames.push_back("membrane_fast_sodium_current_j_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.975);

    this->mVariableNames.push_back("cytosolic_calcium_concentration");
    this->mVariableUnits.push_back("concentration_units");
    this->mInitialConditions.push_back(1e-4);

    this->mVariableNames.push_back("membrane_L_type_calcium_current_d_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.003);

    this->mVariableNames.push_back("membrane_L_type_calcium_current_f_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.994);

    this->mVariableNames.push_back("time_dependent_outward_current_x1_gate__x1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0001);

    this->mParameterNames.push_back("membrane_L_type_calcium_current_conductance");
    this->mParameterUnits.push_back("mS_per_mm2");
    
    this->mParameterNames.push_back("membrane_capacitance");
    this->mParameterUnits.push_back("uF_per_mm2");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_conductance");
    this->mParameterUnits.push_back("mS_per_mm2");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_reduced_inactivation");
    this->mParameterUnits.push_back("dimensionless");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_shift_inactivation");
    this->mParameterUnits.push_back("mV");
    
    this->mParameterNames.push_back("membrane_inward_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("uA_per_mm2");
    
    this->mParameterNames.push_back("membrane_rapid_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("uA_per_mm2");
    
    this->mParameterNames.push_back("sodium_reversal_potential");
    this->mParameterUnits.push_back("mV");
    
    this->mParameterNames.push_back("membrane_data_clamp_current_conductance"); // RJ
    this->mParameterUnits.push_back("mS_per_mm2");

    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_mm2");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_mm2");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current_h_gate_tau");
    this->mDerivedQuantityUnits.push_back("ms");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current_j_gate_tau");
    this->mDerivedQuantityUnits.push_back("ms");
    
    this->mDerivedQuantityNames.push_back("membrane_inward_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_mm2");
    
    this->mDerivedQuantityNames.push_back("membrane_rapid_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_mm2");
    
    this->mDerivedQuantityNames.push_back("membrane_stimulus_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("time");
    this->mDerivedQuantityUnits.push_back("___units_12");
    
    this->mInitialised = true;
}


// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt)
#endif // CHASTE_CVODE
