#ifdef CHASTE_CVODE
#ifndef CELLBEELER_REUTER_MODEL_1977_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_
#define CELLBEELER_REUTER_MODEL_1977_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_

//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: beeler_reuter_model_1977
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24172, pycml: 23797, optimize: 23343)
//! on Fri May 29 17:43:56 2015
//! 
//! <autogenerated>

#include "ChasteSerialization.hpp"
#include <boost/serialization/base_object.hpp>
#include "AbstractCvodeCellWithDataClamp.hpp"
#include "AbstractStimulusFunction.hpp"

class Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt : public AbstractCvodeCellWithDataClamp
{
    friend class boost::serialization::access;
    template<class Archive>
    void serialize(Archive & archive, const unsigned int version)
    {
        archive & boost::serialization::base_object<AbstractCvodeCellWithDataClamp >(*this);
    }
    
    // 
    // Settable parameters and readable variables
    // 
    double var_chaste_interface__slow_inward_current__Cai;
    double var_chaste_interface__environment__fake_dt;
    double var_chaste_interface__i_ionic;
    double var_chaste_interface__slow_inward_current__i_s;
    double var_chaste_interface__slow_inward_current_d_gate__d;
    double var_chaste_interface__slow_inward_current_f_gate__f;
    double var_chaste_interface__sodium_current__i_Na;
    double var_chaste_interface__sodium_current_h_gate__h;
    double var_sodium_current_h_gate__tau_h;
    double var_chaste_interface__sodium_current_j_gate__j;
    double var_sodium_current_j_gate__tau_j;
    double var_chaste_interface__sodium_current_m_gate__m;
    double var_chaste_interface__time_independent_outward_current__i_K1;
    double var_chaste_interface__time_dependent_outward_current__i_x1;
    double var_chaste_interface__stimulus_protocol__Istim;
    double var_chaste_interface__stimulus_protocol__IstimAmplitude;
    double var_chaste_interface__stimulus_protocol__IstimPulseDuration;
    double var_chaste_interface__stimulus_protocol__IstimStart;
    double var_chaste_interface__stimulus_protocol__IstimPeriod;
    double var_chaste_interface__membrane__V;
    double var_chaste_interface__environment__time;
    
    //double var_data_clamp_current__i_data;

public:
    double Get_chaste_interface__slow_inward_current__Cai();
    double Get_chaste_interface__environment__fake_dt();
    double Get_chaste_interface__i_ionic();
    double Get_chaste_interface__slow_inward_current__i_s();
    double Get_chaste_interface__slow_inward_current_d_gate__d();
    double Get_chaste_interface__slow_inward_current_f_gate__f();
    double Get_chaste_interface__sodium_current__i_Na();
    double Get_chaste_interface__sodium_current_h_gate__h();
    double Get_sodium_current_h_gate__tau_h();
    double Get_chaste_interface__sodium_current_j_gate__j();
    double Get_sodium_current_j_gate__tau_j();
    double Get_chaste_interface__sodium_current_m_gate__m();
    double Get_chaste_interface__time_independent_outward_current__i_K1();
    double Get_chaste_interface__time_dependent_outward_current__i_x1();
    double Get_chaste_interface__stimulus_protocol__Istim();
    double Get_chaste_interface__stimulus_protocol__IstimAmplitude();
    double Get_chaste_interface__stimulus_protocol__IstimPulseDuration();
    double Get_chaste_interface__stimulus_protocol__IstimStart();
    double Get_chaste_interface__stimulus_protocol__IstimPeriod();
    double Get_chaste_interface__membrane__V();
    double Get_chaste_interface__environment__time();
    double Get_membrane_L_type_calcium_current_conductance_constant();
    double Get_membrane_capacitance_constant();
    double Get_membrane_fast_sodium_current_conductance_constant();
    double Get_membrane_fast_sodium_current_reduced_inactivation_constant();
    double Get_membrane_fast_sodium_current_shift_inactivation_constant();
    double Get_membrane_inward_rectifier_potassium_current_conductance_constant();
    double Get_membrane_rapid_delayed_rectifier_potassium_current_conductance_constant();
    double Get_membrane_stimulus_current_amplitude_constant();
    double Get_membrane_stimulus_current_duration_constant();
    double Get_membrane_stimulus_current_offset_constant();
    double Get_membrane_stimulus_current_period_constant();
    double Get_sodium_reversal_potential_constant();
    boost::shared_ptr<RegularStimulus> UseCellMLDefaultStimulus();
    double GetIntracellularCalciumConcentration();
    Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus);
    ~Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt();
    AbstractLookupTableCollection* GetLookupTableCollection();
    double GetIIonic(const std::vector<double>* pStateVariables=NULL);
    void EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY);
    void EvaluateAnalyticJacobian(long int N, double var_chaste_interface__environment__time, N_Vector rY, N_Vector rDY, CHASTE_CVODE_DENSE_MATRIX rJacobian, N_Vector rTmp1, N_Vector rTmp2, N_Vector rTmp3);
    N_Vector ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY);

    double Get_membrane_data_clamp_current_conductance_constant();
};


// Needs to be included last
#include "SerializationExportWrapper.hpp"
CHASTE_CLASS_EXPORT(Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt)

namespace boost
{
    namespace serialization
    {
        template<class Archive>
        inline void save_construct_data(
            Archive & ar, const Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt * t, const unsigned int fileVersion)
        {
            const boost::shared_ptr<AbstractIvpOdeSolver> p_solver = t->GetSolver();
            const boost::shared_ptr<AbstractStimulusFunction> p_stimulus = t->GetStimulusFunction();
            ar << p_solver;
            ar << p_stimulus;
        }
        
        template<class Archive>
        inline void load_construct_data(
            Archive & ar, Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt * t, const unsigned int fileVersion)
        {
            boost::shared_ptr<AbstractIvpOdeSolver> p_solver;
            boost::shared_ptr<AbstractStimulusFunction> p_stimulus;
            ar >> p_solver;
            ar >> p_stimulus;
            ::new(t)Cellbeeler_reuter_model_1977_data_clampFromCellMLCvodeOpt(p_solver, p_stimulus);
        }
        
    }
    
}

#endif // CELLBEELER_REUTER_MODEL_1977_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_
#endif // CHASTE_CVODE
