#ifdef CHASTE_CVODE
//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: davies_isap_2012
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24914, pycml: 24885, optimize: 23343)
//! on Wed Aug  5 12:28:35 2015
//! 
//! <autogenerated>

#include "davies_isap_2012CvodeDataClampOpt.hpp"
#include <cmath>
#include <cassert>
#include <memory>
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"
#include "RegularStimulus.hpp"
#include "HeartConfig.hpp"
#include "IsNan.hpp"
#include "MathsCustomFunctions.hpp"

class Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables : public AbstractLookupTableCollection
{
public:
    static Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables* Instance()
    {
        if (mpInstance.get() == NULL)
        {
            mpInstance.reset(new Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables);
        }
        return mpInstance.get();
    }
    
    void FreeMemory()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
        mNeedsRegeneration.assign(mNeedsRegeneration.size(), true);
    }
    
    // Row lookup methods
    // using linear-interpolation
    double* _lookup_0_row(unsigned i, double _factor_)
    {
        for (unsigned j=0; j<41; j++)
        {
            const double y1 = _lookup_table_0[i][j];
            const double y2 = _lookup_table_0[i+1][j];
            _lookup_table_0_row[j] = y1 + (y2-y1)*_factor_;
        }
        return _lookup_table_0_row;
    }
    
    
    const double * IndexTable0(double var_chaste_interface__cell__V)
    {
        const double _offset_0 = var_chaste_interface__cell__V - mTableMins[0];
        const double _offset_0_over_table_step = _offset_0 * mTableStepInverses[0];
        const unsigned _table_index_0 = (unsigned)(_offset_0_over_table_step);
        const double _factor_0 = _offset_0_over_table_step - _table_index_0;
        const double* const _lt_0_row = Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance()->_lookup_0_row(_table_index_0, _factor_0);
        return _lt_0_row;
    }
    
#define COVERAGE_IGNORE
    bool CheckIndex0(double& var_chaste_interface__cell__V)
    {
        bool _oob_0 = false;
        if (var_chaste_interface__cell__V>mTableMaxs[0] || var_chaste_interface__cell__V<mTableMins[0])
        {
#define COVERAGE_IGNORE
            _oob_0 = true;
#undef COVERAGE_IGNORE
        }
        return _oob_0;
    }
#undef COVERAGE_IGNORE

    ~Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
    }
    
protected:
    Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables(const Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables&);
    Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables& operator= (const Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables&);
    Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables()
    {
        assert(mpInstance.get() == NULL);
        mKeyingVariableNames.resize(1);
        mNumberOfTables.resize(1);
        mTableMins.resize(1);
        mTableSteps.resize(1);
        mTableStepInverses.resize(1);
        mTableMaxs.resize(1);
        mNeedsRegeneration.resize(1);
        mKeyingVariableNames[0] = "membrane_voltage";
        mNumberOfTables[0] = 41;
        mTableMins[0] = -100.0001;
        mTableSteps[0] = 0.001;
        mTableStepInverses[0] = 1000.0;
        mTableMaxs[0] = 99.9999;
        mNeedsRegeneration[0] = true;
        _lookup_table_0 = NULL;
        Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::RegenerateTables();
    }
    
    void RegenerateTables()
    {
        AbstractLookupTableCollection::EventHandler::BeginEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
        if (mNeedsRegeneration[0])
        {
            if (_lookup_table_0)
            {
                delete[] _lookup_table_0;
                _lookup_table_0 = NULL;
            }
            const unsigned _table_size_0 = 1 + (unsigned)((mTableMaxs[0]-mTableMins[0])/mTableSteps[0]+0.5);
            _lookup_table_0 = new double[_table_size_0][41];
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][0] = exp((var_chaste_interface__cell__V - 15.0) * 0.074871767015599999);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][1] = exp((var_chaste_interface__cell__V - 15.0) * 0.074871767015599999) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][2] = 1.0 / (1.0 + (2.5 * exp(0.10000000000000001 * (var_chaste_interface__cell__V + 28.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][3] = 0.1245 * exp(var_chaste_interface__cell__V *  -0.00374358835078);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][4] = exp((-var_chaste_interface__cell__V) * 0.0374358835078);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][5] = exp(var_chaste_interface__cell__V * 0.01310255922773);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][6] = exp(var_chaste_interface__cell__V *  -0.024333324280070002);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][7] = 1.0 + (0.27000000000000002 * exp(var_chaste_interface__cell__V *  -0.024333324280070002));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][8] = 1.0 + exp((7.4880000000000004 - var_chaste_interface__cell__V) * 0.16722408026755853);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][9] = exp(var_chaste_interface__cell__V * 0.074871767015599999);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][10] = exp(var_chaste_interface__cell__V * 0.074871767015599999) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][11] = exp(var_chaste_interface__cell__V * 0.0374358835078);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][12] = 1.0 - exp(var_chaste_interface__cell__V * 0.0374358835078);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][13] = (var_chaste_interface__cell__V >=  -40.0) ? 0.0 : (0.13500000000000001 * exp((80.0 + var_chaste_interface__cell__V) *  -0.14705882352941177));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][14] = (var_chaste_interface__cell__V >=  -40.0) ? (1.0 / (0.13 * (1.0 + exp((var_chaste_interface__cell__V + 10.66) *  -0.0900900900900901)))) : ((3.5600000000000001 * exp(0.079000000000000001 * var_chaste_interface__cell__V)) + (310000.0 * exp(0.34999999999999998 * var_chaste_interface__cell__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][15] = ((var_chaste_interface__cell__V + 47.130000000000003) * 0.32000000000000001) / (1.0 - exp( -0.10000000000000001 * (var_chaste_interface__cell__V + 47.130000000000003)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][16] = 0.080000000000000002 * exp((-var_chaste_interface__cell__V) * 0.090909090909090912);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][17] = (var_chaste_interface__cell__V >=  -40.0) ? 0.0 : (((( -127140.0 * exp(0.24440000000000001 * var_chaste_interface__cell__V)) - (3.4740000000000003e-05 * exp( -0.043909999999999998 * var_chaste_interface__cell__V))) * 1.0 * (var_chaste_interface__cell__V + 37.780000000000001)) / (1.0 + exp(0.311 * (var_chaste_interface__cell__V + 79.230000000000004))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][18] = (var_chaste_interface__cell__V >=  -40.0) ? ((0.29999999999999999 * exp( -2.5349999999999999e-07 * var_chaste_interface__cell__V)) / (1.0 + exp( -0.10000000000000001 * (var_chaste_interface__cell__V + 32.0)))) : ((0.1212 * exp( -0.01052 * var_chaste_interface__cell__V)) / (1.0 + exp( -0.13780000000000001 * (var_chaste_interface__cell__V + 40.140000000000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][19] = 1.0 / (1.0 + exp((-(var_chaste_interface__cell__V - 4.0)) * 0.14836795252225518));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][20] = 0.58999999999999997 + ((0.80000000000000004 * exp(0.051999999999999998 * (var_chaste_interface__cell__V + 13.0))) / (1.0 + exp(0.13200000000000001 * (var_chaste_interface__cell__V + 13.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][21] = 9.0 - (8.0 / (1.0 + exp((-(var_chaste_interface__cell__V + 65.0)) * 0.29411764705882354)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][22] = (0.69999999999999996 / (1.0 + exp((var_chaste_interface__cell__V + 17.120000000000001) * 0.14285714285714285))) + 0.29999999999999999;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][23] = 1.0 / ((0.24110000000000001 * exp(-pow(0.044999999999999998 * (var_chaste_interface__cell__V - 9.6913999999999998), 2.0))) + 0.052900000000000003);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][24] = (0.77000000000000002 / (1.0 + exp((var_chaste_interface__cell__V + 17.120000000000001) * 0.14285714285714285))) + 0.23000000000000001;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][25] = 1.0 / ((0.042299999999999997 * exp(-pow(0.058999999999999997 * (var_chaste_interface__cell__V - 18.572600000000001), 2.0))) + 0.0054000000000000003);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][26] = 1.0 / (1.0 + exp( -2.1819999999999999 - (0.18190000000000001 * var_chaste_interface__cell__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][27] = 43.0 + (1.0 / (exp( -5.4950000000000001 + (0.1691 * var_chaste_interface__cell__V)) + exp( -7.6769999999999996 - (0.012800000000000001 * var_chaste_interface__cell__V))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][28] = 1.0 / (1.0 + exp((-(var_chaste_interface__cell__V - 10.5)) * 0.04048582995951417));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][29] = 1.0 / (((7.6100000000000007e-05 * (var_chaste_interface__cell__V + 44.600000000000001)) / (1.0 - exp( -9.9700000000000006 * (var_chaste_interface__cell__V + 44.600000000000001)))) + ((0.00036000000000000002 * (var_chaste_interface__cell__V - 0.55000000000000004)) / (exp(0.128 * (var_chaste_interface__cell__V - 0.55000000000000004)) - 1.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][30] = 1.0 / (1.0 + exp((-(var_chaste_interface__cell__V - 10.5)) * 0.04048582995951417));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][31] = 1.0 / (((7.6100000000000007e-05 * (var_chaste_interface__cell__V + 44.600000000000001)) / (1.0 - exp( -9.9700000000000006 * (var_chaste_interface__cell__V + 44.600000000000001)))) + ((0.00036000000000000002 * (var_chaste_interface__cell__V - 0.55000000000000004)) / (exp(0.128 * (var_chaste_interface__cell__V - 0.55000000000000004)) - 1.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][32] = (25.0 * exp((var_chaste_interface__cell__V - 40.0) * 0.040000000000000001)) / (1.0 + exp((var_chaste_interface__cell__V - 40.0) * 0.040000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][33] = (25.0 * exp((-(var_chaste_interface__cell__V + 90.0)) * 0.040000000000000001)) / (1.0 + exp((-(var_chaste_interface__cell__V + 90.0)) * 0.040000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][34] = 0.029999999999999999 / (1.0 + exp((var_chaste_interface__cell__V + 60.0) * 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][35] = (0.20000000000000001 * exp((var_chaste_interface__cell__V + 25.0) * 0.20000000000000001)) / (1.0 + exp((var_chaste_interface__cell__V + 25.0) * 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][36] = 0.0022499999999999998 / (1.0 + exp((var_chaste_interface__cell__V + 60.0) * 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][37] = (0.10000000000000001 * exp((var_chaste_interface__cell__V + 25.0) * 0.20000000000000001)) / (1.0 + exp((var_chaste_interface__cell__V + 25.0) * 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][38] = ((var_chaste_interface__cell__V + 47.130000000000003) * 0.32000000000000001) / (1.0 - exp( -0.10000000000000001 * (var_chaste_interface__cell__V + 47.130000000000003)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][39] = 0.080000000000000002 * exp((-var_chaste_interface__cell__V) * 0.090909090909090912);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__cell__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][40] = 1.0 / (1.0 + exp((var_chaste_interface__cell__V + 91.0) * 0.16393442622950821));
            }
            
            mNeedsRegeneration[0] = false;
        }
        
        AbstractLookupTableCollection::EventHandler::EndEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
    }
    
private:
    /** The single instance of the class */
    static std::auto_ptr<Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables> mpInstance;

    // Row lookup methods memory
    double _lookup_table_0_row[41];
    
    // Lookup tables
    double (*_lookup_table_0)[41];
    
};

std::auto_ptr<Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables> Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::mpInstance;

    boost::shared_ptr<RegularStimulus> Celldavies_isap_2012FromCellMLCvodeDataClampOpt::UseCellMLDefaultStimulus()
    {
        // Use the default stimulus specified by CellML metadata
        const double var_chaste_interface__cell__stim_offset = 0.0; // millisecond
        const double var_chaste_interface__cell__stim_period = 1000.0; // millisecond
        const double var_chaste_interface__cell__stim_duration = 1.0; // millisecond
        const double var_chaste_interface__cell__stim_amplitude =  -80.0 * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        boost::shared_ptr<RegularStimulus> p_cellml_stim(new RegularStimulus(
                -fabs(var_chaste_interface__cell__stim_amplitude),
                var_chaste_interface__cell__stim_duration,
                var_chaste_interface__cell__stim_period,
                var_chaste_interface__cell__stim_offset
                ));
        mpIntracellularStimulus = p_cellml_stim;
        return p_cellml_stim;
    }
    
    double Celldavies_isap_2012FromCellMLCvodeDataClampOpt::GetIntracellularCalciumConcentration()
    {
        return NV_Ith_S(mStateVariables, 25);
    }
    
    Celldavies_isap_2012FromCellMLCvodeDataClampOpt::Celldavies_isap_2012FromCellMLCvodeDataClampOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
        : AbstractCvodeCellWithDataClamp(
                pOdeSolver,
                29,
                0,
                pIntracellularStimulus)
    {
        // Time units: millisecond
        // 
        this->mpSystemInfo = OdeSystemInformation<Celldavies_isap_2012FromCellMLCvodeDataClampOpt>::Instance();
        Init();

        // We have a default stimulus specified in the CellML file metadata
        this->mHasDefaultStimulusFromCellML = true;
        NV_Ith_S(this->mParameters, 0) = 1.8; // (c,Environment__Ca_o) [mM]
        NV_Ith_S(this->mParameters, 1) = 154.6; // (c,Environment__Cl_o) [mM]
        NV_Ith_S(this->mParameters, 2) = 4; // (c,Environment__K_o) [mM]
        NV_Ith_S(this->mParameters, 3) = 150; // (c,Environment__Na_o) [mM]
        NV_Ith_S(this->mParameters, 4) = 0.000243; // (c,ICaL__pca) [L_per_F_ms]
        NV_Ith_S(this->mParameters, 5) = 10; // (c,ICaL__tau_pow_calcium) [ms]
        NV_Ith_S(this->mParameters, 6) = 0.0000007980336; // (c,ICab__GCab) [L_per_F_ms]
        NV_Ith_S(this->mParameters, 7) = 0.000225; // (c,IClb__GClb) [mS_per_uF]
        NV_Ith_S(this->mParameters, 8) = 0.0575; // (c,IpCa__ibarpca) [uA_per_uF]
        NV_Ith_S(this->mParameters, 9) = 0.0; // (c,chaste_interface__chaste_interface__membrane_data_clamp_current_conductance) [___units_67]
        NV_Ith_S(this->mParameters, 10) = 8.25; // (c,INa__GNa) [mS_per_uF]
        NV_Ith_S(this->mParameters, 11) = 0.5; // (c,IK1__GK1) [mS_per_uF]
        NV_Ith_S(this->mParameters, 12) = 0.011; // (c,INal__GNaL) [mS_per_uF]
        NV_Ith_S(this->mParameters, 13) = 0.00276; // (c,IKp__GKp) [mS_per_uF]
        NV_Ith_S(this->mParameters, 14) = 0.0138542; // (c,IKr__GKrMax) [mS_per_uF]
        NV_Ith_S(this->mParameters, 15) = 0.00746925; // (c,IKs__gks_max) [mS_per_uF]
        NV_Ith_S(this->mParameters, 16) = 5.85; // (c,INaCa__NCXmax) [uA_per_uF]
        NV_Ith_S(this->mParameters, 17) = 0.61875; // (c,INaK__ibarnak) [uA_per_uF]
        NV_Ith_S(this->mParameters, 18) = 4e-7; // (c,Ito2__PCl) [L_per_F_ms]
        NV_Ith_S(this->mParameters, 19) = 0.1805; // (c,Ito__gitodv) [mS_per_uF]
        NV_Ith_S(this->mParameters, 20) = 300; // (c,Ito__Cto) [mV]
    }
    
    Celldavies_isap_2012FromCellMLCvodeDataClampOpt::~Celldavies_isap_2012FromCellMLCvodeDataClampOpt()
    {
    }
    
    AbstractLookupTableCollection* Celldavies_isap_2012FromCellMLCvodeDataClampOpt::GetLookupTableCollection()
    {
        return Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance();
    }
    
    double Celldavies_isap_2012FromCellMLCvodeDataClampOpt::GetIIonic(const std::vector<double>* pStateVariables)
    {
        // For state variable interpolation (SVI) we read in interpolated state variables,
        // otherwise for ionic current interpolation (ICI) we use the state variables of this model (node).
        N_Vector rY;
        bool made_new_cvode_vector = false;
        if (!pStateVariables)
        {
            rY = rGetStateVariables();
        }
        else
        {
            made_new_cvode_vector = true;
            rY = MakeNVector(*pStateVariables);
        }
        
        double var_chaste_interface__cell__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -93.2932771154856
        double var_chaste_interface__INa__H = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.99765453819431
        double var_chaste_interface__INa__m = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.000382187369845771
        double var_chaste_interface__INa__J = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.998157020148849
        double var_chaste_interface__ICaL__d = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 5.38067794749339e-7
        double var_chaste_interface__ICaL__dp = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 8.99805432294836
        double var_chaste_interface__ICaL__f = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.999986839648304
        double var_chaste_interface__ICaL__fca = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.961568137796573
        double var_chaste_interface__ICaL__fca2 = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 0.854261813196152
        double var_chaste_interface__ICaL__f2 = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 0.989081601403786
        double var_chaste_interface__IKr__xr = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0.255981702631947
        double var_chaste_interface__IKs__xs1 = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0.0147449166757808
        double var_chaste_interface__IKs__xs2 = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 0.0147504787196957
        double var_chaste_interface__Ito__ydv = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 0.00894974857468432
        double var_chaste_interface__Ito__ydv2 = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 0.999992183094244
        double var_chaste_interface__Ito__zdv = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 0.787996527242362
        double var_chaste_interface__Ito2__AA = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 0.0014969201082975
        double var_chaste_interface__INal__mL = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 0.000382187369845771
        double var_chaste_interface__INal__hL = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 0.488129650338831
        double var_chaste_interface__Na__Na_i = NV_Ith_S(rY, 22);
        // Units: mM; Initial value: 17.9964119779802
        double var_chaste_interface__K__K_i = NV_Ith_S(rY, 23);
        // Units: mM; Initial value: 134.555737634453
        double var_chaste_interface__Cl__Cl_i = NV_Ith_S(rY, 24);
        // Units: mM; Initial value: 20.1543792471096
        double var_chaste_interface__Ca__Ca_i = NV_Ith_S(rY, 25);
        // Units: mM; Initial value: 0.000223768331231758
        double var_chaste_interface__Ca__Ca_ss = NV_Ith_S(rY, 28);
        // Units: mM; Initial value: 0.000225131045297696
        
        // Lookup table indexing
        const bool _oob_0 = Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__cell__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__cell__V);
        
        const double var_reversal_potentials__ENa = log(NV_Ith_S(mParameters, 3) / var_chaste_interface__Na__Na_i) * 26.712338705500134; // mV
        const double var_INa__INa = (NV_Ith_S(mParameters, 10) * var_chaste_interface__INa__m * var_chaste_interface__INa__m * var_chaste_interface__INa__m * var_chaste_interface__INa__H * var_chaste_interface__INa__J) * (var_chaste_interface__cell__V - var_reversal_potentials__ENa); // uA_per_uF
        const double var_ICaL__ibarca = (NV_Ith_S(mParameters, 4) * (var_chaste_interface__cell__V - 15.0) * ((1.0 * var_chaste_interface__Ca__Ca_ss * _lt_0_row[0]) - (0.34100000000000003 * NV_Ith_S(mParameters, 0))) * 14448.004881000332) / _lt_0_row[1]; // uA_per_uF
        const double var_ICaL__ICaL = pow(var_chaste_interface__ICaL__d, var_chaste_interface__ICaL__dp) * var_chaste_interface__ICaL__f * var_chaste_interface__ICaL__f2 * var_chaste_interface__ICaL__fca * var_chaste_interface__ICaL__fca2 * var_ICaL__ibarca; // uA_per_uF
        const double var_reversal_potentials__EK = log(NV_Ith_S(mParameters, 2) / var_chaste_interface__K__K_i) * 26.712338705500134; // mV
        const double var_IK1__ak1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) - 59.215000000000003))); // per_ms
        const double var_IK1__IK1 = ((NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 2) * 0.25) * var_IK1__ak1) / (var_IK1__ak1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) + 5.476))) + (1.0 * exp(0.061749999999999999 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) - 594.30999999999995)))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) + 4.7530000000000001)))))) * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKp__IKp = (NV_Ith_S(mParameters, 13) * (var_chaste_interface__cell__V - var_reversal_potentials__EK)) / _lt_0_row[8]; // uA_per_uF
        const double var_IKs__IKs = (NV_Ith_S(mParameters, 15) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__Ca__Ca_i, 1.3999999999999999))))) * var_chaste_interface__IKs__xs1 * var_chaste_interface__IKs__xs2 * (var_chaste_interface__cell__V - (log((NV_Ith_S(mParameters, 2) + (0.018329999999999999 * NV_Ith_S(mParameters, 3))) / (var_chaste_interface__K__K_i + (0.018329999999999999 * var_chaste_interface__Na__Na_i))) * 26.712338705500134)); // uA_per_uF
        const double var_IKr__IKr = (NV_Ith_S(mParameters, 14) * sqrt(NV_Ith_S(mParameters, 2) * 0.25)) * var_chaste_interface__IKr__xr * _lt_0_row[2] * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 8) * var_chaste_interface__Ca__Ca_i) / (0.00050000000000000001 + var_chaste_interface__Ca__Ca_i); // uA_per_uF
        const double var_ICab__ICab = (NV_Ith_S(mParameters, 6) * var_chaste_interface__cell__V * ((var_chaste_interface__Ca__Ca_i * _lt_0_row[9]) - (0.34100000000000003 * NV_Ith_S(mParameters, 0))) * 3612.001220250083) / _lt_0_row[10]; // uA_per_uF
        const double var_INaCa__ca_i_NaCa = 1.5 * var_chaste_interface__Ca__Ca_i; // mM
        const double var_INaCa__INaCa = (NV_Ith_S(mParameters, 16) * (1.0 / (1.0 + pow(0.000125 / var_INaCa__ca_i_NaCa, 2.0))) * ((pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 0) * _lt_0_row[5]) - (pow(NV_Ith_S(mParameters, 3), 3.0) * var_INaCa__ca_i_NaCa * _lt_0_row[6]))) / (_lt_0_row[7] * (((1.3 * pow(var_chaste_interface__Na__Na_i, 3.0)) + (669921.875 * var_INaCa__ca_i_NaCa) + (1860.8670000000004 * NV_Ith_S(mParameters, 0) * (1.0 + (var_INaCa__ca_i_NaCa * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 3), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_i * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 0)) + (pow(NV_Ith_S(mParameters, 3), 3.0) * var_INaCa__ca_i_NaCa)))); // uA_per_uF
        const double var_INaK__INaK = (((NV_Ith_S(mParameters, 17) * (1.0 / (1.0 + _lt_0_row[3] + (0.036499999999999998 * ((exp(NV_Ith_S(mParameters, 3) * 0.01485884101040119) - 1.0) * 0.14285714285714285) * _lt_0_row[4]))) * 1.0) / (1.0 + pow(10.0 / var_chaste_interface__Na__Na_i, 2.0))) * NV_Ith_S(mParameters, 2)) / (NV_Ith_S(mParameters, 2) + 1.5); // uA_per_uF
        const double var_Ito__Ito = NV_Ith_S(mParameters, 19) * pow(var_chaste_interface__Ito__ydv, 3.0) * var_chaste_interface__Ito__ydv2 * var_chaste_interface__Ito__zdv * ((var_chaste_interface__cell__V <= 0.0) ? exp(var_chaste_interface__cell__V / NV_Ith_S(mParameters, 20)) : 1.0) * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_Ito2__Ito2 = ((NV_Ith_S(mParameters, 18) * var_chaste_interface__cell__V * (var_chaste_interface__Cl__Cl_i - (NV_Ith_S(mParameters, 1) * _lt_0_row[11])) * 3612.001220250083) / _lt_0_row[12]) * var_chaste_interface__Ito2__AA; // uA_per_uF
        const double var_reversal_potentials__ECl = (-log(NV_Ith_S(mParameters, 1) / var_chaste_interface__Cl__Cl_i)) * 26.712338705500134; // mV
        const double var_IClb__IClb = NV_Ith_S(mParameters, 7) * (var_chaste_interface__cell__V - var_reversal_potentials__ECl); // uA_per_uF
        const double var_INal__INal = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__INal__mL, 3.0) * var_chaste_interface__INal__hL * (var_chaste_interface__cell__V - var_reversal_potentials__ENa); // uA_per_uF
        const double var_cell__caiont = (var_ICaL__ICaL + var_ICab__ICab + var_IpCa__IpCa) - (2.0 * var_INaCa__INaCa); // uA_per_uF
        const double var_cell__naiont = var_INa__INa + (3.0 * var_INaCa__INaCa) + (3.0 * var_INaK__INaK) + var_INal__INal; // uA_per_uF
        const double var_chaste_interface__cell__i_Stim = 0.0;
        const double var_cell__i_Stim = var_chaste_interface__cell__i_Stim / HeartConfig::Instance()->GetCapacitance(); // uA_per_uF
        const double var_cell__kiont = ((var_IKr__IKr + var_IKs__IKs + var_IK1__IK1 + var_IKp__IKp) - (2.0 * var_INaK__INaK)) + var_Ito__Ito + (0.5 * var_cell__i_Stim); // uA_per_uF
        const double var_cell__clont = var_IClb__IClb + var_Ito2__Ito2 + (0.5 * var_cell__i_Stim); // uA_per_uF
        const double var_chaste_interface__i_ionic = (var_cell__naiont + var_cell__kiont + var_cell__caiont + var_cell__clont) * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        
        const double i_ionic = var_chaste_interface__i_ionic;
        if (made_new_cvode_vector)
        {
            DeleteVector(rY);
        }
        EXCEPT_IF_NOT(!std::isnan(i_ionic));
        return i_ionic;
    }
    
    void Celldavies_isap_2012FromCellMLCvodeDataClampOpt::EvaluateYDerivatives(double var_chaste_interface__Environment__time, const N_Vector rY, N_Vector rDY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__cell__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -93.2932771154856
        double var_chaste_interface__INa__H = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.99765453819431
        double var_chaste_interface__INa__m = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.000382187369845771
        double var_chaste_interface__INa__J = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.998157020148849
        double var_chaste_interface__ICaL__d = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 5.38067794749339e-7
        double var_chaste_interface__ICaL__dp = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 8.99805432294836
        double var_chaste_interface__ICaL__f = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.999986839648304
        double var_chaste_interface__ICaL__fca = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.961568137796573
        double var_chaste_interface__ICaL__fca2 = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 0.854261813196152
        double var_chaste_interface__ICaL__f2 = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 0.989081601403786
        double var_chaste_interface__IKr__xr = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0.255981702631947
        double var_chaste_interface__IKs__xs1 = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0.0147449166757808
        double var_chaste_interface__IKs__xs2 = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 0.0147504787196957
        double var_chaste_interface__Ito__ydv = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 0.00894974857468432
        double var_chaste_interface__Ito__ydv2 = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 0.999992183094244
        double var_chaste_interface__Ito__zdv = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 0.787996527242362
        double var_chaste_interface__Ito2__AA = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 0.0014969201082975
        double var_chaste_interface__INal__mL = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 0.000382187369845771
        double var_chaste_interface__INal__hL = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 0.488129650338831
        double var_chaste_interface__Irel__CaMKtrap = NV_Ith_S(rY, 19);
        // Units: dimensionless; Initial value: 0.0971591072782679
        double var_chaste_interface__Irel__ro = NV_Ith_S(rY, 20);
        // Units: dimensionless; Initial value: -1.07543858779373e-32
        double var_chaste_interface__Irel__ri = NV_Ith_S(rY, 21);
        // Units: dimensionless; Initial value: 0.716604593002322
        double var_chaste_interface__Na__Na_i = NV_Ith_S(rY, 22);
        // Units: mM; Initial value: 17.9964119779802
        double var_chaste_interface__K__K_i = NV_Ith_S(rY, 23);
        // Units: mM; Initial value: 134.555737634453
        double var_chaste_interface__Cl__Cl_i = NV_Ith_S(rY, 24);
        // Units: mM; Initial value: 20.1543792471096
        double var_chaste_interface__Ca__Ca_i = NV_Ith_S(rY, 25);
        // Units: mM; Initial value: 0.000223768331231758
        double var_chaste_interface__Ca__Ca_jsr = NV_Ith_S(rY, 26);
        // Units: mM; Initial value: 4.1270622547589
        double var_chaste_interface__Ca__Ca_nsr = NV_Ith_S(rY, 27);
        // Units: mM; Initial value: 4.14835141174613
        double var_chaste_interface__Ca__Ca_ss = NV_Ith_S(rY, 28);
        // Units: mM; Initial value: 0.000225131045297696
        
        
        // Lookup table indexing
        const bool _oob_0 = Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__cell__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__Environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__cell__V);
        
        // Mathematics
        double d_dt_chaste_interface__cell__V;
        const double var_reversal_potentials__ENa = log(NV_Ith_S(mParameters, 3) / var_chaste_interface__Na__Na_i) * 26.712338705500134; // mV
        const double var_INa__INa = (NV_Ith_S(mParameters, 10) * var_chaste_interface__INa__m * var_chaste_interface__INa__m * var_chaste_interface__INa__m * var_chaste_interface__INa__H * var_chaste_interface__INa__J) * (var_chaste_interface__cell__V - var_reversal_potentials__ENa); // uA_per_uF
        const double var_ICaL__ibarca = (NV_Ith_S(mParameters, 4) * (var_chaste_interface__cell__V - 15.0) * ((1.0 * var_chaste_interface__Ca__Ca_ss * _lt_0_row[0]) - (0.34100000000000003 * NV_Ith_S(mParameters, 0))) * 14448.004881000332) / _lt_0_row[1]; // uA_per_uF
        const double var_ICaL__ICaL = pow(var_chaste_interface__ICaL__d, var_chaste_interface__ICaL__dp) * var_chaste_interface__ICaL__f * var_chaste_interface__ICaL__f2 * var_chaste_interface__ICaL__fca * var_chaste_interface__ICaL__fca2 * var_ICaL__ibarca; // uA_per_uF
        const double var_reversal_potentials__EK = log(NV_Ith_S(mParameters, 2) / var_chaste_interface__K__K_i) * 26.712338705500134; // mV
        const double var_IK1__ak1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) - 59.215000000000003))); // per_ms
        const double var_IK1__IK1 = ((NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 2) * 0.25) * var_IK1__ak1) / (var_IK1__ak1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) + 5.476))) + (1.0 * exp(0.061749999999999999 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) - 594.30999999999995)))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) + 4.7530000000000001)))))) * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKp__IKp = (NV_Ith_S(mParameters, 13) * (var_chaste_interface__cell__V - var_reversal_potentials__EK)) / _lt_0_row[8]; // uA_per_uF
        const double var_IKs__IKs = (NV_Ith_S(mParameters, 15) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__Ca__Ca_i, 1.3999999999999999))))) * var_chaste_interface__IKs__xs1 * var_chaste_interface__IKs__xs2 * (var_chaste_interface__cell__V - (log((NV_Ith_S(mParameters, 2) + (0.018329999999999999 * NV_Ith_S(mParameters, 3))) / (var_chaste_interface__K__K_i + (0.018329999999999999 * var_chaste_interface__Na__Na_i))) * 26.712338705500134)); // uA_per_uF
        const double var_IKr__IKr = (NV_Ith_S(mParameters, 14) * sqrt(NV_Ith_S(mParameters, 2) * 0.25)) * var_chaste_interface__IKr__xr * _lt_0_row[2] * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 8) * var_chaste_interface__Ca__Ca_i) / (0.00050000000000000001 + var_chaste_interface__Ca__Ca_i); // uA_per_uF
        const double var_ICab__ICab = (NV_Ith_S(mParameters, 6) * var_chaste_interface__cell__V * ((var_chaste_interface__Ca__Ca_i * _lt_0_row[9]) - (0.34100000000000003 * NV_Ith_S(mParameters, 0))) * 3612.001220250083) / _lt_0_row[10]; // uA_per_uF
        const double var_INaCa__ca_i_NaCa = 1.5 * var_chaste_interface__Ca__Ca_i; // mM
        const double var_INaCa__INaCa = (NV_Ith_S(mParameters, 16) * (1.0 / (1.0 + pow(0.000125 / var_INaCa__ca_i_NaCa, 2.0))) * ((pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 0) * _lt_0_row[5]) - (pow(NV_Ith_S(mParameters, 3), 3.0) * var_INaCa__ca_i_NaCa * _lt_0_row[6]))) / (_lt_0_row[7] * (((1.3 * pow(var_chaste_interface__Na__Na_i, 3.0)) + (669921.875 * var_INaCa__ca_i_NaCa) + (1860.8670000000004 * NV_Ith_S(mParameters, 0) * (1.0 + (var_INaCa__ca_i_NaCa * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 3), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_i * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 0)) + (pow(NV_Ith_S(mParameters, 3), 3.0) * var_INaCa__ca_i_NaCa)))); // uA_per_uF
        const double var_INaK__INaK = (((NV_Ith_S(mParameters, 17) * (1.0 / (1.0 + _lt_0_row[3] + (0.036499999999999998 * ((exp(NV_Ith_S(mParameters, 3) * 0.01485884101040119) - 1.0) * 0.14285714285714285) * _lt_0_row[4]))) * 1.0) / (1.0 + pow(10.0 / var_chaste_interface__Na__Na_i, 2.0))) * NV_Ith_S(mParameters, 2)) / (NV_Ith_S(mParameters, 2) + 1.5); // uA_per_uF
        const double var_Ito__Ito = NV_Ith_S(mParameters, 19) * pow(var_chaste_interface__Ito__ydv, 3.0) * var_chaste_interface__Ito__ydv2 * var_chaste_interface__Ito__zdv * ((var_chaste_interface__cell__V <= 0.0) ? exp(var_chaste_interface__cell__V / NV_Ith_S(mParameters, 20)) : 1.0) * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_Ito2__Ito2 = ((NV_Ith_S(mParameters, 18) * var_chaste_interface__cell__V * (var_chaste_interface__Cl__Cl_i - (NV_Ith_S(mParameters, 1) * _lt_0_row[11])) * 3612.001220250083) / _lt_0_row[12]) * var_chaste_interface__Ito2__AA; // uA_per_uF
        const double var_reversal_potentials__ECl = (-log(NV_Ith_S(mParameters, 1) / var_chaste_interface__Cl__Cl_i)) * 26.712338705500134; // mV
        const double var_IClb__IClb = NV_Ith_S(mParameters, 7) * (var_chaste_interface__cell__V - var_reversal_potentials__ECl); // uA_per_uF
        const double var_INal__INal = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__INal__mL, 3.0) * var_chaste_interface__INal__hL * (var_chaste_interface__cell__V - var_reversal_potentials__ENa); // uA_per_uF
        const double var_cell__naiont = var_INa__INa + (3.0 * var_INaCa__INaCa) + (3.0 * var_INaK__INaK) + var_INal__INal; // uA_per_uF
        const double var_chaste_interface__cell__i_Stim = GetIntracellularAreaStimulus(var_chaste_interface__Environment__time);
        const double var_cell__i_Stim = var_chaste_interface__cell__i_Stim / HeartConfig::Instance()->GetCapacitance(); // uA_per_uF
        const double var_cell__kiont = ((var_IKr__IKr + var_IKs__IKs + var_IK1__IK1 + var_IKp__IKp) - (2.0 * var_INaK__INaK)) + var_Ito__Ito + (0.5 * var_cell__i_Stim); // uA_per_uF
        const double var_cell__clont = var_IClb__IClb + var_Ito2__Ito2 + (0.5 * var_cell__i_Stim); // uA_per_uF
        const double var_cell__Acap = 0.00015343538520132551; // uF
        const double var_cell__AF = var_cell__Acap * 1.0364305332435094e-05; // uF_mole_per_C
        const double var_Irel__CaMKactive = ((0.050000000000000003 * (1.0 - var_chaste_interface__Irel__CaMKtrap)) / (1.0 + (0.0015 / var_chaste_interface__Ca__Ca_ss))) + var_chaste_interface__Irel__CaMKtrap; // dimensionless
        const double var_Irel__dtau_rel = (10.0 * var_Irel__CaMKactive) / (0.14999999999999999 + var_Irel__CaMKactive); // ms
        const double var_Irel__cafac = 1.0 / (1.0 + exp((var_ICaL__ICaL + 0.050000000000000003) * 66.666666666666671)); // dimensionless
        const double var_Irel__irelcicr = (3000.0 * (1.0 / (1.0 + exp((var_ICaL__ibarca + 13.0) * 0.20000000000000001)))) * var_chaste_interface__Irel__ro * var_chaste_interface__Irel__ri * (var_chaste_interface__Ca__Ca_jsr - var_chaste_interface__Ca__Ca_ss); // mM_per_ms
        const double var_Iup_Ileak__iup = ((((0.75 * var_Irel__CaMKactive) / (0.14999999999999999 + var_Irel__CaMKactive)) + 1.0) * 0.0043750000000000004 * var_chaste_interface__Ca__Ca_i) / ((var_chaste_interface__Ca__Ca_i + 0.00092000000000000003) - ((0.00017000000000000001 * var_Irel__CaMKactive) / (0.14999999999999999 + var_Irel__CaMKactive))); // mM_per_ms
        const double var_Iup_Ileak__ileak = (0.0043750000000000004 * var_chaste_interface__Ca__Ca_nsr) * 0.066666666666666666; // mM_per_ms
        const double var_Idiff_Itr__idiff = (var_chaste_interface__Ca__Ca_ss - var_chaste_interface__Ca__Ca_i) * 5.0; // mM_per_ms
        const double var_Idiff_Itr__itr = (var_chaste_interface__Ca__Ca_nsr - var_chaste_interface__Ca__Ca_jsr) * 0.0083333333333333332; // mM_per_ms
        const double var_Na__CTNaCl = (9.8442999999999999e-06 * pow(var_reversal_potentials__ENa - var_reversal_potentials__ECl, 4.0)) / (pow(var_reversal_potentials__ENa - var_reversal_potentials__ECl, 4.0) + 59494197.640692554); // mM_per_ms
        const double var_K__CTKCl = (7.0755999999999996e-06 * (var_reversal_potentials__EK - var_reversal_potentials__ECl)) / ((var_reversal_potentials__EK - var_reversal_potentials__ECl) + 87.825100000000006); // mM_per_ms
        const double d_dt_chaste_interface__INa__H = (_lt_0_row[13] * (1.0 - var_chaste_interface__INa__H)) - (_lt_0_row[14] * var_chaste_interface__INa__H); // 'per millisecond'
        const double d_dt_chaste_interface__INa__m = (_lt_0_row[15] * (1.0 - var_chaste_interface__INa__m)) - (_lt_0_row[16] * var_chaste_interface__INa__m); // 'per millisecond'
        const double d_dt_chaste_interface__INa__J = (_lt_0_row[17] * (1.0 - var_chaste_interface__INa__J)) - (_lt_0_row[18] * var_chaste_interface__INa__J); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__d = (_lt_0_row[19] - var_chaste_interface__ICaL__d) / _lt_0_row[20]; // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__dp = (_lt_0_row[21] - var_chaste_interface__ICaL__dp) / NV_Ith_S(mParameters, 5); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__f = (_lt_0_row[22] - var_chaste_interface__ICaL__f) / _lt_0_row[23]; // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__fca = (((0.29999999999999999 / (1.0 - (var_ICaL__ICaL * 20.0))) + (0.55000000000000004 / (1.0 + (var_chaste_interface__Ca__Ca_ss * 333.33333333333331))) + 0.14999999999999999) - var_chaste_interface__ICaL__fca) / (((10.0 * var_Irel__CaMKactive) / (0.14999999999999999 + var_Irel__CaMKactive)) + (1.0 / (1.0 + (var_chaste_interface__Ca__Ca_ss * 333.33333333333331))) + 0.5); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__fca2 = ((1.0 / (1.0 - (var_ICaL__ICaL * 100.0))) - var_chaste_interface__ICaL__fca2) / ((300.0 / (1.0 + exp(((-var_ICaL__ICaL) - 0.17499999999999999) * 25.0))) + 125.0); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__f2 = (_lt_0_row[24] - var_chaste_interface__ICaL__f2) / _lt_0_row[25]; // 'per millisecond'
        const double d_dt_chaste_interface__IKr__xr = (_lt_0_row[26] - var_chaste_interface__IKr__xr) / _lt_0_row[27]; // 'per millisecond'
        const double d_dt_chaste_interface__IKs__xs1 = (_lt_0_row[28] - var_chaste_interface__IKs__xs1) / _lt_0_row[29]; // 'per millisecond'
        const double d_dt_chaste_interface__IKs__xs2 = ((_lt_0_row[30] - var_chaste_interface__IKs__xs2) / _lt_0_row[31]) * 0.5; // 'per millisecond'
        const double d_dt_chaste_interface__Ito__ydv = (_lt_0_row[32] * (1.0 - var_chaste_interface__Ito__ydv)) - (_lt_0_row[33] * var_chaste_interface__Ito__ydv); // 'per millisecond'
        const double d_dt_chaste_interface__Ito__ydv2 = (_lt_0_row[34] * (1.0 - var_chaste_interface__Ito__ydv2)) - (_lt_0_row[35] * var_chaste_interface__Ito__ydv2); // 'per millisecond'
        const double d_dt_chaste_interface__Ito__zdv = (_lt_0_row[36] * (1.0 - var_chaste_interface__Ito__zdv)) - (_lt_0_row[37] * var_chaste_interface__Ito__zdv); // 'per millisecond'
        const double d_dt_chaste_interface__Ito2__AA = ((1.0 / (1.0 + (0.1502 / var_chaste_interface__Ca__Ca_ss))) - var_chaste_interface__Ito2__AA) * 1.0; // 'per millisecond'
        const double d_dt_chaste_interface__INal__mL = (_lt_0_row[38] * (1.0 - var_chaste_interface__INal__mL)) - (_lt_0_row[39] * var_chaste_interface__INal__mL); // 'per millisecond'
        const double d_dt_chaste_interface__INal__hL = (_lt_0_row[40] - var_chaste_interface__INal__hL) * 0.0016666666666666668; // 'per millisecond'
        const double d_dt_chaste_interface__Irel__CaMKtrap = (0.050000000000000003 * var_Irel__CaMKactive * (var_Irel__CaMKactive - var_chaste_interface__Irel__CaMKtrap)) - (0.00068000000000000005 * var_chaste_interface__Irel__CaMKtrap); // 'per millisecond'
        const double d_dt_chaste_interface__Irel__ro = (((pow(var_chaste_interface__Ca__Ca_jsr, 1.8999999999999999) / (pow(var_chaste_interface__Ca__Ca_jsr, 1.8999999999999999) + pow((49.280000000000001 * var_chaste_interface__Ca__Ca_ss) / (var_chaste_interface__Ca__Ca_ss + 0.0028), 1.8999999999999999))) / (pow(1.0 / var_ICaL__ICaL, 2.0) + 1.0)) - var_chaste_interface__Irel__ro) * 0.33333333333333331; // 'per millisecond'
        const double d_dt_chaste_interface__Irel__ri = ((1.0 / (1.0 + exp(((var_chaste_interface__Ca__Ca_ss - 0.00040000000000000002) + (0.002 * var_Irel__cafac)) * 40000.0))) - var_chaste_interface__Irel__ri) / (3.0 + var_Irel__dtau_rel + ((350.0 - var_Irel__dtau_rel) / (1.0 + exp(((var_chaste_interface__Ca__Ca_ss - 0.0030000000000000001) + (0.0030000000000000001 * var_Irel__cafac)) * 5000.0)))); // 'per millisecond'
        const double d_dt_chaste_interface__Na__Na_i = (((-var_cell__naiont) * var_cell__AF) * 38686.179652867118) + var_Na__CTNaCl; // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__K__K_i = (((-var_cell__kiont) * var_cell__AF) * 38686.179652867118) + var_K__CTKCl; // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Cl__Cl_i = ((var_cell__clont * var_cell__AF) * 38686.179652867118) + var_Na__CTNaCl + var_K__CTKCl; // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_i = (1.0 / (1.0 + (0.00011900000000000002 / pow(var_chaste_interface__Ca__Ca_i + 0.0023800000000000002, 2.0)) + (3.5000000000000004e-05 / pow(var_chaste_interface__Ca__Ca_i + 0.00050000000000000001, 2.0)))) * ((((-((var_ICab__ICab + var_IpCa__IpCa) - (2.0 * var_INaCa__INaCa))) * var_cell__AF) * 19343.089826433559) + (((var_Iup_Ileak__ileak - var_Iup_Ileak__iup) * 2.0983325651856948e-06) * 38686.179652867118) + ((var_Idiff_Itr__idiff * 7.6026542216873e-07) * 38686.179652867118)); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_jsr = (1.0 / (1.0 + (8.0 / pow(var_chaste_interface__Ca__Ca_jsr + 0.80000000000000004, 2.0)))) * (var_Idiff_Itr__itr - var_Irel__irelcicr); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_nsr = (var_Iup_Ileak__iup - ((var_Idiff_Itr__itr * 1.8246370132049518e-07) * 476568.87978169642)) - var_Iup_Ileak__ileak; // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_ss = (1.0 / (1.0 + (4.0890000000000003e-05 / pow(0.00087000000000000001 + var_chaste_interface__Ca__Ca_ss, 2.0)) + (0.0097788000000000007 / pow(0.0086999999999999994 + var_chaste_interface__Ca__Ca_ss, 2.0)))) * (((((-var_ICaL__ICaL) * var_cell__AF) * 657665.05409874103) + ((var_Irel__irelcicr * 1.8246370132049518e-07) * 1315330.1081974821)) - var_Idiff_Itr__idiff); // 'millimole per litre per millisecond'
        
        if (mSetVoltageDerivativeToZero)
        {
            d_dt_chaste_interface__cell__V = 0.0;
        }
        else
        {
            const double var_cell__caiont = (var_ICaL__ICaL + var_ICab__ICab + var_IpCa__IpCa) - (2.0 * var_INaCa__INaCa); // uA_per_uF
            // Special handling of data clamp current here (see #2708)
            // (we want to save expense of calling the interpolation method if possible.)
            double var_chaste_interface__membrane_data_clamp_current = 0.0;
            if (mDataClampIsOn)
            {
                var_chaste_interface__membrane_data_clamp_current = NV_Ith_S(mParameters, 9) * (var_chaste_interface__cell__V - GetExperimentalVoltageAtTimeT(var_chaste_interface__Environment__time)); // uA_per_cm2
            }
            d_dt_chaste_interface__cell__V = -(var_cell__naiont + var_chaste_interface__membrane_data_clamp_current + var_cell__kiont + var_cell__caiont + var_cell__clont); // 'millivolt per millisecond'
        }
        
        NV_Ith_S(rDY, 0) = d_dt_chaste_interface__cell__V;
        NV_Ith_S(rDY, 1) = d_dt_chaste_interface__INa__H;
        NV_Ith_S(rDY, 2) = d_dt_chaste_interface__INa__m;
        NV_Ith_S(rDY, 3) = d_dt_chaste_interface__INa__J;
        NV_Ith_S(rDY, 4) = d_dt_chaste_interface__ICaL__d;
        NV_Ith_S(rDY, 5) = d_dt_chaste_interface__ICaL__dp;
        NV_Ith_S(rDY, 6) = d_dt_chaste_interface__ICaL__f;
        NV_Ith_S(rDY, 7) = d_dt_chaste_interface__ICaL__fca;
        NV_Ith_S(rDY, 8) = d_dt_chaste_interface__ICaL__fca2;
        NV_Ith_S(rDY, 9) = d_dt_chaste_interface__ICaL__f2;
        NV_Ith_S(rDY, 10) = d_dt_chaste_interface__IKr__xr;
        NV_Ith_S(rDY, 11) = d_dt_chaste_interface__IKs__xs1;
        NV_Ith_S(rDY, 12) = d_dt_chaste_interface__IKs__xs2;
        NV_Ith_S(rDY, 13) = d_dt_chaste_interface__Ito__ydv;
        NV_Ith_S(rDY, 14) = d_dt_chaste_interface__Ito__ydv2;
        NV_Ith_S(rDY, 15) = d_dt_chaste_interface__Ito__zdv;
        NV_Ith_S(rDY, 16) = d_dt_chaste_interface__Ito2__AA;
        NV_Ith_S(rDY, 17) = d_dt_chaste_interface__INal__mL;
        NV_Ith_S(rDY, 18) = d_dt_chaste_interface__INal__hL;
        NV_Ith_S(rDY, 19) = d_dt_chaste_interface__Irel__CaMKtrap;
        NV_Ith_S(rDY, 20) = d_dt_chaste_interface__Irel__ro;
        NV_Ith_S(rDY, 21) = d_dt_chaste_interface__Irel__ri;
        NV_Ith_S(rDY, 22) = d_dt_chaste_interface__Na__Na_i;
        NV_Ith_S(rDY, 23) = d_dt_chaste_interface__K__K_i;
        NV_Ith_S(rDY, 24) = d_dt_chaste_interface__Cl__Cl_i;
        NV_Ith_S(rDY, 25) = d_dt_chaste_interface__Ca__Ca_i;
        NV_Ith_S(rDY, 26) = d_dt_chaste_interface__Ca__Ca_jsr;
        NV_Ith_S(rDY, 27) = d_dt_chaste_interface__Ca__Ca_nsr;
        NV_Ith_S(rDY, 28) = d_dt_chaste_interface__Ca__Ca_ss;
    }
    
    N_Vector Celldavies_isap_2012FromCellMLCvodeDataClampOpt::ComputeDerivedQuantities(double var_chaste_interface__Environment__time, const N_Vector & rY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__cell__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -93.2932771154856
        double var_chaste_interface__INa__H = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.99765453819431
        double var_chaste_interface__INa__m = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.000382187369845771
        double var_chaste_interface__INa__J = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.998157020148849
        double var_chaste_interface__IKr__xr = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0.255981702631947
        double var_chaste_interface__IKs__xs1 = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0.0147449166757808
        double var_chaste_interface__IKs__xs2 = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 0.0147504787196957
        double var_chaste_interface__Ito__ydv = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 0.00894974857468432
        double var_chaste_interface__Ito__ydv2 = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 0.999992183094244
        double var_chaste_interface__Ito__zdv = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 0.787996527242362
        double var_chaste_interface__Ito2__AA = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 0.0014969201082975
        double var_chaste_interface__INal__mL = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 0.000382187369845771
        double var_chaste_interface__INal__hL = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 0.488129650338831
        double var_chaste_interface__Na__Na_i = NV_Ith_S(rY, 22);
        // Units: mM; Initial value: 17.9964119779802
        double var_chaste_interface__K__K_i = NV_Ith_S(rY, 23);
        // Units: mM; Initial value: 134.555737634453
        double var_chaste_interface__Cl__Cl_i = NV_Ith_S(rY, 24);
        // Units: mM; Initial value: 20.1543792471096
        double var_chaste_interface__Ca__Ca_i = NV_Ith_S(rY, 25);
        // Units: mM; Initial value: 0.000223768331231758
        
        
        // Lookup table indexing
        const bool _oob_0 = Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__cell__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__Environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Celldavies_isap_2012FromCellMLCvodeDataClampOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__cell__V);
        
        // Mathematics
        const double var_reversal_potentials__ENa = log(NV_Ith_S(mParameters, 3) / var_chaste_interface__Na__Na_i) * 26.712338705500134; // mV
        const double var_INa__INa = (NV_Ith_S(mParameters, 10) * var_chaste_interface__INa__m * var_chaste_interface__INa__m * var_chaste_interface__INa__m * var_chaste_interface__INa__H * var_chaste_interface__INa__J) * (var_chaste_interface__cell__V - var_reversal_potentials__ENa); // uA_per_uF
        const double var_reversal_potentials__EK = log(NV_Ith_S(mParameters, 2) / var_chaste_interface__K__K_i) * 26.712338705500134; // mV
        const double var_IK1__ak1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) - 59.215000000000003))); // per_ms
        const double var_IK1__IK1 = ((NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 2) * 0.25) * var_IK1__ak1) / (var_IK1__ak1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) + 5.476))) + (1.0 * exp(0.061749999999999999 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) - 594.30999999999995)))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__cell__V - var_reversal_potentials__EK) + 4.7530000000000001)))))) * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKp__IKp = (NV_Ith_S(mParameters, 13) * (var_chaste_interface__cell__V - var_reversal_potentials__EK)) / _lt_0_row[8]; // uA_per_uF
        const double var_IKs__IKs = (NV_Ith_S(mParameters, 15) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__Ca__Ca_i, 1.3999999999999999))))) * var_chaste_interface__IKs__xs1 * var_chaste_interface__IKs__xs2 * (var_chaste_interface__cell__V - (log((NV_Ith_S(mParameters, 2) + (0.018329999999999999 * NV_Ith_S(mParameters, 3))) / (var_chaste_interface__K__K_i + (0.018329999999999999 * var_chaste_interface__Na__Na_i))) * 26.712338705500134)); // uA_per_uF
        const double var_IKr__IKr = (NV_Ith_S(mParameters, 14) * sqrt(NV_Ith_S(mParameters, 2) * 0.25)) * var_chaste_interface__IKr__xr * _lt_0_row[2] * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 8) * var_chaste_interface__Ca__Ca_i) / (0.00050000000000000001 + var_chaste_interface__Ca__Ca_i); // uA_per_uF
        const double var_ICab__ICab = (NV_Ith_S(mParameters, 6) * var_chaste_interface__cell__V * ((var_chaste_interface__Ca__Ca_i * _lt_0_row[9]) - (0.34100000000000003 * NV_Ith_S(mParameters, 0))) * 3612.001220250083) / _lt_0_row[10]; // uA_per_uF
        const double var_INaCa__ca_i_NaCa = 1.5 * var_chaste_interface__Ca__Ca_i; // mM
        const double var_INaCa__INaCa = (NV_Ith_S(mParameters, 16) * (1.0 / (1.0 + pow(0.000125 / var_INaCa__ca_i_NaCa, 2.0))) * ((pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 0) * _lt_0_row[5]) - (pow(NV_Ith_S(mParameters, 3), 3.0) * var_INaCa__ca_i_NaCa * _lt_0_row[6]))) / (_lt_0_row[7] * (((1.3 * pow(var_chaste_interface__Na__Na_i, 3.0)) + (669921.875 * var_INaCa__ca_i_NaCa) + (1860.8670000000004 * NV_Ith_S(mParameters, 0) * (1.0 + (var_INaCa__ca_i_NaCa * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 3), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_i * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 0)) + (pow(NV_Ith_S(mParameters, 3), 3.0) * var_INaCa__ca_i_NaCa)))); // uA_per_uF
        const double var_INaK__INaK = (((NV_Ith_S(mParameters, 17) * (1.0 / (1.0 + _lt_0_row[3] + (0.036499999999999998 * ((exp(NV_Ith_S(mParameters, 3) * 0.01485884101040119) - 1.0) * 0.14285714285714285) * _lt_0_row[4]))) * 1.0) / (1.0 + pow(10.0 / var_chaste_interface__Na__Na_i, 2.0))) * NV_Ith_S(mParameters, 2)) / (NV_Ith_S(mParameters, 2) + 1.5); // uA_per_uF
        const double var_Ito__Ito = NV_Ith_S(mParameters, 19) * pow(var_chaste_interface__Ito__ydv, 3.0) * var_chaste_interface__Ito__ydv2 * var_chaste_interface__Ito__zdv * ((var_chaste_interface__cell__V <= 0.0) ? exp(var_chaste_interface__cell__V / NV_Ith_S(mParameters, 20)) : 1.0) * (var_chaste_interface__cell__V - var_reversal_potentials__EK); // uA_per_uF
        const double var_Ito2__Ito2 = ((NV_Ith_S(mParameters, 18) * var_chaste_interface__cell__V * (var_chaste_interface__Cl__Cl_i - (NV_Ith_S(mParameters, 1) * _lt_0_row[11])) * 3612.001220250083) / _lt_0_row[12]) * var_chaste_interface__Ito2__AA; // uA_per_uF
        const double var_reversal_potentials__ECl = (-log(NV_Ith_S(mParameters, 1) / var_chaste_interface__Cl__Cl_i)) * 26.712338705500134; // mV
        const double var_IClb__IClb = NV_Ith_S(mParameters, 7) * (var_chaste_interface__cell__V - var_reversal_potentials__ECl); // uA_per_uF
        const double var_INal__INal = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__INal__mL, 3.0) * var_chaste_interface__INal__hL * (var_chaste_interface__cell__V - var_reversal_potentials__ENa); // uA_per_uF
        const double var_chaste_interface__cell__i_Stim = GetIntracellularAreaStimulus(var_chaste_interface__Environment__time);
        const double var_cell__Acap = 0.00015343538520132551; // uF
        // Special handling of data clamp current here (see #2708)
        // (we want to save expense of calling the interpolation method if possible.)
        double var_chaste_interface__membrane_data_clamp_current = 0.0;
        if (mDataClampIsOn)
        {
            var_chaste_interface__membrane_data_clamp_current = NV_Ith_S(mParameters, 9) * (var_chaste_interface__cell__V - GetExperimentalVoltageAtTimeT(var_chaste_interface__Environment__time)); // uA_per_cm2
        }
        
        N_Vector dqs = N_VNew_Serial(17);
        NV_Ith_S(dqs, 0) = var_ICab__ICab;
        NV_Ith_S(dqs, 1) = var_IClb__IClb;
        NV_Ith_S(dqs, 2) = var_IpCa__IpCa;
        NV_Ith_S(dqs, 3) = var_cell__Acap;
        NV_Ith_S(dqs, 4) = var_chaste_interface__membrane_data_clamp_current;
        NV_Ith_S(dqs, 5) = var_INa__INa;
        NV_Ith_S(dqs, 6) = var_IK1__IK1;
        NV_Ith_S(dqs, 7) = var_INal__INal;
        NV_Ith_S(dqs, 8) = var_IKp__IKp;
        NV_Ith_S(dqs, 9) = var_IKr__IKr;
        NV_Ith_S(dqs, 10) = var_IKs__IKs;
        NV_Ith_S(dqs, 11) = var_INaCa__INaCa;
        NV_Ith_S(dqs, 12) = var_INaK__INaK;
        NV_Ith_S(dqs, 13) = var_chaste_interface__cell__i_Stim;
        NV_Ith_S(dqs, 14) = var_Ito2__Ito2;
        NV_Ith_S(dqs, 15) = var_Ito__Ito;
        NV_Ith_S(dqs, 16) = var_chaste_interface__Environment__time;
        return dqs;
    }
    
template<>
void OdeSystemInformation<Celldavies_isap_2012FromCellMLCvodeDataClampOpt>::Initialise(void)
{
    this->mSystemName = "davies_isap_2012";
    this->mFreeVariableName = "time";
    this->mFreeVariableUnits = "millisecond";
    
    this->mVariableNames.push_back("membrane_voltage");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-93.2932771154856);

    this->mVariableNames.push_back("INa__H");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.99765453819431);

    this->mVariableNames.push_back("INa__m");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000382187369845771);

    this->mVariableNames.push_back("INa__J");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.998157020148849);

    this->mVariableNames.push_back("ICaL__d");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(5.38067794749339e-7);

    this->mVariableNames.push_back("ICaL__dp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(8.99805432294836);

    this->mVariableNames.push_back("ICaL__f");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.999986839648304);

    this->mVariableNames.push_back("ICaL__fca");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.961568137796573);

    this->mVariableNames.push_back("ICaL__fca2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.854261813196152);

    this->mVariableNames.push_back("ICaL__f2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.989081601403786);

    this->mVariableNames.push_back("IKr__xr");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.255981702631947);

    this->mVariableNames.push_back("IKs__xs1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0147449166757808);

    this->mVariableNames.push_back("IKs__xs2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0147504787196957);

    this->mVariableNames.push_back("Ito__ydv");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.00894974857468432);

    this->mVariableNames.push_back("Ito__ydv2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.999992183094244);

    this->mVariableNames.push_back("Ito__zdv");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.787996527242362);

    this->mVariableNames.push_back("Ito2__AA");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0014969201082975);

    this->mVariableNames.push_back("INal__mL");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000382187369845771);

    this->mVariableNames.push_back("INal__hL");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.488129650338831);

    this->mVariableNames.push_back("Irel__CaMKtrap");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0971591072782679);

    this->mVariableNames.push_back("Irel__ro");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(-1.07543858779373e-32);

    this->mVariableNames.push_back("Irel__ri");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.716604593002322);

    this->mVariableNames.push_back("cytosolic_sodium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(17.9964119779802);

    this->mVariableNames.push_back("cytosolic_potassium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(134.555737634453);

    this->mVariableNames.push_back("Cl__Cl_i");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(20.1543792471096);

    this->mVariableNames.push_back("cytosolic_calcium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(0.000223768331231758);

    this->mVariableNames.push_back("JSR_calcium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(4.1270622547589);

    this->mVariableNames.push_back("NSR_calcium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(4.14835141174613);

    this->mVariableNames.push_back("dyadic_space_calcium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(0.000225131045297696);

    this->mParameterNames.push_back("extracellular_calcium_concentration");
    this->mParameterUnits.push_back("mM");
    
    this->mParameterNames.push_back("extracellular_chloride_concentration");
    this->mParameterUnits.push_back("mM");
    
    this->mParameterNames.push_back("extracellular_potassium_concentration");
    this->mParameterUnits.push_back("mM");
    
    this->mParameterNames.push_back("extracellular_sodium_concentration");
    this->mParameterUnits.push_back("mM");
    
    this->mParameterNames.push_back("membrane_L_type_calcium_current_conductance");
    this->mParameterUnits.push_back("L_per_F_ms");
    
    this->mParameterNames.push_back("membrane_L_type_calcium_current_d_gate_power_tau");
    this->mParameterUnits.push_back("ms");
    
    this->mParameterNames.push_back("membrane_background_calcium_current_conductance");
    this->mParameterUnits.push_back("L_per_F_ms");
    
    this->mParameterNames.push_back("membrane_background_chloride_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_calcium_pump_current_conductance");
    this->mParameterUnits.push_back("uA_per_uF");
    
    this->mParameterNames.push_back("membrane_data_clamp_current_conductance");
    this->mParameterUnits.push_back("___units_67");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_inward_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_persistent_sodium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_potassium_pump_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_rapid_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_slow_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_sodium_calcium_exchanger_current_conductance");
    this->mParameterUnits.push_back("uA_per_uF");
    
    this->mParameterNames.push_back("membrane_sodium_potassium_pump_current_permeability");
    this->mParameterUnits.push_back("uA_per_uF");
    
    this->mParameterNames.push_back("membrane_transient_outward_chloride_current_conductance");
    this->mParameterUnits.push_back("L_per_F_ms");
    
    this->mParameterNames.push_back("membrane_transient_outward_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_transient_outward_current_time_independent_rectification_gate_constant");
    this->mParameterUnits.push_back("mV");
    
    this->mDerivedQuantityNames.push_back("membrane_background_calcium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_chloride_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_calcium_pump_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_capacitance");
    this->mDerivedQuantityUnits.push_back("uF");
    
    this->mDerivedQuantityNames.push_back("membrane_data_clamp_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_inward_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_persistent_sodium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_potassium_pump_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_rapid_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_slow_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_calcium_exchanger_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_potassium_pump_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_stimulus_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_transient_outward_chloride_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_transient_outward_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("time");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mInitialised = true;
}


// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Celldavies_isap_2012FromCellMLCvodeDataClampOpt)
#endif // CHASTE_CVODE
