#ifdef CHASTE_CVODE
#ifndef CELLDAVIES_ISAP_2012FROMCELLMLCVODEDATACLAMPOPT_HPP_
#define CELLDAVIES_ISAP_2012FROMCELLMLCVODEDATACLAMPOPT_HPP_

//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: davies_isap_2012
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24914, pycml: 24885, optimize: 23343)
//! on Wed Aug  5 12:28:35 2015
//! 
//! <autogenerated>

#include "ChasteSerialization.hpp"
#include <boost/serialization/base_object.hpp>
#include "AbstractCvodeCellWithDataClamp.hpp"
#include "AbstractStimulusFunction.hpp"

class Celldavies_isap_2012FromCellMLCvodeDataClampOpt : public AbstractCvodeCellWithDataClamp
{
    friend class boost::serialization::access;
    template<class Archive>
    void serialize(Archive & archive, const unsigned int version)
    {
        archive & boost::serialization::base_object<AbstractCvodeCellWithDataClamp >(*this);
    }
    
    // 
    // Settable parameters and readable variables
    // 
    
public:
    boost::shared_ptr<RegularStimulus> UseCellMLDefaultStimulus();
    double GetIntracellularCalciumConcentration();
    Celldavies_isap_2012FromCellMLCvodeDataClampOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus);
    ~Celldavies_isap_2012FromCellMLCvodeDataClampOpt();
    AbstractLookupTableCollection* GetLookupTableCollection();
    double GetIIonic(const std::vector<double>* pStateVariables=NULL);
    void EvaluateYDerivatives(double var_chaste_interface__Environment__time, const N_Vector rY, N_Vector rDY);
    N_Vector ComputeDerivedQuantities(double var_chaste_interface__Environment__time, const N_Vector & rY);
};


// Needs to be included last
#include "SerializationExportWrapper.hpp"
CHASTE_CLASS_EXPORT(Celldavies_isap_2012FromCellMLCvodeDataClampOpt)

namespace boost
{
    namespace serialization
    {
        template<class Archive>
        inline void save_construct_data(
            Archive & ar, const Celldavies_isap_2012FromCellMLCvodeDataClampOpt * t, const unsigned int fileVersion)
        {
            const boost::shared_ptr<AbstractIvpOdeSolver> p_solver = t->GetSolver();
            const boost::shared_ptr<AbstractStimulusFunction> p_stimulus = t->GetStimulusFunction();
            ar << p_solver;
            ar << p_stimulus;
        }
        
        template<class Archive>
        inline void load_construct_data(
            Archive & ar, Celldavies_isap_2012FromCellMLCvodeDataClampOpt * t, const unsigned int fileVersion)
        {
            boost::shared_ptr<AbstractIvpOdeSolver> p_solver;
            boost::shared_ptr<AbstractStimulusFunction> p_stimulus;
            ar >> p_solver;
            ar >> p_stimulus;
            ::new(t)Celldavies_isap_2012FromCellMLCvodeDataClampOpt(p_solver, p_stimulus);
        }
        
    }
    
}

#endif // CELLDAVIES_ISAP_2012FROMCELLMLCVODEDATACLAMPOPT_HPP_
#endif // CHASTE_CVODE
