#ifdef CHASTE_CVODE
//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: luo_rudy_1991
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24172, pycml: 23797, optimize: 23343)
//! on Fri May 29 17:44:47 2015
//! 
//! <autogenerated>

#include "luo_rudy_1991_data_clampCvodeOpt.hpp"
#include <cmath>
#include <cassert>
#include <memory>
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"
#include "RegularStimulus.hpp"
#include "HeartConfig.hpp"
#include "IsNan.hpp"
#include "MathsCustomFunctions.hpp"

class Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables : public AbstractLookupTableCollection
{
public:
    static Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables* Instance()
    {
        if (mpInstance.get() == NULL)
        {
            mpInstance.reset(new Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables);
        }
        return mpInstance.get();
    }
    
    void FreeMemory()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
        mNeedsRegeneration.assign(mNeedsRegeneration.size(), true);
    }
    
    // Row lookup methods
    // using linear-interpolation
    double* _lookup_0_row(unsigned i, double _factor_)
    {
        for (unsigned j=0; j<42; j++)
        {
            const double y1 = _lookup_table_0[i][j];
            const double y2 = _lookup_table_0[i+1][j];
            _lookup_table_0_row[j] = y1 + (y2-y1)*_factor_;
        }
        return _lookup_table_0_row;
    }
    
    
    const double * IndexTable0(double var_chaste_interface__membrane__V)
    {
        const double _offset_0 = var_chaste_interface__membrane__V - mTableMins[0];
        const double _offset_0_over_table_step = _offset_0 * mTableStepInverses[0];
        const unsigned _table_index_0 = (unsigned)(_offset_0_over_table_step);
        const double _factor_0 = _offset_0_over_table_step - _table_index_0;
        const double* const _lt_0_row = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->_lookup_0_row(_table_index_0, _factor_0);
        return _lt_0_row;
    }
    
#define COVERAGE_IGNORE
    bool CheckIndex0(double& var_chaste_interface__membrane__V)
    {
        bool _oob_0 = false;
        if (var_chaste_interface__membrane__V>mTableMaxs[0] || var_chaste_interface__membrane__V<mTableMins[0])
        {
#define COVERAGE_IGNORE
            _oob_0 = true;
#undef COVERAGE_IGNORE
        }
        return _oob_0;
    }
#undef COVERAGE_IGNORE

    ~Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
    }
    
protected:
    Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables(const Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables& operator= (const Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        assert(mpInstance.get() == NULL);
        mKeyingVariableNames.resize(1);
        mNumberOfTables.resize(1);
        mTableMins.resize(1);
        mTableSteps.resize(1);
        mTableStepInverses.resize(1);
        mTableMaxs.resize(1);
        mNeedsRegeneration.resize(1);
        mKeyingVariableNames[0] = "membrane_voltage";
        mNumberOfTables[0] = 42;
        mTableMins[0] = -120.0001;
        mTableSteps[0] = 0.001;
        mTableStepInverses[0] = 1000.0;
        mTableMaxs[0] = 99.9999;
        mNeedsRegeneration[0] = true;
        _lookup_table_0 = NULL;
        Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::RegenerateTables();
    }
    
    void RegenerateTables()
    {
        AbstractLookupTableCollection::EventHandler::BeginEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
        if (mNeedsRegeneration[0])
        {
            if (_lookup_table_0)
            {
                delete[] _lookup_table_0;
                _lookup_table_0 = NULL;
            }
            const unsigned _table_size_0 = 1 + (unsigned)((mTableMaxs[0]-mTableMins[0])/mTableSteps[0]+0.5);
            _lookup_table_0 = new double[_table_size_0][42];
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][0] = (( -0.32000000000000001 * (var_chaste_interface__membrane__V + 47.130000000000003)) * (1.0 / (1.0 - exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7130000000000001)))) - (0.080000000000000002 * exp( -0.090909090909090912 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][1] = 0.32000000000000001 * (1.0 / (1.0 - exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7130000000000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][2] = (0.032000000000000001 * (var_chaste_interface__membrane__V + 47.130000000000003)) / pow(1.0 - exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7130000000000001), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][3] = exp((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 4.7130000000000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][4] = 0.0072727272729999999 * exp( -0.090909090909090912 * var_chaste_interface__membrane__V);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][5] = (var_chaste_interface__membrane__V <=  -100.0) ? 0.0 : ( -100.0 < var_chaste_interface__membrane__V) ? (((((0.11348 * exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.0800000000000001)) * (1.0 / (var_chaste_interface__membrane__V + 77.0))) * (1.0 / exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 1.3999999999999999))) - (((2.8370000000000002 * (exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.0800000000000001) - 1.0)) / pow(var_chaste_interface__membrane__V + 77.0, 2.0)) * (1.0 / exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 1.3999999999999999)))) - (((0.11348 * (exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.0800000000000001) - 1.0)) * (1.0 / (var_chaste_interface__membrane__V + 77.0))) * (1.0 / exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 1.3999999999999999)))) : NAN;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][6] = ( -100.0 < var_chaste_interface__membrane__V) ? (((2.8370000000000002 * (exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 3.0800000000000001) - 1.0)) / (var_chaste_interface__membrane__V + 77.0)) / exp((0.040000000000000001 * var_chaste_interface__membrane__V) + 1.3999999999999999)) : 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][7] = pow(1.0 + exp(1.252173913 - (0.16722408029999999 * var_chaste_interface__membrane__V)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][8] = exp(1.252173913 - (0.16722408029999999 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][9] = 1.0 + exp(1.252173913 - (0.16722408029999999 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][10] =  -0.00095 * (exp(( -0.01 * var_chaste_interface__membrane__V) + 0.050000000000000003) / (1.0 + exp(( -0.071999999999999995 * var_chaste_interface__membrane__V) + 0.35999999999999999)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][11] = (0.0068399999999999997 * exp(( -0.01 * var_chaste_interface__membrane__V) + 0.050000000000000003)) / pow(1.0 + exp(( -0.071999999999999995 * var_chaste_interface__membrane__V) + 0.35999999999999999), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][12] = exp(( -0.071999999999999995 * var_chaste_interface__membrane__V) + 0.35999999999999999);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][13] = 0.0011900000000000001 * (exp(( -0.017000000000000001 * var_chaste_interface__membrane__V) - 0.748) / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][14] = (0.0035000000000000001 * exp(( -0.017000000000000001 * var_chaste_interface__membrane__V) - 0.748)) / pow(1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][15] = exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][16] = ( -0.095000000000000001 * (exp(( -0.01 * var_chaste_interface__membrane__V) + 0.050000000000000003) / (1.0 + exp(( -0.071999999999999995 * var_chaste_interface__membrane__V) + 0.35999999999999999)))) - (0.070000000000000007 * (exp(( -0.017000000000000001 * var_chaste_interface__membrane__V) - 0.748) / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) + 2.2000000000000002))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][17] =  -9.6000000000000002e-05 * (exp(( -0.0080000000000000002 * var_chaste_interface__membrane__V) - 0.224) / (1.0 + exp((0.14999999999999999 * var_chaste_interface__membrane__V) + 4.2000000000000002)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][18] = (0.0018 * exp(( -0.0080000000000000002 * var_chaste_interface__membrane__V) - 0.224)) / pow(1.0 + exp((0.14999999999999999 * var_chaste_interface__membrane__V) + 4.2000000000000002), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][19] = exp((0.14999999999999999 * var_chaste_interface__membrane__V) + 4.2000000000000002);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][20] = 0.00012999999999999999 * (exp(( -0.02 * var_chaste_interface__membrane__V) - 0.59999999999999998) / (1.0 + exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][21] = (0.0012999999999999999 * exp(( -0.02 * var_chaste_interface__membrane__V) - 0.59999999999999998)) / pow(1.0 + exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][22] = exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][23] = ( -0.012 * (exp(( -0.0080000000000000002 * var_chaste_interface__membrane__V) - 0.224) / (1.0 + exp((0.14999999999999999 * var_chaste_interface__membrane__V) + 4.2000000000000002)))) - (0.0064999999999999997 * (exp(( -0.02 * var_chaste_interface__membrane__V) - 0.59999999999999998) / (1.0 + exp(( -0.20000000000000001 * var_chaste_interface__membrane__V) - 6.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][24] = 4.1499999999999999e-05 * (exp((0.083000000000000004 * var_chaste_interface__membrane__V) + 4.1500000000000004) / (1.0 + exp((0.057000000000000002 * var_chaste_interface__membrane__V) + 2.8500000000000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][25] = (2.8500000000000002e-05 * exp((0.083000000000000004 * var_chaste_interface__membrane__V) + 4.1500000000000004)) / pow(1.0 + exp((0.057000000000000002 * var_chaste_interface__membrane__V) + 2.8500000000000001), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][26] = exp((0.057000000000000002 * var_chaste_interface__membrane__V) + 2.8500000000000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][27] = 7.7999999999999999e-05 * (exp(( -0.059999999999999998 * var_chaste_interface__membrane__V) - 1.2) / (1.0 + exp((-(0.040000000000000001 * var_chaste_interface__membrane__V)) - 0.80000000000000004)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][28] = (5.1999999999999997e-05 * exp(( -0.059999999999999998 * var_chaste_interface__membrane__V) - 1.2)) / pow(1.0 + exp((-(0.040000000000000001 * var_chaste_interface__membrane__V)) - 0.80000000000000004), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][29] = exp((-(0.040000000000000001 * var_chaste_interface__membrane__V)) - 0.80000000000000004);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][30] = ( -0.00050000000000000001 * (exp((0.083000000000000004 * var_chaste_interface__membrane__V) + 4.1500000000000004) / (1.0 + exp((0.057000000000000002 * var_chaste_interface__membrane__V) + 2.8500000000000001)))) - (0.0012999999999999999 * (exp(( -0.059999999999999998 * var_chaste_interface__membrane__V) - 1.2) / (1.0 + exp((-(0.040000000000000001 * var_chaste_interface__membrane__V)) - 0.80000000000000004))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][31] = 1.0 / (((0.012 * exp( -0.0080000000000000002 * (var_chaste_interface__membrane__V + 28.0))) / (1.0 + exp(0.14999999999999999 * (var_chaste_interface__membrane__V + 28.0)))) + ((0.0064999999999999997 * exp( -0.02 * (var_chaste_interface__membrane__V + 30.0))) / (1.0 + exp( -0.20000000000000001 * (var_chaste_interface__membrane__V + 30.0)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][32] = (var_chaste_interface__membrane__V >  -100.0) ? ((2.8370000000000002 * (exp(0.040000000000000001 * (var_chaste_interface__membrane__V + 77.0)) - 1.0)) / ((var_chaste_interface__membrane__V + 77.0) * exp(0.040000000000000001 * (var_chaste_interface__membrane__V + 35.0)))) : 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][33] = 1.0 / (1.0 + exp((7.4880000000000004 - var_chaste_interface__membrane__V) * 0.16722408026755853));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][34] = (0.32000000000000001 * (var_chaste_interface__membrane__V + 47.130000000000003)) / (1.0 - exp( -0.10000000000000001 * (var_chaste_interface__membrane__V + 47.130000000000003)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][35] = 0.080000000000000002 * exp((-var_chaste_interface__membrane__V) * 0.090909090909090912);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][36] = (0.095000000000000001 * exp( -0.01 * (var_chaste_interface__membrane__V - 5.0))) / (1.0 + exp( -0.071999999999999995 * (var_chaste_interface__membrane__V - 5.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][37] = (0.070000000000000007 * exp( -0.017000000000000001 * (var_chaste_interface__membrane__V + 44.0))) / (1.0 + exp(0.050000000000000003 * (var_chaste_interface__membrane__V + 44.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][38] = (0.012 * exp( -0.0080000000000000002 * (var_chaste_interface__membrane__V + 28.0))) / (1.0 + exp(0.14999999999999999 * (var_chaste_interface__membrane__V + 28.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][39] = (0.0064999999999999997 * exp( -0.02 * (var_chaste_interface__membrane__V + 30.0))) / (1.0 + exp( -0.20000000000000001 * (var_chaste_interface__membrane__V + 30.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][40] = (0.00050000000000000001 * exp(0.083000000000000004 * (var_chaste_interface__membrane__V + 50.0))) / (1.0 + exp(0.057000000000000002 * (var_chaste_interface__membrane__V + 50.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][41] = (0.0012999999999999999 * exp( -0.059999999999999998 * (var_chaste_interface__membrane__V + 20.0))) / (1.0 + exp( -0.040000000000000001 * (var_chaste_interface__membrane__V + 20.0)));
            }
            
            mNeedsRegeneration[0] = false;
        }
        
        AbstractLookupTableCollection::EventHandler::EndEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
    }
    
private:
    /** The single instance of the class */
    static std::auto_ptr<Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables> mpInstance;

    // Row lookup methods memory
    double _lookup_table_0_row[42];
    
    // Lookup tables
    double (*_lookup_table_0)[42];
    
};

std::auto_ptr<Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables> Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::mpInstance;

    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__intracellular_calcium_concentration__Cai()
    {
        return var_chaste_interface__intracellular_calcium_concentration__Cai;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__fake_dt()
    {
        return var_chaste_interface__environment__fake_dt;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__i_ionic()
    {
        return var_chaste_interface__i_ionic;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__background_current__i_b()
    {
        return var_chaste_interface__background_current__i_b;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_inward_current__i_si()
    {
        return var_chaste_interface__slow_inward_current__i_si;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_inward_current_d_gate__d()
    {
        return var_chaste_interface__slow_inward_current_d_gate__d;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_inward_current_f_gate__f()
    {
        return var_chaste_interface__slow_inward_current_f_gate__f;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_slow_inward_current_f_gate__tau_f()
    {
        return var_slow_inward_current_f_gate__tau_f;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__time_dependent_potassium_current__i_K()
    {
        return var_chaste_interface__time_dependent_potassium_current__i_K;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current__i_Na()
    {
        return var_chaste_interface__fast_sodium_current__i_Na;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current_h_gate__h()
    {
        return var_chaste_interface__fast_sodium_current_h_gate__h;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_fast_sodium_current_h_gate__tau_h()
    {
        return var_fast_sodium_current_h_gate__tau_h;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current_j_gate__j()
    {
        return var_chaste_interface__fast_sodium_current_j_gate__j;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_fast_sodium_current_j_gate__tau_j()
    {
        return var_fast_sodium_current_j_gate__tau_j;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current_m_gate__m()
    {
        return var_chaste_interface__fast_sodium_current_m_gate__m;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__time_independent_potassium_current__i_K1()
    {
        return var_chaste_interface__time_independent_potassium_current__i_K1;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__plateau_potassium_current__i_Kp()
    {
        return var_chaste_interface__plateau_potassium_current__i_Kp;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__I_stim()
    {
        return var_chaste_interface__membrane__I_stim;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_amplitude()
    {
        return var_chaste_interface__membrane__stim_amplitude;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_duration()
    {
        return var_chaste_interface__membrane__stim_duration;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_end()
    {
        return var_chaste_interface__membrane__stim_end;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_start()
    {
        return var_chaste_interface__membrane__stim_start;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_period()
    {
        return var_chaste_interface__membrane__stim_period;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__V()
    {
        return var_chaste_interface__membrane__V;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__time()
    {
        return var_chaste_interface__environment__time;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_cytosolic_potassium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 0);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_cytosolic_sodium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 1);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_extracellular_potassium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 2);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_extracellular_sodium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 3);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_leakage_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 4);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_L_type_calcium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 5);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_capacitance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 6);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_delayed_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 7);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 8);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_reduced_inactivation_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 9);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_shift_inactivation_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 10);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_inward_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 11);
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_plateau_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 12);
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_data_clamp_current_conductance_constant() // RJ
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 13);
    }

    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_amplitude_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_amplitude =  -25.5; // uA_per_cm2
        return var_chaste_interface__membrane__stim_amplitude;
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_duration_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_duration = 2.0; // millisecond
        return var_chaste_interface__membrane__stim_duration;
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_end_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_end = 100000000000.0; // millisecond
        return var_chaste_interface__membrane__stim_end;
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_offset_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_start = 100.0; // millisecond
        return var_chaste_interface__membrane__stim_start;
    }
    
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_period_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_period = 1000.0; // millisecond
        return var_chaste_interface__membrane__stim_period;
    }
    
    
    boost::shared_ptr<RegularStimulus> Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::UseCellMLDefaultStimulus()
    {
        // Use the default stimulus specified by CellML metadata
        var_chaste_interface__membrane__stim_start = 100.0; // millisecond
        var_chaste_interface__membrane__stim_end = 100000000000.0; // millisecond
        var_chaste_interface__membrane__stim_period = 1000.0; // millisecond
        var_chaste_interface__membrane__stim_duration = 2.0; // millisecond
        var_chaste_interface__membrane__stim_amplitude =  -25.5; // uA_per_cm2
        boost::shared_ptr<RegularStimulus> p_cellml_stim(new RegularStimulus(
                -fabs(var_chaste_interface__membrane__stim_amplitude),
                var_chaste_interface__membrane__stim_duration,
                var_chaste_interface__membrane__stim_period,
                var_chaste_interface__membrane__stim_start
              , var_chaste_interface__membrane__stim_end
                ));
        mpIntracellularStimulus = p_cellml_stim;
        return p_cellml_stim;
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::GetIntracellularCalciumConcentration()
    {
        return NV_Ith_S(mStateVariables, 7);
    }
    
    Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
        : AbstractCvodeCellWithDataClamp(
                pOdeSolver,
                8,
                0,
                pIntracellularStimulus)
    {
        // Time units: millisecond
        // 
        this->mpSystemInfo = OdeSystemInformation<Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt>::Instance();
        Init();

        // We have a default stimulus specified in the CellML file metadata
        this->mHasDefaultStimulusFromCellML = true;
        NV_Ith_S(this->mParameters, 0) = 145; // (c,ionic_concentrations__Ki) [millimolar]
        NV_Ith_S(this->mParameters, 1) = 18; // (c,ionic_concentrations__Nai) [millimolar]
        NV_Ith_S(this->mParameters, 2) = 5.4; // (c,ionic_concentrations__Ko) [millimolar]
        NV_Ith_S(this->mParameters, 3) = 140; // (c,ionic_concentrations__Nao) [millimolar]
        NV_Ith_S(this->mParameters, 4) = 0.03921; // (c,background_current__g_b) [milliS_per_cm2]
        NV_Ith_S(this->mParameters, 5) = 0.09; // (c,slow_inward_current__P_si) [milliS_per_cm2]
        NV_Ith_S(this->mParameters, 6) = 1; // (c,membrane__C) [microF_per_cm2]
        NV_Ith_S(this->mParameters, 7) = 0.282; // (c,time_dependent_potassium_current__g_K_max) [milliS_per_cm2]
        NV_Ith_S(this->mParameters, 8) = 23; // (c,fast_sodium_current__g_Na) [milliS_per_cm2]
        NV_Ith_S(this->mParameters, 9) = 0; // (c,fast_sodium_current__perc_reduced_inact_for_IpNa) [dimensionless]
        NV_Ith_S(this->mParameters, 10) = 0; // (c,fast_sodium_current__shift_INa_inact) [millivolt]
        NV_Ith_S(this->mParameters, 11) = 0.6047; // (c,time_independent_potassium_current__g_K1_max) [milliS_per_cm2]
        NV_Ith_S(this->mParameters, 12) = 0.0183; // (c,plateau_potassium_current__g_Kp) [milliS_per_cm2]

        NV_Ith_S(this->mParameters, 13) = 0; // (c,data_clamp_current__g_data) [mS_per_mm2] RJ - start at 0 to generate data

        mUseAnalyticJacobian = true;
        mHasAnalyticJacobian = true;
    }
    
    Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::~Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt()
    {
    }
    
    AbstractLookupTableCollection* Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::GetLookupTableCollection()
    {
        return Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance();
    }
    
    double Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::GetIIonic(const std::vector<double>* pStateVariables)
    {
        // For state variable interpolation (SVI) we read in interpolated state variables,
        // otherwise for ionic current interpolation (ICI) we use the state variables of this model (node).
        N_Vector rY;
        bool made_new_cvode_vector = false;
        if (!pStateVariables)
        {
            rY = rGetStateVariables();
        }
        else
        {
            made_new_cvode_vector = true;
            rY = MakeNVector(*pStateVariables);
        }
        
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -83.853
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.00187018
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.9804713
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.98767124
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0.00316354
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.99427859
        double var_chaste_interface__time_dependent_potassium_current_X_gate__X = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.16647703
        double var_chaste_interface__intracellular_calcium_concentration__Cai = NV_Ith_S(rY, 7);
        // Units: millimolar; Initial value: 0.0002
        
        // Lookup table indexing
        const bool _oob_0 = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        const double var_fast_sodium_current__i_Na = NV_Ith_S(mParameters, 8) * pow(var_chaste_interface__fast_sodium_current_m_gate__m, 3.0) * var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j * (var_chaste_interface__membrane__V - (26.712449447891164 * log(NV_Ith_S(mParameters, 3) / NV_Ith_S(mParameters, 1)))); // microA_per_cm2
        const double var_slow_inward_current__i_si = NV_Ith_S(mParameters, 5) * var_chaste_interface__slow_inward_current_d_gate__d * var_chaste_interface__slow_inward_current_f_gate__f * (var_chaste_interface__membrane__V - (7.7000000000000002 - (13.028700000000001 * log(var_chaste_interface__intracellular_calcium_concentration__Cai * 1.0)))); // microA_per_cm2
        const double var_time_dependent_potassium_current__i_K = (NV_Ith_S(mParameters, 7) * sqrt(NV_Ith_S(mParameters, 2) * 0.18518518518518517)) * var_chaste_interface__time_dependent_potassium_current_X_gate__X * _lt_0_row[32] * (var_chaste_interface__membrane__V - (26.712449447891164 * log((NV_Ith_S(mParameters, 2) + (0.018329999999999999 * NV_Ith_S(mParameters, 3))) / (NV_Ith_S(mParameters, 0) + (0.018329999999999999 * NV_Ith_S(mParameters, 1)))))); // microA_per_cm2
        const double var_time_independent_potassium_current__E_K1 = 26.712449447891164 * log(NV_Ith_S(mParameters, 2) / NV_Ith_S(mParameters, 0)); // millivolt
        const double var_time_independent_potassium_current_K1_gate__alpha_K1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1) - 59.215000000000003))); // per_millisecond
        const double var_time_independent_potassium_current__i_K1 = (NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 2) * 0.18518518518518517)) * (var_time_independent_potassium_current_K1_gate__alpha_K1 / (var_time_independent_potassium_current_K1_gate__alpha_K1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__membrane__V + 5.476) - var_time_independent_potassium_current__E_K1))) + (1.0 * exp(0.061749999999999999 * (var_chaste_interface__membrane__V - (var_time_independent_potassium_current__E_K1 + 594.30999999999995))))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1) + 4.7530000000000001)))))) * (var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1); // microA_per_cm2
        const double var_plateau_potassium_current__i_Kp = NV_Ith_S(mParameters, 12) * _lt_0_row[33] * (var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1); // microA_per_cm2
        const double var_background_current__i_b = NV_Ith_S(mParameters, 4) * (var_chaste_interface__membrane__V -  -59.869999999999997); // microA_per_cm2
        const double var_chaste_interface__time_dependent_potassium_current__i_K = var_time_dependent_potassium_current__i_K; // microA_per_cm2
        const double var_chaste_interface__time_independent_potassium_current__i_K1 = var_time_independent_potassium_current__i_K1; // microA_per_cm2
        const double var_chaste_interface__fast_sodium_current__i_Na = var_fast_sodium_current__i_Na; // microA_per_cm2
        const double var_chaste_interface__slow_inward_current__i_si = var_slow_inward_current__i_si; // microA_per_cm2
        const double var_chaste_interface__plateau_potassium_current__i_Kp = var_plateau_potassium_current__i_Kp; // microA_per_cm2
        const double var_chaste_interface__background_current__i_b = var_background_current__i_b; // microA_per_cm2
        var_chaste_interface__i_ionic = var_chaste_interface__fast_sodium_current__i_Na + var_chaste_interface__slow_inward_current__i_si + var_chaste_interface__time_dependent_potassium_current__i_K + var_chaste_interface__time_independent_potassium_current__i_K1 + var_chaste_interface__plateau_potassium_current__i_Kp + var_chaste_interface__background_current__i_b; // uA_per_cm2
        
        const double i_ionic = var_chaste_interface__i_ionic;
        if (made_new_cvode_vector)
        {
            DeleteVector(rY);
        }
        EXCEPT_IF_NOT(!std::isnan(i_ionic));
        return i_ionic;
    }
    
    void Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -83.853
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.00187018
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.9804713
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.98767124
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0.00316354
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.99427859
        double var_chaste_interface__time_dependent_potassium_current_X_gate__X = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.16647703
        double var_chaste_interface__intracellular_calcium_concentration__Cai = NV_Ith_S(rY, 7);
        // Units: millimolar; Initial value: 0.0002
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        // Mathematics
        double d_dt_chaste_interface__membrane__V;
        const double var_slow_inward_current__i_si = NV_Ith_S(mParameters, 5) * var_chaste_interface__slow_inward_current_d_gate__d * var_chaste_interface__slow_inward_current_f_gate__f * (var_chaste_interface__membrane__V - (7.7000000000000002 - (13.028700000000001 * log(var_chaste_interface__intracellular_calcium_concentration__Cai * 1.0)))); // microA_per_cm2
        const double var_fast_sodium_current_h_gate__beta_h = (var_chaste_interface__membrane__V <  -40.0) ? ((3.5600000000000001 * exp(0.079000000000000001 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) + (310000.0 * exp(0.34999999999999998 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10))))) : (1.0 / (0.13 * (1.0 + exp(((var_chaste_interface__membrane__V + 10.66) - NV_Ith_S(mParameters, 10)) *  -0.0900900900900901)))); // per_millisecond
        const double var_fast_sodium_current_h_gate__alpha_h = (var_chaste_interface__membrane__V <  -40.0) ? (0.13500000000000001 * exp(((80.0 + var_chaste_interface__membrane__V) - NV_Ith_S(mParameters, 10)) *  -0.14705882352941177)) : 0.0; // per_millisecond
        const double var_fast_sodium_current_h_gate__tau_h = 1.0 / (var_fast_sodium_current_h_gate__alpha_h + var_fast_sodium_current_h_gate__beta_h); // millisecond
        const double var_fast_sodium_current_j_gate__alpha_j = (var_chaste_interface__membrane__V <  -40.0) ? (((( -127140.0 * exp(0.24440000000000001 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) - (3.4740000000000003e-05 * exp( -0.043909999999999998 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10))))) * (var_chaste_interface__membrane__V + 37.780000000000001)) / (1.0 + exp(0.311 * ((var_chaste_interface__membrane__V + 79.230000000000004) - NV_Ith_S(mParameters, 10))))) : 0.0; // per_millisecond
        const double var_fast_sodium_current_j_gate__beta_j = (var_chaste_interface__membrane__V <  -40.0) ? ((0.1212 * exp( -0.01052 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) / (1.0 + exp( -0.13780000000000001 * ((var_chaste_interface__membrane__V + 40.140000000000001) - NV_Ith_S(mParameters, 10))))) : ((0.29999999999999999 * exp( -2.5349999999999999e-07 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) / (1.0 + exp( -0.10000000000000001 * ((var_chaste_interface__membrane__V + 32.0) - NV_Ith_S(mParameters, 10))))); // per_millisecond
        const double var_fast_sodium_current_j_gate__tau_j = 1.0 / (var_fast_sodium_current_j_gate__alpha_j + var_fast_sodium_current_j_gate__beta_j); // millisecond
        const double d_dt_chaste_interface__fast_sodium_current_m_gate__m = (_lt_0_row[34] * (1.0 - var_chaste_interface__fast_sodium_current_m_gate__m)) - (_lt_0_row[35] * var_chaste_interface__fast_sodium_current_m_gate__m); // per_millisecond
        const double d_dt_chaste_interface__fast_sodium_current_h_gate__h = ((((var_fast_sodium_current_h_gate__alpha_h * (1.0 - (NV_Ith_S(mParameters, 9) * 0.01))) / (var_fast_sodium_current_h_gate__alpha_h + var_fast_sodium_current_h_gate__beta_h)) + (NV_Ith_S(mParameters, 9) * 0.01)) - var_chaste_interface__fast_sodium_current_h_gate__h) / var_fast_sodium_current_h_gate__tau_h; // per_millisecond
        const double d_dt_chaste_interface__fast_sodium_current_j_gate__j = ((((var_fast_sodium_current_j_gate__alpha_j * (1.0 - (NV_Ith_S(mParameters, 9) * 0.01))) / (var_fast_sodium_current_j_gate__alpha_j + var_fast_sodium_current_j_gate__beta_j)) + (NV_Ith_S(mParameters, 9) * 0.01)) - var_chaste_interface__fast_sodium_current_j_gate__j) / var_fast_sodium_current_j_gate__tau_j; // per_millisecond
        const double d_dt_chaste_interface__slow_inward_current_d_gate__d = (_lt_0_row[36] * (1.0 - var_chaste_interface__slow_inward_current_d_gate__d)) - (_lt_0_row[37] * var_chaste_interface__slow_inward_current_d_gate__d); // per_millisecond
        const double d_dt_chaste_interface__slow_inward_current_f_gate__f = (_lt_0_row[38] * (1.0 - var_chaste_interface__slow_inward_current_f_gate__f)) - (_lt_0_row[39] * var_chaste_interface__slow_inward_current_f_gate__f); // per_millisecond
        const double d_dt_chaste_interface__time_dependent_potassium_current_X_gate__X = (_lt_0_row[40] * (1.0 - var_chaste_interface__time_dependent_potassium_current_X_gate__X)) - (_lt_0_row[41] * var_chaste_interface__time_dependent_potassium_current_X_gate__X); // per_millisecond
        const double d_dt_chaste_interface__intracellular_calcium_concentration__Cai = ( -0.0001 * var_slow_inward_current__i_si) + (0.070000000000000007 * (0.0001 - var_chaste_interface__intracellular_calcium_concentration__Cai)); // 'millimole per litre per millisecond'
        
        double var_data_clamp_current__i_data = 0; // RJ
        if (mDataClampIsOn)
        {
            double interpolated_data_voltage = GetExperimentalVoltageAtTimeT(var_chaste_interface__environment__time);
            var_data_clamp_current__i_data = NV_Ith_S(mParameters, 13) * (var_chaste_interface__membrane__V - interpolated_data_voltage);
        }

        if (mSetVoltageDerivativeToZero)
        {
            d_dt_chaste_interface__membrane__V = 0.0;
        }
        else
        {
            var_chaste_interface__membrane__I_stim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
            const double var_fast_sodium_current__i_Na = NV_Ith_S(mParameters, 8) * pow(var_chaste_interface__fast_sodium_current_m_gate__m, 3.0) * var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j * (var_chaste_interface__membrane__V - (26.712449447891164 * log(NV_Ith_S(mParameters, 3) / NV_Ith_S(mParameters, 1)))); // microA_per_cm2
            const double var_time_dependent_potassium_current__i_K = (NV_Ith_S(mParameters, 7) * sqrt(NV_Ith_S(mParameters, 2) * 0.18518518518518517)) * var_chaste_interface__time_dependent_potassium_current_X_gate__X * _lt_0_row[32] * (var_chaste_interface__membrane__V - (26.712449447891164 * log((NV_Ith_S(mParameters, 2) + (0.018329999999999999 * NV_Ith_S(mParameters, 3))) / (NV_Ith_S(mParameters, 0) + (0.018329999999999999 * NV_Ith_S(mParameters, 1)))))); // microA_per_cm2
            const double var_time_independent_potassium_current__E_K1 = 26.712449447891164 * log(NV_Ith_S(mParameters, 2) / NV_Ith_S(mParameters, 0)); // millivolt
            const double var_time_independent_potassium_current_K1_gate__alpha_K1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1) - 59.215000000000003))); // per_millisecond
            const double var_time_independent_potassium_current__i_K1 = (NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 2) * 0.18518518518518517)) * (var_time_independent_potassium_current_K1_gate__alpha_K1 / (var_time_independent_potassium_current_K1_gate__alpha_K1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__membrane__V + 5.476) - var_time_independent_potassium_current__E_K1))) + (1.0 * exp(0.061749999999999999 * (var_chaste_interface__membrane__V - (var_time_independent_potassium_current__E_K1 + 594.30999999999995))))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1) + 4.7530000000000001)))))) * (var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1); // microA_per_cm2
            const double var_plateau_potassium_current__i_Kp = NV_Ith_S(mParameters, 12) * _lt_0_row[33] * (var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1); // microA_per_cm2
            const double var_background_current__i_b = NV_Ith_S(mParameters, 4) * (var_chaste_interface__membrane__V -  -59.869999999999997); // microA_per_cm2
            d_dt_chaste_interface__membrane__V = ( -1.0 / NV_Ith_S(mParameters, 6)) * (var_chaste_interface__membrane__I_stim + var_fast_sodium_current__i_Na + var_slow_inward_current__i_si + var_time_dependent_potassium_current__i_K + var_time_independent_potassium_current__i_K1 + var_plateau_potassium_current__i_Kp + var_background_current__i_b + var_data_clamp_current__i_data); // 'millivolt per millisecond'
        }
        
        NV_Ith_S(rDY, 0) = d_dt_chaste_interface__membrane__V;
        NV_Ith_S(rDY, 1) = d_dt_chaste_interface__fast_sodium_current_m_gate__m;
        NV_Ith_S(rDY, 2) = d_dt_chaste_interface__fast_sodium_current_h_gate__h;
        NV_Ith_S(rDY, 3) = d_dt_chaste_interface__fast_sodium_current_j_gate__j;
        NV_Ith_S(rDY, 4) = d_dt_chaste_interface__slow_inward_current_d_gate__d;
        NV_Ith_S(rDY, 5) = d_dt_chaste_interface__slow_inward_current_f_gate__f;
        NV_Ith_S(rDY, 6) = d_dt_chaste_interface__time_dependent_potassium_current_X_gate__X;
        NV_Ith_S(rDY, 7) = d_dt_chaste_interface__intracellular_calcium_concentration__Cai;
    }
    
    void Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::EvaluateAnalyticJacobian(long int N, double var_chaste_interface__environment__time, N_Vector rY, N_Vector rDY, CHASTE_CVODE_DENSE_MATRIX rJacobian, N_Vector rTmp1, N_Vector rTmp2, N_Vector rTmp3)
    {
        assert(false); // RJ
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -83.853
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.00187018
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.9804713
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.98767124
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0.00316354
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.99427859
        double var_chaste_interface__time_dependent_potassium_current_X_gate__X = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.16647703
        double var_chaste_interface__intracellular_calcium_concentration__Cai = NV_Ith_S(rY, 7);
        // Units: millimolar; Initial value: 0.0002
        
        // Lookup table indexing
        const bool _oob_0 = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        var_chaste_interface__environment__fake_dt = 1.0; // millisecond
        const double var_t1 = 1.0 / NV_Ith_S(mParameters, 6); // dimensionless
        const double var_t2 = pow(var_chaste_interface__fast_sodium_current_m_gate__m, 2.0); // dimensionless
        const double var_t3 = var_t2 * var_chaste_interface__fast_sodium_current_m_gate__m; // dimensionless
        const double var_t5 = var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j; // dimensionless
        const double var_t7 = NV_Ith_S(mParameters, 5) * var_chaste_interface__slow_inward_current_d_gate__d; // dimensionless
        const double var_t8 = var_t7 * var_chaste_interface__slow_inward_current_f_gate__f; // dimensionless
        const double var_t9 = pow(NV_Ith_S(mParameters, 2), 0.5); // dimensionless
        const double var_t10 = NV_Ith_S(mParameters, 7) * var_t9; // dimensionless
        const double var_t48 = var_chaste_interface__membrane__V - (26.712449447891164 * log((NV_Ith_S(mParameters, 2) + (0.018329999999999999 * NV_Ith_S(mParameters, 3))) / (NV_Ith_S(mParameters, 0) + (0.018329999999999999 * NV_Ith_S(mParameters, 1))))); // dimensionless
        const double var_t74 = 26.712449447891164 * log(NV_Ith_S(mParameters, 2) / NV_Ith_S(mParameters, 0)); // dimensionless
        const double var_t77 = exp(((0.23849999999999999 * var_chaste_interface__membrane__V) - (0.23849999999999999 * var_t74)) - 14.1227775); // dimensionless
        const double var_t78 = 1.0 + var_t77; // dimensionless
        const double var_t80 = 1.0 / pow(var_t78, 2.0); // dimensionless
        const double var_t82 = 1.0 / var_t78; // dimensionless
        const double var_t87 = exp(((0.080320000000000003 * var_chaste_interface__membrane__V) + 0.43983232) - (0.080320000000000003 * var_t74)); // dimensionless
        const double var_t92 = exp(((0.061749999999999999 * var_chaste_interface__membrane__V) - (0.061749999999999999 * var_t74)) - 36.698642499999998); // dimensionless
        const double var_t93 = (0.49124000000000001 * var_t87) + var_t92; // dimensionless
        const double var_t97 = exp((( -0.51429999999999998 * var_chaste_interface__membrane__V) + (0.51429999999999998 * var_t74)) - 2.4444678999999998); // dimensionless
        const double var_t98 = 1.0 + var_t97; // dimensionless
        const double var_t99 = 1.0 / var_t98; // dimensionless
        const double var_t101 = (1.02 * var_t82) + (var_t93 * var_t99); // dimensionless
        const double var_t102 = 1.0 / var_t101; // dimensionless
        const double var_t103 = var_chaste_interface__membrane__V - var_t74; // dimensionless
        const double var_t108 = var_t9 * var_t82; // dimensionless
        const double var_t143 = var_t1 * NV_Ith_S(mParameters, 8); // dimensionless
        const double var_t150 = var_chaste_interface__membrane__V - (26.712449447891164 * log(NV_Ith_S(mParameters, 3) / NV_Ith_S(mParameters, 1))); // dimensionless
        const double var_t160 = var_t1 * NV_Ith_S(mParameters, 5); // dimensionless
        const double var_t163 = (var_chaste_interface__membrane__V - 7.7000000000000002) + (13.028700000000001 * log(var_chaste_interface__intracellular_calcium_concentration__Cai)); // dimensionless
        const double var_t174 = 1.0 / var_chaste_interface__intracellular_calcium_concentration__Cai; // dimensionless
        const double var_t183 = 1.0 - var_chaste_interface__fast_sodium_current_m_gate__m; // dimensionless
        const double var_t206 = exp(( -11.764705879999999 - (0.14705882349999999 * var_chaste_interface__membrane__V)) + (0.14705882349999999 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t210 = (var_chaste_interface__membrane__V <  -40.0) ? ( -0.01985294118 * var_t206) : ( -40.0 <= var_chaste_interface__membrane__V) ? 0.0 : NAN; // dimensionless
        const double var_t211 = 0.01 * NV_Ith_S(mParameters, 9); // dimensionless
        const double var_t212 = 1.0 - var_t211; // dimensionless
        const double var_t216 = (var_chaste_interface__membrane__V <  -40.0) ? (0.13500000000000001 * var_t206) : 0.0; // dimensionless
        const double var_t218 = 0.079000000000000001 * NV_Ith_S(mParameters, 10); // dimensionless
        const double var_t223 = 0.34999999999999998 * NV_Ith_S(mParameters, 10); // dimensionless
        const double var_t231 = exp((( -0.090090090090000005 * var_chaste_interface__membrane__V) - 0.96036036039999995) + (0.090090090090000005 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t236 = var_t216 + ((var_chaste_interface__membrane__V <  -40.0) ? ((3.5600000000000001 * exp((0.079000000000000001 * var_chaste_interface__membrane__V) - var_t218)) + (310000.0 * exp((0.34999999999999998 * var_chaste_interface__membrane__V) - var_t223))) : (1.0 / (0.13 + (0.13 * var_t231)))); // dimensionless
        const double var_t237 = 1.0 / var_t236; // dimensionless
        const double var_t239 = var_t216 * var_t212; // dimensionless
        const double var_t258 = var_t210 + ((var_chaste_interface__membrane__V <=  -40.0) ? ((0.28123999999999999 * exp((0.079000000000000001 * var_chaste_interface__membrane__V) - var_t218)) + (108500.0 * exp((0.34999999999999998 * var_chaste_interface__membrane__V) - var_t223))) : ( -40.0 < var_chaste_interface__membrane__V) ? ((0.011711711709999999 / pow(0.13 + (0.13 * var_t231), 2.0)) * var_t231) : NAN); // dimensionless
        const double var_t268 = 0.24440000000000001 * NV_Ith_S(mParameters, 10); // dimensionless
        const double var_t270 = exp((0.24440000000000001 * var_chaste_interface__membrane__V) - var_t268); // dimensionless
        const double var_t275 = exp((-(0.043909999999999998 * var_chaste_interface__membrane__V)) + (0.043909999999999998 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t283 = exp(((0.311 * var_chaste_interface__membrane__V) + 24.640530009999999) - (0.311 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t284 = 1.0 + var_t283; // dimensionless
        const double var_t285 = 1.0 / var_t284; // dimensionless
        const double var_t289 = ( -127140.0 * var_t270) - (3.4740000000000003e-05 * var_t275); // dimensionless
        const double var_t298 = (var_chaste_interface__membrane__V <  -40.0) ? (((((( -31073.016 * var_t270) + (1.5254334000000001e-06 * var_t275)) * (var_chaste_interface__membrane__V + 37.780000000000001)) * var_t285) + (var_t289 * var_t285)) - ((((0.311 * var_t289) * (var_chaste_interface__membrane__V + 37.780000000000001)) / pow(var_t284, 2.0)) * var_t283)) : ( -40.0 <= var_chaste_interface__membrane__V) ? 0.0 : NAN; // dimensionless
        const double var_t318 = (var_chaste_interface__membrane__V <  -40.0) ? (((( -127140.0 * exp((0.24440000000000001 * var_chaste_interface__membrane__V) - var_t268)) - (3.4740000000000003e-05 * exp((-(0.043909999999999998 * var_chaste_interface__membrane__V)) + (0.043909999999999998 * NV_Ith_S(mParameters, 10))))) * (var_chaste_interface__membrane__V + 37.780000000000001)) / (1.0 + exp(((0.311 * var_chaste_interface__membrane__V) + 24.640529999999998) - (0.311 * NV_Ith_S(mParameters, 10))))) : 0.0; // dimensionless
        const double var_t343 = var_t318 + ((var_chaste_interface__membrane__V <  -40.0) ? ((0.1212 * exp(( -0.01052 * var_chaste_interface__membrane__V) + (0.01052 * NV_Ith_S(mParameters, 10)))) / (1.0 + exp(((-(0.13780000000000001 * var_chaste_interface__membrane__V)) - 5.5312919999999997) + (0.13780000000000001 * NV_Ith_S(mParameters, 10))))) : ((0.29999999999999999 * exp(( -2.5349999999999999e-07 * var_chaste_interface__membrane__V) + (2.5349999999999999e-07 * NV_Ith_S(mParameters, 10)))) / (1.0 + exp(((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 3.2000000000000002) + (0.10000000000000001 * NV_Ith_S(mParameters, 10)))))); // dimensionless
        const double var_t344 = 1.0 / var_t343; // dimensionless
        const double var_t346 = var_t318 * var_t212; // dimensionless
        const double var_t352 = exp(( -0.01052 * var_chaste_interface__membrane__V) + (0.01052 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t355 = exp(((-(0.13780000000000001 * var_chaste_interface__membrane__V)) - 5.5312919950000001) + (0.13780000000000001 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t356 = 1.0 + var_t355; // dimensionless
        const double var_t369 = exp(( -2.5349999990000002e-07 * var_chaste_interface__membrane__V) + (2.5349999990000002e-07 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t372 = exp(((-(0.10000000000000001 * var_chaste_interface__membrane__V)) - 3.2000000000000002) + (0.10000000000000001 * NV_Ith_S(mParameters, 10))); // dimensionless
        const double var_t373 = 1.0 + var_t372; // dimensionless
        const double var_t384 = var_t298 + ((var_chaste_interface__membrane__V <=  -40.0) ? ((( -0.001275024 * var_t352) / var_t356) + (((0.016701359999999998 * var_t352) / pow(var_t356, 2.0)) * var_t355)) : ( -40.0 < var_chaste_interface__membrane__V) ? ((( -7.604999998e-08 * var_t369) / var_t373) + (((0.029999999999999999 * var_t369) / pow(var_t373, 2.0)) * var_t372)) : NAN); // dimensionless
        const double var_t402 = 1.0 - var_chaste_interface__slow_inward_current_d_gate__d; // dimensionless
        const double var_t441 = 1.0 - var_chaste_interface__slow_inward_current_f_gate__f; // dimensionless
        const double var_t480 = 1.0 - var_chaste_interface__time_dependent_potassium_current_X_gate__X; // dimensionless
        
        // Matrix entries
        DENSE_ELEM(rJacobian, 0, 0) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((-var_t1) * (((((((((((NV_Ith_S(mParameters, 8) * var_t3) * var_t5) + var_t8) + ((((0.43033148290000001 * var_t10) * var_chaste_interface__time_dependent_potassium_current_X_gate__X) * _lt_0_row[5]) * var_t48)) + (((0.43033148290000001 * var_t10) * var_chaste_interface__time_dependent_potassium_current_X_gate__X) * _lt_0_row[6])) - (((((0.063304071589999997 * var_t9) * var_t80) * var_t102) * var_t103) * var_t77)) - ((((0.26542587670000001 * var_t108) / pow(var_t101, 2.0)) * var_t103) * (((( -0.24326999999999999 * var_t80) * var_t77) + (((0.039456396800000001 * var_t87) + (0.061749999999999999 * var_t92)) * var_t99)) + (((0.51429999999999998 * var_t93) / pow(var_t98, 2.0)) * var_t97)))) + ((0.26542587670000001 * var_t108) * var_t102)) + ((((0.16722408029999999 * NV_Ith_S(mParameters, 12)) / _lt_0_row[7]) * var_t103) * _lt_0_row[8])) + (NV_Ith_S(mParameters, 12) / _lt_0_row[9])) + NV_Ith_S(mParameters, 4))));
        DENSE_ELEM(rJacobian, 1, 0) = var_chaste_interface__environment__fake_dt * (((_lt_0_row[1] * var_t183) - ((_lt_0_row[2] * var_t183) * _lt_0_row[3])) + (_lt_0_row[4] * var_chaste_interface__fast_sodium_current_m_gate__m));
        DENSE_ELEM(rJacobian, 2, 0) = var_chaste_interface__environment__fake_dt * (((((var_t210 * var_t212) * var_t237) - ((var_t239 / pow(var_t236, 2.0)) * var_t258)) * var_t236) + ((((var_t239 * var_t237) + var_t211) - var_chaste_interface__fast_sodium_current_h_gate__h) * var_t258));
        DENSE_ELEM(rJacobian, 3, 0) = var_chaste_interface__environment__fake_dt * (((((var_t298 * var_t212) * var_t344) - ((var_t346 / pow(var_t343, 2.0)) * var_t384)) * var_t343) + ((((var_t346 * var_t344) + var_t211) - var_chaste_interface__fast_sodium_current_j_gate__j) * var_t384));
        DENSE_ELEM(rJacobian, 4, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[10] * var_t402) + ((_lt_0_row[11] * var_t402) * _lt_0_row[12])) + (_lt_0_row[13] * var_chaste_interface__slow_inward_current_d_gate__d)) + ((_lt_0_row[14] * var_chaste_interface__slow_inward_current_d_gate__d) * _lt_0_row[15]));
        DENSE_ELEM(rJacobian, 5, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[17] * var_t441) - ((_lt_0_row[18] * var_t441) * _lt_0_row[19])) + (_lt_0_row[20] * var_chaste_interface__slow_inward_current_f_gate__f)) - ((_lt_0_row[21] * var_chaste_interface__slow_inward_current_f_gate__f) * _lt_0_row[22]));
        DENSE_ELEM(rJacobian, 6, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[24] * var_t480) - ((_lt_0_row[25] * var_t480) * _lt_0_row[26])) + (_lt_0_row[27] * var_chaste_interface__time_dependent_potassium_current_X_gate__X)) - ((_lt_0_row[28] * var_chaste_interface__time_dependent_potassium_current_X_gate__X) * _lt_0_row[29]));
        DENSE_ELEM(rJacobian, 7, 0) = var_chaste_interface__environment__fake_dt * ( -0.0001 * var_t8);
        DENSE_ELEM(rJacobian, 0, 1) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -3.0 * var_t143) * var_t2) * var_t5) * var_t150));
        DENSE_ELEM(rJacobian, 1, 1) = var_chaste_interface__environment__fake_dt * (_lt_0_row[0]);
        DENSE_ELEM(rJacobian, 0, 2) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((-var_t143) * var_t3) * var_chaste_interface__fast_sodium_current_j_gate__j) * var_t150));
        DENSE_ELEM(rJacobian, 2, 2) = var_chaste_interface__environment__fake_dt * (-var_t236);
        DENSE_ELEM(rJacobian, 0, 3) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((-var_t143) * var_t3) * var_chaste_interface__fast_sodium_current_h_gate__h) * var_t150));
        DENSE_ELEM(rJacobian, 3, 3) = var_chaste_interface__environment__fake_dt * (-var_t343);
        DENSE_ELEM(rJacobian, 0, 4) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((-var_t160) * var_chaste_interface__slow_inward_current_f_gate__f) * var_t163));
        DENSE_ELEM(rJacobian, 4, 4) = var_chaste_interface__environment__fake_dt * (_lt_0_row[16]);
        DENSE_ELEM(rJacobian, 7, 4) = var_chaste_interface__environment__fake_dt * ((( -0.0001 * NV_Ith_S(mParameters, 5)) * var_chaste_interface__slow_inward_current_f_gate__f) * var_t163);
        DENSE_ELEM(rJacobian, 0, 5) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((-var_t160) * var_chaste_interface__slow_inward_current_d_gate__d) * var_t163));
        DENSE_ELEM(rJacobian, 5, 5) = var_chaste_interface__environment__fake_dt * (_lt_0_row[23]);
        DENSE_ELEM(rJacobian, 7, 5) = var_chaste_interface__environment__fake_dt * (( -0.0001 * var_t7) * var_t163);
        DENSE_ELEM(rJacobian, 0, 6) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((( -0.43033148290000001 * var_t1) * NV_Ith_S(mParameters, 7)) * var_t9) * _lt_0_row[6]) * var_t48));
        DENSE_ELEM(rJacobian, 6, 6) = var_chaste_interface__environment__fake_dt * (_lt_0_row[30]);
        DENSE_ELEM(rJacobian, 0, 7) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -13.028700000000001 * var_t160) * var_chaste_interface__slow_inward_current_d_gate__d) * var_chaste_interface__slow_inward_current_f_gate__f) * var_t174));
        DENSE_ELEM(rJacobian, 7, 7) = var_chaste_interface__environment__fake_dt * (((( -0.00130287 * var_t7) * var_chaste_interface__slow_inward_current_f_gate__f) * var_t174) - 0.070000000000000007);
    }
    
    N_Vector Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt::ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -83.853
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.00187018
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.9804713
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.98767124
        double var_chaste_interface__slow_inward_current_d_gate__d = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0.00316354
        double var_chaste_interface__slow_inward_current_f_gate__f = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.99427859
        double var_chaste_interface__time_dependent_potassium_current_X_gate__X = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.16647703
        double var_chaste_interface__intracellular_calcium_concentration__Cai = NV_Ith_S(rY, 7);
        // Units: millimolar; Initial value: 0.0002
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        // Mathematics
        var_chaste_interface__membrane__I_stim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_fast_sodium_current__i_Na = NV_Ith_S(mParameters, 8) * pow(var_chaste_interface__fast_sodium_current_m_gate__m, 3.0) * var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j * (var_chaste_interface__membrane__V - (26.712449447891164 * log(NV_Ith_S(mParameters, 3) / NV_Ith_S(mParameters, 1)))); // microA_per_cm2
        const double var_slow_inward_current__i_si = NV_Ith_S(mParameters, 5) * var_chaste_interface__slow_inward_current_d_gate__d * var_chaste_interface__slow_inward_current_f_gate__f * (var_chaste_interface__membrane__V - (7.7000000000000002 - (13.028700000000001 * log(var_chaste_interface__intracellular_calcium_concentration__Cai * 1.0)))); // microA_per_cm2
        const double var_time_dependent_potassium_current__i_K = (NV_Ith_S(mParameters, 7) * sqrt(NV_Ith_S(mParameters, 2) * 0.18518518518518517)) * var_chaste_interface__time_dependent_potassium_current_X_gate__X * _lt_0_row[32] * (var_chaste_interface__membrane__V - (26.712449447891164 * log((NV_Ith_S(mParameters, 2) + (0.018329999999999999 * NV_Ith_S(mParameters, 3))) / (NV_Ith_S(mParameters, 0) + (0.018329999999999999 * NV_Ith_S(mParameters, 1)))))); // microA_per_cm2
        const double var_time_independent_potassium_current__E_K1 = 26.712449447891164 * log(NV_Ith_S(mParameters, 2) / NV_Ith_S(mParameters, 0)); // millivolt
        const double var_time_independent_potassium_current_K1_gate__alpha_K1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1) - 59.215000000000003))); // per_millisecond
        const double var_time_independent_potassium_current__i_K1 = (NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 2) * 0.18518518518518517)) * (var_time_independent_potassium_current_K1_gate__alpha_K1 / (var_time_independent_potassium_current_K1_gate__alpha_K1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__membrane__V + 5.476) - var_time_independent_potassium_current__E_K1))) + (1.0 * exp(0.061749999999999999 * (var_chaste_interface__membrane__V - (var_time_independent_potassium_current__E_K1 + 594.30999999999995))))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1) + 4.7530000000000001)))))) * (var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1); // microA_per_cm2
        const double var_plateau_potassium_current__i_Kp = NV_Ith_S(mParameters, 12) * _lt_0_row[33] * (var_chaste_interface__membrane__V - var_time_independent_potassium_current__E_K1); // microA_per_cm2
        const double var_background_current__i_b = NV_Ith_S(mParameters, 4) * (var_chaste_interface__membrane__V -  -59.869999999999997); // microA_per_cm2
        const double var_fast_sodium_current_h_gate__beta_h = (var_chaste_interface__membrane__V <  -40.0) ? ((3.5600000000000001 * exp(0.079000000000000001 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) + (310000.0 * exp(0.34999999999999998 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10))))) : (1.0 / (0.13 * (1.0 + exp(((var_chaste_interface__membrane__V + 10.66) - NV_Ith_S(mParameters, 10)) *  -0.0900900900900901)))); // per_millisecond
        const double var_fast_sodium_current_h_gate__alpha_h = (var_chaste_interface__membrane__V <  -40.0) ? (0.13500000000000001 * exp(((80.0 + var_chaste_interface__membrane__V) - NV_Ith_S(mParameters, 10)) *  -0.14705882352941177)) : 0.0; // per_millisecond
        const double var_fast_sodium_current_h_gate__tau_h = 1.0 / (var_fast_sodium_current_h_gate__alpha_h + var_fast_sodium_current_h_gate__beta_h); // millisecond
        const double var_fast_sodium_current_j_gate__alpha_j = (var_chaste_interface__membrane__V <  -40.0) ? (((( -127140.0 * exp(0.24440000000000001 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) - (3.4740000000000003e-05 * exp( -0.043909999999999998 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10))))) * (var_chaste_interface__membrane__V + 37.780000000000001)) / (1.0 + exp(0.311 * ((var_chaste_interface__membrane__V + 79.230000000000004) - NV_Ith_S(mParameters, 10))))) : 0.0; // per_millisecond
        const double var_fast_sodium_current_j_gate__beta_j = (var_chaste_interface__membrane__V <  -40.0) ? ((0.1212 * exp( -0.01052 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) / (1.0 + exp( -0.13780000000000001 * ((var_chaste_interface__membrane__V + 40.140000000000001) - NV_Ith_S(mParameters, 10))))) : ((0.29999999999999999 * exp( -2.5349999999999999e-07 * (var_chaste_interface__membrane__V - NV_Ith_S(mParameters, 10)))) / (1.0 + exp( -0.10000000000000001 * ((var_chaste_interface__membrane__V + 32.0) - NV_Ith_S(mParameters, 10))))); // per_millisecond
        const double var_fast_sodium_current_j_gate__tau_j = 1.0 / (var_fast_sodium_current_j_gate__alpha_j + var_fast_sodium_current_j_gate__beta_j); // millisecond
        const double var_slow_inward_current_f_gate__tau_f = _lt_0_row[31]; // millisecond
        const double var_chaste_interface__time_dependent_potassium_current__i_K = var_time_dependent_potassium_current__i_K; // microA_per_cm2
        const double var_chaste_interface__time_independent_potassium_current__i_K1 = var_time_independent_potassium_current__i_K1; // microA_per_cm2
        const double var_chaste_interface__fast_sodium_current__i_Na = var_fast_sodium_current__i_Na; // microA_per_cm2
        const double var_chaste_interface__slow_inward_current__i_si = var_slow_inward_current__i_si; // microA_per_cm2
        const double var_chaste_interface__plateau_potassium_current__i_Kp = var_plateau_potassium_current__i_Kp; // microA_per_cm2
        const double var_chaste_interface__background_current__i_b = var_background_current__i_b; // microA_per_cm2
        
        N_Vector dqs = N_VNew_Serial(11);
        NV_Ith_S(dqs, 0) = var_chaste_interface__background_current__i_b;
        NV_Ith_S(dqs, 1) = var_chaste_interface__slow_inward_current__i_si;
        NV_Ith_S(dqs, 2) = var_slow_inward_current_f_gate__tau_f;
        NV_Ith_S(dqs, 3) = var_chaste_interface__time_dependent_potassium_current__i_K;
        NV_Ith_S(dqs, 4) = var_chaste_interface__fast_sodium_current__i_Na;
        NV_Ith_S(dqs, 5) = var_fast_sodium_current_h_gate__tau_h;
        NV_Ith_S(dqs, 6) = var_fast_sodium_current_j_gate__tau_j;
        NV_Ith_S(dqs, 7) = var_chaste_interface__time_independent_potassium_current__i_K1;
        NV_Ith_S(dqs, 8) = var_chaste_interface__plateau_potassium_current__i_Kp;
        NV_Ith_S(dqs, 9) = var_chaste_interface__membrane__I_stim;
        NV_Ith_S(dqs, 10) = var_chaste_interface__environment__time;
        return dqs;
    }
    
template<>
void OdeSystemInformation<Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt>::Initialise(void)
{
    this->mSystemName = "luo_rudy_1991";
    this->mFreeVariableName = "time";
    this->mFreeVariableUnits = "millisecond";
    
    this->mVariableNames.push_back("membrane_voltage");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-83.853);

    this->mVariableNames.push_back("membrane_fast_sodium_current_m_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.00187018);

    this->mVariableNames.push_back("membrane_fast_sodium_current_h_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.9804713);

    this->mVariableNames.push_back("membrane_fast_sodium_current_j_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.98767124);

    this->mVariableNames.push_back("membrane_L_type_calcium_current_d_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.00316354);

    this->mVariableNames.push_back("membrane_L_type_calcium_current_f_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.99427859);

    this->mVariableNames.push_back("time_dependent_potassium_current_X_gate__X");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.16647703);

    this->mVariableNames.push_back("cytosolic_calcium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(0.0002);

    this->mParameterNames.push_back("cytosolic_potassium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("cytosolic_sodium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("extracellular_potassium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("extracellular_sodium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("leakage_current_conductance");
    this->mParameterUnits.push_back("milliS_per_cm2");
    
    this->mParameterNames.push_back("membrane_L_type_calcium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_cm2");
    
    this->mParameterNames.push_back("membrane_capacitance");
    this->mParameterUnits.push_back("microF_per_cm2");
    
    this->mParameterNames.push_back("membrane_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_cm2");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_cm2");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_reduced_inactivation");
    this->mParameterUnits.push_back("dimensionless");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_shift_inactivation");
    this->mParameterUnits.push_back("millivolt");
    
    this->mParameterNames.push_back("membrane_inward_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_cm2");
    
    this->mParameterNames.push_back("membrane_plateau_potassium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_cm2");
    
    this->mParameterNames.push_back("membrane_data_clamp_current_conductance"); // RJ
    this->mParameterUnits.push_back("mS_per_mm2");

    this->mDerivedQuantityNames.push_back("leakage_current");
    this->mDerivedQuantityUnits.push_back("microA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current_f_gate_tau");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current_h_gate_tau");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current_j_gate_tau");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_inward_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_plateau_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_stimulus_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("time");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mInitialised = true;
}


// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt)
#endif // CHASTE_CVODE
