#ifdef CHASTE_CVODE
#ifndef CELLLUO_RUDY_1991_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_
#define CELLLUO_RUDY_1991_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_

//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: luo_rudy_1991
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24172, pycml: 23797, optimize: 23343)
//! on Fri May 29 17:44:47 2015
//! 
//! <autogenerated>

#include "ChasteSerialization.hpp"
#include <boost/serialization/base_object.hpp>
#include "AbstractCvodeCellWithDataClamp.hpp"
#include "AbstractStimulusFunction.hpp"

class Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt : public AbstractCvodeCellWithDataClamp
{
    friend class boost::serialization::access;
    template<class Archive>
    void serialize(Archive & archive, const unsigned int version)
    {
        archive & boost::serialization::base_object<AbstractCvodeCellWithDataClamp >(*this);
    }
    
    // 
    // Settable parameters and readable variables
    // 
    double var_chaste_interface__intracellular_calcium_concentration__Cai;
    double var_chaste_interface__environment__fake_dt;
    double var_chaste_interface__i_ionic;
    double var_chaste_interface__background_current__i_b;
    double var_chaste_interface__slow_inward_current__i_si;
    double var_chaste_interface__slow_inward_current_d_gate__d;
    double var_chaste_interface__slow_inward_current_f_gate__f;
    double var_slow_inward_current_f_gate__tau_f;
    double var_chaste_interface__time_dependent_potassium_current__i_K;
    double var_chaste_interface__fast_sodium_current__i_Na;
    double var_chaste_interface__fast_sodium_current_h_gate__h;
    double var_fast_sodium_current_h_gate__tau_h;
    double var_chaste_interface__fast_sodium_current_j_gate__j;
    double var_fast_sodium_current_j_gate__tau_j;
    double var_chaste_interface__fast_sodium_current_m_gate__m;
    double var_chaste_interface__time_independent_potassium_current__i_K1;
    double var_chaste_interface__plateau_potassium_current__i_Kp;
    double var_chaste_interface__membrane__I_stim;
    double var_chaste_interface__membrane__stim_amplitude;
    double var_chaste_interface__membrane__stim_duration;
    double var_chaste_interface__membrane__stim_end;
    double var_chaste_interface__membrane__stim_start;
    double var_chaste_interface__membrane__stim_period;
    double var_chaste_interface__membrane__V;
    double var_chaste_interface__environment__time;
    
public:
    double Get_chaste_interface__intracellular_calcium_concentration__Cai();
    double Get_chaste_interface__environment__fake_dt();
    double Get_chaste_interface__i_ionic();
    double Get_chaste_interface__background_current__i_b();
    double Get_chaste_interface__slow_inward_current__i_si();
    double Get_chaste_interface__slow_inward_current_d_gate__d();
    double Get_chaste_interface__slow_inward_current_f_gate__f();
    double Get_slow_inward_current_f_gate__tau_f();
    double Get_chaste_interface__time_dependent_potassium_current__i_K();
    double Get_chaste_interface__fast_sodium_current__i_Na();
    double Get_chaste_interface__fast_sodium_current_h_gate__h();
    double Get_fast_sodium_current_h_gate__tau_h();
    double Get_chaste_interface__fast_sodium_current_j_gate__j();
    double Get_fast_sodium_current_j_gate__tau_j();
    double Get_chaste_interface__fast_sodium_current_m_gate__m();
    double Get_chaste_interface__time_independent_potassium_current__i_K1();
    double Get_chaste_interface__plateau_potassium_current__i_Kp();
    double Get_chaste_interface__membrane__I_stim();
    double Get_chaste_interface__membrane__stim_amplitude();
    double Get_chaste_interface__membrane__stim_duration();
    double Get_chaste_interface__membrane__stim_end();
    double Get_chaste_interface__membrane__stim_start();
    double Get_chaste_interface__membrane__stim_period();
    double Get_chaste_interface__membrane__V();
    double Get_chaste_interface__environment__time();
    double Get_cytosolic_potassium_concentration_constant();
    double Get_cytosolic_sodium_concentration_constant();
    double Get_extracellular_potassium_concentration_constant();
    double Get_extracellular_sodium_concentration_constant();
    double Get_leakage_current_conductance_constant();
    double Get_membrane_L_type_calcium_current_conductance_constant();
    double Get_membrane_capacitance_constant();
    double Get_membrane_delayed_rectifier_potassium_current_conductance_constant();
    double Get_membrane_fast_sodium_current_conductance_constant();
    double Get_membrane_fast_sodium_current_reduced_inactivation_constant();
    double Get_membrane_fast_sodium_current_shift_inactivation_constant();
    double Get_membrane_inward_rectifier_potassium_current_conductance_constant();
    double Get_membrane_plateau_potassium_current_conductance_constant();
    double Get_membrane_stimulus_current_amplitude_constant();
    double Get_membrane_stimulus_current_duration_constant();
    double Get_membrane_stimulus_current_end_constant();
    double Get_membrane_stimulus_current_offset_constant();
    double Get_membrane_stimulus_current_period_constant();
    boost::shared_ptr<RegularStimulus> UseCellMLDefaultStimulus();
    double GetIntracellularCalciumConcentration();
    Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus);
    ~Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt();
    AbstractLookupTableCollection* GetLookupTableCollection();
    double GetIIonic(const std::vector<double>* pStateVariables=NULL);
    void EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY);
    void EvaluateAnalyticJacobian(long int N, double var_chaste_interface__environment__time, N_Vector rY, N_Vector rDY, CHASTE_CVODE_DENSE_MATRIX rJacobian, N_Vector rTmp1, N_Vector rTmp2, N_Vector rTmp3);
    N_Vector ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY);

    double Get_membrane_data_clamp_current_conductance_constant();
};


// Needs to be included last
#include "SerializationExportWrapper.hpp"
CHASTE_CLASS_EXPORT(Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt)

namespace boost
{
    namespace serialization
    {
        template<class Archive>
        inline void save_construct_data(
            Archive & ar, const Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt * t, const unsigned int fileVersion)
        {
            const boost::shared_ptr<AbstractIvpOdeSolver> p_solver = t->GetSolver();
            const boost::shared_ptr<AbstractStimulusFunction> p_stimulus = t->GetStimulusFunction();
            ar << p_solver;
            ar << p_stimulus;
        }
        
        template<class Archive>
        inline void load_construct_data(
            Archive & ar, Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt * t, const unsigned int fileVersion)
        {
            boost::shared_ptr<AbstractIvpOdeSolver> p_solver;
            boost::shared_ptr<AbstractStimulusFunction> p_stimulus;
            ar >> p_solver;
            ar >> p_stimulus;
            ::new(t)Cellluo_rudy_1991_data_clampFromCellMLCvodeOpt(p_solver, p_stimulus);
        }
        
    }
    
}

#endif // CELLLUO_RUDY_1991_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_
#endif // CHASTE_CVODE
