#ifdef CHASTE_CVODE
#ifndef CELLOHARA_RUDY_2011_ENDO_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_
#define CELLOHARA_RUDY_2011_ENDO_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_

//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: ohara_rudy_2011
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24172, pycml: 23797, optimize: 23343)
//! on Fri May 29 17:47:42 2015
//! 
//! <autogenerated>

#include "ChasteSerialization.hpp"
#include <boost/serialization/base_object.hpp>
#include "AbstractCvodeCellWithDataClamp.hpp"
#include "AbstractStimulusFunction.hpp"

class Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt : public AbstractCvodeCellWithDataClamp
{
    friend class boost::serialization::access;
    template<class Archive>
    void serialize(Archive & archive, const unsigned int version)
    {
        archive & boost::serialization::base_object<AbstractCvodeCellWithDataClamp >(*this);
    }
    
    // 
    // Settable parameters and readable variables
    // 
    double var_ryr__Jrel;
    double var_chaste_interface__INaCa_i__INaCa_ss;
    double var_chaste_interface__intracellular_ions__cai;
    double var_chaste_interface__intracellular_ions__ki;
    double var_chaste_interface__intracellular_ions__nai;
    double var_chaste_interface__environment__fake_dt;
    double var_chaste_interface__i_ionic;
    double var_chaste_interface__ICaL__ICaK;
    double var_chaste_interface__ICaL__ICaNa;
    double var_chaste_interface__ICaL__ICaL;
    double var_chaste_interface__ICab__ICab;
    double var_chaste_interface__IKb__IKb;
    double var_chaste_interface__INab__INab;
    double var_chaste_interface__IpCa__IpCa;
    double var_chaste_interface__INa__INa;
    double var_INa__h;
    double var_chaste_interface__INa__j;
    double var_chaste_interface__IK1__IK1;
    double var_chaste_interface__INaL__INaL;
    double var_chaste_interface__IKr__IKr;
    double var_chaste_interface__IKs__IKs;
    double var_chaste_interface__INaCa_i__INaCa_i;
    double var_chaste_interface__INaK__INaK;
    double var_chaste_interface__membrane__Istim;
    double var_chaste_interface__membrane__i_Stim_Amplitude;
    double var_chaste_interface__membrane__i_Stim_PulseDuration;
    double var_chaste_interface__membrane__i_Stim_Start;
    double var_chaste_interface__membrane__i_Stim_Period;
    double var_chaste_interface__membrane__v;
    double var_chaste_interface__environment__time;
    
public:
    double Get_ryr__Jrel();
    double Get_chaste_interface__INaCa_i__INaCa_ss();
    double Get_chaste_interface__intracellular_ions__cai();
    double Get_chaste_interface__intracellular_ions__ki();
    double Get_chaste_interface__intracellular_ions__nai();
    double Get_chaste_interface__environment__fake_dt();
    double Get_chaste_interface__i_ionic();
    double Get_chaste_interface__ICaL__ICaK();
    double Get_chaste_interface__ICaL__ICaNa();
    double Get_chaste_interface__ICaL__ICaL();
    double Get_chaste_interface__ICab__ICab();
    double Get_chaste_interface__IKb__IKb();
    double Get_chaste_interface__INab__INab();
    double Get_chaste_interface__IpCa__IpCa();
    double Get_chaste_interface__INa__INa();
    double Get_INa__h();
    double Get_chaste_interface__INa__j();
    double Get_chaste_interface__IK1__IK1();
    double Get_chaste_interface__INaL__INaL();
    double Get_chaste_interface__IKr__IKr();
    double Get_chaste_interface__IKs__IKs();
    double Get_chaste_interface__INaCa_i__INaCa_i();
    double Get_chaste_interface__INaK__INaK();
    double Get_chaste_interface__membrane__Istim();
    double Get_chaste_interface__membrane__i_Stim_Amplitude();
    double Get_chaste_interface__membrane__i_Stim_PulseDuration();
    double Get_chaste_interface__membrane__i_Stim_Start();
    double Get_chaste_interface__membrane__i_Stim_Period();
    double Get_chaste_interface__membrane__v();
    double Get_chaste_interface__environment__time();
    double Get_SR_release_current_max_constant();
    double Get_SR_uptake_current_max_constant();
    double Get_extracellular_calcium_concentration_constant();
    double Get_extracellular_potassium_concentration_constant();
    double Get_extracellular_sodium_concentration_constant();
    double Get_membrane_L_type_calcium_current_conductance_constant();
    double Get_membrane_background_calcium_current_conductance_constant();
    double Get_membrane_background_potassium_current_conductance_constant();
    double Get_membrane_background_sodium_current_conductance_constant();
    double Get_membrane_calcium_pump_current_conductance_constant();
    double Get_membrane_fast_sodium_current_conductance_constant();
    double Get_membrane_inward_rectifier_potassium_current_conductance_constant();
    double Get_membrane_persistent_sodium_current_conductance_constant();
    double Get_membrane_rapid_delayed_rectifier_potassium_current_conductance_constant();
    double Get_membrane_slow_delayed_rectifier_potassium_current_conductance_constant();
    double Get_membrane_sodium_calcium_exchanger_current_conductance_constant();
    double Get_membrane_sodium_potassium_pump_current_permeability_constant();
    double Get_membrane_stimulus_current_amplitude_constant();
    double Get_membrane_stimulus_current_duration_constant();
    double Get_membrane_stimulus_current_offset_constant();
    double Get_membrane_stimulus_current_period_constant();
    double Get_membrane_transient_outward_current_conductance_constant();
    boost::shared_ptr<RegularStimulus> UseCellMLDefaultStimulus();
    double GetIntracellularCalciumConcentration();
    Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus);
    ~Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt();
    AbstractLookupTableCollection* GetLookupTableCollection();
    double GetIIonic(const std::vector<double>* pStateVariables=NULL);
    void EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY);
    void EvaluateAnalyticJacobian(long int N, double var_chaste_interface__environment__time, N_Vector rY, N_Vector rDY, CHASTE_CVODE_DENSE_MATRIX rJacobian, N_Vector rTmp1, N_Vector rTmp2, N_Vector rTmp3);
    N_Vector ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY);

    double Get_membrane_data_clamp_current_conductance_constant();
};


// Needs to be included last
#include "SerializationExportWrapper.hpp"
CHASTE_CLASS_EXPORT(Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt)

namespace boost
{
    namespace serialization
    {
        template<class Archive>
        inline void save_construct_data(
            Archive & ar, const Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt * t, const unsigned int fileVersion)
        {
            const boost::shared_ptr<AbstractIvpOdeSolver> p_solver = t->GetSolver();
            const boost::shared_ptr<AbstractStimulusFunction> p_stimulus = t->GetStimulusFunction();
            ar << p_solver;
            ar << p_stimulus;
        }
        
        template<class Archive>
        inline void load_construct_data(
            Archive & ar, Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt * t, const unsigned int fileVersion)
        {
            boost::shared_ptr<AbstractIvpOdeSolver> p_solver;
            boost::shared_ptr<AbstractStimulusFunction> p_stimulus;
            ar >> p_solver;
            ar >> p_stimulus;
            ::new(t)Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt(p_solver, p_stimulus);
        }
        
    }
    
}

#endif // CELLOHARA_RUDY_2011_ENDO_DATA_CLAMPFROMCELLMLCVODEOPT_HPP_
#endif // CHASTE_CVODE
