#ifdef CHASTE_CVODE
//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: tentusscher_model_2004_epi
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24172, pycml: 23797, optimize: 23343)
//! on Fri May 29 17:46:07 2015
//! 
//! <autogenerated>

#include "ten_tusscher_model_2004_epi_data_clampCvodeOpt.hpp"
#include <cmath>
#include <cassert>
#include <memory>
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"
#include "RegularStimulus.hpp"
#include "HeartConfig.hpp"
#include "IsNan.hpp"
#include "MathsCustomFunctions.hpp"

class Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables : public AbstractLookupTableCollection
{
public:
    static Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables* Instance()
    {
        if (mpInstance.get() == NULL)
        {
            mpInstance.reset(new Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables);
        }
        return mpInstance.get();
    }
    
    void FreeMemory()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
        mNeedsRegeneration.assign(mNeedsRegeneration.size(), true);
    }
    
    // Row lookup methods
    // using linear-interpolation
    double* _lookup_0_row(unsigned i, double _factor_)
    {
        for (unsigned j=0; j<92; j++)
        {
            const double y1 = _lookup_table_0[i][j];
            const double y2 = _lookup_table_0[i+1][j];
            _lookup_table_0_row[j] = y1 + (y2-y1)*_factor_;
        }
        return _lookup_table_0_row;
    }
    
    
    const double * IndexTable0(double var_chaste_interface__membrane__V)
    {
        const double _offset_0 = var_chaste_interface__membrane__V - mTableMins[0];
        const double _offset_0_over_table_step = _offset_0 * mTableStepInverses[0];
        const unsigned _table_index_0 = (unsigned)(_offset_0_over_table_step);
        const double _factor_0 = _offset_0_over_table_step - _table_index_0;
        const double* const _lt_0_row = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->_lookup_0_row(_table_index_0, _factor_0);
        return _lt_0_row;
    }
    
#define COVERAGE_IGNORE
    bool CheckIndex0(double& var_chaste_interface__membrane__V)
    {
        bool _oob_0 = false;
        if (var_chaste_interface__membrane__V>mTableMaxs[0] || var_chaste_interface__membrane__V<mTableMins[0])
        {
#define COVERAGE_IGNORE
            _oob_0 = true;
#undef COVERAGE_IGNORE
        }
        return _oob_0;
    }
#undef COVERAGE_IGNORE

    ~Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
    }
    
protected:
    Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables(const Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables& operator= (const Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        assert(mpInstance.get() == NULL);
        mKeyingVariableNames.resize(1);
        mNumberOfTables.resize(1);
        mTableMins.resize(1);
        mTableSteps.resize(1);
        mTableStepInverses.resize(1);
        mTableMaxs.resize(1);
        mNeedsRegeneration.resize(1);
        mKeyingVariableNames[0] = "membrane_voltage";
        mNumberOfTables[0] = 92;
        mTableMins[0] = -120.0001;
        mTableSteps[0] = 0.001;
        mTableStepInverses[0] = 1000.0;
        mTableMaxs[0] = 99.9999;
        mNeedsRegeneration[0] = true;
        _lookup_table_0 = NULL;
        Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::RegenerateTables();
    }
    
    void RegenerateTables()
    {
        AbstractLookupTableCollection::EventHandler::BeginEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
        if (mNeedsRegeneration[0])
        {
            if (_lookup_table_0)
            {
                delete[] _lookup_table_0;
                _lookup_table_0 = NULL;
            }
            const unsigned _table_size_0 = 1 + (unsigned)((mTableMaxs[0]-mTableMins[0])/mTableSteps[0]+0.5);
            _lookup_table_0 = new double[_table_size_0][92];
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][0] = exp(2.0 * ((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][1] = 1.0 / (exp(2.0 * ((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07)) - 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][2] = pow(exp(2.0 * ((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07)) - 1.0, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][3] = pow((1.0 + (0.1245 * exp( -0.10000000000000001 * ((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07)))) + (0.035299999999999998 * exp(-((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][4] = ( -0.00046605194074318104 * exp( -0.10000000000000001 * ((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07))) - (0.0013214163460429152 * exp(-((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][5] = exp(( -0.65000000000000002 * var_chaste_interface__membrane__V) * 0.037433890822745473);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][6] = 1.0 / (1.0 + (0.10000000000000001 * exp(( -0.65000000000000002 * var_chaste_interface__membrane__V) * 0.037433890822745473)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][7] = 0.013101861787960915 * exp((0.34999999999999998 * var_chaste_interface__membrane__V) * 0.037433890822745473);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][8] = exp((0.34999999999999998 * var_chaste_interface__membrane__V) * 0.037433890822745473);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][9] = pow(1.0 + (0.10000000000000001 * exp(( -0.65000000000000002 * var_chaste_interface__membrane__V) * 0.037433890822745473)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][10] = 1.0 / (1.0 + exp(4.1806020080000001 - (0.16722408029999999 * var_chaste_interface__membrane__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][11] = pow(1.0 + exp(4.1806020080000001 - (0.16722408029999999 * var_chaste_interface__membrane__V)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][12] = exp(4.1806020080000001 - (0.16722408029999999 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][13] = 1.0 / ((1.0 + (0.1245 * exp( -0.10000000000000001 * ((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07)))) + (0.035299999999999998 * exp(-((var_chaste_interface__membrane__V * 96485.341499999995) * 3.8797490106562429e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][14] = 1.0 / (1.0 + exp( -3.7142857142857144 - (0.14285714285714285 * var_chaste_interface__membrane__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][15] = 1.0 / (1.0 + exp((0.041666666666666664 * var_chaste_interface__membrane__V) + 3.6666666666666665));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][16] = 1.0 / (1.0 + exp( -0.35714285714285715 - (0.071428571428571425 * var_chaste_interface__membrane__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][17] = 1.0 / pow(1.0 + exp( -6.2967884820000002 - (0.1107419712 * var_chaste_interface__membrane__V)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][18] = -(1.0 / (((1.3999999999999999 * ((1.3999999999999999 / (1.0 + exp( -2.6923076923076925 - (0.076923076923076927 * var_chaste_interface__membrane__V)))) + 0.25)) * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 1.0)))) + (1.0 / (1.0 + exp(2.5 - (0.050000000000000003 * var_chaste_interface__membrane__V))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][19] = ((0.1333333333 / pow(1.0 + exp( -0.66666666649999995 - (0.1333333333 * var_chaste_interface__membrane__V)), 2.0)) * exp( -0.66666666649999995 - (0.1333333333 * var_chaste_interface__membrane__V))) * (1.0 / (((1.3999999999999999 * ((1.3999999999999999 / (1.0 + exp( -2.6923076923076925 - (0.076923076923076927 * var_chaste_interface__membrane__V)))) + 0.25)) * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 1.0)))) + (1.0 / (1.0 + exp(2.5 - (0.050000000000000003 * var_chaste_interface__membrane__V))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][20] = 1.0 / (1.0 + exp( -0.66666666649999995 - (0.1333333333 * var_chaste_interface__membrane__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][21] = pow(((1.3999999999999999 * ((1.3999999999999999 / (1.0 + exp( -2.6923076923076925 - (0.076923076923076927 * var_chaste_interface__membrane__V)))) + 0.25)) * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 1.0)))) + (1.0 / (1.0 + exp(2.5 - (0.050000000000000003 * var_chaste_interface__membrane__V)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][22] = ((((0.15076923079999999 / pow(1.0 + exp( -2.6923076923076925 - (0.076923076923076927 * var_chaste_interface__membrane__V)), 2.0)) * exp( -2.6923076923076925 - (0.076923076923076927 * var_chaste_interface__membrane__V))) * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 1.0)))) - (((0.28000000000000003 * ((1.3999999999999999 / (1.0 + exp( -2.6923076923076925 - (0.076923076923076927 * var_chaste_interface__membrane__V)))) + 0.25)) / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 1.0), 2.0)) * exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 1.0))) + ((0.050000000000000003 / pow(1.0 + exp(2.5 - (0.050000000000000003 * var_chaste_interface__membrane__V)), 2.0)) * exp(2.5 - (0.050000000000000003 * var_chaste_interface__membrane__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][23] = -(1.0 / (((1125.0 * exp( -0.0041666666666666666 * pow(var_chaste_interface__membrane__V + 27.0, 2.0))) + 80.0) + (165.0 / (1.0 + exp(2.5 - (0.10000000000000001 * var_chaste_interface__membrane__V))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][24] = (( -0.14285714285714285 / pow(1.0 + exp((0.14285714285714285 * var_chaste_interface__membrane__V) + 2.8571428571428572), 2.0)) * exp((0.14285714285714285 * var_chaste_interface__membrane__V) + 2.8571428571428572)) * (1.0 / (((1125.0 * exp( -0.0041666666666666666 * pow(var_chaste_interface__membrane__V + 27.0, 2.0))) + 80.0) + (165.0 / (1.0 + exp(2.5 - (0.10000000000000001 * var_chaste_interface__membrane__V))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][25] = 1.0 / (1.0 + exp((0.14285714285714285 * var_chaste_interface__membrane__V) + 2.8571428571428572));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][26] = pow(((1125.0 * exp( -0.0041666666666666666 * pow(var_chaste_interface__membrane__V + 27.0, 2.0))) + 80.0) + (165.0 / (1.0 + exp(2.5 - (0.10000000000000001 * var_chaste_interface__membrane__V)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][27] = ((1125.0 * (( -0.0083333333333333332 * var_chaste_interface__membrane__V) - 0.22500000000000001)) * exp( -0.0041666666666666666 * pow(var_chaste_interface__membrane__V + 27.0, 2.0))) + ((16.5 / pow(1.0 + exp(2.5 - (0.10000000000000001 * var_chaste_interface__membrane__V)), 2.0)) * exp(2.5 - (0.10000000000000001 * var_chaste_interface__membrane__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][28] = -(((var_chaste_interface__membrane__V <  -40.0) ? (0.057000000000000002 * exp(( -0.14705882349999999 * var_chaste_interface__membrane__V) - 11.764705879999999)) : 0.0) + ((var_chaste_interface__membrane__V <  -40.0) ? ((2.7000000000000002 * exp(0.079000000000000001 * var_chaste_interface__membrane__V)) + (310000.0 * exp(0.34849999999999998 * var_chaste_interface__membrane__V))) : (0.77000000000000002 / (0.13 + (0.13 * exp(( -0.090090090090000005 * var_chaste_interface__membrane__V) - 0.96036036039999995))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][29] = ((var_chaste_interface__membrane__V <  -40.0) ? (0.057000000000000002 * exp(( -0.14705882349999999 * var_chaste_interface__membrane__V) - 11.764705879999999)) : 0.0) + ((var_chaste_interface__membrane__V <  -40.0) ? ((2.7000000000000002 * exp(0.079000000000000001 * var_chaste_interface__membrane__V)) + (310000.0 * exp(0.34849999999999998 * var_chaste_interface__membrane__V))) : (0.77000000000000002 / (0.13 + (0.13 * exp(( -0.090090090090000005 * var_chaste_interface__membrane__V) - 0.96036036039999995)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][30] = ((var_chaste_interface__membrane__V <  -40.0) ? ( -0.0083823529409999993 * exp(( -0.14705882349999999 * var_chaste_interface__membrane__V) - 11.764705879999999)) : ( -40.0 <= var_chaste_interface__membrane__V) ? 0.0 : NAN) + ((var_chaste_interface__membrane__V <=  -40.0) ? ((0.21329999999999999 * exp(0.079000000000000001 * var_chaste_interface__membrane__V)) + (108035.0 * exp(0.34849999999999998 * var_chaste_interface__membrane__V))) : ( -40.0 < var_chaste_interface__membrane__V) ? ((0.009018018018 / pow(0.13 + (0.13 * exp(( -0.090090090090000005 * var_chaste_interface__membrane__V) - 0.96036036039999995)), 2.0)) * exp(( -0.090090090090000005 * var_chaste_interface__membrane__V) - 0.96036036039999995)) : NAN);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][31] = -(((var_chaste_interface__membrane__V <  -40.0) ? (((( -25428.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__V)) - (6.9480000000000002e-06 * exp( -0.043909999999999998 * var_chaste_interface__membrane__V))) * (var_chaste_interface__membrane__V + 37.780000000000001)) / (1.0 + exp((0.311 * var_chaste_interface__membrane__V) + 24.640529999999998))) : 0.0) + ((var_chaste_interface__membrane__V <  -40.0) ? ((0.024240000000000001 * exp( -0.01052 * var_chaste_interface__membrane__V)) / (1.0 + exp((-(0.13780000000000001 * var_chaste_interface__membrane__V)) - 5.5312919999999997))) : ((0.59999999999999998 * exp(0.057000000000000002 * var_chaste_interface__membrane__V)) / (1.0 + exp(( -0.10000000000000001 * var_chaste_interface__membrane__V) - 3.2000000000000002)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][32] = ((var_chaste_interface__membrane__V <  -40.0) ? (((( -25428.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__V)) - (6.9480000000000002e-06 * exp( -0.043909999999999998 * var_chaste_interface__membrane__V))) * (var_chaste_interface__membrane__V + 37.780000000000001)) / (1.0 + exp((0.311 * var_chaste_interface__membrane__V) + 24.640529999999998))) : 0.0) + ((var_chaste_interface__membrane__V <  -40.0) ? ((0.024240000000000001 * exp( -0.01052 * var_chaste_interface__membrane__V)) / (1.0 + exp((-(0.13780000000000001 * var_chaste_interface__membrane__V)) - 5.5312919999999997))) : ((0.59999999999999998 * exp(0.057000000000000002 * var_chaste_interface__membrane__V)) / (1.0 + exp(( -0.10000000000000001 * var_chaste_interface__membrane__V) - 3.2000000000000002))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][33] = ((var_chaste_interface__membrane__V <  -40.0) ? (((((( -6214.6031999999996 * exp(0.24440000000000001 * var_chaste_interface__membrane__V)) + (3.0508668000000001e-07 * exp( -0.043909999999999998 * var_chaste_interface__membrane__V))) * (var_chaste_interface__membrane__V + 37.780000000000001)) * (1.0 / (1.0 + exp((0.311 * var_chaste_interface__membrane__V) + 24.640530009999999)))) + ((( -25428.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__V)) - (6.9480000000000002e-06 * exp( -0.043909999999999998 * var_chaste_interface__membrane__V))) * (1.0 / (1.0 + exp((0.311 * var_chaste_interface__membrane__V) + 24.640530009999999))))) - ((((0.311 * (( -25428.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__V)) - (6.9480000000000002e-06 * exp( -0.043909999999999998 * var_chaste_interface__membrane__V)))) * (var_chaste_interface__membrane__V + 37.780000000000001)) / pow(1.0 + exp((0.311 * var_chaste_interface__membrane__V) + 24.640530009999999), 2.0)) * exp((0.311 * var_chaste_interface__membrane__V) + 24.640530009999999))) : ( -40.0 <= var_chaste_interface__membrane__V) ? 0.0 : NAN) + ((var_chaste_interface__membrane__V <=  -40.0) ? ((( -0.00025500479999999997 * exp( -0.01052 * var_chaste_interface__membrane__V)) / (1.0 + exp((-(0.13780000000000001 * var_chaste_interface__membrane__V)) - 5.5312919950000001))) + (((0.003340272 * exp( -0.01052 * var_chaste_interface__membrane__V)) / pow(1.0 + exp((-(0.13780000000000001 * var_chaste_interface__membrane__V)) - 5.5312919950000001), 2.0)) * exp((-(0.13780000000000001 * var_chaste_interface__membrane__V)) - 5.5312919950000001))) : ( -40.0 < var_chaste_interface__membrane__V) ? (((0.034200000000000001 * exp(0.057000000000000002 * var_chaste_interface__membrane__V)) / (1.0 + exp(( -0.10000000000000001 * var_chaste_interface__membrane__V) - 3.2000000000000002))) + (((0.059999999999999998 * exp(0.057000000000000002 * var_chaste_interface__membrane__V)) / pow(1.0 + exp(( -0.10000000000000001 * var_chaste_interface__membrane__V) - 3.2000000000000002), 2.0)) * exp(( -0.10000000000000001 * var_chaste_interface__membrane__V) - 3.2000000000000002))) : NAN);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][34] = -((1.0 + exp( -12.0 - (0.20000000000000001 * var_chaste_interface__membrane__V))) * (1.0 / ((0.10000000000000001 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 7.0))) + (0.10000000000000001 / (1.0 + exp((0.0050000000000000001 * var_chaste_interface__membrane__V) - 0.25))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][35] = (((0.22148394239999999 / pow(1.0 + exp( -6.2967884820000002 - (0.1107419712 * var_chaste_interface__membrane__V)), 2.0)) / (1.0 + exp( -6.2967884820000002 - (0.1107419712 * var_chaste_interface__membrane__V)))) * exp( -6.2967884820000002 - (0.1107419712 * var_chaste_interface__membrane__V))) * ((1.0 + exp( -12.0 - (0.20000000000000001 * var_chaste_interface__membrane__V))) * (1.0 / ((0.10000000000000001 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 7.0))) + (0.10000000000000001 / (1.0 + exp((0.0050000000000000001 * var_chaste_interface__membrane__V) - 0.25))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][36] = exp( -12.0 - (0.20000000000000001 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][37] = 1.0 / ((0.10000000000000001 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 7.0))) + (0.10000000000000001 / (1.0 + exp((0.0050000000000000001 * var_chaste_interface__membrane__V) - 0.25))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][38] = 1.0 + exp( -12.0 - (0.20000000000000001 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][39] = pow((0.10000000000000001 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 7.0))) + (0.10000000000000001 / (1.0 + exp((0.0050000000000000001 * var_chaste_interface__membrane__V) - 0.25))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][40] = (( -0.02 / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 7.0), 2.0)) * exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 7.0)) - ((0.00050000000000000001 / pow(1.0 + exp((0.0050000000000000001 * var_chaste_interface__membrane__V) - 0.25), 2.0)) * exp((0.0050000000000000001 * var_chaste_interface__membrane__V) - 0.25));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][41] = ((5.2910052910052912e-05 / pow(1.0 + exp( -3.7142857142857144 - (0.14285714285714285 * var_chaste_interface__membrane__V)), 2.0)) * exp( -3.7142857142857144 - (0.14285714285714285 * var_chaste_interface__membrane__V))) * ((1.0 + exp( -4.5 - (0.10000000000000001 * var_chaste_interface__membrane__V))) * (1.0 + exp((0.086956521740000001 * var_chaste_interface__membrane__V) + 2.6086956520000002)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][42] = exp( -4.5 - (0.10000000000000001 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][43] = 1.0 + exp((0.086956521740000001 * var_chaste_interface__membrane__V) + 2.6086956520000002);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][44] = 1.0 + exp( -4.5 - (0.10000000000000001 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][45] = exp((0.086956521740000001 * var_chaste_interface__membrane__V) + 2.6086956520000002);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][46] =  -0.00037037037037037035 * ((1.0 + exp( -4.5 - (0.10000000000000001 * var_chaste_interface__membrane__V))) * (1.0 + exp((0.086956521740000001 * var_chaste_interface__membrane__V) + 2.6086956520000002)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][47] = (( -0.01240079365 / pow(1.0 + exp((0.041666666666666664 * var_chaste_interface__membrane__V) + 3.6666666666666665), 2.0)) * exp((0.041666666666666664 * var_chaste_interface__membrane__V) + 3.6666666666666665)) * ((1.0 + exp( -3.0 - (0.050000000000000003 * var_chaste_interface__membrane__V))) * (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) - 3.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][48] = exp( -3.0 - (0.050000000000000003 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][49] = 1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) - 3.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][50] = 1.0 + exp( -3.0 - (0.050000000000000003 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][51] = exp((0.050000000000000003 * var_chaste_interface__membrane__V) - 3.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][52] =  -0.29761904760000002 * ((1.0 + exp( -3.0 - (0.050000000000000003 * var_chaste_interface__membrane__V))) * (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) - 3.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][53] = ((6.4935064935064935e-05 / pow(1.0 + exp( -0.35714285714285715 - (0.071428571428571425 * var_chaste_interface__membrane__V)), 2.0)) * exp( -0.35714285714285715 - (0.071428571428571425 * var_chaste_interface__membrane__V))) * (pow(1.0 + exp( -1.6666666666666667 - (0.16666666666666666 * var_chaste_interface__membrane__V)), 0.5) * (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) - 3.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][54] = pow(1.0 + exp( -1.6666666666666667 - (0.16666666666666666 * var_chaste_interface__membrane__V)), 0.5);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][55] = exp( -1.6666666666666667 - (0.16666666666666666 * var_chaste_interface__membrane__V));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][56] =  -0.00090909090909090909 * (pow(1.0 + exp( -1.6666666666666667 - (0.16666666666666666 * var_chaste_interface__membrane__V)), 0.5) * (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__V) - 3.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][57] = ((0.16666666666666666 / pow(1.0 + exp(3.3333333333333335 - (0.16666666666666666 * var_chaste_interface__membrane__V)), 2.0)) * exp(3.3333333333333335 - (0.16666666666666666 * var_chaste_interface__membrane__V))) * (1.0 / ((9.5 * exp( -0.00055555555555555556 * pow(40.0 + var_chaste_interface__membrane__V, 2.0))) + 0.80000000000000004));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][58] = 1.0 / (1.0 + exp(3.3333333333333335 - (0.16666666666666666 * var_chaste_interface__membrane__V)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][59] = pow((9.5 * exp( -0.00055555555555555556 * pow(40.0 + var_chaste_interface__membrane__V, 2.0))) + 0.80000000000000004, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][60] = exp( -0.00055555555555555556 * pow(40.0 + var_chaste_interface__membrane__V, 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][61] = -(1.0 / ((9.5 * exp( -0.00055555555555555556 * pow(40.0 + var_chaste_interface__membrane__V, 2.0))) + 0.80000000000000004));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][62] = (( -0.20000000000000001 / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 4.0), 2.0)) * exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 4.0)) * (1.0 / (((85.0 * exp( -0.0031250000000000002 * pow(var_chaste_interface__membrane__V + 45.0, 2.0))) + (5.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) - 4.0)))) + 3.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][63] = 1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) + 4.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][64] = pow(((85.0 * exp( -0.0031250000000000002 * pow(var_chaste_interface__membrane__V + 45.0, 2.0))) + (5.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) - 4.0)))) + 3.0, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][65] = ((85.0 * (( -0.0062500000000000003 * var_chaste_interface__membrane__V) - 0.28125)) * exp( -0.0031250000000000002 * pow(var_chaste_interface__membrane__V + 45.0, 2.0))) - ((1.0 / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) - 4.0), 2.0)) * exp((0.20000000000000001 * var_chaste_interface__membrane__V) - 4.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][66] = -(1.0 / (((85.0 * exp( -0.0031250000000000002 * pow(var_chaste_interface__membrane__V + 45.0, 2.0))) + (5.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__V) - 4.0)))) + 3.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][67] = 1.0 / (((var_chaste_interface__membrane__V <  -40.0) ? (0.057000000000000002 * exp((-(var_chaste_interface__membrane__V + 80.0)) * 0.14705882352941177)) : 0.0) + ((var_chaste_interface__membrane__V <  -40.0) ? ((2.7000000000000002 * exp(0.079000000000000001 * var_chaste_interface__membrane__V)) + (310000.0 * exp(0.34849999999999998 * var_chaste_interface__membrane__V))) : (0.77000000000000002 / (0.13 * (1.0 + exp((var_chaste_interface__membrane__V + 10.66) *  -0.0900900900900901))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][68] = 1.0 / (((var_chaste_interface__membrane__V <  -40.0) ? ((((( -25428.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__V)) - (6.9480000000000002e-06 * exp( -0.043909999999999998 * var_chaste_interface__membrane__V))) * (var_chaste_interface__membrane__V + 37.780000000000001)) * 1.0) / (1.0 + exp(0.311 * (var_chaste_interface__membrane__V + 79.230000000000004)))) : 0.0) + ((var_chaste_interface__membrane__V <  -40.0) ? ((0.024240000000000001 * exp( -0.01052 * var_chaste_interface__membrane__V)) / (1.0 + exp( -0.13780000000000001 * (var_chaste_interface__membrane__V + 40.140000000000001)))) : ((0.59999999999999998 * exp(0.057000000000000002 * var_chaste_interface__membrane__V)) / (1.0 + exp( -0.10000000000000001 * (var_chaste_interface__membrane__V + 32.0))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][69] = exp((var_chaste_interface__membrane__V * 192970.68299999999) * 3.8797490106562429e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][70] = exp((var_chaste_interface__membrane__V * 192970.68299999999) * 3.8797490106562429e-07) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][71] = (1125.0 * exp((-pow(var_chaste_interface__membrane__V + 27.0, 2.0)) * 0.0041666666666666666)) + 80.0 + (165.0 / (1.0 + exp((25.0 - var_chaste_interface__membrane__V) * 0.10000000000000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][72] = 1.0 + (0.1245 * exp((var_chaste_interface__membrane__V *  -9648.5341499999995) * 3.8797490106562429e-07)) + (0.035299999999999998 * exp(((-var_chaste_interface__membrane__V) * 96485.341499999995) * 3.8797490106562429e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][73] = exp((var_chaste_interface__membrane__V * 33769.869524999995) * 3.8797490106562429e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][74] = exp((var_chaste_interface__membrane__V *  -62715.471975) * 3.8797490106562429e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][75] = 1.0 + (0.10000000000000001 * exp((var_chaste_interface__membrane__V *  -62715.471975) * 3.8797490106562429e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][76] = 1.0 + exp((25.0 - var_chaste_interface__membrane__V) * 0.16722408026755853);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][77] = 1.0 / (1.0 + exp(( -26.0 - var_chaste_interface__membrane__V) * 0.14285714285714285));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][78] = 1.0 * (450.0 / (1.0 + exp(( -45.0 - var_chaste_interface__membrane__V) * 0.10000000000000001))) * (6.0 / (1.0 + exp((var_chaste_interface__membrane__V + 30.0) * 0.086956521739130432)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][79] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__V + 88.0) * 0.041666666666666664));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][80] = 1.0 * (3.0 / (1.0 + exp(( -60.0 - var_chaste_interface__membrane__V) * 0.050000000000000003))) * (1.1200000000000001 / (1.0 + exp((var_chaste_interface__membrane__V - 60.0) * 0.050000000000000003)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][81] = 1.0 / (1.0 + exp(( -5.0 - var_chaste_interface__membrane__V) * 0.071428571428571425));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][82] = 1.0 * (1100.0 / sqrt(1.0 + exp(( -10.0 - var_chaste_interface__membrane__V) * 0.16666666666666666))) * (1.0 / (1.0 + exp((var_chaste_interface__membrane__V - 60.0) * 0.050000000000000003)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][83] = 1.0 / pow(1.0 + exp(( -56.859999999999999 - var_chaste_interface__membrane__V) * 0.11074197120708749), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][84] = 1.0 * (1.0 / (1.0 + exp(( -60.0 - var_chaste_interface__membrane__V) * 0.20000000000000001))) * ((0.10000000000000001 / (1.0 + exp((var_chaste_interface__membrane__V + 35.0) * 0.20000000000000001))) + (0.10000000000000001 / (1.0 + exp((var_chaste_interface__membrane__V - 50.0) * 0.0050000000000000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][85] = 1.0 / (1.0 + exp(( -5.0 - var_chaste_interface__membrane__V) * 0.13333333333333333));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][86] = (1.0 * ((1.3999999999999999 / (1.0 + exp(( -35.0 - var_chaste_interface__membrane__V) * 0.076923076923076927))) + 0.25) * (1.3999999999999999 / (1.0 + exp((var_chaste_interface__membrane__V + 5.0) * 0.20000000000000001)))) + (1.0 / (1.0 + exp((50.0 - var_chaste_interface__membrane__V) * 0.050000000000000003)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][87] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__V + 20.0) * 0.14285714285714285));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][88] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__V + 20.0) * 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][89] = (85.0 * exp((-pow(var_chaste_interface__membrane__V + 45.0, 2.0)) * 0.0031250000000000002)) + (5.0 / (1.0 + exp((var_chaste_interface__membrane__V - 20.0) * 0.20000000000000001))) + 3.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][90] = 1.0 / (1.0 + exp((20.0 - var_chaste_interface__membrane__V) * 0.16666666666666666));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__V = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][91] = (9.5 * exp((-pow(var_chaste_interface__membrane__V + 40.0, 2.0)) * 0.00055555555555555556)) + 0.80000000000000004;
            }
            
            mNeedsRegeneration[0] = false;
        }
        
        AbstractLookupTableCollection::EventHandler::EndEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
    }
    
private:
    /** The single instance of the class */
    static std::auto_ptr<Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables> mpInstance;

    // Row lookup methods memory
    double _lookup_table_0_row[92];
    
    // Lookup tables
    double (*_lookup_table_0)[92];
    
};

std::auto_ptr<Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables> Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::mpInstance;

    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__calcium_dynamics__Ca_SR()
    {
        return var_chaste_interface__calcium_dynamics__Ca_SR;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_calcium_dynamics__i_rel()
    {
        return var_calcium_dynamics__i_rel;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__calcium_dynamics__Ca_i()
    {
        return var_chaste_interface__calcium_dynamics__Ca_i;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__potassium_dynamics__K_i()
    {
        return var_chaste_interface__potassium_dynamics__K_i;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_dynamics__Na_i()
    {
        return var_chaste_interface__sodium_dynamics__Na_i;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__fake_dt()
    {
        return var_chaste_interface__environment__fake_dt;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__i_ionic()
    {
        return var_chaste_interface__i_ionic;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__L_type_Ca_current__i_CaL()
    {
        return var_chaste_interface__L_type_Ca_current__i_CaL;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__L_type_Ca_current_d_gate__d()
    {
        return var_chaste_interface__L_type_Ca_current_d_gate__d;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__L_type_Ca_current_fCa_gate__fCa()
    {
        return var_chaste_interface__L_type_Ca_current_fCa_gate__fCa;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_L_type_Ca_current_fCa_gate__tau_fCa()
    {
        return var_L_type_Ca_current_fCa_gate__tau_fCa;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__L_type_Ca_current_f_gate__f()
    {
        return var_chaste_interface__L_type_Ca_current_f_gate__f;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_L_type_Ca_current_f_gate__tau_f()
    {
        return var_L_type_Ca_current_f_gate__tau_f;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__calcium_background_current__i_b_Ca()
    {
        return var_chaste_interface__calcium_background_current__i_b_Ca;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_background_current__i_b_Na()
    {
        return var_chaste_interface__sodium_background_current__i_b_Na;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__calcium_pump_current__i_p_Ca()
    {
        return var_chaste_interface__calcium_pump_current__i_p_Ca;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current__i_Na()
    {
        return var_chaste_interface__fast_sodium_current__i_Na;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current_h_gate__h()
    {
        return var_chaste_interface__fast_sodium_current_h_gate__h;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_fast_sodium_current_h_gate__tau_h()
    {
        return var_fast_sodium_current_h_gate__tau_h;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current_j_gate__j()
    {
        return var_chaste_interface__fast_sodium_current_j_gate__j;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_fast_sodium_current_j_gate__tau_j()
    {
        return var_fast_sodium_current_j_gate__tau_j;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__fast_sodium_current_m_gate__m()
    {
        return var_chaste_interface__fast_sodium_current_m_gate__m;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__inward_rectifier_potassium_current__i_K1()
    {
        return var_chaste_interface__inward_rectifier_potassium_current__i_K1;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__potassium_pump_current__i_p_K()
    {
        return var_chaste_interface__potassium_pump_current__i_p_K;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__rapid_time_dependent_potassium_current__i_Kr()
    {
        return var_chaste_interface__rapid_time_dependent_potassium_current__i_Kr;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__slow_time_dependent_potassium_current__i_Ks()
    {
        return var_chaste_interface__slow_time_dependent_potassium_current__i_Ks;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_calcium_exchanger_current__i_NaCa()
    {
        return var_chaste_interface__sodium_calcium_exchanger_current__i_NaCa;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__sodium_potassium_pump_current__i_NaK()
    {
        return var_chaste_interface__sodium_potassium_pump_current__i_NaK;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__i_Stim()
    {
        return var_chaste_interface__membrane__i_Stim;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_amplitude()
    {
        return var_chaste_interface__membrane__stim_amplitude;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_duration()
    {
        return var_chaste_interface__membrane__stim_duration;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_start()
    {
        return var_chaste_interface__membrane__stim_start;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__stim_period()
    {
        return var_chaste_interface__membrane__stim_period;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__transient_outward_current__i_to()
    {
        return var_chaste_interface__transient_outward_current__i_to;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__V()
    {
        return var_chaste_interface__membrane__V;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__time()
    {
        return var_chaste_interface__environment__time;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_SR_leak_current_max_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 0);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_SR_release_current_max_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 1);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_SR_uptake_current_max_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 2);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_concentration_clamp_onoff_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 3);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_extracellular_calcium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 4);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_extracellular_potassium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 5);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_extracellular_sodium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 6);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_L_type_calcium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 7);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_L_type_calcium_current_fCa_gate_tau_constant()
    {
        // Constant value given in CellML
        const double var_L_type_Ca_current_fCa_gate__tau_fCa = 2.0; // millisecond
        return var_L_type_Ca_current_fCa_gate__tau_fCa;
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_background_calcium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 8);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_background_sodium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 9);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_calcium_pump_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 10);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_capacitance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 11);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 12);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_reduced_inactivation_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 13);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_shift_inactivation_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 14);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_inward_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 15);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_potassium_pump_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 16);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_rapid_delayed_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 17);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_slow_delayed_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 18);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_sodium_calcium_exchanger_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 19);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_sodium_potassium_pump_current_permeability_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 20);
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_amplitude_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_amplitude =  -52.0 * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        return var_chaste_interface__membrane__stim_amplitude;
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_duration_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_duration = 1.0; // millisecond
        return var_chaste_interface__membrane__stim_duration;
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_offset_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_start = 100.0; // millisecond
        return var_chaste_interface__membrane__stim_start;
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_period_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__stim_period = 1000.0; // millisecond
        return var_chaste_interface__membrane__stim_period;
    }
    
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_transient_outward_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 21);
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Get_membrane_data_clamp_current_conductance_constant() // RJ
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 22);
    }

    
    boost::shared_ptr<RegularStimulus> Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::UseCellMLDefaultStimulus()
    {
        // Use the default stimulus specified by CellML metadata
        var_chaste_interface__membrane__stim_start = 100.0; // millisecond
        var_chaste_interface__membrane__stim_period = 1000.0; // millisecond
        var_chaste_interface__membrane__stim_duration = 1.0; // millisecond
        var_chaste_interface__membrane__stim_amplitude =  -52.0 * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        boost::shared_ptr<RegularStimulus> p_cellml_stim(new RegularStimulus(
                -fabs(var_chaste_interface__membrane__stim_amplitude),
                var_chaste_interface__membrane__stim_duration,
                var_chaste_interface__membrane__stim_period,
                var_chaste_interface__membrane__stim_start
                ));
        mpIntracellularStimulus = p_cellml_stim;
        return p_cellml_stim;
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::GetIntracellularCalciumConcentration()
    {
        return NV_Ith_S(mStateVariables, 12);
    }
    
    Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
        : AbstractCvodeCellWithDataClamp(
                pOdeSolver,
                17,
                0,
                pIntracellularStimulus)
    {
        // Time units: millisecond
        // 
        this->mpSystemInfo = OdeSystemInformation<Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt>::Instance();
        Init();

        // We have a default stimulus specified in the CellML file metadata
        this->mHasDefaultStimulusFromCellML = true;
        NV_Ith_S(this->mParameters, 0) = 8e-5; // (c,calcium_dynamics__V_leak) [per_millisecond]
        NV_Ith_S(this->mParameters, 1) = 0.016464; // (c,calcium_dynamics__a_rel) [millimolar_per_millisecond]
        NV_Ith_S(this->mParameters, 2) = 0.000425; // (c,calcium_dynamics__Vmax_up) [millimolar_per_millisecond]
        NV_Ith_S(this->mParameters, 3) = 1; // (c,sodium_dynamics__conc_clamp) [dimensionless]
        NV_Ith_S(this->mParameters, 4) = 2; // (c,calcium_dynamics__Ca_o) [millimolar]
        NV_Ith_S(this->mParameters, 5) = 5.4; // (c,potassium_dynamics__K_o) [millimolar]
        NV_Ith_S(this->mParameters, 6) = 140; // (c,sodium_dynamics__Na_o) [millimolar]
        NV_Ith_S(this->mParameters, 7) = 0.000175; // (c,L_type_Ca_current__g_CaL) [litre_per_farad_second]
        NV_Ith_S(this->mParameters, 8) = 0.000592; // (c,calcium_background_current__g_bca) [nanoS_per_picoF]
        NV_Ith_S(this->mParameters, 9) = 0.00029; // (c,sodium_background_current__g_bna) [nanoS_per_picoF]
        NV_Ith_S(this->mParameters, 10) = 0.825; // (c,calcium_pump_current__g_pCa) [picoA_per_picoF]
        NV_Ith_S(this->mParameters, 11) = 0.185; // (c,membrane__Cm) [microF]
        NV_Ith_S(this->mParameters, 12) = 14.838; // (c,fast_sodium_current__g_Na) [nanoS_per_picoF]
        NV_Ith_S(this->mParameters, 13) = 0; // (c,fast_sodium_current__perc_reduced_inact_for_IpNa) [dimensionless]
        NV_Ith_S(this->mParameters, 14) = 0; // (c,fast_sodium_current__shift_INa_inact) [millivolt]
        NV_Ith_S(this->mParameters, 15) = 5.405; // (c,inward_rectifier_potassium_current__g_K1) [nanoS_per_picoF]
        NV_Ith_S(this->mParameters, 16) = 0.0146; // (c,potassium_pump_current__g_pK) [nanoS_per_picoF]
        NV_Ith_S(this->mParameters, 17) = 0.096; // (c,rapid_time_dependent_potassium_current__g_Kr) [nanoS_per_picoF]
        NV_Ith_S(this->mParameters, 18) = 0.245; // (c,slow_time_dependent_potassium_current__g_Ks) [nanoS_per_picoF]
        NV_Ith_S(this->mParameters, 19) = 1000; // (c,sodium_calcium_exchanger_current__K_NaCa) [picoA_per_picoF]
        NV_Ith_S(this->mParameters, 20) = 1.362; // (c,sodium_potassium_pump_current__P_NaK) [picoA_per_picoF]
        NV_Ith_S(this->mParameters, 21) = 0.294; // (c,transient_outward_current__g_to) [nanoS_per_picoF]

        NV_Ith_S(this->mParameters, 22) = 0; // (c,data_clamp_current__g_data) [mS_per_mm2] RJ - start at 0 to generate data

        mUseAnalyticJacobian = true;
        mHasAnalyticJacobian = true;
    }
    
    Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::~Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt()
    {
    }
    
    AbstractLookupTableCollection* Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::GetLookupTableCollection()
    {
        return Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance();
    }
    
    double Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::GetIIonic(const std::vector<double>* pStateVariables)
    {
        // For state variable interpolation (SVI) we read in interpolated state variables,
        // otherwise for ionic current interpolation (ICI) we use the state variables of this model (node).
        N_Vector rY;
        bool made_new_cvode_vector = false;
        if (!pStateVariables)
        {
            rY = rGetStateVariables();
        }
        else
        {
            made_new_cvode_vector = true;
            rY = MakeNVector(*pStateVariables);
        }
        
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -86.2
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__L_type_Ca_current_d_gate__d = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__L_type_Ca_current_f_gate__f = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__L_type_Ca_current_fCa_gate__fCa = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_s_gate__s = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_r_gate__r = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__calcium_dynamics__Ca_i = NV_Ith_S(rY, 12);
        // Units: millimolar; Initial value: 0.0002
        double var_chaste_interface__sodium_dynamics__Na_i = NV_Ith_S(rY, 15);
        // Units: millimolar; Initial value: 11.6
        double var_chaste_interface__potassium_dynamics__K_i = NV_Ith_S(rY, 16);
        // Units: millimolar; Initial value: 138.3
        
        // Lookup table indexing
        const bool _oob_0 = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        const double var_reversal_potentials__E_K = 26.713760659695648 * log(NV_Ith_S(mParameters, 5) / var_chaste_interface__potassium_dynamics__K_i); // millivolt
        const double var_inward_rectifier_potassium_current__alpha_K1 = 0.10000000000000001 / (1.0 + exp(0.059999999999999998 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) - 200.0))); // per_millisecond
        const double var_inward_rectifier_potassium_current__i_K1 = NV_Ith_S(mParameters, 15) * (var_inward_rectifier_potassium_current__alpha_K1 / (var_inward_rectifier_potassium_current__alpha_K1 + (((3.0 * exp(0.00020000000000000001 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) + 100.0))) + (1.0 * exp(0.10000000000000001 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) - 10.0)))) / (1.0 + exp( -0.5 * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K)))))) * sqrt(NV_Ith_S(mParameters, 5) * 0.18518518518518517) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_transient_outward_current__i_to = NV_Ith_S(mParameters, 21) * var_chaste_interface__transient_outward_current_r_gate__r * var_chaste_interface__transient_outward_current_s_gate__s * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_rapid_time_dependent_potassium_current__i_Kr = NV_Ith_S(mParameters, 17) * sqrt(NV_Ith_S(mParameters, 5) * 0.18518518518518517) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 * var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_slow_time_dependent_potassium_current__i_Ks = NV_Ith_S(mParameters, 18) * pow(var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs, 2.0) * (var_chaste_interface__membrane__V - (26.713760659695648 * log((NV_Ith_S(mParameters, 5) + (0.029999999999999999 * NV_Ith_S(mParameters, 6))) / (var_chaste_interface__potassium_dynamics__K_i + (0.029999999999999999 * var_chaste_interface__sodium_dynamics__Na_i))))); // picoA_per_picoF
        const double var_L_type_Ca_current__i_CaL = (((NV_Ith_S(mParameters, 7) * var_chaste_interface__L_type_Ca_current_d_gate__d * var_chaste_interface__L_type_Ca_current_f_gate__f * var_chaste_interface__L_type_Ca_current_fCa_gate__fCa * var_chaste_interface__membrane__V * 37237684497.486488) * 3.8797490106562429e-07) * ((var_chaste_interface__calcium_dynamics__Ca_i * _lt_0_row[69]) - (0.34100000000000003 * NV_Ith_S(mParameters, 4)))) / _lt_0_row[70]; // picoA_per_picoF
        const double var_sodium_potassium_pump_current__i_NaK = ((((NV_Ith_S(mParameters, 20) * NV_Ith_S(mParameters, 5)) / (NV_Ith_S(mParameters, 5) + 1.0)) * var_chaste_interface__sodium_dynamics__Na_i) / (var_chaste_interface__sodium_dynamics__Na_i + 40.0)) / _lt_0_row[72]; // picoA_per_picoF
        const double var_reversal_potentials__E_Na = 26.713760659695648 * log(NV_Ith_S(mParameters, 6) / var_chaste_interface__sodium_dynamics__Na_i); // millivolt
        const double var_fast_sodium_current__i_Na = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__fast_sodium_current_m_gate__m, 3.0) * var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j * (var_chaste_interface__membrane__V - var_reversal_potentials__E_Na); // picoA_per_picoF
        const double var_sodium_background_current__i_b_Na = NV_Ith_S(mParameters, 9) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_Na); // picoA_per_picoF
        const double var_sodium_calcium_exchanger_current__i_NaCa = (NV_Ith_S(mParameters, 19) * ((_lt_0_row[73] * pow(var_chaste_interface__sodium_dynamics__Na_i, 3.0) * NV_Ith_S(mParameters, 4)) - (_lt_0_row[74] * pow(NV_Ith_S(mParameters, 6), 3.0) * var_chaste_interface__calcium_dynamics__Ca_i * 2.5))) / ((669921.875 + pow(NV_Ith_S(mParameters, 6), 3.0)) * (1.3799999999999999 + NV_Ith_S(mParameters, 4)) * _lt_0_row[75]); // picoA_per_picoF
        const double var_calcium_background_current__i_b_Ca = NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__V - (13.356880329847824 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__calcium_dynamics__Ca_i))); // picoA_per_picoF
        const double var_potassium_pump_current__i_p_K = (NV_Ith_S(mParameters, 16) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K)) / _lt_0_row[76]; // picoA_per_picoF
        const double var_calcium_pump_current__i_p_Ca = (NV_Ith_S(mParameters, 10) * var_chaste_interface__calcium_dynamics__Ca_i) / (var_chaste_interface__calcium_dynamics__Ca_i + 0.00050000000000000001); // picoA_per_picoF
        const double var_chaste_interface__L_type_Ca_current__i_CaL = var_L_type_Ca_current__i_CaL; // picoA_per_picoF
        const double var_chaste_interface__sodium_background_current__i_b_Na = var_sodium_background_current__i_b_Na; // picoA_per_picoF
        const double var_chaste_interface__inward_rectifier_potassium_current__i_K1 = var_inward_rectifier_potassium_current__i_K1; // picoA_per_picoF
        const double var_chaste_interface__fast_sodium_current__i_Na = var_fast_sodium_current__i_Na; // picoA_per_picoF
        const double var_chaste_interface__rapid_time_dependent_potassium_current__i_Kr = var_rapid_time_dependent_potassium_current__i_Kr; // picoA_per_picoF
        const double var_chaste_interface__slow_time_dependent_potassium_current__i_Ks = var_slow_time_dependent_potassium_current__i_Ks; // picoA_per_picoF
        const double var_chaste_interface__calcium_pump_current__i_p_Ca = var_calcium_pump_current__i_p_Ca; // picoA_per_picoF
        const double var_chaste_interface__sodium_calcium_exchanger_current__i_NaCa = var_sodium_calcium_exchanger_current__i_NaCa; // picoA_per_picoF
        const double var_chaste_interface__sodium_potassium_pump_current__i_NaK = var_sodium_potassium_pump_current__i_NaK; // picoA_per_picoF
        const double var_chaste_interface__potassium_pump_current__i_p_K = var_potassium_pump_current__i_p_K; // picoA_per_picoF
        const double var_chaste_interface__transient_outward_current__i_to = var_transient_outward_current__i_to; // picoA_per_picoF
        const double var_chaste_interface__calcium_background_current__i_b_Ca = var_calcium_background_current__i_b_Ca; // picoA_per_picoF
        var_chaste_interface__i_ionic = (var_chaste_interface__inward_rectifier_potassium_current__i_K1 + var_chaste_interface__transient_outward_current__i_to + var_chaste_interface__rapid_time_dependent_potassium_current__i_Kr + var_chaste_interface__slow_time_dependent_potassium_current__i_Ks + var_chaste_interface__L_type_Ca_current__i_CaL + var_chaste_interface__sodium_potassium_pump_current__i_NaK + var_chaste_interface__fast_sodium_current__i_Na + var_chaste_interface__sodium_background_current__i_b_Na + var_chaste_interface__sodium_calcium_exchanger_current__i_NaCa + var_chaste_interface__calcium_background_current__i_b_Ca + var_chaste_interface__potassium_pump_current__i_p_K + var_chaste_interface__calcium_pump_current__i_p_Ca) * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        
        const double i_ionic = var_chaste_interface__i_ionic;
        if (made_new_cvode_vector)
        {
            DeleteVector(rY);
        }
        EXCEPT_IF_NOT(!std::isnan(i_ionic));
        return i_ionic;
    }
    
    void Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -86.2
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__L_type_Ca_current_d_gate__d = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__L_type_Ca_current_f_gate__f = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__L_type_Ca_current_fCa_gate__fCa = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_s_gate__s = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_r_gate__r = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__calcium_dynamics__Ca_i = NV_Ith_S(rY, 12);
        // Units: millimolar; Initial value: 0.0002
        double var_chaste_interface__calcium_dynamics__Ca_SR = NV_Ith_S(rY, 13);
        // Units: millimolar; Initial value: 0.2
        double var_chaste_interface__calcium_dynamics__g = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__sodium_dynamics__Na_i = NV_Ith_S(rY, 15);
        // Units: millimolar; Initial value: 11.6
        double var_chaste_interface__potassium_dynamics__K_i = NV_Ith_S(rY, 16);
        // Units: millimolar; Initial value: 138.3
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        // Mathematics
        double d_dt_chaste_interface__membrane__V;
        const double var_reversal_potentials__E_K = 26.713760659695648 * log(NV_Ith_S(mParameters, 5) / var_chaste_interface__potassium_dynamics__K_i); // millivolt
        const double var_inward_rectifier_potassium_current__alpha_K1 = 0.10000000000000001 / (1.0 + exp(0.059999999999999998 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) - 200.0))); // per_millisecond
        const double var_inward_rectifier_potassium_current__i_K1 = NV_Ith_S(mParameters, 15) * (var_inward_rectifier_potassium_current__alpha_K1 / (var_inward_rectifier_potassium_current__alpha_K1 + (((3.0 * exp(0.00020000000000000001 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) + 100.0))) + (1.0 * exp(0.10000000000000001 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) - 10.0)))) / (1.0 + exp( -0.5 * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K)))))) * sqrt(NV_Ith_S(mParameters, 5) * 0.18518518518518517) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_transient_outward_current__i_to = NV_Ith_S(mParameters, 21) * var_chaste_interface__transient_outward_current_r_gate__r * var_chaste_interface__transient_outward_current_s_gate__s * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_rapid_time_dependent_potassium_current__i_Kr = NV_Ith_S(mParameters, 17) * sqrt(NV_Ith_S(mParameters, 5) * 0.18518518518518517) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 * var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_slow_time_dependent_potassium_current__i_Ks = NV_Ith_S(mParameters, 18) * pow(var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs, 2.0) * (var_chaste_interface__membrane__V - (26.713760659695648 * log((NV_Ith_S(mParameters, 5) + (0.029999999999999999 * NV_Ith_S(mParameters, 6))) / (var_chaste_interface__potassium_dynamics__K_i + (0.029999999999999999 * var_chaste_interface__sodium_dynamics__Na_i))))); // picoA_per_picoF
        const double var_L_type_Ca_current__i_CaL = (((NV_Ith_S(mParameters, 7) * var_chaste_interface__L_type_Ca_current_d_gate__d * var_chaste_interface__L_type_Ca_current_f_gate__f * var_chaste_interface__L_type_Ca_current_fCa_gate__fCa * var_chaste_interface__membrane__V * 37237684497.486488) * 3.8797490106562429e-07) * ((var_chaste_interface__calcium_dynamics__Ca_i * _lt_0_row[69]) - (0.34100000000000003 * NV_Ith_S(mParameters, 4)))) / _lt_0_row[70]; // picoA_per_picoF
        const double var_sodium_potassium_pump_current__i_NaK = ((((NV_Ith_S(mParameters, 20) * NV_Ith_S(mParameters, 5)) / (NV_Ith_S(mParameters, 5) + 1.0)) * var_chaste_interface__sodium_dynamics__Na_i) / (var_chaste_interface__sodium_dynamics__Na_i + 40.0)) / _lt_0_row[72]; // picoA_per_picoF
        const double var_reversal_potentials__E_Na = 26.713760659695648 * log(NV_Ith_S(mParameters, 6) / var_chaste_interface__sodium_dynamics__Na_i); // millivolt
        const double var_fast_sodium_current__i_Na = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__fast_sodium_current_m_gate__m, 3.0) * var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j * (var_chaste_interface__membrane__V - var_reversal_potentials__E_Na); // picoA_per_picoF
        const double var_sodium_background_current__i_b_Na = NV_Ith_S(mParameters, 9) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_Na); // picoA_per_picoF
        const double var_sodium_calcium_exchanger_current__i_NaCa = (NV_Ith_S(mParameters, 19) * ((_lt_0_row[73] * pow(var_chaste_interface__sodium_dynamics__Na_i, 3.0) * NV_Ith_S(mParameters, 4)) - (_lt_0_row[74] * pow(NV_Ith_S(mParameters, 6), 3.0) * var_chaste_interface__calcium_dynamics__Ca_i * 2.5))) / ((669921.875 + pow(NV_Ith_S(mParameters, 6), 3.0)) * (1.3799999999999999 + NV_Ith_S(mParameters, 4)) * _lt_0_row[75]); // picoA_per_picoF
        const double var_calcium_background_current__i_b_Ca = NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__V - (13.356880329847824 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__calcium_dynamics__Ca_i))); // picoA_per_picoF
        const double var_potassium_pump_current__i_p_K = (NV_Ith_S(mParameters, 16) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K)) / _lt_0_row[76]; // picoA_per_picoF
        const double var_calcium_pump_current__i_p_Ca = (NV_Ith_S(mParameters, 10) * var_chaste_interface__calcium_dynamics__Ca_i) / (var_chaste_interface__calcium_dynamics__Ca_i + 0.00050000000000000001); // picoA_per_picoF
        var_chaste_interface__membrane__i_Stim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_fast_sodium_current_h_gate__tau_h = _lt_0_row[67]; // millisecond
        const double var_fast_sodium_current_j_gate__tau_j = _lt_0_row[68]; // millisecond
        const double var_L_type_Ca_current_f_gate__tau_f = _lt_0_row[71]; // millisecond
        const double var_L_type_Ca_current_fCa_gate__fCa_inf = ((1.0 / (1.0 + pow(var_chaste_interface__calcium_dynamics__Ca_i * 3076.9230769230771, 8.0))) + (0.10000000000000001 / (1.0 + exp((var_chaste_interface__calcium_dynamics__Ca_i - 0.00050000000000000001) * 10000.0))) + (0.20000000000000001 / (1.0 + exp((var_chaste_interface__calcium_dynamics__Ca_i - 0.00075000000000000002) * 1250.0))) + 0.23000000000000001) * 0.68493150684931503; // dimensionless
        const double var_L_type_Ca_current_fCa_gate__tau_fCa = 2.0; // millisecond
        const double var_calcium_dynamics__i_rel = (((NV_Ith_S(mParameters, 1) * pow(var_chaste_interface__calcium_dynamics__Ca_SR, 2.0)) / (0.0625 + pow(var_chaste_interface__calcium_dynamics__Ca_SR, 2.0))) + 0.0082319999999999997) * var_chaste_interface__L_type_Ca_current_d_gate__d * var_chaste_interface__calcium_dynamics__g; // millimolar_per_millisecond
        const double var_calcium_dynamics__i_up = NV_Ith_S(mParameters, 2) / (1.0 + (6.2499999999999997e-08 / pow(var_chaste_interface__calcium_dynamics__Ca_i, 2.0))); // millimolar_per_millisecond
        const double var_calcium_dynamics__i_leak = NV_Ith_S(mParameters, 0) * (var_chaste_interface__calcium_dynamics__Ca_SR - var_chaste_interface__calcium_dynamics__Ca_i); // millimolar_per_millisecond
        const double var_calcium_dynamics__g_inf = (var_chaste_interface__calcium_dynamics__Ca_i < 0.00035) ? (1.0 / (1.0 + pow(var_chaste_interface__calcium_dynamics__Ca_i * 2857.1428571428573, 6.0))) : (1.0 / (1.0 + pow(var_chaste_interface__calcium_dynamics__Ca_i * 2857.1428571428573, 16.0))); // dimensionless
        const double d_dt_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 = (_lt_0_row[77] - var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1) / _lt_0_row[78]; // per_millisecond
        const double d_dt_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 = (_lt_0_row[79] - var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2) / _lt_0_row[80]; // per_millisecond
        const double d_dt_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs = (_lt_0_row[81] - var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs) / _lt_0_row[82]; // per_millisecond
        const double d_dt_chaste_interface__fast_sodium_current_m_gate__m = (_lt_0_row[83] - var_chaste_interface__fast_sodium_current_m_gate__m) / _lt_0_row[84]; // per_millisecond
        const double d_dt_chaste_interface__fast_sodium_current_h_gate__h = ((((1.0 * (1.0 - (NV_Ith_S(mParameters, 13) * 0.01))) / pow(1.0 + exp(((var_chaste_interface__membrane__V + 71.549999999999997) - NV_Ith_S(mParameters, 14)) * 0.13458950201884254), 2.0)) + (NV_Ith_S(mParameters, 13) * 0.01)) - var_chaste_interface__fast_sodium_current_h_gate__h) / var_fast_sodium_current_h_gate__tau_h; // per_millisecond
        const double d_dt_chaste_interface__fast_sodium_current_j_gate__j = ((((1.0 * (1.0 - (NV_Ith_S(mParameters, 13) * 0.01))) / pow(1.0 + exp(((var_chaste_interface__membrane__V + 71.549999999999997) - NV_Ith_S(mParameters, 14)) * 0.13458950201884254), 2.0)) + (NV_Ith_S(mParameters, 13) * 0.01)) - var_chaste_interface__fast_sodium_current_j_gate__j) / var_fast_sodium_current_j_gate__tau_j; // per_millisecond
        const double d_dt_chaste_interface__L_type_Ca_current_d_gate__d = (_lt_0_row[85] - var_chaste_interface__L_type_Ca_current_d_gate__d) / _lt_0_row[86]; // per_millisecond
        const double d_dt_chaste_interface__L_type_Ca_current_f_gate__f = (_lt_0_row[87] - var_chaste_interface__L_type_Ca_current_f_gate__f) / var_L_type_Ca_current_f_gate__tau_f; // per_millisecond
        const double d_dt_chaste_interface__L_type_Ca_current_fCa_gate__fCa = ((var_L_type_Ca_current_fCa_gate__fCa_inf > var_chaste_interface__L_type_Ca_current_fCa_gate__fCa) && (var_chaste_interface__membrane__V >  -60.0)) ? 0.0 : ((var_L_type_Ca_current_fCa_gate__fCa_inf - var_chaste_interface__L_type_Ca_current_fCa_gate__fCa) / var_L_type_Ca_current_fCa_gate__tau_fCa); // per_millisecond
        const double d_dt_chaste_interface__transient_outward_current_s_gate__s = (_lt_0_row[88] - var_chaste_interface__transient_outward_current_s_gate__s) / _lt_0_row[89]; // per_millisecond
        const double d_dt_chaste_interface__transient_outward_current_r_gate__r = (_lt_0_row[90] - var_chaste_interface__transient_outward_current_r_gate__r) / _lt_0_row[91]; // per_millisecond
        const double d_dt_chaste_interface__calcium_dynamics__Ca_i = (1.0 / (1.0 + (0.00014999999999999999 / pow(var_chaste_interface__calcium_dynamics__Ca_i + 0.001, 2.0)))) * (((var_calcium_dynamics__i_leak - var_calcium_dynamics__i_up) + var_calcium_dynamics__i_rel) - (((1.0 * ((var_L_type_Ca_current__i_CaL + var_calcium_background_current__i_b_Ca + var_calcium_pump_current__i_p_Ca) - (2.0 * var_sodium_calcium_exchanger_current__i_NaCa))) * 0.00031590674984870111) * NV_Ith_S(mParameters, 11))); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__calcium_dynamics__Ca_SR = (((1.0 / (1.0 + (3.0 / pow(var_chaste_interface__calcium_dynamics__Ca_SR + 0.29999999999999999, 2.0)))) * 0.016403999999999998) * 914.0767824497259) * (var_calcium_dynamics__i_up - (var_calcium_dynamics__i_rel + var_calcium_dynamics__i_leak)); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__calcium_dynamics__g = ((var_calcium_dynamics__g_inf > var_chaste_interface__calcium_dynamics__g) && (var_chaste_interface__membrane__V >  -60.0)) ? 0.0 : ((var_calcium_dynamics__g_inf - var_chaste_interface__calcium_dynamics__g) * 0.5); // per_millisecond
        const double d_dt_chaste_interface__sodium_dynamics__Na_i = (((-NV_Ith_S(mParameters, 3)) * 1.0 * (var_fast_sodium_current__i_Na + var_sodium_background_current__i_b_Na + (3.0 * var_sodium_potassium_pump_current__i_NaK) + (3.0 * var_sodium_calcium_exchanger_current__i_NaCa))) * 0.00063181349969740222) * NV_Ith_S(mParameters, 11); // 'millimole per litre per millisecond'
        //const double d_dt_chaste_interface__potassium_dynamics__K_i = (((-NV_Ith_S(mParameters, 3)) * 1.0 * ((var_inward_rectifier_potassium_current__i_K1 + var_transient_outward_current__i_to + var_rapid_time_dependent_potassium_current__i_Kr + var_slow_time_dependent_potassium_current__i_Ks + var_potassium_pump_current__i_p_K + (var_chaste_interface__membrane__i_Stim / HeartConfig::Instance()->GetCapacitance())) - (2.0 * var_sodium_potassium_pump_current__i_NaK))) * 0.00063181349969740222) * NV_Ith_S(mParameters, 11); // 'millimole per litre per millisecond' // RJ

        double var_data_clamp_current__i_data = 0; // RJ
        if (mDataClampIsOn)
        {
            double interpolated_data_voltage = GetExperimentalVoltageAtTimeT(var_chaste_interface__environment__time);
            var_data_clamp_current__i_data = NV_Ith_S(mParameters, 22) * (var_chaste_interface__membrane__V - interpolated_data_voltage);
        }

        if (mSetVoltageDerivativeToZero)
        {
            d_dt_chaste_interface__membrane__V = 0.0;
        }
        else // RJ
        {
            d_dt_chaste_interface__membrane__V = -(var_data_clamp_current__i_data + var_inward_rectifier_potassium_current__i_K1 + var_transient_outward_current__i_to + var_rapid_time_dependent_potassium_current__i_Kr + var_slow_time_dependent_potassium_current__i_Ks + var_L_type_Ca_current__i_CaL + var_sodium_potassium_pump_current__i_NaK + var_fast_sodium_current__i_Na + var_sodium_background_current__i_b_Na + var_sodium_calcium_exchanger_current__i_NaCa + var_calcium_background_current__i_b_Ca + var_potassium_pump_current__i_p_K + var_calcium_pump_current__i_p_Ca + (var_chaste_interface__membrane__i_Stim / HeartConfig::Instance()->GetCapacitance())); // 'millivolt per millisecond'
        }
        
        NV_Ith_S(rDY, 0) = d_dt_chaste_interface__membrane__V;
        NV_Ith_S(rDY, 1) = d_dt_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1;
        NV_Ith_S(rDY, 2) = d_dt_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2;
        NV_Ith_S(rDY, 3) = d_dt_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs;
        NV_Ith_S(rDY, 4) = d_dt_chaste_interface__fast_sodium_current_m_gate__m;
        NV_Ith_S(rDY, 5) = d_dt_chaste_interface__fast_sodium_current_h_gate__h;
        NV_Ith_S(rDY, 6) = d_dt_chaste_interface__fast_sodium_current_j_gate__j;
        NV_Ith_S(rDY, 7) = d_dt_chaste_interface__L_type_Ca_current_d_gate__d;
        NV_Ith_S(rDY, 8) = d_dt_chaste_interface__L_type_Ca_current_f_gate__f;
        NV_Ith_S(rDY, 9) = d_dt_chaste_interface__L_type_Ca_current_fCa_gate__fCa;
        NV_Ith_S(rDY, 10) = d_dt_chaste_interface__transient_outward_current_s_gate__s;
        NV_Ith_S(rDY, 11) = d_dt_chaste_interface__transient_outward_current_r_gate__r;
        NV_Ith_S(rDY, 12) = d_dt_chaste_interface__calcium_dynamics__Ca_i;
        NV_Ith_S(rDY, 13) = d_dt_chaste_interface__calcium_dynamics__Ca_SR;
        NV_Ith_S(rDY, 14) = d_dt_chaste_interface__calcium_dynamics__g;
        NV_Ith_S(rDY, 15) = d_dt_chaste_interface__sodium_dynamics__Na_i;
        //NV_Ith_S(rDY, 16) = d_dt_chaste_interface__potassium_dynamics__K_i;
        NV_Ith_S(rDY, 16) = 0;  // RJ -
    }
    
    void Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::EvaluateAnalyticJacobian(long int N, double var_chaste_interface__environment__time, N_Vector rY, N_Vector rDY, CHASTE_CVODE_DENSE_MATRIX rJacobian, N_Vector rTmp1, N_Vector rTmp2, N_Vector rTmp3)
    {
        assert(false); // RJ
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -86.2
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__L_type_Ca_current_d_gate__d = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__L_type_Ca_current_f_gate__f = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__L_type_Ca_current_fCa_gate__fCa = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_s_gate__s = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_r_gate__r = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__calcium_dynamics__Ca_i = NV_Ith_S(rY, 12);
        // Units: millimolar; Initial value: 0.0002
        double var_chaste_interface__calcium_dynamics__Ca_SR = NV_Ith_S(rY, 13);
        // Units: millimolar; Initial value: 0.2
        double var_chaste_interface__calcium_dynamics__g = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__sodium_dynamics__Na_i = NV_Ith_S(rY, 15);
        // Units: millimolar; Initial value: 11.6
        double var_chaste_interface__potassium_dynamics__K_i = NV_Ith_S(rY, 16);
        // Units: millimolar; Initial value: 138.3
        
        // Lookup table indexing
        const bool _oob_0 = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        var_chaste_interface__environment__fake_dt = 1.0; // millisecond
        const double var_t4 = 1.0 / var_chaste_interface__potassium_dynamics__K_i; // dimensionless
        const double var_t8 = 26.713760659695648 * log(NV_Ith_S(mParameters, 5) * var_t4); // dimensionless
        const double var_t11 = exp(((0.059999999999999998 * var_chaste_interface__membrane__V) - (0.059999999999999998 * var_t8)) - 12.0); // dimensionless
        const double var_t12 = 1.0 + var_t11; // dimensionless
        const double var_t14 = 1.0 / pow(var_t12, 2.0); // dimensionless
        const double var_t15 = NV_Ith_S(mParameters, 15) * var_t14; // dimensionless
        const double var_t16 = 1.0 / var_t12; // dimensionless
        const double var_t21 = exp(((0.00020000000000000001 * var_chaste_interface__membrane__V) - (0.00020000000000000001 * var_t8)) + 0.02); // dimensionless
        const double var_t26 = exp(((0.10000000000000001 * var_chaste_interface__membrane__V) - (0.10000000000000001 * var_t8)) - 1.0); // dimensionless
        const double var_t27 = (3.0 * var_t21) + var_t26; // dimensionless
        const double var_t31 = exp(( -0.5 * var_chaste_interface__membrane__V) + (0.5 * var_t8)); // dimensionless
        const double var_t32 = 1.0 + var_t31; // dimensionless
        const double var_t33 = 1.0 / var_t32; // dimensionless
        const double var_t35 = (0.10000000000000001 * var_t16) + (var_t27 * var_t33); // dimensionless
        const double var_t36 = 1.0 / var_t35; // dimensionless
        const double var_t38 = pow(NV_Ith_S(mParameters, 5), 0.5); // dimensionless
        const double var_t39 = var_chaste_interface__membrane__V - var_t8; // dimensionless
        const double var_t40 = var_t38 * var_t39; // dimensionless
        const double var_t43 = (((0.0025819888969999998 * var_t15) * var_t36) * var_t40) * var_t11; // dimensionless
        const double var_t44 = NV_Ith_S(mParameters, 15) * var_t16; // dimensionless
        const double var_t47 = var_t44 / pow(var_t35, 2.0); // dimensionless
        const double var_t56 = var_t27 / pow(var_t32, 2.0); // dimensionless
        const double var_t62 = ((0.043033148290000003 * var_t47) * var_t40) * (((( -0.0060000000000000001 * var_t14) * var_t11) + (((0.00059999999999999995 * var_t21) + (0.10000000000000001 * var_t26)) * var_t33)) + ((0.5 * var_t56) * var_t31)); // dimensionless
        const double var_t63 = var_t36 * var_t38; // dimensionless
        const double var_t64 = var_t44 * var_t63; // dimensionless
        const double var_t65 = 0.043033148290000003 * var_t64; // dimensionless
        const double var_t66 = NV_Ith_S(mParameters, 21) * var_chaste_interface__transient_outward_current_r_gate__r; // dimensionless
        const double var_t67 = var_t66 * var_chaste_interface__transient_outward_current_s_gate__s; // dimensionless
        const double var_t68 = NV_Ith_S(mParameters, 17) * var_t38; // dimensionless
        const double var_t70 = (var_t68 * var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2; // dimensionless
        const double var_t71 = 0.43033148290000001 * var_t70; // dimensionless
        const double var_t73 = NV_Ith_S(mParameters, 18) * pow(var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs, 2.0); // dimensionless
        const double var_t74 = NV_Ith_S(mParameters, 7) * var_chaste_interface__L_type_Ca_current_d_gate__d; // dimensionless
        const double var_t75 = var_chaste_interface__L_type_Ca_current_f_gate__f * var_chaste_interface__L_type_Ca_current_fCa_gate__fCa; // dimensionless
        const double var_t86 = var_chaste_interface__calcium_dynamics__Ca_i * _lt_0_row[0]; // dimensionless
        const double var_t88 = var_t86 - (0.34100000000000003 * NV_Ith_S(mParameters, 4)); // dimensionless
        const double var_t93 = (3611.8217397063131 * var_t88) * _lt_0_row[1]; // dimensionless
        const double var_t95 = ((4.0 * var_t74) * var_t75) * var_t93; // dimensionless
        const double var_t97 = (var_t74 * var_t75) * var_chaste_interface__membrane__V; // dimensionless
        const double var_t108 = (((8.0 * var_t97) * 135.20454067538475) * var_t86) * _lt_0_row[1]; // dimensionless
        const double var_t115 = ((((8.0 * var_t97) * 135.20454067538475) * var_t88) / _lt_0_row[2]) * _lt_0_row[0]; // dimensionless
        const double var_t116 = NV_Ith_S(mParameters, 20) * NV_Ith_S(mParameters, 5); // dimensionless
        const double var_t118 = 1.0 / (NV_Ith_S(mParameters, 5) + 1.0); // dimensionless
        const double var_t119 = var_t116 * var_t118; // dimensionless
        const double var_t120 = var_chaste_interface__sodium_dynamics__Na_i + 40.0; // dimensionless
        const double var_t121 = 1.0 / var_t120; // dimensionless
        const double var_t141 = (((var_t119 * var_chaste_interface__sodium_dynamics__Na_i) * var_t121) / _lt_0_row[3]) * _lt_0_row[4]; // dimensionless
        const double var_t142 = pow(var_chaste_interface__fast_sodium_current_m_gate__m, 2.0); // dimensionless
        const double var_t143 = var_t142 * var_chaste_interface__fast_sodium_current_m_gate__m; // dimensionless
        const double var_t144 = NV_Ith_S(mParameters, 12) * var_t143; // dimensionless
        const double var_t145 = var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j; // dimensionless
        const double var_t146 = var_t144 * var_t145; // dimensionless
        const double var_t154 = pow(var_chaste_interface__sodium_dynamics__Na_i, 2.0); // dimensionless
        const double var_t155 = var_t154 * var_chaste_interface__sodium_dynamics__Na_i; // dimensionless
        const double var_t166 = pow(NV_Ith_S(mParameters, 6), 2.0) * NV_Ith_S(mParameters, 6); // dimensionless
        const double var_t167 = _lt_0_row[5] * var_t166; // dimensionless
        const double var_t169 = (var_t167 * var_chaste_interface__calcium_dynamics__Ca_i) * 2.5; // dimensionless
        const double var_t176 = 1.0 / (669921.875 + var_t166); // dimensionless
        const double var_t178 = 1.0 / (1.3799999999999999 + NV_Ith_S(mParameters, 4)); // dimensionless
        const double var_t179 = var_t176 * var_t178; // dimensionless
        const double var_t183 = var_t179 * _lt_0_row[6]; // dimensionless
        const double var_t184 = (NV_Ith_S(mParameters, 19) * (((_lt_0_row[7] * var_t155) * NV_Ith_S(mParameters, 4)) - ( -0.024332029034784559 * var_t169))) * var_t183; // dimensionless
        const double var_t188 = NV_Ith_S(mParameters, 19) * (((_lt_0_row[8] * var_t155) * NV_Ith_S(mParameters, 4)) - var_t169); // dimensionless
        const double var_t197 = ((((((var_t188 * var_t179) / _lt_0_row[9]) * 0.10000000000000001) *  -0.65000000000000002) * 96485.341499999995) * 3.8797490106562429e-07) * _lt_0_row[5]; // dimensionless
        const double var_t203 = NV_Ith_S(mParameters, 16) * _lt_0_row[10]; // dimensionless
        const double var_t209 = (((0.16722408029999999 * NV_Ith_S(mParameters, 16)) * var_t39) / _lt_0_row[11]) * _lt_0_row[12]; // dimensionless
        const double var_t222 = 1.0 / (var_chaste_interface__potassium_dynamics__K_i + (0.029999999999999999 * var_chaste_interface__sodium_dynamics__Na_i)); // dimensionless
        const double var_t227 = var_chaste_interface__membrane__V - (26.713760659695648 * log((NV_Ith_S(mParameters, 5) + (0.029999999999999999 * NV_Ith_S(mParameters, 6))) * var_t222)); // dimensionless
        const double var_t231 = 1.0 / var_chaste_interface__sodium_dynamics__Na_i; // dimensionless
        const double var_t236 = var_chaste_interface__membrane__V - (26.713760659695648 * log(NV_Ith_S(mParameters, 6) * var_t231)); // dimensionless
        const double var_t240 = var_chaste_interface__fast_sodium_current_j_gate__j * var_t236; // dimensionless
        const double var_t244 = NV_Ith_S(mParameters, 7) * var_chaste_interface__L_type_Ca_current_f_gate__f; // dimensionless
        const double var_t245 = var_chaste_interface__L_type_Ca_current_fCa_gate__fCa * var_chaste_interface__membrane__V; // dimensionless
        const double var_t252 = var_chaste_interface__L_type_Ca_current_f_gate__f * var_chaste_interface__membrane__V; // dimensionless
        const double var_t263 = ((((4.0 * var_t97) * 1119664.739308957) * 0.0032258064516129032) * _lt_0_row[0]) * _lt_0_row[1]; // dimensionless
        const double var_t267 = var_t178 * _lt_0_row[6]; // dimensionless
        const double var_t269 = ((((NV_Ith_S(mParameters, 19) * _lt_0_row[5]) * var_t166) * 2.5) * var_t176) * var_t267; // dimensionless
        const double var_t272 = 1.0 / var_chaste_interface__calcium_dynamics__Ca_i; // dimensionless
        const double var_t275 = (((0.5 * NV_Ith_S(mParameters, 8)) * 8314.4719999999998) * 0.0032129232812012176) * var_t272; // dimensionless
        const double var_t276 = var_chaste_interface__calcium_dynamics__Ca_i + 0.00050000000000000001; // dimensionless
        const double var_t277 = 1.0 / var_t276; // dimensionless
        const double var_t278 = NV_Ith_S(mParameters, 10) * var_t277; // dimensionless
        const double var_t279 = NV_Ith_S(mParameters, 10) * var_chaste_interface__calcium_dynamics__Ca_i; // dimensionless
        const double var_t282 = var_t279 / pow(var_t276, 2.0); // dimensionless
        const double var_t284 = var_t73 * 8314.4719999999998; // dimensionless
        const double var_t287 = ((var_t284 * 0.0032129232812012176) * var_t222) * 0.029999999999999999; // dimensionless
        const double var_t291 = ((var_t116 * var_t118) * var_t121) * _lt_0_row[13]; // dimensionless
        const double var_t296 = ((var_t119 * var_chaste_interface__sodium_dynamics__Na_i) / pow(var_t120, 2.0)) * _lt_0_row[13]; // dimensionless
        const double var_t299 = ((var_t146 * 2577486.3199999998) * 1.0364268649036186e-05) * var_t231; // dimensionless
        const double var_t302 = ((NV_Ith_S(mParameters, 9) * 8314.4719999999998) * 0.0032129232812012176) * var_t231; // dimensionless
        const double var_t307 = ((((NV_Ith_S(mParameters, 19) * _lt_0_row[8]) * var_t154) * NV_Ith_S(mParameters, 4)) * var_t176) * var_t267; // dimensionless
        const double var_t312 = 1.0364268649036186e-05 * var_t4; // dimensionless
        const double var_t313 = var_t312 * var_t11; // dimensionless
        const double var_t338 = 2577486.3199999998 * var_t312; // dimensionless
        const double var_t350 = ((((((((((0.0025819888969999998 * var_t15) * var_t63) * var_t39) * 2577486.3199999998) * var_t313) + (((0.043033148290000003 * var_t47) * var_t40) * (((((( -0.0060000000000000001 * var_t14) * 8314.4719999999998) * 310.0) * var_t313) + ((((1546.4917919999998 * var_t312) * var_t21) + ((257748.63199999998 * var_t312) * var_t26)) * var_t33)) + (((((0.5 * var_t56) * 8314.4719999999998) * 0.0032129232812012176) * var_t4) * var_t31)))) - ((0.043033148290000003 * var_t64) * var_t338)) - (var_t67 * var_t338)) - ((0.43033148290000001 * var_t70) * var_t338)) - ((var_t284 * 0.0032129232812012176) * var_t222)) - ((((NV_Ith_S(mParameters, 16) * 8314.4719999999998) * 310.0) * var_t312) * _lt_0_row[10]); // dimensionless
        const double var_t370 = _lt_0_row[14] - var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1; // dimensionless
        const double var_t397 = _lt_0_row[15] - var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2; // dimensionless
        const double var_t422 = _lt_0_row[16] - var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs; // dimensionless
        const double var_t462 = _lt_0_row[17] - var_chaste_interface__fast_sodium_current_m_gate__m; // dimensionless
        const double var_t481 = 0.01 * NV_Ith_S(mParameters, 13); // dimensionless
        const double var_t482 = 1.0 - var_t481; // dimensionless
        const double var_t486 = exp(((0.134589502 * var_chaste_interface__membrane__V) + 9.6298788680000005) - (0.134589502 * NV_Ith_S(mParameters, 14))); // dimensionless
        const double var_t487 = 1.0 + var_t486; // dimensionless
        const double var_t488 = pow(var_t487, 2.0); // dimensionless
        const double var_t491 = (var_t482 / var_t488) / var_t487; // dimensionless
        const double var_t518 = var_t482 / var_t488; // dimensionless
        const double var_t722 = pow(var_chaste_interface__calcium_dynamics__Ca_i, 2.0); // dimensionless
        const double var_t723 = pow(var_t722, 2.0); // dimensionless
        const double var_t724 = pow(var_t723, 2.0); // dimensionless
        const double var_t726 = 1.0 + (8.0340237690000001e+27 * var_t724); // dimensionless
        const double var_t731 = exp((10000.0 * var_chaste_interface__calcium_dynamics__Ca_i) - 5.0); // dimensionless
        const double var_t732 = 1.0 + var_t731; // dimensionless
        const double var_t737 = exp((1250.0 * var_chaste_interface__calcium_dynamics__Ca_i) - 0.9375); // dimensionless
        const double var_t738 = 1.0 + var_t737; // dimensionless
        const double var_t744 = (var_chaste_interface__L_type_Ca_current_fCa_gate__fCa < ((((0.68493150680000003 / var_t726) + (0.068493150680000003 / var_t732)) + (0.13698630140000001 / var_t738)) + 0.15753424660000001)) && ( -60.0 < var_chaste_interface__membrane__V); // dimensionless
        const double var_t749 = var_t722 * var_chaste_interface__calcium_dynamics__Ca_i; // dimensionless
        const double var_t750 = var_t723 * var_t749; // dimensionless
        const double var_t825 = var_chaste_interface__calcium_dynamics__Ca_i + 0.001; // dimensionless
        const double var_t826 = pow(var_t825, 2.0); // dimensionless
        const double var_t829 = 1.0 + (0.00014999999999999999 / var_t826); // dimensionless
        const double var_t830 = 1.0 / var_t829; // dimensionless
        const double var_t837 = 0.00063181349969740233 * NV_Ith_S(mParameters, 11); // dimensionless
        const double var_t840 = pow(var_chaste_interface__calcium_dynamics__Ca_SR, 2.0); // dimensionless
        const double var_t843 = 0.0625 + var_t840; // dimensionless
        const double var_t844 = 1.0 / var_t843; // dimensionless
        const double var_t846 = ((NV_Ith_S(mParameters, 1) * var_t840) * var_t844) + 0.0082319999999999997; // dimensionless
        const double var_t848 = var_t245 * 96485.341499999995; // dimensionless
        const double var_t853 = (((3.8797490106562429e-07 * var_t88) * _lt_0_row[1]) * 60.960741282614002) * NV_Ith_S(mParameters, 11); // dimensionless
        const double var_t859 = (var_t830 * NV_Ith_S(mParameters, 7)) * var_chaste_interface__L_type_Ca_current_d_gate__d; // dimensionless
        const double var_t870 = NV_Ith_S(mParameters, 0) * (var_chaste_interface__calcium_dynamics__Ca_SR - var_chaste_interface__calcium_dynamics__Ca_i); // dimensionless
        const double var_t874 = 1.0 + (6.2499999999999997e-08 / var_t722); // dimensionless
        const double var_t876 = NV_Ith_S(mParameters, 2) / var_t874; // dimensionless
        const double var_t878 = (var_t846 * var_chaste_interface__L_type_Ca_current_d_gate__d) * var_chaste_interface__calcium_dynamics__g; // dimensionless
        const double var_t893 = 1.0364268649036186e-05 * NV_Ith_S(mParameters, 11); // dimensionless
        const double var_t909 = (((2.0 * NV_Ith_S(mParameters, 2)) / pow(var_t874, 2.0)) * 6.2499999999999997e-08) / var_t749; // dimensionless
        const double var_t928 = NV_Ith_S(mParameters, 0) + (((2.0 * (((NV_Ith_S(mParameters, 1) * var_chaste_interface__calcium_dynamics__Ca_SR) * var_t844) - (((NV_Ith_S(mParameters, 1) * var_t840) * var_chaste_interface__calcium_dynamics__Ca_SR) / pow(var_t843, 2.0)))) * var_chaste_interface__L_type_Ca_current_d_gate__d) * var_chaste_interface__calcium_dynamics__g); // dimensionless
        const double var_t936 = var_t183 * var_t837; // dimensionless
        const double var_t940 = var_chaste_interface__calcium_dynamics__Ca_SR + 0.29999999999999999; // dimensionless
        const double var_t941 = pow(var_t940, 2.0); // dimensionless
        const double var_t944 = 1.0 + (3.0 / var_t941); // dimensionless
        const double var_t946 = (1.0 / var_t944) * 0.016403999999999998; // dimensionless
        const double var_t948 = 914.0767824497259 * var_t846; // dimensionless
        const double var_t973 = (5.43991024e+20 * var_t723) * var_t722; // dimensionless
        const double var_t977 = 1.9720198860000001e+55 * pow(var_t724, 2.0); // dimensionless
        const double var_t982 = (var_chaste_interface__calcium_dynamics__g < ((var_chaste_interface__calcium_dynamics__Ca_i < 0.00035) ? (1.0 / (1.0 + var_t973)) : (1.0 / (1.0 + var_t977)))) && ( -60.0 < var_chaste_interface__membrane__V); // dimensionless
        const double var_t1010 = NV_Ith_S(mParameters, 3) * NV_Ith_S(mParameters, 12); // dimensionless
        const double var_t1019 = (var_t236 * 60.960741282614002) * var_t893; // dimensionless
        const double var_t1039 = NV_Ith_S(mParameters, 3) * NV_Ith_S(mParameters, 17); // dimensionless
        const double var_t1043 = (var_t39 * 60.960741282614002) * var_t893; // dimensionless
        const double var_t1056 = NV_Ith_S(mParameters, 3) * NV_Ith_S(mParameters, 21); // dimensionless
        
        // Matrix entries
        DENSE_ELEM(rJacobian, 0, 0) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((((((((((((var_t43 + var_t62) - var_t65) - var_t67) - var_t71) - var_t73) - var_t95) - var_t108) + var_t115) + var_t141) - var_t146) - NV_Ith_S(mParameters, 9)) - var_t184) + var_t197) - NV_Ith_S(mParameters, 8)) - var_t203) - var_t209));
        DENSE_ELEM(rJacobian, 1, 0) = var_chaste_interface__environment__fake_dt * ((_lt_0_row[41] - (((3.7037037037037037e-05 * var_t370) * _lt_0_row[42]) * _lt_0_row[43])) + (((3.2206119159999999e-05 * var_t370) * _lt_0_row[44]) * _lt_0_row[45]));
        DENSE_ELEM(rJacobian, 2, 0) = var_chaste_interface__environment__fake_dt * ((_lt_0_row[47] - (((0.01488095238 * var_t397) * _lt_0_row[48]) * _lt_0_row[49])) + (((0.01488095238 * var_t397) * _lt_0_row[50]) * _lt_0_row[51]));
        DENSE_ELEM(rJacobian, 3, 0) = var_chaste_interface__environment__fake_dt * ((_lt_0_row[53] - ((((7.5757575757575758e-05 * var_t422) / _lt_0_row[54]) * _lt_0_row[49]) * _lt_0_row[55])) + (((4.5454545454545452e-05 * var_t422) * _lt_0_row[54]) * _lt_0_row[51]));
        DENSE_ELEM(rJacobian, 4, 0) = var_chaste_interface__environment__fake_dt * ((_lt_0_row[35] - (((0.20000000000000001 * var_t462) * _lt_0_row[36]) * _lt_0_row[37])) - (((var_t462 * _lt_0_row[38]) / _lt_0_row[39]) * _lt_0_row[40]));
        DENSE_ELEM(rJacobian, 5, 0) = var_chaste_interface__environment__fake_dt * (((( -0.269179004 * var_t491) * var_t486) * _lt_0_row[29]) + (((var_t518 + var_t481) - var_chaste_interface__fast_sodium_current_h_gate__h) * _lt_0_row[30]));
        DENSE_ELEM(rJacobian, 6, 0) = var_chaste_interface__environment__fake_dt * (((( -0.269179004 * var_t491) * var_t486) * _lt_0_row[32]) + (((var_t518 + var_t481) - var_chaste_interface__fast_sodium_current_j_gate__j) * _lt_0_row[33]));
        DENSE_ELEM(rJacobian, 7, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[19] - (((_lt_0_row[20] - var_chaste_interface__L_type_Ca_current_d_gate__d) / _lt_0_row[21]) * _lt_0_row[22]));
        DENSE_ELEM(rJacobian, 8, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[24] - (((_lt_0_row[25] - var_chaste_interface__L_type_Ca_current_f_gate__f) / _lt_0_row[26]) * _lt_0_row[27]));
        DENSE_ELEM(rJacobian, 9, 0) = var_chaste_interface__environment__fake_dt * (var_t744 ? 0.0 : 0.0);
        DENSE_ELEM(rJacobian, 10, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[62] - (((_lt_0_row[63] - var_chaste_interface__transient_outward_current_s_gate__s) / _lt_0_row[64]) * _lt_0_row[65]));
        DENSE_ELEM(rJacobian, 11, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[57] - ((((9.5 * (_lt_0_row[58] - var_chaste_interface__transient_outward_current_r_gate__r)) / _lt_0_row[59]) * ( -0.044444444444444446 - (0.0011111111111111111 * var_chaste_interface__membrane__V))) * _lt_0_row[60]));
        DENSE_ELEM(rJacobian, 12, 0) = var_chaste_interface__environment__fake_dt * ((( -0.5 * var_t830) * (((((var_t95 + var_t108) - var_t115) + NV_Ith_S(mParameters, 8)) - (2.0 * var_t184)) + (2.0 * var_t197))) * var_t837);
        DENSE_ELEM(rJacobian, 14, 0) = var_chaste_interface__environment__fake_dt * (var_t982 ? 0.0 : 0.0);
        DENSE_ELEM(rJacobian, 15, 0) = var_chaste_interface__environment__fake_dt * (((-NV_Ith_S(mParameters, 3)) * ((((var_t146 + NV_Ith_S(mParameters, 9)) - (3.0 * var_t141)) + (3.0 * var_t184)) - (3.0 * var_t197))) * var_t837);
        DENSE_ELEM(rJacobian, 16, 0) = var_chaste_interface__environment__fake_dt * (((-NV_Ith_S(mParameters, 3)) * (((((((((-var_t43) - var_t62) + var_t65) + var_t67) + var_t71) + var_t73) + var_t203) + var_t209) + (2.0 * var_t141))) * var_t837);
        DENSE_ELEM(rJacobian, 0, 1) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -0.43033148290000001 * var_t68) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2) * var_t39));
        DENSE_ELEM(rJacobian, 1, 1) = var_chaste_interface__environment__fake_dt * (_lt_0_row[46]);
        DENSE_ELEM(rJacobian, 16, 1) = var_chaste_interface__environment__fake_dt * (((( -0.43033148290000001 * var_t1039) * var_t38) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2) * var_t1043);
        DENSE_ELEM(rJacobian, 0, 2) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -0.43033148290000001 * var_t68) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1) * var_t39));
        DENSE_ELEM(rJacobian, 2, 2) = var_chaste_interface__environment__fake_dt * (_lt_0_row[52]);
        DENSE_ELEM(rJacobian, 16, 2) = var_chaste_interface__environment__fake_dt * (((( -0.43033148290000001 * var_t1039) * var_t38) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1) * var_t1043);
        DENSE_ELEM(rJacobian, 0, 3) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -2.0 * NV_Ith_S(mParameters, 18)) * var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs) * var_t227));
        DENSE_ELEM(rJacobian, 3, 3) = var_chaste_interface__environment__fake_dt * (_lt_0_row[56]);
        DENSE_ELEM(rJacobian, 16, 3) = var_chaste_interface__environment__fake_dt * (((((( -2.0 * NV_Ith_S(mParameters, 3)) * NV_Ith_S(mParameters, 18)) * var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs) * var_t227) * 60.960741282614002) * var_t893);
        DENSE_ELEM(rJacobian, 0, 4) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -3.0 * NV_Ith_S(mParameters, 12)) * var_t142) * var_t145) * var_t236));
        DENSE_ELEM(rJacobian, 4, 4) = var_chaste_interface__environment__fake_dt * (_lt_0_row[34]);
        DENSE_ELEM(rJacobian, 15, 4) = var_chaste_interface__environment__fake_dt * ((((( -3.0 * var_t1010) * var_t142) * var_chaste_interface__fast_sodium_current_h_gate__h) * var_t240) * var_t837);
        DENSE_ELEM(rJacobian, 0, 5) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((-var_t144) * var_t240));
        DENSE_ELEM(rJacobian, 5, 5) = var_chaste_interface__environment__fake_dt * (_lt_0_row[28]);
        DENSE_ELEM(rJacobian, 15, 5) = var_chaste_interface__environment__fake_dt * ((((-var_t1010) * var_t143) * var_chaste_interface__fast_sodium_current_j_gate__j) * var_t1019);
        DENSE_ELEM(rJacobian, 0, 6) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((-var_t144) * var_chaste_interface__fast_sodium_current_h_gate__h) * var_t236));
        DENSE_ELEM(rJacobian, 6, 6) = var_chaste_interface__environment__fake_dt * (_lt_0_row[31]);
        DENSE_ELEM(rJacobian, 15, 6) = var_chaste_interface__environment__fake_dt * ((((-var_t1010) * var_t143) * var_chaste_interface__fast_sodium_current_h_gate__h) * var_t1019);
        DENSE_ELEM(rJacobian, 0, 7) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -4.0 * var_t244) * var_t245) * var_t93));
        DENSE_ELEM(rJacobian, 7, 7) = var_chaste_interface__environment__fake_dt * (_lt_0_row[18]);
        DENSE_ELEM(rJacobian, 12, 7) = var_chaste_interface__environment__fake_dt * (var_t830 * ((var_t846 * var_chaste_interface__calcium_dynamics__g) - (((2.0 * var_t244) * var_t848) * var_t853)));
        DENSE_ELEM(rJacobian, 13, 7) = var_chaste_interface__environment__fake_dt * (((-var_t946) * var_t948) * var_chaste_interface__calcium_dynamics__g);
        DENSE_ELEM(rJacobian, 0, 8) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -4.0 * var_t74) * var_t245) * var_t93));
        DENSE_ELEM(rJacobian, 8, 8) = var_chaste_interface__environment__fake_dt * (_lt_0_row[23]);
        DENSE_ELEM(rJacobian, 12, 8) = var_chaste_interface__environment__fake_dt * ((( -2.0 * var_t859) * var_t848) * var_t853);
        DENSE_ELEM(rJacobian, 0, 9) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -4.0 * var_t74) * var_t252) * var_t93));
        DENSE_ELEM(rJacobian, 9, 9) = var_chaste_interface__environment__fake_dt * (var_t744 ? 0.0 :  -0.5);
        DENSE_ELEM(rJacobian, 12, 9) = var_chaste_interface__environment__fake_dt * (((( -2.0 * var_t859) * var_t252) * 96485.341499999995) * var_t853);
        DENSE_ELEM(rJacobian, 0, 10) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((-var_t66) * var_t39));
        DENSE_ELEM(rJacobian, 10, 10) = var_chaste_interface__environment__fake_dt * (_lt_0_row[66]);
        DENSE_ELEM(rJacobian, 16, 10) = var_chaste_interface__environment__fake_dt * (((-var_t1056) * var_chaste_interface__transient_outward_current_r_gate__r) * var_t1043);
        DENSE_ELEM(rJacobian, 0, 11) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((-NV_Ith_S(mParameters, 21)) * var_chaste_interface__transient_outward_current_s_gate__s) * var_t39));
        DENSE_ELEM(rJacobian, 11, 11) = var_chaste_interface__environment__fake_dt * (_lt_0_row[61]);
        DENSE_ELEM(rJacobian, 16, 11) = var_chaste_interface__environment__fake_dt * (((-var_t1056) * var_chaste_interface__transient_outward_current_s_gate__s) * var_t1043);
        DENSE_ELEM(rJacobian, 0, 12) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((((-var_t263) + var_t269) - var_t275) - var_t278) + var_t282));
        DENSE_ELEM(rJacobian, 9, 12) = var_chaste_interface__environment__fake_dt * (var_t744 ? 0.0 : (((( -2.201102402e+28 / pow(var_t726, 2.0)) * var_t750) - ((342.46575339999998 / pow(var_t732, 2.0)) * var_t731)) - ((85.616438380000005 / pow(var_t738, 2.0)) * var_t737)));
        DENSE_ELEM(rJacobian, 12, 12) = var_chaste_interface__environment__fake_dt * ((((((2.0 / pow(var_t829, 2.0)) * (((var_t870 - var_t876) + var_t878) - (((0.5 * (((((4.0 * var_t97) * var_t93) + (NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__V - (13.356880329847824 * log(NV_Ith_S(mParameters, 4) * var_t272))))) + (var_t279 * var_t277)) - ((2.0 * var_t188) * var_t183))) * 60.960741282614002) * var_t893))) * 0.00014999999999999999) / var_t826) / var_t825) + (var_t830 * (((-NV_Ith_S(mParameters, 0)) - var_t909) - (((0.5 * ((((var_t263 + var_t275) + var_t278) - var_t282) + (2.0 * var_t269))) * 60.960741282614002) * var_t893))));
        DENSE_ELEM(rJacobian, 13, 12) = var_chaste_interface__environment__fake_dt * ((var_t946 * 914.0767824497259) * (var_t909 + NV_Ith_S(mParameters, 0)));
        DENSE_ELEM(rJacobian, 14, 12) = var_chaste_interface__environment__fake_dt * (var_t982 ? 0.0 : (((var_chaste_interface__calcium_dynamics__Ca_i <= 0.00035) ? ((( -3.2639461439999999e+21 / pow(1.0 + var_t973, 2.0)) * var_t723) * var_chaste_interface__calcium_dynamics__Ca_i) : (0.00035 < var_chaste_interface__calcium_dynamics__Ca_i) ? ((( -3.1552318180000002e+56 / pow(1.0 + var_t977, 2.0)) * var_t724) * var_t750) : NAN) * 0.5));
        DENSE_ELEM(rJacobian, 15, 12) = var_chaste_interface__environment__fake_dt * (((((3.0 * NV_Ith_S(mParameters, 3)) * NV_Ith_S(mParameters, 19)) * var_t167) * 2.5) * var_t936);
        DENSE_ELEM(rJacobian, 12, 13) = var_chaste_interface__environment__fake_dt * (var_t830 * var_t928);
        DENSE_ELEM(rJacobian, 13, 13) = var_chaste_interface__environment__fake_dt * (((((((((2.0 / pow(var_t944, 2.0)) * 0.016403999999999998) * 914.0767824497259) * ((var_t876 - var_t878) - var_t870)) * 10.0) * 0.29999999999999999) / var_t941) / var_t940) - ((var_t946 * 914.0767824497259) * var_t928));
        DENSE_ELEM(rJacobian, 12, 14) = var_chaste_interface__environment__fake_dt * ((var_t830 * var_t846) * var_chaste_interface__L_type_Ca_current_d_gate__d);
        DENSE_ELEM(rJacobian, 13, 14) = var_chaste_interface__environment__fake_dt * (((-var_t946) * var_t948) * var_chaste_interface__L_type_Ca_current_d_gate__d);
        DENSE_ELEM(rJacobian, 14, 14) = var_chaste_interface__environment__fake_dt * (var_t982 ? 0.0 :  -0.5);
        DENSE_ELEM(rJacobian, 0, 15) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t287) - var_t291) + var_t296) - var_t299) - var_t302) - (3.0 * var_t307)));
        DENSE_ELEM(rJacobian, 12, 15) = var_chaste_interface__environment__fake_dt * ((((((3.0 * var_t830) * NV_Ith_S(mParameters, 19)) * _lt_0_row[8]) * var_t154) * NV_Ith_S(mParameters, 4)) * var_t936);
        DENSE_ELEM(rJacobian, 15, 15) = var_chaste_interface__environment__fake_dt * (((-NV_Ith_S(mParameters, 3)) * ((((var_t299 + var_t302) + (3.0 * var_t291)) - (3.0 * var_t296)) + (9.0 * var_t307))) * var_t837);
        DENSE_ELEM(rJacobian, 16, 15) = var_chaste_interface__environment__fake_dt * (((-NV_Ith_S(mParameters, 3)) * ((var_t287 - (2.0 * var_t291)) + (2.0 * var_t296))) * var_t837);
        DENSE_ELEM(rJacobian, 0, 16) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : var_t350);
        DENSE_ELEM(rJacobian, 16, 16) = var_chaste_interface__environment__fake_dt * ((NV_Ith_S(mParameters, 3) * var_t350) * var_t837);
    }
    
    N_Vector Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt::ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__V = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -86.2
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_m_gate__m = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__fast_sodium_current_h_gate__h = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__fast_sodium_current_j_gate__j = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.75
        double var_chaste_interface__L_type_Ca_current_d_gate__d = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__L_type_Ca_current_f_gate__f = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__L_type_Ca_current_fCa_gate__fCa = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_s_gate__s = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__transient_outward_current_r_gate__r = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__calcium_dynamics__Ca_i = NV_Ith_S(rY, 12);
        // Units: millimolar; Initial value: 0.0002
        double var_chaste_interface__calcium_dynamics__Ca_SR = NV_Ith_S(rY, 13);
        // Units: millimolar; Initial value: 0.2
        double var_chaste_interface__calcium_dynamics__g = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__sodium_dynamics__Na_i = NV_Ith_S(rY, 15);
        // Units: millimolar; Initial value: 11.6
        double var_chaste_interface__potassium_dynamics__K_i = NV_Ith_S(rY, 16);
        // Units: millimolar; Initial value: 138.3
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__V);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__V);
        
        // Mathematics
        const double var_reversal_potentials__E_K = 26.713760659695648 * log(NV_Ith_S(mParameters, 5) / var_chaste_interface__potassium_dynamics__K_i); // millivolt
        const double var_inward_rectifier_potassium_current__alpha_K1 = 0.10000000000000001 / (1.0 + exp(0.059999999999999998 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) - 200.0))); // per_millisecond
        const double var_inward_rectifier_potassium_current__i_K1 = NV_Ith_S(mParameters, 15) * (var_inward_rectifier_potassium_current__alpha_K1 / (var_inward_rectifier_potassium_current__alpha_K1 + (((3.0 * exp(0.00020000000000000001 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) + 100.0))) + (1.0 * exp(0.10000000000000001 * ((var_chaste_interface__membrane__V - var_reversal_potentials__E_K) - 10.0)))) / (1.0 + exp( -0.5 * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K)))))) * sqrt(NV_Ith_S(mParameters, 5) * 0.18518518518518517) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_transient_outward_current__i_to = NV_Ith_S(mParameters, 21) * var_chaste_interface__transient_outward_current_r_gate__r * var_chaste_interface__transient_outward_current_s_gate__s * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_rapid_time_dependent_potassium_current__i_Kr = NV_Ith_S(mParameters, 17) * sqrt(NV_Ith_S(mParameters, 5) * 0.18518518518518517) * var_chaste_interface__rapid_time_dependent_potassium_current_Xr1_gate__Xr1 * var_chaste_interface__rapid_time_dependent_potassium_current_Xr2_gate__Xr2 * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K); // picoA_per_picoF
        const double var_slow_time_dependent_potassium_current__i_Ks = NV_Ith_S(mParameters, 18) * pow(var_chaste_interface__slow_time_dependent_potassium_current_Xs_gate__Xs, 2.0) * (var_chaste_interface__membrane__V - (26.713760659695648 * log((NV_Ith_S(mParameters, 5) + (0.029999999999999999 * NV_Ith_S(mParameters, 6))) / (var_chaste_interface__potassium_dynamics__K_i + (0.029999999999999999 * var_chaste_interface__sodium_dynamics__Na_i))))); // picoA_per_picoF
        const double var_L_type_Ca_current__i_CaL = (((NV_Ith_S(mParameters, 7) * var_chaste_interface__L_type_Ca_current_d_gate__d * var_chaste_interface__L_type_Ca_current_f_gate__f * var_chaste_interface__L_type_Ca_current_fCa_gate__fCa * var_chaste_interface__membrane__V * 37237684497.486488) * 3.8797490106562429e-07) * ((var_chaste_interface__calcium_dynamics__Ca_i * _lt_0_row[69]) - (0.34100000000000003 * NV_Ith_S(mParameters, 4)))) / _lt_0_row[70]; // picoA_per_picoF
        const double var_sodium_potassium_pump_current__i_NaK = ((((NV_Ith_S(mParameters, 20) * NV_Ith_S(mParameters, 5)) / (NV_Ith_S(mParameters, 5) + 1.0)) * var_chaste_interface__sodium_dynamics__Na_i) / (var_chaste_interface__sodium_dynamics__Na_i + 40.0)) / _lt_0_row[72]; // picoA_per_picoF
        const double var_reversal_potentials__E_Na = 26.713760659695648 * log(NV_Ith_S(mParameters, 6) / var_chaste_interface__sodium_dynamics__Na_i); // millivolt
        const double var_fast_sodium_current__i_Na = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__fast_sodium_current_m_gate__m, 3.0) * var_chaste_interface__fast_sodium_current_h_gate__h * var_chaste_interface__fast_sodium_current_j_gate__j * (var_chaste_interface__membrane__V - var_reversal_potentials__E_Na); // picoA_per_picoF
        const double var_sodium_background_current__i_b_Na = NV_Ith_S(mParameters, 9) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_Na); // picoA_per_picoF
        const double var_sodium_calcium_exchanger_current__i_NaCa = (NV_Ith_S(mParameters, 19) * ((_lt_0_row[73] * pow(var_chaste_interface__sodium_dynamics__Na_i, 3.0) * NV_Ith_S(mParameters, 4)) - (_lt_0_row[74] * pow(NV_Ith_S(mParameters, 6), 3.0) * var_chaste_interface__calcium_dynamics__Ca_i * 2.5))) / ((669921.875 + pow(NV_Ith_S(mParameters, 6), 3.0)) * (1.3799999999999999 + NV_Ith_S(mParameters, 4)) * _lt_0_row[75]); // picoA_per_picoF
        const double var_calcium_background_current__i_b_Ca = NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__V - (13.356880329847824 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__calcium_dynamics__Ca_i))); // picoA_per_picoF
        const double var_potassium_pump_current__i_p_K = (NV_Ith_S(mParameters, 16) * (var_chaste_interface__membrane__V - var_reversal_potentials__E_K)) / _lt_0_row[76]; // picoA_per_picoF
        const double var_calcium_pump_current__i_p_Ca = (NV_Ith_S(mParameters, 10) * var_chaste_interface__calcium_dynamics__Ca_i) / (var_chaste_interface__calcium_dynamics__Ca_i + 0.00050000000000000001); // picoA_per_picoF
        var_chaste_interface__membrane__i_Stim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_fast_sodium_current_h_gate__tau_h = _lt_0_row[67]; // millisecond
        const double var_fast_sodium_current_j_gate__tau_j = _lt_0_row[68]; // millisecond
        const double var_L_type_Ca_current_f_gate__tau_f = _lt_0_row[71]; // millisecond
        const double var_L_type_Ca_current_fCa_gate__tau_fCa = 2.0; // millisecond
        const double var_calcium_dynamics__i_rel = (((NV_Ith_S(mParameters, 1) * pow(var_chaste_interface__calcium_dynamics__Ca_SR, 2.0)) / (0.0625 + pow(var_chaste_interface__calcium_dynamics__Ca_SR, 2.0))) + 0.0082319999999999997) * var_chaste_interface__L_type_Ca_current_d_gate__d * var_chaste_interface__calcium_dynamics__g; // millimolar_per_millisecond
        const double var_chaste_interface__L_type_Ca_current__i_CaL = var_L_type_Ca_current__i_CaL; // picoA_per_picoF
        const double var_chaste_interface__sodium_background_current__i_b_Na = var_sodium_background_current__i_b_Na; // picoA_per_picoF
        const double var_chaste_interface__inward_rectifier_potassium_current__i_K1 = var_inward_rectifier_potassium_current__i_K1; // picoA_per_picoF
        const double var_chaste_interface__fast_sodium_current__i_Na = var_fast_sodium_current__i_Na; // picoA_per_picoF
        const double var_chaste_interface__rapid_time_dependent_potassium_current__i_Kr = var_rapid_time_dependent_potassium_current__i_Kr; // picoA_per_picoF
        const double var_chaste_interface__slow_time_dependent_potassium_current__i_Ks = var_slow_time_dependent_potassium_current__i_Ks; // picoA_per_picoF
        const double var_chaste_interface__calcium_pump_current__i_p_Ca = var_calcium_pump_current__i_p_Ca; // picoA_per_picoF
        const double var_chaste_interface__sodium_calcium_exchanger_current__i_NaCa = var_sodium_calcium_exchanger_current__i_NaCa; // picoA_per_picoF
        const double var_chaste_interface__sodium_potassium_pump_current__i_NaK = var_sodium_potassium_pump_current__i_NaK; // picoA_per_picoF
        const double var_chaste_interface__potassium_pump_current__i_p_K = var_potassium_pump_current__i_p_K; // picoA_per_picoF
        const double var_chaste_interface__transient_outward_current__i_to = var_transient_outward_current__i_to; // picoA_per_picoF
        const double var_chaste_interface__calcium_background_current__i_b_Ca = var_calcium_background_current__i_b_Ca; // picoA_per_picoF
        
        N_Vector dqs = N_VNew_Serial(19);
        NV_Ith_S(dqs, 0) = var_calcium_dynamics__i_rel;
        NV_Ith_S(dqs, 1) = var_chaste_interface__L_type_Ca_current__i_CaL;
        NV_Ith_S(dqs, 2) = var_L_type_Ca_current_fCa_gate__tau_fCa;
        NV_Ith_S(dqs, 3) = var_L_type_Ca_current_f_gate__tau_f;
        NV_Ith_S(dqs, 4) = var_chaste_interface__calcium_background_current__i_b_Ca;
        NV_Ith_S(dqs, 5) = var_chaste_interface__sodium_background_current__i_b_Na;
        NV_Ith_S(dqs, 6) = var_chaste_interface__calcium_pump_current__i_p_Ca;
        NV_Ith_S(dqs, 7) = var_chaste_interface__fast_sodium_current__i_Na;
        NV_Ith_S(dqs, 8) = var_fast_sodium_current_h_gate__tau_h;
        NV_Ith_S(dqs, 9) = var_fast_sodium_current_j_gate__tau_j;
        NV_Ith_S(dqs, 10) = var_chaste_interface__inward_rectifier_potassium_current__i_K1;
        NV_Ith_S(dqs, 11) = var_chaste_interface__potassium_pump_current__i_p_K;
        NV_Ith_S(dqs, 12) = var_chaste_interface__rapid_time_dependent_potassium_current__i_Kr;
        NV_Ith_S(dqs, 13) = var_chaste_interface__slow_time_dependent_potassium_current__i_Ks;
        NV_Ith_S(dqs, 14) = var_chaste_interface__sodium_calcium_exchanger_current__i_NaCa;
        NV_Ith_S(dqs, 15) = var_chaste_interface__sodium_potassium_pump_current__i_NaK;
        NV_Ith_S(dqs, 16) = var_chaste_interface__membrane__i_Stim;
        NV_Ith_S(dqs, 17) = var_chaste_interface__transient_outward_current__i_to;
        NV_Ith_S(dqs, 18) = var_chaste_interface__environment__time;
        return dqs;
    }
    
template<>
void OdeSystemInformation<Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt>::Initialise(void)
{
    this->mSystemName = "tentusscher_model_2004_epi";
    this->mFreeVariableName = "time";
    this->mFreeVariableUnits = "millisecond";
    
    this->mVariableNames.push_back("membrane_voltage");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-86.2);

    this->mVariableNames.push_back("rapid_time_dependent_potassium_current_Xr1_gate__Xr1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("rapid_time_dependent_potassium_current_Xr2_gate__Xr2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("slow_time_dependent_potassium_current_Xs_gate__Xs");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("membrane_fast_sodium_current_m_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("membrane_fast_sodium_current_h_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.75);

    this->mVariableNames.push_back("membrane_fast_sodium_current_j_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.75);

    this->mVariableNames.push_back("membrane_L_type_calcium_current_d_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("membrane_L_type_calcium_current_f_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("membrane_L_type_calcium_current_fCa_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("transient_outward_current_s_gate__s");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("transient_outward_current_r_gate__r");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("cytosolic_calcium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(0.0002);

    this->mVariableNames.push_back("JSR_calcium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(0.2);

    this->mVariableNames.push_back("calcium_dynamics__g");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("cytosolic_sodium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(11.6);

    this->mVariableNames.push_back("cytosolic_potassium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(138.3);

    this->mParameterNames.push_back("SR_leak_current_max");
    this->mParameterUnits.push_back("per_millisecond");
    
    this->mParameterNames.push_back("SR_release_current_max");
    this->mParameterUnits.push_back("millimolar_per_millisecond");
    
    this->mParameterNames.push_back("SR_uptake_current_max");
    this->mParameterUnits.push_back("millimolar_per_millisecond");
    
    this->mParameterNames.push_back("concentration_clamp_onoff");
    this->mParameterUnits.push_back("dimensionless");
    
    this->mParameterNames.push_back("extracellular_calcium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("extracellular_potassium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("extracellular_sodium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("membrane_L_type_calcium_current_conductance");
    this->mParameterUnits.push_back("litre_per_farad_second");
    
    this->mParameterNames.push_back("membrane_background_calcium_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_background_sodium_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_calcium_pump_current_conductance");
    this->mParameterUnits.push_back("picoA_per_picoF");
    
    this->mParameterNames.push_back("membrane_capacitance");
    this->mParameterUnits.push_back("microF");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_reduced_inactivation");
    this->mParameterUnits.push_back("dimensionless");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_shift_inactivation");
    this->mParameterUnits.push_back("millivolt");
    
    this->mParameterNames.push_back("membrane_inward_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_potassium_pump_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_rapid_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_slow_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_sodium_calcium_exchanger_current_conductance");
    this->mParameterUnits.push_back("picoA_per_picoF");
    
    this->mParameterNames.push_back("membrane_sodium_potassium_pump_current_permeability");
    this->mParameterUnits.push_back("picoA_per_picoF");
    
    this->mParameterNames.push_back("membrane_transient_outward_current_conductance");
    this->mParameterUnits.push_back("nanoS_per_picoF");
    
    this->mParameterNames.push_back("membrane_data_clamp_current_conductance"); // RJ
    this->mParameterUnits.push_back("mS_per_mm2");

    this->mDerivedQuantityNames.push_back("SR_release_current");
    this->mDerivedQuantityUnits.push_back("millimolar_per_millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current_fCa_gate_tau");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current_f_gate_tau");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_background_calcium_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_sodium_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_calcium_pump_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current_h_gate_tau");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current_j_gate_tau");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mDerivedQuantityNames.push_back("membrane_inward_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_potassium_pump_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_rapid_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_slow_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_calcium_exchanger_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_potassium_pump_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("membrane_stimulus_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_transient_outward_current");
    this->mDerivedQuantityUnits.push_back("picoA_per_picoF");
    
    this->mDerivedQuantityNames.push_back("time");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mInitialised = true;
}


// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Cellten_tusscher_model_2004_epi_data_clampFromCellMLCvodeOpt)
#endif // CHASTE_CVODE
