#ifdef CHASTE_CVODE
//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: decker_2009
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24885, pycml: 24885, optimize: 23343)
//! on Mon Aug  3 16:41:17 2015
//! 
//! <autogenerated>

#include "decker_2009CvodeDataClampOpt.hpp"
#include <cmath>
#include <cassert>
#include <memory>
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"
#include "RegularStimulus.hpp"
#include "HeartConfig.hpp"
#include "IsNan.hpp"
#include "MathsCustomFunctions.hpp"

class Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables : public AbstractLookupTableCollection
{
public:
    static Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables* Instance()
    {
        if (mpInstance.get() == NULL)
        {
            mpInstance.reset(new Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables);
        }
        return mpInstance.get();
    }
    
    void FreeMemory()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
        mNeedsRegeneration.assign(mNeedsRegeneration.size(), true);
    }
    
    // Row lookup methods
    // using linear-interpolation
    double* _lookup_0_row(unsigned i, double _factor_)
    {
        for (unsigned j=0; j<230; j++)
        {
            const double y1 = _lookup_table_0[i][j];
            const double y2 = _lookup_table_0[i+1][j];
            _lookup_table_0_row[j] = y1 + (y2-y1)*_factor_;
        }
        return _lookup_table_0_row;
    }
    
    
    const double * IndexTable0(double var_chaste_interface__membrane__Vm)
    {
        const double _offset_0 = var_chaste_interface__membrane__Vm - mTableMins[0];
        const double _offset_0_over_table_step = _offset_0 * mTableStepInverses[0];
        const unsigned _table_index_0 = (unsigned)(_offset_0_over_table_step);
        const double _factor_0 = _offset_0_over_table_step - _table_index_0;
        const double* const _lt_0_row = Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance()->_lookup_0_row(_table_index_0, _factor_0);
        return _lt_0_row;
    }
    
#define COVERAGE_IGNORE
    bool CheckIndex0(double& var_chaste_interface__membrane__Vm)
    {
        bool _oob_0 = false;
        if (var_chaste_interface__membrane__Vm>mTableMaxs[0] || var_chaste_interface__membrane__Vm<mTableMins[0])
        {
#define COVERAGE_IGNORE
            _oob_0 = true;
#undef COVERAGE_IGNORE
        }
        return _oob_0;
    }
#undef COVERAGE_IGNORE

    ~Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
    }
    
protected:
    Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables(const Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables&);
    Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables& operator= (const Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables&);
    Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables()
    {
        assert(mpInstance.get() == NULL);
        mKeyingVariableNames.resize(1);
        mNumberOfTables.resize(1);
        mTableMins.resize(1);
        mTableSteps.resize(1);
        mTableStepInverses.resize(1);
        mTableMaxs.resize(1);
        mNeedsRegeneration.resize(1);
        mKeyingVariableNames[0] = "membrane_voltage";
        mNumberOfTables[0] = 230;
        mTableMins[0] = -100.0001;
        mTableSteps[0] = 0.001;
        mTableStepInverses[0] = 1000.0;
        mTableMaxs[0] = 99.9999;
        mNeedsRegeneration[0] = true;
        _lookup_table_0 = NULL;
        Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::RegenerateTables();
    }
    
    void RegenerateTables()
    {
        AbstractLookupTableCollection::EventHandler::BeginEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
        if (mNeedsRegeneration[0])
        {
            if (_lookup_table_0)
            {
                delete[] _lookup_table_0;
                _lookup_table_0 = NULL;
            }
            const unsigned _table_size_0 = 1 + (unsigned)((mTableMaxs[0]-mTableMins[0])/mTableSteps[0]+0.5);
            _lookup_table_0 = new double[_table_size_0][230];
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][0] = 1.0 / (1.0 + exp((0.064935064939999995 * var_chaste_interface__membrane__Vm) + 0.64935064939999998));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][1] = exp(2.0 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][2] = 1.0 / (exp(2.0 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)) - 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][3] = 1.0 + exp(1.252173913 - (0.16722408029999999 * var_chaste_interface__membrane__Vm));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][4] = pow(1.0 + exp(1.252173913 - (0.16722408029999999 * var_chaste_interface__membrane__Vm)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][5] = exp(1.252173913 - (0.16722408029999999 * var_chaste_interface__membrane__Vm));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][6] = pow(1.0 + exp((0.064935064939999995 * var_chaste_interface__membrane__Vm) + 0.64935064939999998), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][7] = exp((0.064935064939999995 * var_chaste_interface__membrane__Vm) + 0.64935064939999998);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][8] = exp(0.0018181818181818182 * var_chaste_interface__membrane__Vm);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][9] = exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][10] = 1.0 / (exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07) - 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][11] = 1.0 / (1.0 + (0.32000000000000001 * exp(( -0.72999999999999998 * var_chaste_interface__membrane__Vm) * 0.037435883507802616)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][12] = 0.037435883507802616 * exp((0.27000000000000002 * var_chaste_interface__membrane__Vm) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][13] = 11.605123887418811 * (0.0032258064516129032 * exp(( -0.72999999999999998 * var_chaste_interface__membrane__Vm) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][14] = 100.0 * exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][15] =  -1.0 / (exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07) - 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][16] = 1.0 / pow(exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07) - 1.0, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][17] = 1.0 / pow(exp(2.0 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)) - 1.0, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][18] = exp(2.0 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)) * (1.0 / (exp(2.0 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][19] = pow(1.0 + exp(( -1.0 * (var_chaste_interface__membrane__Vm -  -92.0)) * 0.037435883507802616), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][20] = exp(( -1.0 * (var_chaste_interface__membrane__Vm -  -92.0)) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][21] = exp((0.27000000000000002 * var_chaste_interface__membrane__Vm) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][22] = exp(( -0.72999999999999998 * var_chaste_interface__membrane__Vm) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][23] = 1.0 / pow(1.0 + (0.32000000000000001 * exp(( -0.72999999999999998 * var_chaste_interface__membrane__Vm) * 0.037435883507802616)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][24] =  -0.0087450223874226928 * exp(( -0.72999999999999998 * var_chaste_interface__membrane__Vm) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][25] = exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07) * (1.0 / (exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][26] = ( -1.0 / (exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07) - 1.0)) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][27] = 1.0 + exp(( -1.0 * (var_chaste_interface__membrane__Vm -  -92.0)) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][28] = 0.020615995291219026 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][29] = 0.061682378852543303 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][30] = 1.0 / (24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][31] = 1.0 / (1.0 + exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][32] = 0.33330000329999998 * ((1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0)) * exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][33] = -((2.3990723740000002 / pow(24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)), 2.0)) * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][34] = pow(1.0 + exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][35] = exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][36] = 0.99990000999999995 - (0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][37] = (0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 9.9990001000000006e-05;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][38] = 1.0 / (0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][39] = (1.0 / ((0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 9.9990001000000006e-05)) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][40] = 0.80000000010000005 * (((9.9999999999999995e-07 * (1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0))) * exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)) * (0.99990000999999995 - (0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][41] = 0.99990000990000005 * ((9.9999999999999995e-07 * ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001)) * ((1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0)) * exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][42] = 9.9999999999999995e-07 * ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][43] = 1.0 / pow(0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][44] = 1.0 / ((0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 9.9990001000000006e-05);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][45] = (1.0 * (1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0))) * exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][46] = 1.0 / pow((0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 9.9990001000000006e-05, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][47] = (3.0 * (9.9999999999999995e-07 * ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001))) * (0.99990000999999995 - (0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][48] = (9.9999999999999995e-07 * ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001)) * (0.99990000999999995 - (0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][49] = (1.0 / (0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))))) * (1.0 / ((0.99990000999999995 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 9.9990001000000006e-05));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][50] = 1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][51] = exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][52] = 0.0032258064516129032 * exp(( -0.72999999999999998 * var_chaste_interface__membrane__Vm) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][53] = 0.0032258064516129032 * ( -1.0 / (exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][54] = -((1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][55] = (0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))))) * ((1.0 / (24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)))) + (1.0 / (30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][56] = ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001) * ((1.0 / (24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)))) + (1.0 / (30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][57] = (1.0 - (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][58] = (((-((0.10582010579999999 * ((1.0 / pow(1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001), 2.0)) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))))) * exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) + (((1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / pow(0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))), 2.0))) * ((0.041599999999999998 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))) - (((0.1056 * exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005)) / pow(1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716), 2.0)) * exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716))))) - ((0.2666666667 * ((1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0)) * exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))) * ((1.0 / (24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)))) + (1.0 / (30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001))))))) - ((0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))))) * ((-((2.3990723740000002 / pow(24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)), 2.0)) * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997))) + ((2.8271490699999999 / pow(30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)), 2.0)) * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][59] = (0.10582010579999999 * ((1.0 / pow(1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001), 2.0)) * exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][60] = (1.0 - (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)))) * (1.0 / pow(0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][61] = (0.041599999999999998 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))) - (((0.1056 * exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005)) / pow(1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716), 2.0)) * exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][62] = (0.2666666667 * ((1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0)) * exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))) * ((1.0 / (24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)))) + (1.0 / (30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][63] = ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001) * ((-((2.3990723740000002 / pow(24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)), 2.0)) * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997))) + ((2.8271490699999999 / pow(30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)), 2.0)) * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][64] = (-((0.10582010579999999 * ((1.0 / pow(1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001), 2.0)) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))))) * exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) + (((1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / pow(0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))), 2.0))) * ((0.041599999999999998 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))) - (((0.1056 * exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005)) / pow(1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716), 2.0)) * exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][65] = (0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))))) * ((-((2.3990723740000002 / pow(24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)), 2.0)) * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997))) + ((2.8271490699999999 / pow(30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)), 2.0)) * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][66] = -((1.0 - (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][67] = (-((1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))))) - 9.9999999999999995e-07;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][68] = 0.80000000010000005 * (9.9999999999999995e-07 * ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][69] = 0.99990000990000005 * (9.9999999999999995e-07 * ((0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997)))) + 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][70] = (-((1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))))) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][71] = (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][72] = ((((0.10582010579999999 * ((1.0 / pow(1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001), 2.0)) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))))) * exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)) + (((1.0 - (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)))) * (1.0 / pow(0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))), 2.0))) * ((0.041599999999999998 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))) - (((0.1056 * exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005)) / pow(1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716), 2.0)) * exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716))))) - ((0.2666666667 * ((1.0 / pow(1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997), 2.0)) * exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))) * ((1.0 / (24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)))) + (1.0 / (30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001))))))) - ((0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))))) * ((-((2.3990723740000002 / pow(24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)), 2.0)) * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997))) + ((2.8271490699999999 / pow(30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)), 2.0)) * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][73] = 0.10582010579999999 * ((1.0 / pow(1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001), 2.0)) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][74] = exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][75] = (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / pow(0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][76] =  -9.9999999999999995e-07 + ((1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][77] = ((0.80000000000000004 - (0.80000000000000004 * (1.0 / (1.0 + exp((0.33333333333333331 * var_chaste_interface__membrane__Vm) + 5.8333333329999997))))) * ((1.0 / (24.827999999999999 + (24.827999999999999 * exp((0.0966276935 * var_chaste_interface__membrane__Vm) + 4.7444197509999997)))) + (1.0 / (30.553000000000001 + (30.553000000000001 * exp(( -0.092532617750000004 * var_chaste_interface__membrane__Vm) - 0.019709447580000001)))))) - 9.9999999999999995e-07;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][78] = ((0.10582010579999999 * ((1.0 / pow(1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001), 2.0)) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))))) * exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)) + (((1.0 - (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)))) * (1.0 / pow(0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))), 2.0))) * ((0.041599999999999998 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))) - (((0.1056 * exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005)) / pow(1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716), 2.0)) * exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][79] = (-((1.0 - (1.0 / (1.0 + exp(( -0.10582010579999999 * var_chaste_interface__membrane__Vm) + 1.4349206350000001)))) * (1.0 / (0.58999999999999997 + (0.80000000000000004 * (exp((0.051999999999999998 * var_chaste_interface__membrane__Vm) + 0.67600000000000005) / (1.0 + exp((0.13200000000000001 * var_chaste_interface__membrane__Vm) + 1.716)))))))) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][80] = -(((0.00059999999999999995 * (var_chaste_interface__membrane__Vm - 1.7383999999999999)) * (1.0 / (1.0 - exp(( -0.13600000000000001 * var_chaste_interface__membrane__Vm) + 0.2364224)))) + ((0.00029999999999999997 * (var_chaste_interface__membrane__Vm + 38.360799999999998)) * (1.0 / (exp((0.1522 * var_chaste_interface__membrane__Vm) + 5.8385137599999997) - 1.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][81] = ((0.23529411759999999 / pow(1.0 + exp(( -0.23529411759999999 * var_chaste_interface__membrane__Vm) - 2.3729411759999999), 2.0)) * exp(( -0.23529411759999999 * var_chaste_interface__membrane__Vm) - 2.3729411759999999)) * (((0.00059999999999999995 * (var_chaste_interface__membrane__Vm - 1.7383999999999999)) * (1.0 / (1.0 - exp(( -0.13600000000000001 * var_chaste_interface__membrane__Vm) + 0.2364224)))) + ((0.00029999999999999997 * (var_chaste_interface__membrane__Vm + 38.360799999999998)) * (1.0 / (exp((0.1522 * var_chaste_interface__membrane__Vm) + 5.8385137599999997) - 1.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][82] = 1.0 / (1.0 + exp(( -0.23529411759999999 * var_chaste_interface__membrane__Vm) - 2.3729411759999999));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][83] = (((0.00059999999999999995 * (1.0 / (1.0 - exp(( -0.13600000000000001 * var_chaste_interface__membrane__Vm) + 0.2364224)))) - (((8.1600000000000005e-05 * (var_chaste_interface__membrane__Vm - 1.7383999999999999)) / pow(1.0 - exp(( -0.13600000000000001 * var_chaste_interface__membrane__Vm) + 0.2364224), 2.0)) * exp(( -0.13600000000000001 * var_chaste_interface__membrane__Vm) + 0.2364224))) + (0.00029999999999999997 * (1.0 / (exp((0.1522 * var_chaste_interface__membrane__Vm) + 5.8385137599999997) - 1.0)))) - (((4.566e-05 * (var_chaste_interface__membrane__Vm + 38.360799999999998)) / pow(exp((0.1522 * var_chaste_interface__membrane__Vm) + 5.8385137599999997) - 1.0, 2.0)) * exp((0.1522 * var_chaste_interface__membrane__Vm) + 5.8385137599999997));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][84] = -(0.059458391919999999 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][85] = 0.083986312199829993 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][86] = 0.054056314956532958 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][87] = (-(0.02972919596 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.0062346537740000001 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][88] = 0.01460066118316 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][89] = (-(0.00088822814330000003 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0026575493479999998 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][90] = 0.041454023711973778 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][91] = 0.02972919596 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][92] = (((-(0.01486459798 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.083986312199999996 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.01460066118 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.0062346537740000001 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][93] = 0.16797262439999999 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][94] = 0.0093519806610000006 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][95] = 0.02920132236 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][96] = (((-(0.00044411407170000001 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0046579696590000001 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) - (0.0035720449100000002 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0026575493479999998 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][97] = 0.010307997643288489 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][98] = 0.10811262991306592 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][99] = 0.082908047423947556 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][100] = 0.046261784130703636 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][101] = 0.014864597980859999 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][102] = ((-(0.16797262439999999 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.02920132236 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.0062346537740000001 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][103] = 0.043801983539999999 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][104] = ((0.0093159393180000001 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07))))) - (0.0071440898200000004 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0026575493479999998 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][105] = 0.0051539988222245011 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][106] = 0.12436207113592133 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][107] = (-(0.01486459798 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.0093519806610000006 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][108] = (-(0.00044411407170000001 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0039863240220000002 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][109] = ((-(0.083986312199999996 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.01460066118 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.0093519806610000006 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][110] = 0.012469307549999999 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][111] = ((0.0046579696590000001 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07))))) - (0.0035720449100000002 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0039863240220000002 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][112] = (-(0.012469307549999999 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - 0.089538306411019994;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][113] = 0.077319900973309999 * exp( -0.064726122489999996 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][114] = 0.058079204715634471 * (0.0032258064516129032 * exp( -0.064726122489999996 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][115] = 0.059458391919999999 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][116] = ((-(0.044593793940000001 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.083986312199999996 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.01460066118 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][117] = 0.0031173268874 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][118] = ((-(0.001332342215 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0046579696590000001 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) - (0.0035720449100000002 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][119] = 0.015420594710234542 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][120] = 0.044593793940000001 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][121] = ((-(0.02972919596 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.16797262439999999 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.02920132236 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][122] = 0.25195893660000002 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][123] = ((-(0.00088822814330000003 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0093159393180000001 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) - (0.0071440898200000004 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][124] = 0.01546199646551299 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][125] = 0.16216894490441422 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][126] = ((-(0.01486459798 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.25195893660000002 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.043801983539999999 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][127] = 0.33594524879999998 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][128] = ((-(0.00044411407170000001 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.01397390898 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) - (0.01071613473 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][129] = 0.21622525987255228 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][130] = (-(0.33594524879999998 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.058402644720000001 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][131] = (0.018631878639999998 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07))))) - (0.014288179640000001 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][132] = (-(0.044593793940000001 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.003117326887 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][133] = (-(0.001332342215 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0013287746739999999 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][134] = 0.0062346537740000001 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][135] = (((-(0.02972919596 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.083986312199999996 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.01460066118 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.003117326887 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][136] = (((-(0.00088822814330000003 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0046579696590000001 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) - (0.0035720449100000002 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0013287746739999999 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][137] = 0.030841189420469085 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][138] = (((-(0.01486459798 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.16797262439999999 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.02920132236 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.003117326887 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][139] = (((-(0.00044411407170000001 * (11.605123887418811 * (0.0032258064516129032 * exp(0.029877301235880002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0093159393180000001 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) - (0.0071440898200000004 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0013287746739999999 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][140] = 0.058402644720000001 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][141] = ((-(0.25195893660000002 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.043801983539999999 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.003117326887 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][142] = ((0.01397390898 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.055461057129999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07))))) - (0.01071613473 * (11.605123887418811 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))))) + (0.0013287746739999999 * (11.605123887418811 * (0.0032258064516129032 * exp( -0.42625451939999998 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][143] = 0.16581609484789511 * (0.0032258064516129032 * exp(0.24464953099645001 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][144] = -(0.79405459960000002 * exp( -0.080173781929999993 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][145] = (-(0.79405459960000002 * exp( -0.080173781929999993 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) + 0.089538306411019994;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][146] = (( -0.077319900969999994 * exp( -0.064726122489999996 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07))) - (0.58638228660000002 * exp(0.28205554331496002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.79405459960000002 * exp( -0.080173781929999993 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][147] = (0.058079204715634471 * (0.0032258064516129032 * exp( -0.064726122489999996 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)))) - (0.0061916096611172753 * exp(0.28205554331496002 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][148] = 0.0023832567043969165 * exp( -0.080173781929999993 * ((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][149] = (( -0.16393442620000001 / pow(1.0 + exp((0.16393442620000001 * var_chaste_interface__membrane__Vm) + 14.918032780000001), 2.0)) * exp((0.16393442620000001 * var_chaste_interface__membrane__Vm) + 14.918032780000001)) * 0.0016666666666666668;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][150] = (( -0.32000000000000001 * (var_chaste_interface__membrane__Vm + 47.130000000000003)) * (1.0 / (1.0 - exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 4.7130000000000001)))) - (0.080000000000000002 * exp( -0.090909090909090912 * var_chaste_interface__membrane__Vm));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][151] = 0.32000000000000001 * (1.0 / (1.0 - exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 4.7130000000000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][152] = 0.032000000000000001 * ((var_chaste_interface__membrane__Vm + 47.130000000000003) / pow(1.0 - exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 4.7130000000000001), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][153] = exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 4.7130000000000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][154] = 0.0072727272729999999 * exp( -0.090909090909090912 * var_chaste_interface__membrane__Vm);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][155] = (-(( -40.0 <= var_chaste_interface__membrane__Vm) ? 0.0 : (0.13500000000000001 * exp( -11.764705879999999 - (0.14705882349999999 * var_chaste_interface__membrane__Vm))))) - (( -40.0 <= var_chaste_interface__membrane__Vm) ? (1.0 / (0.13 + (0.13 * exp(( -0.090090090090000005 * var_chaste_interface__membrane__Vm) - 0.96036036039999995)))) : ((3.5600000000000001 * exp(0.079000000000000001 * var_chaste_interface__membrane__Vm)) + (310000.0 * exp(0.34999999999999998 * var_chaste_interface__membrane__Vm))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][156] = (var_chaste_interface__membrane__Vm <  -40.0) ? ( -0.01985294118 * exp( -11.764705879999999 - (0.14705882349999999 * var_chaste_interface__membrane__Vm))) : ( -40.0 <= var_chaste_interface__membrane__Vm) ? 0.0 : NAN;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][157] = (var_chaste_interface__membrane__Vm <=  -40.0) ? ((0.28123999999999999 * exp(0.079000000000000001 * var_chaste_interface__membrane__Vm)) + (108500.0 * exp(0.34999999999999998 * var_chaste_interface__membrane__Vm))) : ( -40.0 < var_chaste_interface__membrane__Vm) ? ((0.011711711709999999 / pow(0.13 + (0.13 * exp(( -0.090090090090000005 * var_chaste_interface__membrane__Vm) - 0.96036036039999995)), 2.0)) * exp(( -0.090090090090000005 * var_chaste_interface__membrane__Vm) - 0.96036036039999995)) : NAN;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][158] = (-(( -40.0 <= var_chaste_interface__membrane__Vm) ? 0.0 : (((( -127140.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__Vm)) - (6.9480000000000006e-05 * exp( -0.043909999999999998 * var_chaste_interface__membrane__Vm))) * (var_chaste_interface__membrane__Vm + 37.780000000000001)) / (1.0 + exp((0.311 * var_chaste_interface__membrane__Vm) + 24.640529999999998))))) - (( -40.0 <= var_chaste_interface__membrane__Vm) ? ((0.29999999999999999 * exp( -2.5349999999999999e-07 * var_chaste_interface__membrane__Vm)) / (1.0 + exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 3.2000000000000002))) : ((0.1212 * exp( -0.01052 * var_chaste_interface__membrane__Vm)) / (1.0 + exp((-(0.13780000000000001 * var_chaste_interface__membrane__Vm)) - 5.5312919999999997))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][159] = (var_chaste_interface__membrane__Vm <  -40.0) ? (((((( -31073.016 * exp(0.24440000000000001 * var_chaste_interface__membrane__Vm)) + (3.0508668000000001e-06 * exp( -0.043909999999999998 * var_chaste_interface__membrane__Vm))) * (var_chaste_interface__membrane__Vm + 37.780000000000001)) * (1.0 / (1.0 + exp((0.311 * var_chaste_interface__membrane__Vm) + 24.640530009999999)))) + ((( -127140.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__Vm)) - (6.9479999990000002e-05 * exp( -0.043909999999999998 * var_chaste_interface__membrane__Vm))) * (1.0 / (1.0 + exp((0.311 * var_chaste_interface__membrane__Vm) + 24.640530009999999))))) - ((((0.311 * (( -127140.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__Vm)) - (6.9479999990000002e-05 * exp( -0.043909999999999998 * var_chaste_interface__membrane__Vm)))) * (var_chaste_interface__membrane__Vm + 37.780000000000001)) / pow(1.0 + exp((0.311 * var_chaste_interface__membrane__Vm) + 24.640530009999999), 2.0)) * exp((0.311 * var_chaste_interface__membrane__Vm) + 24.640530009999999))) : ( -40.0 <= var_chaste_interface__membrane__Vm) ? 0.0 : NAN;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][160] = (var_chaste_interface__membrane__Vm <=  -40.0) ? ((( -0.001275024 * exp( -0.01052 * var_chaste_interface__membrane__Vm)) / (1.0 + exp((-(0.13780000000000001 * var_chaste_interface__membrane__Vm)) - 5.5312919950000001))) + (((0.016701359999999998 * exp( -0.01052 * var_chaste_interface__membrane__Vm)) / pow(1.0 + exp((-(0.13780000000000001 * var_chaste_interface__membrane__Vm)) - 5.5312919950000001), 2.0)) * exp((-(0.13780000000000001 * var_chaste_interface__membrane__Vm)) - 5.5312919950000001))) : ( -40.0 < var_chaste_interface__membrane__Vm) ? ((( -7.604999998e-08 * exp( -2.5349999990000002e-07 * var_chaste_interface__membrane__Vm)) / (1.0 + exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 3.2000000000000002))) + (((0.029999999999999999 * exp( -2.5349999990000002e-07 * var_chaste_interface__membrane__Vm)) / pow(1.0 + exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 3.2000000000000002), 2.0)) * exp((-(0.10000000000000001 * var_chaste_interface__membrane__Vm)) - 3.2000000000000002))) : NAN;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][161] = -((1.0 / (1.2089000000000001 + (1.2089000000000001 * exp((-(0.034035137880000003 * var_chaste_interface__membrane__Vm)) + 0.62658348490000004)))) + (3.5 / (1.0 + exp((0.034035137880000003 * var_chaste_interface__membrane__Vm) + 3.4035137880000002))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][162] = ((0.14019346699999999 / pow(1.0 + exp(( -0.14019346699999999 * var_chaste_interface__membrane__Vm) - 1.3230057479999999), 2.0)) * exp(( -0.14019346699999999 * var_chaste_interface__membrane__Vm) - 1.3230057479999999)) * ((1.0 / (1.2089000000000001 + (1.2089000000000001 * exp((-(0.034035137880000003 * var_chaste_interface__membrane__Vm)) + 0.62658348490000004)))) + (3.5 / (1.0 + exp((0.034035137880000003 * var_chaste_interface__membrane__Vm) + 3.4035137880000002))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][163] = 1.0 / (1.0 + exp(( -0.14019346699999999 * var_chaste_interface__membrane__Vm) - 1.3230057479999999));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][164] = ((0.041145078180000003 / pow(1.2089000000000001 + (1.2089000000000001 * exp((-(0.034035137880000003 * var_chaste_interface__membrane__Vm)) + 0.62658348490000004)), 2.0)) * exp((-(0.034035137880000003 * var_chaste_interface__membrane__Vm)) + 0.62658348490000004)) - ((0.1191229826 / pow(1.0 + exp((0.034035137880000003 * var_chaste_interface__membrane__Vm) + 3.4035137880000002), 2.0)) * exp((0.034035137880000003 * var_chaste_interface__membrane__Vm) + 3.4035137880000002));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][165] = ( -0.025000000000000001 * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6)))) - (1.0 / (9.7952999999999992 + (9.7952999999999992 * exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][166] =  -0.0050000000000000001 * (1.0 / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][167] = exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][168] = 1.0883666670000001 * (1.0 / pow(9.7952999999999992 + (9.7952999999999992 * exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112)), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][169] = exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][170] = ( -0.0040000000000000001 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 12.0))) - (1.0 / (9.7952999999999992 + (9.7952999999999992 * exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][171] =  -0.00080000000000000004 / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 12.0), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][172] = exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 12.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][173] = (((( -0.0050000000000000001 * (1.0 / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6), 2.0))) / ((0.025000000000000001 * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6)))) + (0.20000000000000001 / (1.0 + exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112))))) * exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6)) - (((0.025000000000000001 * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6)))) / pow((0.025000000000000001 * (1.0 / (1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6)))) + (0.20000000000000001 / (1.0 + exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112))), 2.0)) * ((( -0.0050000000000000001 * (1.0 / pow(1.0 + exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6), 2.0))) * exp((0.20000000000000001 * var_chaste_interface__membrane__Vm) + 11.6)) + ((0.022222222222222223 / pow(1.0 + exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112), 2.0)) * exp(( -0.1111111111111111 * var_chaste_interface__membrane__Vm) - 2.1111111111111112))))) * 0.125;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][174] = exp((var_chaste_interface__membrane__Vm * 192970.0) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][175] = exp((var_chaste_interface__membrane__Vm * 192970.0) * 3.8799692706433766e-07) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][176] = 1.0 / (24.827999999999999 * (1.0 + exp((var_chaste_interface__membrane__Vm + 49.100000000000001) * 0.096627693496956227)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][177] = 1.0 + exp((-(var_chaste_interface__membrane__Vm + 0.21299999999999999)) * 0.092532617747756077);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][178] = ((1.0 / (1.0 + exp((var_chaste_interface__membrane__Vm + 17.5) * 0.33333333333333331))) + 0.0001) * 0.99990000999900008;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][179] = 1.0 - (((1.0 / (1.0 + exp((var_chaste_interface__membrane__Vm + 17.5) * 0.33333333333333331))) + 0.0001) * 0.99990000999900008);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][180] = (((1.0 / (1.0 + exp((var_chaste_interface__membrane__Vm + 17.5) * 0.33333333333333331))) + 0.25) * 0.80000000000000004) / (1.0 / ((1.0 / (24.827999999999999 * (1.0 + exp((var_chaste_interface__membrane__Vm + 49.100000000000001) * 0.096627693496956227)))) + (1.0 / (30.553000000000001 * (1.0 + exp((-(var_chaste_interface__membrane__Vm + 0.21299999999999999)) * 0.092532617747756077))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][181] = (1.0 - (((1.0 / (1.0 + exp((var_chaste_interface__membrane__Vm + 17.5) * 0.33333333333333331))) + 0.25) * 0.80000000000000004)) / (1.0 / ((1.0 / (24.827999999999999 * (1.0 + exp((var_chaste_interface__membrane__Vm + 49.100000000000001) * 0.096627693496956227)))) + (1.0 / (30.553000000000001 * (1.0 + exp((-(var_chaste_interface__membrane__Vm + 0.21299999999999999)) * 0.092532617747756077))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][182] = 1.0 / (1.0 + exp(-(((var_chaste_interface__membrane__Vm -  -92.0) * 96485.0) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][183] = exp((var_chaste_interface__membrane__Vm * 26050.950000000001) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][184] = exp((var_chaste_interface__membrane__Vm *  -70434.050000000003) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][185] = 1.0 + (0.32000000000000001 * exp((var_chaste_interface__membrane__Vm *  -70434.050000000003) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][186] = 1.0 / (1.0 + exp((7.4880000000000004 - var_chaste_interface__membrane__Vm) * 0.16722408026755853));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][187] = exp((96485.0 * var_chaste_interface__membrane__Vm) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][188] = exp((96485.0 * var_chaste_interface__membrane__Vm) * 3.8799692706433766e-07) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][189] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__Vm + 10.0) * 0.064935064935064929));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][190] = exp(var_chaste_interface__membrane__Vm * 0.0018181818181818182);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][191] = 1.0 - exp((var_chaste_interface__membrane__Vm * 96485.0) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][192] = 0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][193] = 0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][194] = -((3.0 * (0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07))) + (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07)) + (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][195] = 0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][196] = -((2.0 * (0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07))) + (2.0 * (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07))) + (2.0 * (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][197] = -((0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07)) + (3.0 * (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07))) + (3.0 * (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][198] = -((4.0 * (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07))) + (4.0 * (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][199] = -((3.0 * (0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07))) + (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][200] = 0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][201] = -((2.0 * (0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07))) + (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07)) + (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07)) + (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][202] = -((0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07)) + (2.0 * (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07))) + (2.0 * (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07))) + (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][203] = -((3.0 * (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07))) + (3.0 * (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07))) + (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][204] = -((2.0 * (0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07))) + (2.0 * (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][205] = -((0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07)) + (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07)) + (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07)) + (2.0 * (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][206] = -((2.0 * (0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07))) + (2.0 * (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07))) + (2.0 * (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][207] = -((0.014864597980859999 * exp((var_chaste_interface__membrane__Vm * 2882.7114097438821) * 3.8799692706433766e-07)) + (3.0 * (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][208] = -((0.083986312199829993 * exp((var_chaste_interface__membrane__Vm *  -5351.1600968638604) * 3.8799692706433766e-07)) + (0.01460066118316 * exp((var_chaste_interface__membrane__Vm * 23605.00999819248) * 3.8799692706433766e-07)) + (3.0 * (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][209] = -((4.0 * (0.0031173268874 * exp((var_chaste_interface__membrane__Vm *  -41127.167308531185) * 3.8799692706433766e-07))) + 0.089538306411019994);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][210] = 0.077319900973309999 * exp((var_chaste_interface__membrane__Vm *  -6245.099928323184) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][211] = -((0.077319900973309999 * exp((var_chaste_interface__membrane__Vm *  -6245.099928323184) * 3.8799692706433766e-07)) + (0.58638228663014003 * exp((var_chaste_interface__membrane__Vm * 27214.129096743916) * 3.8799692706433766e-07)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][212] = 0.79405459958640001 * exp((var_chaste_interface__membrane__Vm *  -7735.5673494938583) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][213] = (1.0 / (1.0 + exp((-(var_chaste_interface__membrane__Vm - 13.56)) * 0.10582010582010583))) / (0.58999999999999997 + ((0.80000000000000004 * exp(0.051999999999999998 * (var_chaste_interface__membrane__Vm + 13.0))) / (1.0 + exp(0.13200000000000001 * (var_chaste_interface__membrane__Vm + 13.0)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][214] = (1.0 - (1.0 / (1.0 + exp((-(var_chaste_interface__membrane__Vm - 13.56)) * 0.10582010582010583)))) / (0.58999999999999997 + ((0.80000000000000004 * exp(0.051999999999999998 * (var_chaste_interface__membrane__Vm + 13.0))) / (1.0 + exp(0.13200000000000001 * (var_chaste_interface__membrane__Vm + 13.0)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][215] = (0.32000000000000001 * (var_chaste_interface__membrane__Vm + 47.130000000000003)) / (1.0 - exp( -0.10000000000000001 * (var_chaste_interface__membrane__Vm + 47.130000000000003)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][216] = 0.080000000000000002 * exp((-var_chaste_interface__membrane__Vm) * 0.090909090909090912);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][217] = (var_chaste_interface__membrane__Vm >=  -40.0) ? 0.0 : (0.13500000000000001 * exp((80.0 + var_chaste_interface__membrane__Vm) *  -0.14705882352941177));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][218] = (var_chaste_interface__membrane__Vm >=  -40.0) ? (1.0 / (0.13 * (1.0 + exp((var_chaste_interface__membrane__Vm + 10.66) *  -0.0900900900900901)))) : ((3.5600000000000001 * exp(0.079000000000000001 * var_chaste_interface__membrane__Vm)) + (310000.0 * exp(0.34999999999999998 * var_chaste_interface__membrane__Vm)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][219] = (var_chaste_interface__membrane__Vm >=  -40.0) ? 0.0 : (((( -127140.0 * exp(0.24440000000000001 * var_chaste_interface__membrane__Vm)) - (6.9480000000000006e-05 * exp( -0.043909999999999998 * var_chaste_interface__membrane__Vm))) * (var_chaste_interface__membrane__Vm + 37.780000000000001)) / (1.0 + exp(0.311 * (var_chaste_interface__membrane__Vm + 79.230000000000004))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][220] = (var_chaste_interface__membrane__Vm >=  -40.0) ? ((0.29999999999999999 * exp( -2.5349999999999999e-07 * var_chaste_interface__membrane__Vm)) / (1.0 + exp( -0.10000000000000001 * (var_chaste_interface__membrane__Vm + 32.0)))) : ((0.1212 * exp( -0.01052 * var_chaste_interface__membrane__Vm)) / (1.0 + exp( -0.13780000000000001 * (var_chaste_interface__membrane__Vm + 40.140000000000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][221] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__Vm + 91.0) * 0.16393442622950821));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][222] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__Vm + 10.085000000000001)) * 0.23529411764705882));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][223] = 1.0 / (((0.00059999999999999995 * (var_chaste_interface__membrane__Vm - 1.7383999999999999)) / (1.0 - exp( -0.13600000000000001 * (var_chaste_interface__membrane__Vm - 1.7383999999999999)))) + ((0.00029999999999999997 * (var_chaste_interface__membrane__Vm + 38.360799999999998)) / (exp(0.1522 * (var_chaste_interface__membrane__Vm + 38.360799999999998)) - 1.0)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][224] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__Vm + 9.4369999999999994) *  -0.14019346698443852));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][225] = 1.0 / ((1.0 / (1.2089000000000001 * (1.0 + exp((var_chaste_interface__membrane__Vm - 18.4099) *  -0.034035137876343539)))) + (3.5 / (1.0 + exp((var_chaste_interface__membrane__Vm + 100.0) * 0.034035137876343539))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][226] = 0.025000000000000001 / (1.0 + exp((var_chaste_interface__membrane__Vm + 58.0) * 0.20000000000000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][227] = 1.0 / (9.7952999999999992 * (1.0 + exp((var_chaste_interface__membrane__Vm + 19.0) *  -0.1111111111111111)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][228] = 1.0 / (250.0 * (1.0 + exp((var_chaste_interface__membrane__Vm + 60.0) * 0.20000000000000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__Vm = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][229] = (0.025000000000000001 / (1.0 + exp((var_chaste_interface__membrane__Vm + 58.0) * 0.20000000000000001))) / ((0.025000000000000001 / (1.0 + exp((var_chaste_interface__membrane__Vm + 58.0) * 0.20000000000000001))) + (1.0 / (5.0 * (1.0 + exp((var_chaste_interface__membrane__Vm + 19.0) *  -0.1111111111111111)))));
            }
            
            mNeedsRegeneration[0] = false;
        }
        
        AbstractLookupTableCollection::EventHandler::EndEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
    }
    
private:
    /** The single instance of the class */
    static std::auto_ptr<Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables> mpInstance;

    // Row lookup methods memory
    double _lookup_table_0_row[230];
    
    // Lookup tables
    double (*_lookup_table_0)[230];
    
};

std::auto_ptr<Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables> Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::mpInstance;

    boost::shared_ptr<RegularStimulus> Celldecker_2009FromCellMLCvodeDataClampOpt::UseCellMLDefaultStimulus()
    {
        // Use the default stimulus specified by CellML metadata
        const double var_chaste_interface__membrane__stim_offset = 0.0; // millisecond
        const double var_chaste_interface__membrane__stim_period = 1000.0; // millisecond
        const double var_chaste_interface__membrane__stim_duration = 0.5; // millisecond
        const double var_chaste_interface__membrane__stim_amplitude =  -80.0 * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        boost::shared_ptr<RegularStimulus> p_cellml_stim(new RegularStimulus(
                -fabs(var_chaste_interface__membrane__stim_amplitude),
                var_chaste_interface__membrane__stim_duration,
                var_chaste_interface__membrane__stim_period,
                var_chaste_interface__membrane__stim_offset
                ));
        mpIntracellularStimulus = p_cellml_stim;
        return p_cellml_stim;
    }
    
    double Celldecker_2009FromCellMLCvodeDataClampOpt::GetIntracellularCalciumConcentration()
    {
        return NV_Ith_S(mStateVariables, 37);
    }
    
    Celldecker_2009FromCellMLCvodeDataClampOpt::Celldecker_2009FromCellMLCvodeDataClampOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
        : AbstractCvodeCellWithDataClamp(
                pOdeSolver,
                46,
                0,
                pIntracellularStimulus)
    {
        // Time units: millisecond
        // 
        this->mpSystemInfo = OdeSystemInformation<Celldecker_2009FromCellMLCvodeDataClampOpt>::Instance();
        Init();

        // We have a default stimulus specified in the CellML file metadata
        this->mHasDefaultStimulusFromCellML = true;
        NV_Ith_S(this->mParameters, 0) = 0.004375; // (c,Ileak__Ileak_max) [mM_per_ms]
        NV_Ith_S(this->mParameters, 1) = 0.1125; // (c,Irel__kappa) [mM_per_uA_per_uF_per_ms_per_ms]
        NV_Ith_S(this->mParameters, 2) = 0.004375; // (c,Iup__iupbar) [mM_per_ms]
        NV_Ith_S(this->mParameters, 3) = 1.8; // (c,model_parameters__Ca_o) [mM]
        NV_Ith_S(this->mParameters, 4) = 5.4; // (c,model_parameters__K_o) [mM]
        NV_Ith_S(this->mParameters, 5) = 140; // (c,model_parameters__Na_o) [mM]
        NV_Ith_S(this->mParameters, 6) = 0.00015552; // (c,ICaL__PCa) [L_per_F_ms]
        NV_Ith_S(this->mParameters, 7) = 1.99508e-7; // (c,ICab__PCab) [L_per_F_ms]
        NV_Ith_S(this->mParameters, 8) = 0.000225; // (c,IClb__gClb) [mS_per_uF]
        NV_Ith_S(this->mParameters, 9) = 3.2e-9; // (c,INab__PNab) [L_per_F_ms]
        NV_Ith_S(this->mParameters, 10) = 0.0575; // (c,IpCa__gpCa) [uA_per_uF]
        NV_Ith_S(this->mParameters, 11) = 0.0; // (c,chaste_interface__chaste_interface__membrane_data_clamp_current_conductance) [___units_85]
        NV_Ith_S(this->mParameters, 12) = 9.075; // (c,INa__g_Na) [mS_per_uF]
        NV_Ith_S(this->mParameters, 13) = 0.5; // (c,IK1__g_K1_max) [mS_per_uF]
        NV_Ith_S(this->mParameters, 14) = 0.0065; // (c,INaL__gNaL) [mS_per_uF]
        NV_Ith_S(this->mParameters, 15) = 0.00276; // (c,IKp__gKp) [mS_per_uF]
        NV_Ith_S(this->mParameters, 16) = 0.0138542; // (c,IKr__gKr_max) [mS_per_uF]
        NV_Ith_S(this->mParameters, 17) = 0.0826; // (c,IKs__gKs_max) [mS_per_uF]
        NV_Ith_S(this->mParameters, 18) = 4.5; // (c,INaCa__Vmax) [uA_per_uF]
        NV_Ith_S(this->mParameters, 19) = 1.4; // (c,INaK__ibarnak) [uA_per_uF]
        NV_Ith_S(this->mParameters, 20) = 9e-7; // (c,Ito2__PCl) [L_per_F_ms]
        NV_Ith_S(this->mParameters, 21) = 0.497458; // (c,Ito1__gto1) [mS_per_uF]
    }
    
    Celldecker_2009FromCellMLCvodeDataClampOpt::~Celldecker_2009FromCellMLCvodeDataClampOpt()
    {
    }
    
    AbstractLookupTableCollection* Celldecker_2009FromCellMLCvodeDataClampOpt::GetLookupTableCollection()
    {
        return Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance();
    }
    
    double Celldecker_2009FromCellMLCvodeDataClampOpt::GetIIonic(const std::vector<double>* pStateVariables)
    {
        // For state variable interpolation (SVI) we read in interpolated state variables,
        // otherwise for ionic current interpolation (ICI) we use the state variables of this model (node).
        N_Vector rY;
        bool made_new_cvode_vector = false;
        if (!pStateVariables)
        {
            rY = rGetStateVariables();
        }
        else
        {
            made_new_cvode_vector = true;
            rY = MakeNVector(*pStateVariables);
        }
        
        double var_chaste_interface__membrane__Vm = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -87.4947322902196
        double var_chaste_interface__IKs__C1 = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.476679784307081
        double var_chaste_interface__IKs__C2 = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.255181042718489
        double var_chaste_interface__IKs__C3 = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.0512272866698557
        double var_chaste_interface__IKs__C4 = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0.0045705849736195
        double var_chaste_interface__IKs__C5 = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.000152923243503507
        double var_chaste_interface__IKs__C6 = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.132814156809568
        double var_chaste_interface__IKs__C7 = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.053324572164618
        double var_chaste_interface__IKs__C8 = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 0.00713656414955778
        double var_chaste_interface__IKs__C9 = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 0.000318368292970148
        double var_chaste_interface__IKs__C10 = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0.0138769647384953
        double var_chaste_interface__IKs__C11 = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0.00371438476499172
        double var_chaste_interface__IKs__C12 = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 0.000248553788631871
        double var_chaste_interface__IKs__C13 = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 0.000644426171899078
        double var_chaste_interface__IKs__C14 = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 8.62495047666861e-5
        double var_chaste_interface__IKs__C15 = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 1.12344645485893e-5
        double var_chaste_interface__IKs__O1 = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 1.05292905767805e-5
        double var_chaste_interface__ICaL__O = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 2.26882961412491e-5
        double var_chaste_interface__ICaL__O_star = NV_Ith_S(rY, 20);
        // Units: dimensionless; Initial value: 1.23556404128518e-10
        double var_chaste_interface__INa_m_gate__m = NV_Ith_S(rY, 24);
        // Units: dimensionless; Initial value: 0.00101841101248412
        double var_chaste_interface__INa_h_gate__h = NV_Ith_S(rY, 25);
        // Units: dimensionless; Initial value: 0.991354143386887
        double var_chaste_interface__INa_j_gate__j = NV_Ith_S(rY, 26);
        // Units: dimensionless; Initial value: 0.99709036251243
        double var_chaste_interface__INaL_mL_gate__mL = NV_Ith_S(rY, 27);
        // Units: dimensionless; Initial value: 0.00101841101248412
        double var_chaste_interface__INaL_hL_gate__hL = NV_Ith_S(rY, 28);
        // Units: dimensionless; Initial value: 0.319611809402137
        double var_chaste_interface__IKr_xr_gate__xr = NV_Ith_S(rY, 29);
        // Units: dimensionless; Initial value: 4.06959064407486e-6
        double var_chaste_interface__Ito1_a_gate__a = NV_Ith_S(rY, 30);
        // Units: dimensionless; Initial value: 1.76776038804228e-5
        double var_chaste_interface__Ito1_i1f_gate__i1f = NV_Ith_S(rY, 31);
        // Units: dimensionless; Initial value: 0.997976503910799
        double var_chaste_interface__Ito1_i1s_gate__i1s = NV_Ith_S(rY, 32);
        // Units: dimensionless; Initial value: 0.947581184798815
        double var_chaste_interface__Ito2_i2f_gate__i2f = NV_Ith_S(rY, 33);
        // Units: dimensionless; Initial value: 0.996044894628276
        double var_chaste_interface__Irel__Irel = NV_Ith_S(rY, 34);
        // Units: mM_per_ms; Initial value: 0.000714227102027745
        double var_chaste_interface__Ca__Ca_i = NV_Ith_S(rY, 37);
        // Units: mM; Initial value: 8.38749860095482e-5
        double var_chaste_interface__Ca__Ca_ss_sr = NV_Ith_S(rY, 38);
        // Units: mM; Initial value: 0.00011296707102434
        double var_chaste_interface__Ca__Ca_ss_CaL = NV_Ith_S(rY, 39);
        // Units: mM; Initial value: 0.000119239795531548
        double var_chaste_interface__Na__Na_i = NV_Ith_S(rY, 40);
        // Units: mM; Initial value: 8.01031392415197
        double var_chaste_interface__Na__Na_ss_sr = NV_Ith_S(rY, 41);
        // Units: mM; Initial value: 8.01033434859049
        double var_chaste_interface__Cl__Cl_i = NV_Ith_S(rY, 42);
        // Units: mM; Initial value: 20.6683603724432
        double var_chaste_interface__K__K_i = NV_Ith_S(rY, 44);
        // Units: mM; Initial value: 144.907134343314
        
        // Lookup table indexing
        const bool _oob_0 = Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__Vm);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__Vm);
        
        const double var_chaste_interface__membrane__i_Stim = 0.0;
        const double var_ICaL__ICaL = ((((NV_Ith_S(mParameters, 6) * var_chaste_interface__membrane__Vm * 37237420900.0) * 3.8799692706433766e-07) * ((1.0 * var_chaste_interface__Ca__Ca_ss_CaL * _lt_0_row[174]) - (0.34100000000000003 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[175]) * (var_chaste_interface__ICaL__O + var_chaste_interface__ICaL__O_star); // uA_per_uF
        const double var_INaCa__INaCa_ss_sr = (0.20000000000000001 * NV_Ith_S(mParameters, 18) * ((pow(var_chaste_interface__Na__Na_ss_sr, 3.0) * NV_Ith_S(mParameters, 3) * _lt_0_row[183]) - (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_ss_sr * _lt_0_row[184]))) / ((1.0 + pow(0.000125 / var_chaste_interface__Ca__Ca_ss_sr, 2.0)) * _lt_0_row[185] * (((1.3 * pow(var_chaste_interface__Na__Na_ss_sr, 3.0)) + (669921.875 * var_chaste_interface__Ca__Ca_ss_sr) + (1860.8670000000004 * NV_Ith_S(mParameters, 3) * (1.0 + (var_chaste_interface__Ca__Ca_ss_sr * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 5), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_ss_sr * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_ss_sr, 3.0) * NV_Ith_S(mParameters, 3)) + (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_ss_sr)))); // uA_per_uF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 10) * var_chaste_interface__Ca__Ca_i) / (0.00050000000000000001 + var_chaste_interface__Ca__Ca_i); // uA_per_uF
        const double var_ICab__ICab = (((NV_Ith_S(mParameters, 7) * var_chaste_interface__membrane__Vm * 37237420900.0) * 3.8799692706433766e-07) * ((1.0 * var_chaste_interface__Ca__Ca_i * _lt_0_row[174]) - (0.34100000000000003 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[175]; // uA_per_uF
        const double var_INaCa__INaCa = ((0.80000000000000004 * NV_Ith_S(mParameters, 18) * ((pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 3) * _lt_0_row[183]) - (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_i * _lt_0_row[184]))) / ((1.0 + pow(0.000125 / var_chaste_interface__Ca__Ca_i, 2.0)) * _lt_0_row[185] * (((1.3 * pow(var_chaste_interface__Na__Na_i, 3.0)) + (669921.875 * var_chaste_interface__Ca__Ca_i) + (1860.8670000000004 * NV_Ith_S(mParameters, 3) * (1.0 + (var_chaste_interface__Ca__Ca_i * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 5), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_i * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 3)) + (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_i))))) + var_INaCa__INaCa_ss_sr; // uA_per_uF
        const double var_membrane__caiont = (var_ICaL__ICaL + var_ICab__ICab + var_IpCa__IpCa) - (2.0 * (var_INaCa__INaCa + var_INaCa__INaCa_ss_sr)); // uA_per_uF
        const double var_reversal_potentials__ENa = 26.712338705498265 * log(NV_Ith_S(mParameters, 5) / var_chaste_interface__Na__Na_i); // mV
        const double var_INa__INa = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__INa_m_gate__m, 3.0) * var_chaste_interface__INa_h_gate__h * var_chaste_interface__INa_j_gate__j * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ENa); // uA_per_uF
        const double var_INab__INab = (96485.0 * NV_Ith_S(mParameters, 9) * ((96485.0 * var_chaste_interface__membrane__Vm) * 3.8799692706433766e-07) * ((var_chaste_interface__Na__Na_i * _lt_0_row[187]) - NV_Ith_S(mParameters, 5))) / _lt_0_row[188]; // uA_per_uF
        const double var_INaL__INaL = NV_Ith_S(mParameters, 14) * pow(var_chaste_interface__INaL_mL_gate__mL, 3.0) * var_chaste_interface__INaL_hL_gate__hL * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ENa); // uA_per_uF
        const double var_INaK__INaK = NV_Ith_S(mParameters, 19) * _lt_0_row[182] * (NV_Ith_S(mParameters, 4) / (NV_Ith_S(mParameters, 4) + 1.5)) * pow(var_chaste_interface__Na__Na_i / (var_chaste_interface__Na__Na_i + 2.6000000000000001), 3.0); // uA_per_uF
        const double var_membrane__naiont = var_INa__INa + (3.0 * (var_INaCa__INaCa + var_INaCa__INaCa_ss_sr)) + (3.0 * var_INaK__INaK) + var_INaL__INaL + var_INab__INab; // uA_per_uF
        const double var_reversal_potentials__EK = 26.712338705498265 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__K__K_i); // mV
        const double var_Ito1__Ito1 = NV_Ith_S(mParameters, 21) * pow(var_chaste_interface__Ito1_a_gate__a, 3.0) * var_chaste_interface__Ito1_i1f_gate__i1f * var_chaste_interface__Ito1_i1s_gate__i1s * _lt_0_row[190] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKr__IKr = (NV_Ith_S(mParameters, 16) * sqrt(NV_Ith_S(mParameters, 4) * 0.18518518518518517)) * var_chaste_interface__IKr_xr_gate__xr * _lt_0_row[189] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKs__O2 = 1.0 - (var_chaste_interface__IKs__C1 + var_chaste_interface__IKs__C2 + var_chaste_interface__IKs__C3 + var_chaste_interface__IKs__C4 + var_chaste_interface__IKs__C5 + var_chaste_interface__IKs__C6 + var_chaste_interface__IKs__C7 + var_chaste_interface__IKs__C8 + var_chaste_interface__IKs__C9 + var_chaste_interface__IKs__C10 + var_chaste_interface__IKs__C11 + var_chaste_interface__IKs__C12 + var_chaste_interface__IKs__C13 + var_chaste_interface__IKs__C14 + var_chaste_interface__IKs__C15 + var_chaste_interface__IKs__O1); // dimensionless
        const double var_IKs__IKs = (NV_Ith_S(mParameters, 17) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__Ca__Ca_i, 1.3999999999999999))))) * (var_chaste_interface__IKs__O1 + var_IKs__O2) * (var_chaste_interface__membrane__Vm - (26.712338705498265 * log((NV_Ith_S(mParameters, 4) + (0.018329999999999999 * NV_Ith_S(mParameters, 5))) / (var_chaste_interface__K__K_i + (0.018329999999999999 * var_chaste_interface__Na__Na_i))))); // uA_per_uF
        const double var_IKp__IKp = NV_Ith_S(mParameters, 15) * _lt_0_row[186] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IK1_K1_gate__alpha_k1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) - 59.215000000000003))); // dimensionless
        const double var_IK1__IK1 = (NV_Ith_S(mParameters, 13) * sqrt(NV_Ith_S(mParameters, 4) * 0.18518518518518517)) * (var_IK1_K1_gate__alpha_k1 / (var_IK1_K1_gate__alpha_k1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) + 5.476))) + exp(0.061749999999999999 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) - 594.30999999999995))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) + 4.7530000000000001)))))) * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_membrane__kiont = var_IKr__IKr + var_IKs__IKs + var_IK1__IK1 + var_IKp__IKp + ( -2.0 * var_INaK__INaK) + var_Ito1__Ito1 + (var_chaste_interface__membrane__i_Stim / HeartConfig::Instance()->GetCapacitance()); // uA_per_uF
        const double var_reversal_potentials__ECl =  -26.712338705498265 * log(100.0 / var_chaste_interface__Cl__Cl_i); // mV
        const double var_IClb__IClb = NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ECl); // uA_per_uF
        const double var_Ito2__Ito2 = ((((NV_Ith_S(mParameters, 20) * var_chaste_interface__membrane__Vm * 9309355225.0) * 3.8799692706433766e-07) * (var_chaste_interface__Cl__Cl_i - _lt_0_row[14])) / _lt_0_row[191]) * 1.0 * var_chaste_interface__Ito2_i2f_gate__i2f * (1.0 - (1.0 / (1.0 + pow(var_chaste_interface__Irel__Irel * 2.5, 2.0)))); // uA_per_uF
        const double var_membrane__clont = var_IClb__IClb + var_Ito2__Ito2; // uA_per_uF
        const double var_chaste_interface__i_ionic = (var_membrane__naiont + var_membrane__kiont + var_membrane__caiont + var_membrane__clont) * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        
        const double i_ionic = var_chaste_interface__i_ionic;
        if (made_new_cvode_vector)
        {
            DeleteVector(rY);
        }
        EXCEPT_IF_NOT(!std::isnan(i_ionic));
        return i_ionic;
    }
    
    void Celldecker_2009FromCellMLCvodeDataClampOpt::EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__Vm = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -87.4947322902196
        double var_chaste_interface__IKs__C1 = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.476679784307081
        double var_chaste_interface__IKs__C2 = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.255181042718489
        double var_chaste_interface__IKs__C3 = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.0512272866698557
        double var_chaste_interface__IKs__C4 = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0.0045705849736195
        double var_chaste_interface__IKs__C5 = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.000152923243503507
        double var_chaste_interface__IKs__C6 = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.132814156809568
        double var_chaste_interface__IKs__C7 = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.053324572164618
        double var_chaste_interface__IKs__C8 = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 0.00713656414955778
        double var_chaste_interface__IKs__C9 = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 0.000318368292970148
        double var_chaste_interface__IKs__C10 = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0.0138769647384953
        double var_chaste_interface__IKs__C11 = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0.00371438476499172
        double var_chaste_interface__IKs__C12 = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 0.000248553788631871
        double var_chaste_interface__IKs__C13 = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 0.000644426171899078
        double var_chaste_interface__IKs__C14 = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 8.62495047666861e-5
        double var_chaste_interface__IKs__C15 = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 1.12344645485893e-5
        double var_chaste_interface__IKs__O1 = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 1.05292905767805e-5
        double var_chaste_interface__ICaL__C = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 0.99996982093287
        double var_chaste_interface__ICaL__O = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 2.26882961412491e-5
        double var_chaste_interface__ICaL__C_star = NV_Ith_S(rY, 19);
        // Units: dimensionless; Initial value: 7.49117189549873e-6
        double var_chaste_interface__ICaL__O_star = NV_Ith_S(rY, 20);
        // Units: dimensionless; Initial value: 1.23556404128518e-10
        double var_chaste_interface__ICaL__CI = NV_Ith_S(rY, 21);
        // Units: dimensionless; Initial value: 5.89853003114132e-11
        double var_chaste_interface__ICaL__OI = NV_Ith_S(rY, 22);
        // Units: dimensionless; Initial value: 8.01952813127322e-17
        double var_chaste_interface__ICaL__CI_star = NV_Ith_S(rY, 23);
        // Units: dimensionless; Initial value: 1.9237001017021e-9
        double var_chaste_interface__INa_m_gate__m = NV_Ith_S(rY, 24);
        // Units: dimensionless; Initial value: 0.00101841101248412
        double var_chaste_interface__INa_h_gate__h = NV_Ith_S(rY, 25);
        // Units: dimensionless; Initial value: 0.991354143386887
        double var_chaste_interface__INa_j_gate__j = NV_Ith_S(rY, 26);
        // Units: dimensionless; Initial value: 0.99709036251243
        double var_chaste_interface__INaL_mL_gate__mL = NV_Ith_S(rY, 27);
        // Units: dimensionless; Initial value: 0.00101841101248412
        double var_chaste_interface__INaL_hL_gate__hL = NV_Ith_S(rY, 28);
        // Units: dimensionless; Initial value: 0.319611809402137
        double var_chaste_interface__IKr_xr_gate__xr = NV_Ith_S(rY, 29);
        // Units: dimensionless; Initial value: 4.06959064407486e-6
        double var_chaste_interface__Ito1_a_gate__a = NV_Ith_S(rY, 30);
        // Units: dimensionless; Initial value: 1.76776038804228e-5
        double var_chaste_interface__Ito1_i1f_gate__i1f = NV_Ith_S(rY, 31);
        // Units: dimensionless; Initial value: 0.997976503910799
        double var_chaste_interface__Ito1_i1s_gate__i1s = NV_Ith_S(rY, 32);
        // Units: dimensionless; Initial value: 0.947581184798815
        double var_chaste_interface__Ito2_i2f_gate__i2f = NV_Ith_S(rY, 33);
        // Units: dimensionless; Initial value: 0.996044894628276
        double var_chaste_interface__Irel__Irel = NV_Ith_S(rY, 34);
        // Units: mM_per_ms; Initial value: 0.000714227102027745
        double var_chaste_interface__Ca__Ca_JSR = NV_Ith_S(rY, 35);
        // Units: mM; Initial value: 0.993914988616979
        double var_chaste_interface__Ca__Ca_NSR = NV_Ith_S(rY, 36);
        // Units: mM; Initial value: 1.01475649943057
        double var_chaste_interface__Ca__Ca_i = NV_Ith_S(rY, 37);
        // Units: mM; Initial value: 8.38749860095482e-5
        double var_chaste_interface__Ca__Ca_ss_sr = NV_Ith_S(rY, 38);
        // Units: mM; Initial value: 0.00011296707102434
        double var_chaste_interface__Ca__Ca_ss_CaL = NV_Ith_S(rY, 39);
        // Units: mM; Initial value: 0.000119239795531548
        double var_chaste_interface__Na__Na_i = NV_Ith_S(rY, 40);
        // Units: mM; Initial value: 8.01031392415197
        double var_chaste_interface__Na__Na_ss_sr = NV_Ith_S(rY, 41);
        // Units: mM; Initial value: 8.01033434859049
        double var_chaste_interface__Cl__Cl_i = NV_Ith_S(rY, 42);
        // Units: mM; Initial value: 20.6683603724432
        double var_chaste_interface__Cl__Cl_ss = NV_Ith_S(rY, 43);
        // Units: mM; Initial value: 20.6683605553303
        double var_chaste_interface__K__K_i = NV_Ith_S(rY, 44);
        // Units: mM; Initial value: 144.907134343314
        double var_chaste_interface__CaMK_active__CaMK_trap = NV_Ith_S(rY, 45);
        // Units: dimensionless; Initial value: 0.0114911034744777
        
        
        // Lookup table indexing
        const bool _oob_0 = Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__Vm);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__Vm);
        
        // Mathematics
        double d_dt_chaste_interface__membrane__Vm;
        const double var_chaste_interface__membrane__i_Stim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_ICaL__ICaL = ((((NV_Ith_S(mParameters, 6) * var_chaste_interface__membrane__Vm * 37237420900.0) * 3.8799692706433766e-07) * ((1.0 * var_chaste_interface__Ca__Ca_ss_CaL * _lt_0_row[174]) - (0.34100000000000003 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[175]) * (var_chaste_interface__ICaL__O + var_chaste_interface__ICaL__O_star); // uA_per_uF
        const double var_INaCa__INaCa_ss_sr = (0.20000000000000001 * NV_Ith_S(mParameters, 18) * ((pow(var_chaste_interface__Na__Na_ss_sr, 3.0) * NV_Ith_S(mParameters, 3) * _lt_0_row[183]) - (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_ss_sr * _lt_0_row[184]))) / ((1.0 + pow(0.000125 / var_chaste_interface__Ca__Ca_ss_sr, 2.0)) * _lt_0_row[185] * (((1.3 * pow(var_chaste_interface__Na__Na_ss_sr, 3.0)) + (669921.875 * var_chaste_interface__Ca__Ca_ss_sr) + (1860.8670000000004 * NV_Ith_S(mParameters, 3) * (1.0 + (var_chaste_interface__Ca__Ca_ss_sr * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 5), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_ss_sr * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_ss_sr, 3.0) * NV_Ith_S(mParameters, 3)) + (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_ss_sr)))); // uA_per_uF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 10) * var_chaste_interface__Ca__Ca_i) / (0.00050000000000000001 + var_chaste_interface__Ca__Ca_i); // uA_per_uF
        const double var_ICab__ICab = (((NV_Ith_S(mParameters, 7) * var_chaste_interface__membrane__Vm * 37237420900.0) * 3.8799692706433766e-07) * ((1.0 * var_chaste_interface__Ca__Ca_i * _lt_0_row[174]) - (0.34100000000000003 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[175]; // uA_per_uF
        const double var_INaCa__INaCa = ((0.80000000000000004 * NV_Ith_S(mParameters, 18) * ((pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 3) * _lt_0_row[183]) - (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_i * _lt_0_row[184]))) / ((1.0 + pow(0.000125 / var_chaste_interface__Ca__Ca_i, 2.0)) * _lt_0_row[185] * (((1.3 * pow(var_chaste_interface__Na__Na_i, 3.0)) + (669921.875 * var_chaste_interface__Ca__Ca_i) + (1860.8670000000004 * NV_Ith_S(mParameters, 3) * (1.0 + (var_chaste_interface__Ca__Ca_i * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 5), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_i * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 3)) + (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_i))))) + var_INaCa__INaCa_ss_sr; // uA_per_uF
        const double var_reversal_potentials__ENa = 26.712338705498265 * log(NV_Ith_S(mParameters, 5) / var_chaste_interface__Na__Na_i); // mV
        const double var_INa__INa = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__INa_m_gate__m, 3.0) * var_chaste_interface__INa_h_gate__h * var_chaste_interface__INa_j_gate__j * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ENa); // uA_per_uF
        const double var_INab__INab = (96485.0 * NV_Ith_S(mParameters, 9) * ((96485.0 * var_chaste_interface__membrane__Vm) * 3.8799692706433766e-07) * ((var_chaste_interface__Na__Na_i * _lt_0_row[187]) - NV_Ith_S(mParameters, 5))) / _lt_0_row[188]; // uA_per_uF
        const double var_INaL__INaL = NV_Ith_S(mParameters, 14) * pow(var_chaste_interface__INaL_mL_gate__mL, 3.0) * var_chaste_interface__INaL_hL_gate__hL * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ENa); // uA_per_uF
        const double var_INaK__INaK = NV_Ith_S(mParameters, 19) * _lt_0_row[182] * (NV_Ith_S(mParameters, 4) / (NV_Ith_S(mParameters, 4) + 1.5)) * pow(var_chaste_interface__Na__Na_i / (var_chaste_interface__Na__Na_i + 2.6000000000000001), 3.0); // uA_per_uF
        const double var_reversal_potentials__EK = 26.712338705498265 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__K__K_i); // mV
        const double var_Ito1__Ito1 = NV_Ith_S(mParameters, 21) * pow(var_chaste_interface__Ito1_a_gate__a, 3.0) * var_chaste_interface__Ito1_i1f_gate__i1f * var_chaste_interface__Ito1_i1s_gate__i1s * _lt_0_row[190] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKr__IKr = (NV_Ith_S(mParameters, 16) * sqrt(NV_Ith_S(mParameters, 4) * 0.18518518518518517)) * var_chaste_interface__IKr_xr_gate__xr * _lt_0_row[189] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKs__O2 = 1.0 - (var_chaste_interface__IKs__C1 + var_chaste_interface__IKs__C2 + var_chaste_interface__IKs__C3 + var_chaste_interface__IKs__C4 + var_chaste_interface__IKs__C5 + var_chaste_interface__IKs__C6 + var_chaste_interface__IKs__C7 + var_chaste_interface__IKs__C8 + var_chaste_interface__IKs__C9 + var_chaste_interface__IKs__C10 + var_chaste_interface__IKs__C11 + var_chaste_interface__IKs__C12 + var_chaste_interface__IKs__C13 + var_chaste_interface__IKs__C14 + var_chaste_interface__IKs__C15 + var_chaste_interface__IKs__O1); // dimensionless
        const double var_IKs__IKs = (NV_Ith_S(mParameters, 17) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__Ca__Ca_i, 1.3999999999999999))))) * (var_chaste_interface__IKs__O1 + var_IKs__O2) * (var_chaste_interface__membrane__Vm - (26.712338705498265 * log((NV_Ith_S(mParameters, 4) + (0.018329999999999999 * NV_Ith_S(mParameters, 5))) / (var_chaste_interface__K__K_i + (0.018329999999999999 * var_chaste_interface__Na__Na_i))))); // uA_per_uF
        const double var_IKp__IKp = NV_Ith_S(mParameters, 15) * _lt_0_row[186] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IK1_K1_gate__alpha_k1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) - 59.215000000000003))); // dimensionless
        const double var_IK1__IK1 = (NV_Ith_S(mParameters, 13) * sqrt(NV_Ith_S(mParameters, 4) * 0.18518518518518517)) * (var_IK1_K1_gate__alpha_k1 / (var_IK1_K1_gate__alpha_k1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) + 5.476))) + exp(0.061749999999999999 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) - 594.30999999999995))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) + 4.7530000000000001)))))) * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_reversal_potentials__ECl =  -26.712338705498265 * log(100.0 / var_chaste_interface__Cl__Cl_i); // mV
        const double var_IClb__IClb = NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ECl); // uA_per_uF
        const double var_Ito2__Ito2 = ((((NV_Ith_S(mParameters, 20) * var_chaste_interface__membrane__Vm * 9309355225.0) * 3.8799692706433766e-07) * (var_chaste_interface__Cl__Cl_i - _lt_0_row[14])) / _lt_0_row[191]) * 1.0 * var_chaste_interface__Ito2_i2f_gate__i2f * (1.0 - (1.0 / (1.0 + pow(var_chaste_interface__Irel__Irel * 2.5, 2.0)))); // uA_per_uF
        const double var_ICaL__OI_star = 1.0 - (var_chaste_interface__ICaL__C + var_chaste_interface__ICaL__O + var_chaste_interface__ICaL__C_star + var_chaste_interface__ICaL__O_star + var_chaste_interface__ICaL__CI + var_chaste_interface__ICaL__OI + var_chaste_interface__ICaL__CI_star); // dimensionless
        const double var_ICaL__IV_tau_star = 1.0 / (_lt_0_row[176] + (1.0 / ((25.0 - (17.5 / (1.0 + pow(0.0030000000000000001 / var_chaste_interface__Ca__Ca_ss_CaL, 4.0)))) * _lt_0_row[177]))); // ms
        const double var_ICaL__delta = 3.0 / (1.0 + pow(0.0030000000000000001 / var_chaste_interface__Ca__Ca_ss_CaL, 4.0)); // per_ms
        const double var_ICaL__y_star = _lt_0_row[179] / var_ICaL__IV_tau_star; // per_ms
        const double var_ICaL__x_star = _lt_0_row[178] / var_ICaL__IV_tau_star; // per_ms
        const double var_ICaL__delta_I = (9.9999999999999995e-07 * _lt_0_row[180] * var_ICaL__y_star * var_ICaL__delta) / (_lt_0_row[181] * var_ICaL__x_star * 1.0); // per_ms
        const double var_CT_Na_Cl__CT_Na_Cl = (2.4610800000000002e-05 * pow(var_reversal_potentials__ENa - var_reversal_potentials__ECl, 4.0)) / (pow(var_reversal_potentials__ENa - var_reversal_potentials__ECl, 4.0) + 59494197.640692554); // mM_per_ms
        const double var_CT_K_Cl__CT_K_Cl = (1.77e-05 * (var_reversal_potentials__EK - var_reversal_potentials__ECl)) / ((var_reversal_potentials__EK + 87.825100000000006) - var_reversal_potentials__ECl); // mM_per_ms
        const double var_CaMK_active__CaMK_active = ((0.050000000000000003 * (1.0 - var_chaste_interface__CaMK_active__CaMK_trap)) / (1.0 + (0.0015 / var_chaste_interface__Ca__Ca_ss_sr))) + var_chaste_interface__CaMK_active__CaMK_trap; // dimensionless
        const double var_Irel__beta_tau = 4.75 * (1.0 + (1.0 / (1.0 + pow(0.28000000000000003 / (1.0 * var_CaMK_active__CaMK_active), 10.0)))); // ms
        const double var_Iup__Iup = ((((var_CaMK_active__CaMK_active * 0.75) / (0.14999999999999999 + (var_CaMK_active__CaMK_active * 1.0))) + 1.0) * NV_Ith_S(mParameters, 2) * var_chaste_interface__Ca__Ca_i) / ((var_chaste_interface__Ca__Ca_i + 0.00092000000000000003) - ((var_CaMK_active__CaMK_active * 0.00017000000000000001) / (0.14999999999999999 + (var_CaMK_active__CaMK_active * 1.0)))); // mM_per_ms
        const double var_Ileak__Ileak = (NV_Ith_S(mParameters, 0) * 0.066666666666666666) * var_chaste_interface__Ca__Ca_NSR; // mM_per_ms
        const double var_Itr__Itr = (var_chaste_interface__Ca__Ca_NSR - var_chaste_interface__Ca__Ca_JSR) * 0.040000000000000001; // mM_per_ms
        const double var_Ca__Idiff = (var_chaste_interface__Ca__Ca_ss_sr - var_chaste_interface__Ca__Ca_i) * 5.0; // mM_per_ms
        const double var_Ca__Idiff_ss = (var_chaste_interface__Ca__Ca_ss_sr - var_chaste_interface__Ca__Ca_ss_CaL) * 0.5; // mM_per_ms
        const double var_Na__Idiff_Na = (var_chaste_interface__Na__Na_ss_sr - var_chaste_interface__Na__Na_i) * 5.0; // mM_per_ms
        const double var_Cl__Idiff_Cl = (var_chaste_interface__Cl__Cl_ss - var_chaste_interface__Cl__Cl_i) * 5.0; // mM_per_ms
        const double d_dt_chaste_interface__IKs__C1 = ( -4.0 * _lt_0_row[192] * var_chaste_interface__IKs__C1) + (_lt_0_row[193] * var_chaste_interface__IKs__C2); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C2 = (_lt_0_row[194] * var_chaste_interface__IKs__C2) + (4.0 * _lt_0_row[192] * var_chaste_interface__IKs__C1) + (2.0 * _lt_0_row[193] * var_chaste_interface__IKs__C3) + (_lt_0_row[195] * var_chaste_interface__IKs__C6); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C3 = (_lt_0_row[196] * var_chaste_interface__IKs__C3) + (3.0 * _lt_0_row[192] * var_chaste_interface__IKs__C2) + (3.0 * _lt_0_row[193] * var_chaste_interface__IKs__C4) + (_lt_0_row[195] * var_chaste_interface__IKs__C7); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C4 = (_lt_0_row[197] * var_chaste_interface__IKs__C4) + (2.0 * _lt_0_row[192] * var_chaste_interface__IKs__C3) + (4.0 * _lt_0_row[193] * var_chaste_interface__IKs__C5) + (_lt_0_row[195] * var_chaste_interface__IKs__C8); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C5 = (_lt_0_row[198] * var_chaste_interface__IKs__C5) + (_lt_0_row[192] * var_chaste_interface__IKs__C4) + (_lt_0_row[195] * var_chaste_interface__IKs__C9); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C6 = (_lt_0_row[199] * var_chaste_interface__IKs__C6) + (_lt_0_row[193] * var_chaste_interface__IKs__C7) + (_lt_0_row[200] * var_chaste_interface__IKs__C2); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C7 = (_lt_0_row[201] * var_chaste_interface__IKs__C7) + (3.0 * _lt_0_row[192] * var_chaste_interface__IKs__C6) + (2.0 * _lt_0_row[193] * var_chaste_interface__IKs__C8) + (2.0 * _lt_0_row[200] * var_chaste_interface__IKs__C3) + (2.0 * _lt_0_row[195] * var_chaste_interface__IKs__C10); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C8 = (_lt_0_row[202] * var_chaste_interface__IKs__C8) + (2.0 * _lt_0_row[192] * var_chaste_interface__IKs__C7) + (3.0 * _lt_0_row[193] * var_chaste_interface__IKs__C9) + (3.0 * _lt_0_row[200] * var_chaste_interface__IKs__C4) + (2.0 * _lt_0_row[195] * var_chaste_interface__IKs__C11); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C9 = (_lt_0_row[203] * var_chaste_interface__IKs__C9) + (_lt_0_row[192] * var_chaste_interface__IKs__C8) + (4.0 * _lt_0_row[200] * var_chaste_interface__IKs__C5) + (2.0 * _lt_0_row[195] * var_chaste_interface__IKs__C12); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C10 = (_lt_0_row[204] * var_chaste_interface__IKs__C10) + (_lt_0_row[193] * var_chaste_interface__IKs__C11) + (_lt_0_row[200] * var_chaste_interface__IKs__C7); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C11 = (_lt_0_row[205] * var_chaste_interface__IKs__C11) + (2.0 * _lt_0_row[192] * var_chaste_interface__IKs__C10) + (2.0 * _lt_0_row[193] * var_chaste_interface__IKs__C12) + (2.0 * _lt_0_row[200] * var_chaste_interface__IKs__C8) + (3.0 * _lt_0_row[195] * var_chaste_interface__IKs__C13); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C12 = (_lt_0_row[206] * var_chaste_interface__IKs__C12) + (_lt_0_row[192] * var_chaste_interface__IKs__C11) + (3.0 * _lt_0_row[200] * var_chaste_interface__IKs__C9) + (3.0 * _lt_0_row[195] * var_chaste_interface__IKs__C14); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C13 = (_lt_0_row[207] * var_chaste_interface__IKs__C13) + (_lt_0_row[193] * var_chaste_interface__IKs__C14) + (_lt_0_row[200] * var_chaste_interface__IKs__C11); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C14 = (_lt_0_row[208] * var_chaste_interface__IKs__C14) + (_lt_0_row[192] * var_chaste_interface__IKs__C13) + (2.0 * _lt_0_row[200] * var_chaste_interface__IKs__C12) + (4.0 * _lt_0_row[195] * var_chaste_interface__IKs__C15); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__C15 = (_lt_0_row[209] * var_chaste_interface__IKs__C15) + (_lt_0_row[200] * var_chaste_interface__IKs__C14) + (_lt_0_row[210] * var_chaste_interface__IKs__O1); // 'per millisecond'
        const double d_dt_chaste_interface__IKs__O1 = (_lt_0_row[211] * var_chaste_interface__IKs__O1) + (_lt_0_row[212] * var_IKs__O2) + (0.089538306411019994 * var_chaste_interface__IKs__C15); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__C = ((-(_lt_0_row[213] + var_ICaL__delta + _lt_0_row[181])) * var_chaste_interface__ICaL__C) + (_lt_0_row[214] * var_chaste_interface__ICaL__O) + (1.0 * var_chaste_interface__ICaL__C_star) + (_lt_0_row[180] * var_chaste_interface__ICaL__CI); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__O = ((-(_lt_0_row[214] + var_ICaL__delta + _lt_0_row[181])) * var_chaste_interface__ICaL__O) + (_lt_0_row[213] * var_chaste_interface__ICaL__C) + (1.0 * var_chaste_interface__ICaL__O_star) + (_lt_0_row[180] * var_chaste_interface__ICaL__OI); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__C_star = ((-(_lt_0_row[213] + 1.0 + var_ICaL__y_star)) * var_chaste_interface__ICaL__C_star) + (var_ICaL__delta * var_chaste_interface__ICaL__C) + (_lt_0_row[214] * var_chaste_interface__ICaL__O_star) + (var_ICaL__x_star * var_chaste_interface__ICaL__CI_star); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__O_star = ((-(_lt_0_row[214] + 1.0 + var_ICaL__y_star)) * var_chaste_interface__ICaL__O_star) + (var_ICaL__delta * var_chaste_interface__ICaL__O) + (_lt_0_row[213] * var_chaste_interface__ICaL__C_star) + (var_ICaL__x_star * var_ICaL__OI_star); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__CI = ((-(_lt_0_row[213] + var_ICaL__delta_I + _lt_0_row[180])) * var_chaste_interface__ICaL__CI) + (_lt_0_row[181] * var_chaste_interface__ICaL__C) + (9.9999999999999995e-07 * var_chaste_interface__ICaL__CI_star) + (_lt_0_row[214] * var_chaste_interface__ICaL__OI); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__OI = ((-(_lt_0_row[214] + var_ICaL__delta_I + _lt_0_row[180])) * var_chaste_interface__ICaL__OI) + (_lt_0_row[181] * var_chaste_interface__ICaL__O) + (9.9999999999999995e-07 * var_ICaL__OI_star) + (_lt_0_row[213] * var_chaste_interface__ICaL__CI); // 'per millisecond'
        const double d_dt_chaste_interface__ICaL__CI_star = ((-(_lt_0_row[213] + 9.9999999999999995e-07 + var_ICaL__x_star)) * var_chaste_interface__ICaL__CI_star) + (var_ICaL__delta_I * var_chaste_interface__ICaL__CI) + (var_ICaL__y_star * var_chaste_interface__ICaL__C_star) + (_lt_0_row[214] * var_ICaL__OI_star); // 'per millisecond'
        const double d_dt_chaste_interface__INa_m_gate__m = (_lt_0_row[215] * (1.0 - var_chaste_interface__INa_m_gate__m)) - (_lt_0_row[216] * var_chaste_interface__INa_m_gate__m); // 'per millisecond'
        const double d_dt_chaste_interface__INa_h_gate__h = (_lt_0_row[217] * (1.0 - var_chaste_interface__INa_h_gate__h)) - (_lt_0_row[218] * var_chaste_interface__INa_h_gate__h); // 'per millisecond'
        const double d_dt_chaste_interface__INa_j_gate__j = (_lt_0_row[219] * (1.0 - var_chaste_interface__INa_j_gate__j)) - (_lt_0_row[220] * var_chaste_interface__INa_j_gate__j); // 'per millisecond'
        const double d_dt_chaste_interface__INaL_mL_gate__mL = (_lt_0_row[215] * (1.0 - var_chaste_interface__INaL_mL_gate__mL)) - (_lt_0_row[216] * var_chaste_interface__INaL_mL_gate__mL); // 'per millisecond'
        const double d_dt_chaste_interface__INaL_hL_gate__hL = (_lt_0_row[221] - var_chaste_interface__INaL_hL_gate__hL) * 0.0016666666666666668; // 'per millisecond'
        const double d_dt_chaste_interface__IKr_xr_gate__xr = (_lt_0_row[222] - var_chaste_interface__IKr_xr_gate__xr) / _lt_0_row[223]; // 'per millisecond'
        const double d_dt_chaste_interface__Ito1_a_gate__a = (_lt_0_row[224] - var_chaste_interface__Ito1_a_gate__a) / _lt_0_row[225]; // 'per millisecond'
        const double d_dt_chaste_interface__Ito1_i1f_gate__i1f = (_lt_0_row[226] * (1.0 - var_chaste_interface__Ito1_i1f_gate__i1f)) - (_lt_0_row[227] * var_chaste_interface__Ito1_i1f_gate__i1f); // 'per millisecond'
        const double d_dt_chaste_interface__Ito1_i1s_gate__i1s = (_lt_0_row[228] * (1.0 - var_chaste_interface__Ito1_i1s_gate__i1s)) - (_lt_0_row[227] * var_chaste_interface__Ito1_i1s_gate__i1s); // 'per millisecond'
        const double d_dt_chaste_interface__Ito2_i2f_gate__i2f = (_lt_0_row[229] - var_chaste_interface__Ito2_i2f_gate__i2f) * 0.125; // 'per millisecond'
        const double d_dt_chaste_interface__Irel__Irel = (-(((var_ICaL__ICaL * (var_Irel__beta_tau * NV_Ith_S(mParameters, 1))) / (1.0 + pow(1.0 / var_chaste_interface__Ca__Ca_JSR, 8.0))) + var_chaste_interface__Irel__Irel)) / (var_Irel__beta_tau / (1.0 + (0.0123 / var_chaste_interface__Ca__Ca_JSR))); // 'mM per millisecond per ms'
        const double d_dt_chaste_interface__Ca__Ca_JSR = (1.0 / (1.0 + (8.0 / pow(var_chaste_interface__Ca__Ca_JSR + 0.80000000000000004, 2.0)))) * (var_Itr__Itr - var_chaste_interface__Irel__Irel); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_NSR = var_Iup__Iup - (var_Ileak__Ileak + ((var_Itr__Itr * 1.8246370132049518e-07) * 476568.87978169642)); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_i = (1.0 / (1.0 + (0.00011900000000000002 / pow(var_chaste_interface__Ca__Ca_i + 0.0023800000000000002, 2.0)) + (3.5000000000000004e-05 / pow(var_chaste_interface__Ca__Ca_i + 0.00050000000000000001, 2.0)))) * ((((-((var_ICab__ICab + var_IpCa__IpCa) - (2.0 * var_INaCa__INaCa))) * 1.5902511810263306e-09) * 19400.149088458438) + (((var_Ileak__Ileak - var_Iup__Iup) * 2.0983325651856948e-06) * 38800.298176916876) + ((var_Ca__Idiff * 7.6026542216873e-07) * 38800.298176916876)); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_ss_sr = (-(1.0 / (1.0 + (4.0890000000000003e-05 / pow(0.00087000000000000001 + var_chaste_interface__Ca__Ca_ss_sr, 2.0)) + (0.0097788000000000007 / pow(0.0086999999999999994 + var_chaste_interface__Ca__Ca_ss_sr, 2.0))))) * ((var_Ca__Idiff + var_Ca__Idiff_ss) - (((var_INaCa__INaCa_ss_sr * 3.1805023620526612e-09) * 657665.05409874103) + ((var_chaste_interface__Irel__Irel * 1.8246370132049518e-07) * 1315330.1081974821))); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Ca__Ca_ss_CaL = (-(1.0 / (1.0 + (4.0890000000000003e-05 / pow(0.00087000000000000001 + var_chaste_interface__Ca__Ca_ss_CaL, 2.0)) + (0.0097788000000000007 / pow(0.0086999999999999994 + var_chaste_interface__Ca__Ca_ss_CaL, 2.0))))) * (((var_ICaL__ICaL * 1.5902511810263306e-09) * 6576650.5409874106) - ((var_Ca__Idiff_ss * 7.6026542216873e-07) * 13153301.081974821)); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Na__Na_i = -(((((3.0 * var_INaCa__INaCa) + (3.0 * var_INaK__INaK) + var_INa__INa + var_INaL__INaL + var_INab__INab) * 1.5902511810263306e-09) * 38800.298176916876) - (var_CT_Na_Cl__CT_Na_Cl + ((var_Na__Idiff_Na * 7.6026542216873e-07) * 38800.298176916876))); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Na__Na_ss_sr = -(((var_INaCa__INaCa_ss_sr * 4.7707535430789916e-09) * 1315330.1081974821) + var_Na__Idiff_Na); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Cl__Cl_i = -(((var_IClb__IClb * 1.5902511810263306e-09) *  -38800.298176916876) - (var_CT_Na_Cl__CT_Na_Cl + var_CT_K_Cl__CT_K_Cl + ((var_Cl__Idiff_Cl * 7.6026542216873e-07) * 38800.298176916876))); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__Cl__Cl_ss = -(((var_Ito2__Ito2 * 1.5902511810263306e-09) *  -1315330.1081974821) + var_Cl__Idiff_Cl); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__K__K_i = -(((((var_IKs__IKs + var_IKr__IKr + var_IK1__IK1 + var_Ito1__Ito1 + var_IKp__IKp + (var_chaste_interface__membrane__i_Stim / HeartConfig::Instance()->GetCapacitance())) - (2.0 * var_INaK__INaK)) * 1.5902511810263306e-09) * 38800.298176916876) - var_CT_K_Cl__CT_K_Cl); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__CaMK_active__CaMK_trap = (0.050000000000000003 * var_CaMK_active__CaMK_active * (var_CaMK_active__CaMK_active - var_chaste_interface__CaMK_active__CaMK_trap)) - (0.00068000000000000005 * var_chaste_interface__CaMK_active__CaMK_trap); // 'per millisecond'
        
        if (mSetVoltageDerivativeToZero)
        {
            d_dt_chaste_interface__membrane__Vm = 0.0;
        }
        else
        {
            const double var_membrane__caiont = (var_ICaL__ICaL + var_ICab__ICab + var_IpCa__IpCa) - (2.0 * (var_INaCa__INaCa + var_INaCa__INaCa_ss_sr)); // uA_per_uF
            const double var_membrane__naiont = var_INa__INa + (3.0 * (var_INaCa__INaCa + var_INaCa__INaCa_ss_sr)) + (3.0 * var_INaK__INaK) + var_INaL__INaL + var_INab__INab; // uA_per_uF
            const double var_membrane__kiont = var_IKr__IKr + var_IKs__IKs + var_IK1__IK1 + var_IKp__IKp + ( -2.0 * var_INaK__INaK) + var_Ito1__Ito1 + (var_chaste_interface__membrane__i_Stim / HeartConfig::Instance()->GetCapacitance()); // uA_per_uF
            const double var_membrane__clont = var_IClb__IClb + var_Ito2__Ito2; // uA_per_uF
            double var_chaste_interface__membrane_data_clamp_current = 0.0;
            if (mDataClampIsOn)
            {
                var_chaste_interface__membrane_data_clamp_current = NV_Ith_S(mParameters, 11) * (var_chaste_interface__membrane__Vm - GetExperimentalVoltageAtTimeT(var_chaste_interface__environment__time)); // uA_per_cm2
            }
            d_dt_chaste_interface__membrane__Vm = -(var_membrane__naiont + var_chaste_interface__membrane_data_clamp_current + var_membrane__kiont + var_membrane__caiont + var_membrane__clont); // 'millivolt per millisecond'
        }
        
        NV_Ith_S(rDY, 0) = d_dt_chaste_interface__membrane__Vm;
        NV_Ith_S(rDY, 1) = d_dt_chaste_interface__IKs__C1;
        NV_Ith_S(rDY, 2) = d_dt_chaste_interface__IKs__C2;
        NV_Ith_S(rDY, 3) = d_dt_chaste_interface__IKs__C3;
        NV_Ith_S(rDY, 4) = d_dt_chaste_interface__IKs__C4;
        NV_Ith_S(rDY, 5) = d_dt_chaste_interface__IKs__C5;
        NV_Ith_S(rDY, 6) = d_dt_chaste_interface__IKs__C6;
        NV_Ith_S(rDY, 7) = d_dt_chaste_interface__IKs__C7;
        NV_Ith_S(rDY, 8) = d_dt_chaste_interface__IKs__C8;
        NV_Ith_S(rDY, 9) = d_dt_chaste_interface__IKs__C9;
        NV_Ith_S(rDY, 10) = d_dt_chaste_interface__IKs__C10;
        NV_Ith_S(rDY, 11) = d_dt_chaste_interface__IKs__C11;
        NV_Ith_S(rDY, 12) = d_dt_chaste_interface__IKs__C12;
        NV_Ith_S(rDY, 13) = d_dt_chaste_interface__IKs__C13;
        NV_Ith_S(rDY, 14) = d_dt_chaste_interface__IKs__C14;
        NV_Ith_S(rDY, 15) = d_dt_chaste_interface__IKs__C15;
        NV_Ith_S(rDY, 16) = d_dt_chaste_interface__IKs__O1;
        NV_Ith_S(rDY, 17) = d_dt_chaste_interface__ICaL__C;
        NV_Ith_S(rDY, 18) = d_dt_chaste_interface__ICaL__O;
        NV_Ith_S(rDY, 19) = d_dt_chaste_interface__ICaL__C_star;
        NV_Ith_S(rDY, 20) = d_dt_chaste_interface__ICaL__O_star;
        NV_Ith_S(rDY, 21) = d_dt_chaste_interface__ICaL__CI;
        NV_Ith_S(rDY, 22) = d_dt_chaste_interface__ICaL__OI;
        NV_Ith_S(rDY, 23) = d_dt_chaste_interface__ICaL__CI_star;
        NV_Ith_S(rDY, 24) = d_dt_chaste_interface__INa_m_gate__m;
        NV_Ith_S(rDY, 25) = d_dt_chaste_interface__INa_h_gate__h;
        NV_Ith_S(rDY, 26) = d_dt_chaste_interface__INa_j_gate__j;
        NV_Ith_S(rDY, 27) = d_dt_chaste_interface__INaL_mL_gate__mL;
        NV_Ith_S(rDY, 28) = d_dt_chaste_interface__INaL_hL_gate__hL;
        NV_Ith_S(rDY, 29) = d_dt_chaste_interface__IKr_xr_gate__xr;
        NV_Ith_S(rDY, 30) = d_dt_chaste_interface__Ito1_a_gate__a;
        NV_Ith_S(rDY, 31) = d_dt_chaste_interface__Ito1_i1f_gate__i1f;
        NV_Ith_S(rDY, 32) = d_dt_chaste_interface__Ito1_i1s_gate__i1s;
        NV_Ith_S(rDY, 33) = d_dt_chaste_interface__Ito2_i2f_gate__i2f;
        NV_Ith_S(rDY, 34) = d_dt_chaste_interface__Irel__Irel;
        NV_Ith_S(rDY, 35) = d_dt_chaste_interface__Ca__Ca_JSR;
        NV_Ith_S(rDY, 36) = d_dt_chaste_interface__Ca__Ca_NSR;
        NV_Ith_S(rDY, 37) = d_dt_chaste_interface__Ca__Ca_i;
        NV_Ith_S(rDY, 38) = d_dt_chaste_interface__Ca__Ca_ss_sr;
        NV_Ith_S(rDY, 39) = d_dt_chaste_interface__Ca__Ca_ss_CaL;
        NV_Ith_S(rDY, 40) = d_dt_chaste_interface__Na__Na_i;
        NV_Ith_S(rDY, 41) = d_dt_chaste_interface__Na__Na_ss_sr;
        NV_Ith_S(rDY, 42) = d_dt_chaste_interface__Cl__Cl_i;
        NV_Ith_S(rDY, 43) = d_dt_chaste_interface__Cl__Cl_ss;
        NV_Ith_S(rDY, 44) = d_dt_chaste_interface__K__K_i;
        NV_Ith_S(rDY, 45) = d_dt_chaste_interface__CaMK_active__CaMK_trap;
    }
    
    N_Vector Celldecker_2009FromCellMLCvodeDataClampOpt::ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__Vm = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -87.4947322902196
        double var_chaste_interface__IKs__C1 = NV_Ith_S(rY, 1);
        // Units: dimensionless; Initial value: 0.476679784307081
        double var_chaste_interface__IKs__C2 = NV_Ith_S(rY, 2);
        // Units: dimensionless; Initial value: 0.255181042718489
        double var_chaste_interface__IKs__C3 = NV_Ith_S(rY, 3);
        // Units: dimensionless; Initial value: 0.0512272866698557
        double var_chaste_interface__IKs__C4 = NV_Ith_S(rY, 4);
        // Units: dimensionless; Initial value: 0.0045705849736195
        double var_chaste_interface__IKs__C5 = NV_Ith_S(rY, 5);
        // Units: dimensionless; Initial value: 0.000152923243503507
        double var_chaste_interface__IKs__C6 = NV_Ith_S(rY, 6);
        // Units: dimensionless; Initial value: 0.132814156809568
        double var_chaste_interface__IKs__C7 = NV_Ith_S(rY, 7);
        // Units: dimensionless; Initial value: 0.053324572164618
        double var_chaste_interface__IKs__C8 = NV_Ith_S(rY, 8);
        // Units: dimensionless; Initial value: 0.00713656414955778
        double var_chaste_interface__IKs__C9 = NV_Ith_S(rY, 9);
        // Units: dimensionless; Initial value: 0.000318368292970148
        double var_chaste_interface__IKs__C10 = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0.0138769647384953
        double var_chaste_interface__IKs__C11 = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 0.00371438476499172
        double var_chaste_interface__IKs__C12 = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 0.000248553788631871
        double var_chaste_interface__IKs__C13 = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 0.000644426171899078
        double var_chaste_interface__IKs__C14 = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 8.62495047666861e-5
        double var_chaste_interface__IKs__C15 = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 1.12344645485893e-5
        double var_chaste_interface__IKs__O1 = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 1.05292905767805e-5
        double var_chaste_interface__ICaL__O = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 2.26882961412491e-5
        double var_chaste_interface__ICaL__O_star = NV_Ith_S(rY, 20);
        // Units: dimensionless; Initial value: 1.23556404128518e-10
        double var_chaste_interface__INa_m_gate__m = NV_Ith_S(rY, 24);
        // Units: dimensionless; Initial value: 0.00101841101248412
        double var_chaste_interface__INa_h_gate__h = NV_Ith_S(rY, 25);
        // Units: dimensionless; Initial value: 0.991354143386887
        double var_chaste_interface__INa_j_gate__j = NV_Ith_S(rY, 26);
        // Units: dimensionless; Initial value: 0.99709036251243
        double var_chaste_interface__INaL_mL_gate__mL = NV_Ith_S(rY, 27);
        // Units: dimensionless; Initial value: 0.00101841101248412
        double var_chaste_interface__INaL_hL_gate__hL = NV_Ith_S(rY, 28);
        // Units: dimensionless; Initial value: 0.319611809402137
        double var_chaste_interface__IKr_xr_gate__xr = NV_Ith_S(rY, 29);
        // Units: dimensionless; Initial value: 4.06959064407486e-6
        double var_chaste_interface__Ito1_a_gate__a = NV_Ith_S(rY, 30);
        // Units: dimensionless; Initial value: 1.76776038804228e-5
        double var_chaste_interface__Ito1_i1f_gate__i1f = NV_Ith_S(rY, 31);
        // Units: dimensionless; Initial value: 0.997976503910799
        double var_chaste_interface__Ito1_i1s_gate__i1s = NV_Ith_S(rY, 32);
        // Units: dimensionless; Initial value: 0.947581184798815
        double var_chaste_interface__Ito2_i2f_gate__i2f = NV_Ith_S(rY, 33);
        // Units: dimensionless; Initial value: 0.996044894628276
        double var_chaste_interface__Irel__Irel = NV_Ith_S(rY, 34);
        // Units: mM_per_ms; Initial value: 0.000714227102027745
        double var_chaste_interface__Ca__Ca_NSR = NV_Ith_S(rY, 36);
        // Units: mM; Initial value: 1.01475649943057
        double var_chaste_interface__Ca__Ca_i = NV_Ith_S(rY, 37);
        // Units: mM; Initial value: 8.38749860095482e-5
        double var_chaste_interface__Ca__Ca_ss_sr = NV_Ith_S(rY, 38);
        // Units: mM; Initial value: 0.00011296707102434
        double var_chaste_interface__Ca__Ca_ss_CaL = NV_Ith_S(rY, 39);
        // Units: mM; Initial value: 0.000119239795531548
        double var_chaste_interface__Na__Na_i = NV_Ith_S(rY, 40);
        // Units: mM; Initial value: 8.01031392415197
        double var_chaste_interface__Na__Na_ss_sr = NV_Ith_S(rY, 41);
        // Units: mM; Initial value: 8.01033434859049
        double var_chaste_interface__Cl__Cl_i = NV_Ith_S(rY, 42);
        // Units: mM; Initial value: 20.6683603724432
        double var_chaste_interface__K__K_i = NV_Ith_S(rY, 44);
        // Units: mM; Initial value: 144.907134343314
        double var_chaste_interface__CaMK_active__CaMK_trap = NV_Ith_S(rY, 45);
        // Units: dimensionless; Initial value: 0.0114911034744777
        
        
        // Lookup table indexing
        const bool _oob_0 = Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__Vm);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Celldecker_2009FromCellMLCvodeDataClampOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__Vm);
        
        // Mathematics
        const double var_chaste_interface__membrane__i_Stim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_ICaL__ICaL = ((((NV_Ith_S(mParameters, 6) * var_chaste_interface__membrane__Vm * 37237420900.0) * 3.8799692706433766e-07) * ((1.0 * var_chaste_interface__Ca__Ca_ss_CaL * _lt_0_row[174]) - (0.34100000000000003 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[175]) * (var_chaste_interface__ICaL__O + var_chaste_interface__ICaL__O_star); // uA_per_uF
        const double var_INaCa__INaCa_ss_sr = (0.20000000000000001 * NV_Ith_S(mParameters, 18) * ((pow(var_chaste_interface__Na__Na_ss_sr, 3.0) * NV_Ith_S(mParameters, 3) * _lt_0_row[183]) - (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_ss_sr * _lt_0_row[184]))) / ((1.0 + pow(0.000125 / var_chaste_interface__Ca__Ca_ss_sr, 2.0)) * _lt_0_row[185] * (((1.3 * pow(var_chaste_interface__Na__Na_ss_sr, 3.0)) + (669921.875 * var_chaste_interface__Ca__Ca_ss_sr) + (1860.8670000000004 * NV_Ith_S(mParameters, 3) * (1.0 + (var_chaste_interface__Ca__Ca_ss_sr * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 5), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_ss_sr * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_ss_sr, 3.0) * NV_Ith_S(mParameters, 3)) + (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_ss_sr)))); // uA_per_uF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 10) * var_chaste_interface__Ca__Ca_i) / (0.00050000000000000001 + var_chaste_interface__Ca__Ca_i); // uA_per_uF
        const double var_ICab__ICab = (((NV_Ith_S(mParameters, 7) * var_chaste_interface__membrane__Vm * 37237420900.0) * 3.8799692706433766e-07) * ((1.0 * var_chaste_interface__Ca__Ca_i * _lt_0_row[174]) - (0.34100000000000003 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[175]; // uA_per_uF
        const double var_INaCa__INaCa = ((0.80000000000000004 * NV_Ith_S(mParameters, 18) * ((pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 3) * _lt_0_row[183]) - (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_i * _lt_0_row[184]))) / ((1.0 + pow(0.000125 / var_chaste_interface__Ca__Ca_i, 2.0)) * _lt_0_row[185] * (((1.3 * pow(var_chaste_interface__Na__Na_i, 3.0)) + (669921.875 * var_chaste_interface__Ca__Ca_i) + (1860.8670000000004 * NV_Ith_S(mParameters, 3) * (1.0 + (var_chaste_interface__Ca__Ca_i * 277.77777777777777)))) + ((0.0035999999999999999 * pow(NV_Ith_S(mParameters, 5), 3.0) * (1.0 + pow(var_chaste_interface__Na__Na_i * 0.081300813008130079, 3.0))) + (pow(var_chaste_interface__Na__Na_i, 3.0) * NV_Ith_S(mParameters, 3)) + (pow(NV_Ith_S(mParameters, 5), 3.0) * var_chaste_interface__Ca__Ca_i))))) + var_INaCa__INaCa_ss_sr; // uA_per_uF
        const double var_reversal_potentials__ENa = 26.712338705498265 * log(NV_Ith_S(mParameters, 5) / var_chaste_interface__Na__Na_i); // mV
        const double var_INa__INa = NV_Ith_S(mParameters, 12) * pow(var_chaste_interface__INa_m_gate__m, 3.0) * var_chaste_interface__INa_h_gate__h * var_chaste_interface__INa_j_gate__j * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ENa); // uA_per_uF
        const double var_INab__INab = (96485.0 * NV_Ith_S(mParameters, 9) * ((96485.0 * var_chaste_interface__membrane__Vm) * 3.8799692706433766e-07) * ((var_chaste_interface__Na__Na_i * _lt_0_row[187]) - NV_Ith_S(mParameters, 5))) / _lt_0_row[188]; // uA_per_uF
        const double var_INaL__INaL = NV_Ith_S(mParameters, 14) * pow(var_chaste_interface__INaL_mL_gate__mL, 3.0) * var_chaste_interface__INaL_hL_gate__hL * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ENa); // uA_per_uF
        const double var_INaK__INaK = NV_Ith_S(mParameters, 19) * _lt_0_row[182] * (NV_Ith_S(mParameters, 4) / (NV_Ith_S(mParameters, 4) + 1.5)) * pow(var_chaste_interface__Na__Na_i / (var_chaste_interface__Na__Na_i + 2.6000000000000001), 3.0); // uA_per_uF
        const double var_reversal_potentials__EK = 26.712338705498265 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__K__K_i); // mV
        const double var_Ito1__Ito1 = NV_Ith_S(mParameters, 21) * pow(var_chaste_interface__Ito1_a_gate__a, 3.0) * var_chaste_interface__Ito1_i1f_gate__i1f * var_chaste_interface__Ito1_i1s_gate__i1s * _lt_0_row[190] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKr__IKr = (NV_Ith_S(mParameters, 16) * sqrt(NV_Ith_S(mParameters, 4) * 0.18518518518518517)) * var_chaste_interface__IKr_xr_gate__xr * _lt_0_row[189] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IKs__O2 = 1.0 - (var_chaste_interface__IKs__C1 + var_chaste_interface__IKs__C2 + var_chaste_interface__IKs__C3 + var_chaste_interface__IKs__C4 + var_chaste_interface__IKs__C5 + var_chaste_interface__IKs__C6 + var_chaste_interface__IKs__C7 + var_chaste_interface__IKs__C8 + var_chaste_interface__IKs__C9 + var_chaste_interface__IKs__C10 + var_chaste_interface__IKs__C11 + var_chaste_interface__IKs__C12 + var_chaste_interface__IKs__C13 + var_chaste_interface__IKs__C14 + var_chaste_interface__IKs__C15 + var_chaste_interface__IKs__O1); // dimensionless
        const double var_IKs__IKs = (NV_Ith_S(mParameters, 17) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__Ca__Ca_i, 1.3999999999999999))))) * (var_chaste_interface__IKs__O1 + var_IKs__O2) * (var_chaste_interface__membrane__Vm - (26.712338705498265 * log((NV_Ith_S(mParameters, 4) + (0.018329999999999999 * NV_Ith_S(mParameters, 5))) / (var_chaste_interface__K__K_i + (0.018329999999999999 * var_chaste_interface__Na__Na_i))))); // uA_per_uF
        const double var_IKp__IKp = NV_Ith_S(mParameters, 15) * _lt_0_row[186] * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_IK1_K1_gate__alpha_k1 = 1.02 / (1.0 + exp(0.23849999999999999 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) - 59.215000000000003))); // dimensionless
        const double var_IK1__IK1 = (NV_Ith_S(mParameters, 13) * sqrt(NV_Ith_S(mParameters, 4) * 0.18518518518518517)) * (var_IK1_K1_gate__alpha_k1 / (var_IK1_K1_gate__alpha_k1 + (((0.49124000000000001 * exp(0.080320000000000003 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) + 5.476))) + exp(0.061749999999999999 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) - 594.30999999999995))) / (1.0 + exp( -0.51429999999999998 * ((var_chaste_interface__membrane__Vm - var_reversal_potentials__EK) + 4.7530000000000001)))))) * (var_chaste_interface__membrane__Vm - var_reversal_potentials__EK); // uA_per_uF
        const double var_reversal_potentials__ECl =  -26.712338705498265 * log(100.0 / var_chaste_interface__Cl__Cl_i); // mV
        const double var_IClb__IClb = NV_Ith_S(mParameters, 8) * (var_chaste_interface__membrane__Vm - var_reversal_potentials__ECl); // uA_per_uF
        const double var_Ito2__Ito2 = ((((NV_Ith_S(mParameters, 20) * var_chaste_interface__membrane__Vm * 9309355225.0) * 3.8799692706433766e-07) * (var_chaste_interface__Cl__Cl_i - _lt_0_row[14])) / _lt_0_row[191]) * 1.0 * var_chaste_interface__Ito2_i2f_gate__i2f * (1.0 - (1.0 / (1.0 + pow(var_chaste_interface__Irel__Irel * 2.5, 2.0)))); // uA_per_uF
        const double var_chaste_interface__membrane_data_clamp_current = NV_Ith_S(mParameters, 11) * (var_chaste_interface__membrane__Vm - GetExperimentalVoltageAtTimeT(var_chaste_interface__environment__time)); // uA_per_cm2
        const double var_CaMK_active__CaMK_active = ((0.050000000000000003 * (1.0 - var_chaste_interface__CaMK_active__CaMK_trap)) / (1.0 + (0.0015 / var_chaste_interface__Ca__Ca_ss_sr))) + var_chaste_interface__CaMK_active__CaMK_trap; // dimensionless
        const double var_Iup__Iup = ((((var_CaMK_active__CaMK_active * 0.75) / (0.14999999999999999 + (var_CaMK_active__CaMK_active * 1.0))) + 1.0) * NV_Ith_S(mParameters, 2) * var_chaste_interface__Ca__Ca_i) / ((var_chaste_interface__Ca__Ca_i + 0.00092000000000000003) - ((var_CaMK_active__CaMK_active * 0.00017000000000000001) / (0.14999999999999999 + (var_CaMK_active__CaMK_active * 1.0)))); // mM_per_ms
        const double var_Ileak__Ileak = (NV_Ith_S(mParameters, 0) * 0.066666666666666666) * var_chaste_interface__Ca__Ca_NSR; // mM_per_ms
        
        N_Vector dqs = N_VNew_Serial(21);
        NV_Ith_S(dqs, 0) = var_Ileak__Ileak;
        NV_Ith_S(dqs, 1) = var_Iup__Iup;
        NV_Ith_S(dqs, 2) = var_ICaL__ICaL;
        NV_Ith_S(dqs, 3) = var_ICab__ICab;
        NV_Ith_S(dqs, 4) = var_IClb__IClb;
        NV_Ith_S(dqs, 5) = var_INab__INab;
        NV_Ith_S(dqs, 6) = var_IpCa__IpCa;
        NV_Ith_S(dqs, 7) = var_chaste_interface__membrane_data_clamp_current;
        NV_Ith_S(dqs, 8) = var_INa__INa;
        NV_Ith_S(dqs, 9) = var_IK1__IK1;
        NV_Ith_S(dqs, 10) = var_INaL__INaL;
        NV_Ith_S(dqs, 11) = var_IKp__IKp;
        NV_Ith_S(dqs, 12) = var_IKr__IKr;
        NV_Ith_S(dqs, 13) = var_IKs__IKs;
        NV_Ith_S(dqs, 14) = var_INaCa__INaCa;
        NV_Ith_S(dqs, 15) = var_INaCa__INaCa_ss_sr;
        NV_Ith_S(dqs, 16) = var_INaK__INaK;
        NV_Ith_S(dqs, 17) = var_chaste_interface__membrane__i_Stim;
        NV_Ith_S(dqs, 18) = var_Ito2__Ito2;
        NV_Ith_S(dqs, 19) = var_Ito1__Ito1;
        NV_Ith_S(dqs, 20) = var_chaste_interface__environment__time;
        return dqs;
    }
    
template<>
void OdeSystemInformation<Celldecker_2009FromCellMLCvodeDataClampOpt>::Initialise(void)
{
    this->mSystemName = "decker_2009";
    this->mFreeVariableName = "time";
    this->mFreeVariableUnits = "millisecond";
    
    this->mVariableNames.push_back("membrane_voltage");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-87.4947322902196);

    this->mVariableNames.push_back("IKs__C1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.476679784307081);

    this->mVariableNames.push_back("IKs__C2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.255181042718489);

    this->mVariableNames.push_back("IKs__C3");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0512272866698557);

    this->mVariableNames.push_back("IKs__C4");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0045705849736195);

    this->mVariableNames.push_back("IKs__C5");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000152923243503507);

    this->mVariableNames.push_back("IKs__C6");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.132814156809568);

    this->mVariableNames.push_back("IKs__C7");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.053324572164618);

    this->mVariableNames.push_back("IKs__C8");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.00713656414955778);

    this->mVariableNames.push_back("IKs__C9");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000318368292970148);

    this->mVariableNames.push_back("IKs__C10");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0138769647384953);

    this->mVariableNames.push_back("IKs__C11");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.00371438476499172);

    this->mVariableNames.push_back("IKs__C12");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000248553788631871);

    this->mVariableNames.push_back("IKs__C13");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.000644426171899078);

    this->mVariableNames.push_back("IKs__C14");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(8.62495047666861e-5);

    this->mVariableNames.push_back("IKs__C15");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1.12344645485893e-5);

    this->mVariableNames.push_back("IKs__O1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1.05292905767805e-5);

    this->mVariableNames.push_back("ICaL__C");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.99996982093287);

    this->mVariableNames.push_back("ICaL__O");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(2.26882961412491e-5);

    this->mVariableNames.push_back("ICaL__C_star");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(7.49117189549873e-6);

    this->mVariableNames.push_back("ICaL__O_star");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1.23556404128518e-10);

    this->mVariableNames.push_back("ICaL__CI");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(5.89853003114132e-11);

    this->mVariableNames.push_back("ICaL__OI");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(8.01952813127322e-17);

    this->mVariableNames.push_back("ICaL__CI_star");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1.9237001017021e-9);

    this->mVariableNames.push_back("membrane_fast_sodium_current_m_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.00101841101248412);

    this->mVariableNames.push_back("membrane_fast_sodium_current_h_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.991354143386887);

    this->mVariableNames.push_back("membrane_fast_sodium_current_j_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.99709036251243);

    this->mVariableNames.push_back("INaL_mL_gate__mL");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.00101841101248412);

    this->mVariableNames.push_back("INaL_hL_gate__hL");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.319611809402137);

    this->mVariableNames.push_back("IKr_xr_gate__xr");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(4.06959064407486e-6);

    this->mVariableNames.push_back("Ito1_a_gate__a");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1.76776038804228e-5);

    this->mVariableNames.push_back("Ito1_i1f_gate__i1f");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.997976503910799);

    this->mVariableNames.push_back("Ito1_i1s_gate__i1s");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.947581184798815);

    this->mVariableNames.push_back("Ito2_i2f_gate__i2f");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.996044894628276);

    this->mVariableNames.push_back("SR_release_current");
    this->mVariableUnits.push_back("mM_per_ms");
    this->mInitialConditions.push_back(0.000714227102027745);

    this->mVariableNames.push_back("Ca__Ca_JSR");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(0.993914988616979);

    this->mVariableNames.push_back("Ca__Ca_NSR");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(1.01475649943057);

    this->mVariableNames.push_back("cytosolic_calcium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(8.38749860095482e-5);

    this->mVariableNames.push_back("Ca__Ca_ss_sr");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(0.00011296707102434);

    this->mVariableNames.push_back("Ca__Ca_ss_CaL");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(0.000119239795531548);

    this->mVariableNames.push_back("cytosolic_sodium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(8.01031392415197);

    this->mVariableNames.push_back("dyadic_space_sodium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(8.01033434859049);

    this->mVariableNames.push_back("cytosolic_chloride_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(20.6683603724432);

    this->mVariableNames.push_back("dyadic_space_chloride_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(20.6683605553303);

    this->mVariableNames.push_back("cytosolic_potassium_concentration");
    this->mVariableUnits.push_back("mM");
    this->mInitialConditions.push_back(144.907134343314);

    this->mVariableNames.push_back("CaMK_active__CaMK_trap");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0.0114911034744777);

    this->mParameterNames.push_back("SR_leak_current_max");
    this->mParameterUnits.push_back("mM_per_ms");
    
    this->mParameterNames.push_back("SR_release_current_max");
    this->mParameterUnits.push_back("mM_per_uA_per_uF_per_ms_per_ms");
    
    this->mParameterNames.push_back("SR_uptake_current_max");
    this->mParameterUnits.push_back("mM_per_ms");
    
    this->mParameterNames.push_back("extracellular_calcium_concentration");
    this->mParameterUnits.push_back("mM");
    
    this->mParameterNames.push_back("extracellular_potassium_concentration");
    this->mParameterUnits.push_back("mM");
    
    this->mParameterNames.push_back("extracellular_sodium_concentration");
    this->mParameterUnits.push_back("mM");
    
    this->mParameterNames.push_back("membrane_L_type_calcium_current_conductance");
    this->mParameterUnits.push_back("L_per_F_ms");
    
    this->mParameterNames.push_back("membrane_background_calcium_current_conductance");
    this->mParameterUnits.push_back("L_per_F_ms");
    
    this->mParameterNames.push_back("membrane_background_chloride_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_background_sodium_current_conductance");
    this->mParameterUnits.push_back("L_per_F_ms");
    
    this->mParameterNames.push_back("membrane_calcium_pump_current_conductance");
    this->mParameterUnits.push_back("uA_per_uF");
    
    this->mParameterNames.push_back("membrane_data_clamp_current_conductance");
    this->mParameterUnits.push_back("___units_85");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_inward_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_persistent_sodium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_potassium_pump_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_rapid_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_slow_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mParameterNames.push_back("membrane_sodium_calcium_exchanger_current_conductance");
    this->mParameterUnits.push_back("uA_per_uF");
    
    this->mParameterNames.push_back("membrane_sodium_potassium_pump_current_permeability");
    this->mParameterUnits.push_back("uA_per_uF");
    
    this->mParameterNames.push_back("membrane_transient_outward_chloride_current_conductance");
    this->mParameterUnits.push_back("L_per_F_ms");
    
    this->mParameterNames.push_back("membrane_transient_outward_current_conductance");
    this->mParameterUnits.push_back("mS_per_uF");
    
    this->mDerivedQuantityNames.push_back("SR_leak_current");
    this->mDerivedQuantityUnits.push_back("mM_per_ms");
    
    this->mDerivedQuantityNames.push_back("SR_uptake_current");
    this->mDerivedQuantityUnits.push_back("mM_per_ms");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_calcium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_chloride_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_sodium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_calcium_pump_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_data_clamp_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_inward_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_persistent_sodium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_potassium_pump_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_rapid_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_slow_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_calcium_exchanger_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_calcium_exchanger_dyadic_space_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_potassium_pump_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_stimulus_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("membrane_transient_outward_chloride_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("membrane_transient_outward_current");
    this->mDerivedQuantityUnits.push_back("uA_per_uF");
    
    this->mDerivedQuantityNames.push_back("time");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mInitialised = true;
}


// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Celldecker_2009FromCellMLCvodeDataClampOpt)
#endif // CHASTE_CVODE
