#ifdef CHASTE_CVODE
//! @file
//! 
//! This source file was generated from CellML.
//! 
//! Model: ohara_rudy_2011
//! 
//! Processed by pycml - CellML Tools in Python
//!     (translators: 24172, pycml: 23797, optimize: 23343)
//! on Fri May 29 17:47:42 2015
//! 
//! <autogenerated>

#include "ohara_rudy_2011_endo_data_clampCvodeOpt.hpp"
#include <cmath>
#include <cassert>
#include <memory>
#include "Exception.hpp"
#include "OdeSystemInformation.hpp"
#include "RegularStimulus.hpp"
#include "HeartConfig.hpp"
#include "IsNan.hpp"
#include "MathsCustomFunctions.hpp"

class Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables : public AbstractLookupTableCollection
{
public:
    static Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables* Instance()
    {
        if (mpInstance.get() == NULL)
        {
            mpInstance.reset(new Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables);
        }
        return mpInstance.get();
    }
    
    void FreeMemory()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
        mNeedsRegeneration.assign(mNeedsRegeneration.size(), true);
    }
    
    // Row lookup methods
    // using linear-interpolation
    double* _lookup_0_row(unsigned i, double _factor_)
    {
        for (unsigned j=0; j<234; j++)
        {
            const double y1 = _lookup_table_0[i][j];
            const double y2 = _lookup_table_0[i+1][j];
            _lookup_table_0_row[j] = y1 + (y2-y1)*_factor_;
        }
        return _lookup_table_0_row;
    }
    
    
    const double * IndexTable0(double var_chaste_interface__membrane__v)
    {
        const double _offset_0 = var_chaste_interface__membrane__v - mTableMins[0];
        const double _offset_0_over_table_step = _offset_0 * mTableStepInverses[0];
        const unsigned _table_index_0 = (unsigned)(_offset_0_over_table_step);
        const double _factor_0 = _offset_0_over_table_step - _table_index_0;
        const double* const _lt_0_row = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->_lookup_0_row(_table_index_0, _factor_0);
        return _lt_0_row;
    }
    
#define COVERAGE_IGNORE
    bool CheckIndex0(double& var_chaste_interface__membrane__v)
    {
        bool _oob_0 = false;
        if (var_chaste_interface__membrane__v>mTableMaxs[0] || var_chaste_interface__membrane__v<mTableMins[0])
        {
#define COVERAGE_IGNORE
            _oob_0 = true;
#undef COVERAGE_IGNORE
        }
        return _oob_0;
    }
#undef COVERAGE_IGNORE

    ~Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        if (_lookup_table_0)
        {
            delete[] _lookup_table_0;
            _lookup_table_0 = NULL;
        }
    }
    
protected:
    Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables(const Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables& operator= (const Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables&);
    Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables()
    {
        assert(mpInstance.get() == NULL);
        mKeyingVariableNames.resize(1);
        mNumberOfTables.resize(1);
        mTableMins.resize(1);
        mTableSteps.resize(1);
        mTableStepInverses.resize(1);
        mTableMaxs.resize(1);
        mNeedsRegeneration.resize(1);
        mKeyingVariableNames[0] = "membrane_voltage";
        mNumberOfTables[0] = 234;
        mTableMins[0] = -120.0001;
        mTableSteps[0] = 0.001;
        mTableStepInverses[0] = 1000.0;
        mTableMaxs[0] = 99.9999;
        mNeedsRegeneration[0] = true;
        _lookup_table_0 = NULL;
        Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::RegenerateTables();
    }
    
    void RegenerateTables()
    {
        AbstractLookupTableCollection::EventHandler::BeginEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
        if (mNeedsRegeneration[0])
        {
            if (_lookup_table_0)
            {
                delete[] _lookup_table_0;
                _lookup_table_0 = NULL;
            }
            const unsigned _table_size_0 = 1 + (unsigned)((mTableMaxs[0]-mTableMins[0])/mTableSteps[0]+0.5);
            _lookup_table_0 = new double[_table_size_0][234];
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][0] = exp((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][1] = 1.0 / (exp((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07) - 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][2] = exp(2.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][3] = 1.0 / (exp(2.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) - 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][4] = pow(1.0 + exp(( -0.054525627040000003 * var_chaste_interface__membrane__v) + 0.78953107950000001), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][5] = exp(( -0.054525627040000003 * var_chaste_interface__membrane__v) + 0.78953107950000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][6] = 1.0 / (1.0 + exp((0.0066137566140000003 * var_chaste_interface__membrane__v) - 1.412698413));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][7] = 1.0 - (1.0 / (1.0 + exp((0.0066137566140000003 * var_chaste_interface__membrane__v) - 1.412698413)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][8] = 1.0 / exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][9] = (1.0 / pow(exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0)) / exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][10] = 1.0 / pow(pow(exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][11] = 4.6644804351351539e-05 * ((1.0 / pow(exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0)) / exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][12] = 1.0 / exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][13] = 1.6790786303582269e-06 * (1.0 / pow(pow(exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][14] = 0.11021712774165104 * (1.0 / exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][15] = ((1.0 / exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616)) *  -0.155) * 0.037435883507802616;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][16] = 0.0013388973049288464 * ((1.0 / pow(exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0)) / exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][17] = (1.0 / pow(exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0)) / exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][18] = ((1.0 / exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616)) * 1.155) * 0.037435883507802616;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][19] = 1.0 / pow(pow(exp((0.38500000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][20] = 0.000147569415290295 * (1.0 / pow(pow(exp(( -0.051666666666666666 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][21] = 1.0 + exp(( -0.054525627040000003 * var_chaste_interface__membrane__v) + 0.78953107950000001);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][22] = 1.0 / (1.0 + exp((0.02617115938 * var_chaste_interface__membrane__v) + 1.434441246));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][23] = 1.0 - (1.0 / (1.0 + exp((0.02617115938 * var_chaste_interface__membrane__v) + 1.434441246)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][24] = pow(1.0 + exp((0.013333333333333334 * var_chaste_interface__membrane__v) + 0.73333333333333328), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][25] = 1.0 / (1.0 + exp((0.033333333333333333 * var_chaste_interface__membrane__v) - 0.33333333333333331));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][26] = exp((0.013333333333333334 * var_chaste_interface__membrane__v) + 0.73333333333333328);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][27] = (1.0 / (1.0 + exp((0.013333333333333334 * var_chaste_interface__membrane__v) + 0.73333333333333328))) * (1.0 / (1.0 + exp((0.033333333333333333 * var_chaste_interface__membrane__v) - 0.33333333333333331)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][28] =  -0.02617115938 * (1.0 / pow(1.0 + exp((0.02617115938 * var_chaste_interface__membrane__v) + 1.434441246), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][29] = exp((0.02617115938 * var_chaste_interface__membrane__v) + 1.434441246);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][30] = (0.02617115938 * (1.0 / pow(1.0 + exp((0.02617115938 * var_chaste_interface__membrane__v) + 1.434441246), 2.0))) * exp((0.02617115938 * var_chaste_interface__membrane__v) + 1.434441246);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][31] = 1.0 / (1.0 + exp((0.013333333333333334 * var_chaste_interface__membrane__v) + 0.73333333333333328));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][32] = pow(1.0 + exp((0.033333333333333333 * var_chaste_interface__membrane__v) - 0.33333333333333331), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][33] = exp((0.033333333333333333 * var_chaste_interface__membrane__v) - 0.33333333333333331);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][34] =  -0.0066137566140000003 * (1.0 / pow(1.0 + exp((0.0066137566140000003 * var_chaste_interface__membrane__v) - 1.412698413), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][35] = exp((0.0066137566140000003 * var_chaste_interface__membrane__v) - 1.412698413);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][36] = 0.0066137566140000003 * ((1.0 / pow(1.0 + exp((0.0066137566140000003 * var_chaste_interface__membrane__v) - 1.412698413), 2.0)) * exp((0.0066137566140000003 * var_chaste_interface__membrane__v) - 1.412698413));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][37] = 1.0 + (1.0 / exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][38] = 1.0 / exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][39] = 1.0 + exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][40] = 1.0 / exp((0.16700000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][41] = exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][42] = 1.0 / pow(exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][43] = 0.011348161597821153 * (1.0 / exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][44] = pow(exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][45] = 50403.763999999996 * (3.8799692706433766e-07 * exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][46] = 0.0032258064516129032 * exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][47] = exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616) * 0.011348161597821153;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][48] = (0.20000000000000001 * exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616)) * 0.011348161597821153;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][49] = 0.20000000000000001 * exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][50] = 3.8799692706433766e-07 * exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][51] = (0.20000000000000001 * pow(exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0)) * 0.00012878077165026273;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][52] = (0.013333333333333334 * pow(exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0)) * 0.00012878077165026273;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][53] = 11.605123887418811 * (0.0032258064516129032 * exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][54] = 0.20000000000000001 * pow(exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][55] = 0.00012878077165026273 * (1.0 / pow(exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616), 2.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][56] = exp(2.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) * (1.0 / (exp(2.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][57] = exp((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07) * (1.0 / (exp((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][58] = 0.059999999999999998 * ((1.0 / pow(1.0 + exp((0.10000000000000001 * var_chaste_interface__membrane__v) - 1.0), 2.0)) * exp((0.10000000000000001 * var_chaste_interface__membrane__v) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][59] =  -0.059999999999999998 * ((1.0 / pow(1.0 + exp((0.10000000000000001 * var_chaste_interface__membrane__v) - 1.0), 2.0)) * exp((0.10000000000000001 * var_chaste_interface__membrane__v) - 1.0));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][60] = 1.0 / pow(exp((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07) - 1.0, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][61] = 0.69999999999999996 - (0.59999999999999998 * (1.0 / (1.0 + exp((0.10000000000000001 * var_chaste_interface__membrane__v) - 1.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][62] = 0.29999999999999999 + (0.59999999999999998 * (1.0 / (1.0 + exp((0.10000000000000001 * var_chaste_interface__membrane__v) - 1.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][63] = 1.0 / pow(exp(2.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) - 1.0, 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][64] = ((1.0 / exp((0.16700000000000001 * var_chaste_interface__membrane__v) * 0.037435883507802616)) * 0.011348161597821153) * (1.0 + exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][65] = exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616) * 0.00012878077165026273;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][66] = (0.20000000000000001 * exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616)) * 0.00012878077165026273;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][67] = 5000.0 * (1.0 + exp((0.52239999999999998 * var_chaste_interface__membrane__v) * 0.037435883507802616));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][68] = 0.0032258064516129032 * exp((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][69] = 0.0032258064516129032 * exp(2.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][70] = 1.0 / (1.0 + exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][71] = 1.0 / (1.3540000000000001 + (0.0001 / (exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763) + exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][72] = 1.0 / (1.0 - (0.5 / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][73] = -(1.0 / (0.59999999999999998 + (1.0 / (exp(( -0.050000000000000003 * var_chaste_interface__membrane__v) - 0.29999999999999999) + exp((0.089999999999999997 * var_chaste_interface__membrane__v) + 1.26)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][74] = ((0.23640661939999999 / pow(1.0 + exp(( -0.23640661939999999 * var_chaste_interface__membrane__v) - 0.93144208039999998), 2.0)) * exp(( -0.23640661939999999 * var_chaste_interface__membrane__v) - 0.93144208039999998)) * (1.0 / (0.59999999999999998 + (1.0 / (exp(( -0.050000000000000003 * var_chaste_interface__membrane__v) - 0.29999999999999999) + exp((0.089999999999999997 * var_chaste_interface__membrane__v) + 1.26)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][75] = 1.0 / (1.0 + exp(( -0.23640661939999999 * var_chaste_interface__membrane__v) - 0.93144208039999998));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][76] = pow(0.59999999999999998 + (1.0 / (exp(( -0.050000000000000003 * var_chaste_interface__membrane__v) - 0.29999999999999999) + exp((0.089999999999999997 * var_chaste_interface__membrane__v) + 1.26))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][77] = pow(exp(( -0.050000000000000003 * var_chaste_interface__membrane__v) - 0.29999999999999999) + exp((0.089999999999999997 * var_chaste_interface__membrane__v) + 1.26), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][78] = ( -0.050000000000000003 * exp(( -0.050000000000000003 * var_chaste_interface__membrane__v) - 0.29999999999999999)) + (0.089999999999999997 * exp((0.089999999999999997 * var_chaste_interface__membrane__v) + 1.26));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][79] = -(1.0 / (7.0 + (1.0 / ((0.040000000000000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.040000000000000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][80] = ( -0.2705627706 * ((1.0 / pow(1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996), 2.0)) * exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996))) * (1.0 / (7.0 + (1.0 / ((0.040000000000000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.040000000000000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][81] = 1.0 / (1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][82] = pow(7.0 + (1.0 / ((0.040000000000000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.040000000000000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714))))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][83] = (1.0 / pow((0.040000000000000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.040000000000000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714))), 2.0)) * (( -0.0057142857140000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.0057142857140000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][84] = -(1.0 / (17.5 + (2.5 * (1.0 / ((0.040000000000000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.040000000000000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714))))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][85] = ( -0.2705627706 * ((1.0 / pow(1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996), 2.0)) * exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996))) * (1.0 / (17.5 + (2.5 * (1.0 / ((0.040000000000000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.040000000000000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714))))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][86] = pow(17.5 + (2.5 * (1.0 / ((0.040000000000000001 * exp((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)) + (0.040000000000000001 * exp(-((-(0.14285714285714285 * var_chaste_interface__membrane__v)) + 0.5714285714285714)))))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][87] = -(1.0 / (100.0 + (1.0 / ((0.00012 * exp( -0.33333333333333331 * var_chaste_interface__membrane__v)) + (0.00012 * exp(0.14285714285714285 * var_chaste_interface__membrane__v))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][88] = ( -0.2705627706 * ((1.0 / pow(1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996), 2.0)) * exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996))) * (1.0 / (100.0 + (1.0 / ((0.00012 * exp( -0.33333333333333331 * var_chaste_interface__membrane__v)) + (0.00012 * exp(0.14285714285714285 * var_chaste_interface__membrane__v))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][89] = pow(100.0 + (1.0 / ((0.00012 * exp( -0.33333333333333331 * var_chaste_interface__membrane__v)) + (0.00012 * exp(0.14285714285714285 * var_chaste_interface__membrane__v)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][90] = pow((0.00012 * exp( -0.33333333333333331 * var_chaste_interface__membrane__v)) + (0.00012 * exp(0.14285714285714285 * var_chaste_interface__membrane__v)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][91] = ( -4.0000000000000003e-05 * exp( -0.33333333333333331 * var_chaste_interface__membrane__v)) + (1.7142857140000001e-05 * exp(0.14285714285714285 * var_chaste_interface__membrane__v));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][92] = -(1.0 / (7.0 + (1.0 / ((0.0044999999999999997 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.0044999999999999997 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][93] = ( -0.2705627706 * ((1.0 / pow(1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996), 2.0)) * exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996))) * (1.0 / (7.0 + (1.0 / ((0.0044999999999999997 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.0044999999999999997 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][94] = pow(7.0 + (1.0 / ((0.0044999999999999997 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.0044999999999999997 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0))))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][95] = (1.0 / pow((0.0044999999999999997 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.0044999999999999997 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0))), 2.0)) * (( -0.00044999999999999999 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.00044999999999999999 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][96] = -(1.0 / (17.5 + (2.5 * (1.0 / ((0.0044999999999999997 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.0044999999999999997 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0))))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][97] = ( -0.2705627706 * ((1.0 / pow(1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996), 2.0)) * exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996))) * (1.0 / (17.5 + (2.5 * (1.0 / ((0.0044999999999999997 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.0044999999999999997 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0))))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][98] = pow(17.5 + (2.5 * (1.0 / ((0.0044999999999999997 * exp((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)) + (0.0044999999999999997 * exp(-((-(0.10000000000000001 * var_chaste_interface__membrane__v)) - 2.0)))))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][99] = -(1.0 / (1000.0 + (1.0 / ((3.4999999999999997e-05 * exp(( -0.25 * var_chaste_interface__membrane__v) - 1.25)) + (3.4999999999999997e-05 * exp((0.16666666666666666 * var_chaste_interface__membrane__v) + 0.83333333333333337))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][100] = ( -0.2705627706 * ((1.0 / pow(1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996), 2.0)) * exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996))) * (1.0 / (1000.0 + (1.0 / ((3.4999999999999997e-05 * exp(( -0.25 * var_chaste_interface__membrane__v) - 1.25)) + (3.4999999999999997e-05 * exp((0.16666666666666666 * var_chaste_interface__membrane__v) + 0.83333333333333337))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][101] = pow(1000.0 + (1.0 / ((3.4999999999999997e-05 * exp(( -0.25 * var_chaste_interface__membrane__v) - 1.25)) + (3.4999999999999997e-05 * exp((0.16666666666666666 * var_chaste_interface__membrane__v) + 0.83333333333333337)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][102] = pow((3.4999999999999997e-05 * exp(( -0.25 * var_chaste_interface__membrane__v) - 1.25)) + (3.4999999999999997e-05 * exp((0.16666666666666666 * var_chaste_interface__membrane__v) + 0.83333333333333337)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][103] = ( -8.7499999999999992e-06 * exp(( -0.25 * var_chaste_interface__membrane__v) - 1.25)) + (5.8333333330000002e-06 * exp((0.16666666666666666 * var_chaste_interface__membrane__v) + 0.83333333333333337));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][104] =  -0.0036075036079999999 * ((1.0 / pow(1.0 + exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996), 2.0)) * exp((0.2705627706 * var_chaste_interface__membrane__v) + 5.2976190479999996));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][105] = ( -0.0081833060559999993 * exp(( -0.049115913560000002 * var_chaste_interface__membrane__v) - 6.2475442049999996)) - (0.0081833060559999993 * exp((0.01442377037 * var_chaste_interface__membrane__v) + 3.415548824));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][106] = exp(( -0.049115913560000002 * var_chaste_interface__membrane__v) - 6.2475442049999996) + exp((0.01442377037 * var_chaste_interface__membrane__v) + 3.415548824);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][107] = ( -0.049115913560000002 * exp(( -0.049115913560000002 * var_chaste_interface__membrane__v) - 6.2475442049999996)) + (0.01442377037 * exp((0.01442377037 * var_chaste_interface__membrane__v) + 3.415548824));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][108] = -(1.0 / (12.98 + (1.0 / ((0.36520000000000002 * exp((0.2584647196 * var_chaste_interface__membrane__v) - 8.1829930229999999)) + (4.1230000000000003e-05 * exp(( -0.049067713440000001 * var_chaste_interface__membrane__v) + 2.3444553479999999))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][109] = (0.1472970982 * ((1.0 / pow(1.0 + exp(( -0.1472970982 * var_chaste_interface__membrane__v) - 1.2280159079999999), 2.0)) * exp(( -0.1472970982 * var_chaste_interface__membrane__v) - 1.2280159079999999))) * (1.0 / (12.98 + (1.0 / ((0.36520000000000002 * exp((0.2584647196 * var_chaste_interface__membrane__v) - 8.1829930229999999)) + (4.1230000000000003e-05 * exp(( -0.049067713440000001 * var_chaste_interface__membrane__v) + 2.3444553479999999))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][110] = 1.0 / (1.0 + exp(( -0.1472970982 * var_chaste_interface__membrane__v) - 1.2280159079999999));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][111] = pow(12.98 + (1.0 / ((0.36520000000000002 * exp((0.2584647196 * var_chaste_interface__membrane__v) - 8.1829930229999999)) + (4.1230000000000003e-05 * exp(( -0.049067713440000001 * var_chaste_interface__membrane__v) + 2.3444553479999999)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][112] = pow((0.36520000000000002 * exp((0.2584647196 * var_chaste_interface__membrane__v) - 8.1829930229999999)) + (4.1230000000000003e-05 * exp(( -0.049067713440000001 * var_chaste_interface__membrane__v) + 2.3444553479999999)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][113] = (0.094391315599999998 * exp((0.2584647196 * var_chaste_interface__membrane__v) - 8.1829930229999999)) - (2.0230618250000001e-06 * exp(( -0.049067713440000001 * var_chaste_interface__membrane__v) + 2.3444553479999999));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][114] = -(1.0 / (1.865 + (1.0 / ((0.066290000000000002 * exp((0.13596193070000001 * var_chaste_interface__membrane__v) - 4.7178789950000004)) + (1.128e-05 * exp(( -0.03855050116 * var_chaste_interface__membrane__v) + 1.1464919039999999))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][115] = (0.1472970982 * ((1.0 / pow(1.0 + exp(( -0.1472970982 * var_chaste_interface__membrane__v) - 1.2280159079999999), 2.0)) * exp(( -0.1472970982 * var_chaste_interface__membrane__v) - 1.2280159079999999))) * (1.0 / (1.865 + (1.0 / ((0.066290000000000002 * exp((0.13596193070000001 * var_chaste_interface__membrane__v) - 4.7178789950000004)) + (1.128e-05 * exp(( -0.03855050116 * var_chaste_interface__membrane__v) + 1.1464919039999999))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][116] = pow(1.865 + (1.0 / ((0.066290000000000002 * exp((0.13596193070000001 * var_chaste_interface__membrane__v) - 4.7178789950000004)) + (1.128e-05 * exp(( -0.03855050116 * var_chaste_interface__membrane__v) + 1.1464919039999999)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][117] = pow((0.066290000000000002 * exp((0.13596193070000001 * var_chaste_interface__membrane__v) - 4.7178789950000004)) + (1.128e-05 * exp(( -0.03855050116 * var_chaste_interface__membrane__v) + 1.1464919039999999)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][118] = (0.0090129163860000003 * exp((0.13596193070000001 * var_chaste_interface__membrane__v) - 4.7178789950000004)) - (4.3484965309999999e-07 * exp(( -0.03855050116 * var_chaste_interface__membrane__v) + 1.1464919039999999));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][119] = -(1.0 / (817.29999999999995 + (1.0 / ((0.00023259999999999999 * exp((0.056179775279999997 * var_chaste_interface__membrane__v) + 2.712359551)) + (0.001292 * exp(( -0.0043478260869565218 * var_chaste_interface__membrane__v) - 0.91304347826086951))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][120] = (0.1119570085 * ((1.0 / pow(1.0 + exp(( -0.1119570085 * var_chaste_interface__membrane__v) - 1.298701299), 2.0)) * exp(( -0.1119570085 * var_chaste_interface__membrane__v) - 1.298701299))) * (1.0 / (817.29999999999995 + (1.0 / ((0.00023259999999999999 * exp((0.056179775279999997 * var_chaste_interface__membrane__v) + 2.712359551)) + (0.001292 * exp(( -0.0043478260869565218 * var_chaste_interface__membrane__v) - 0.91304347826086951))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][121] = 1.0 / (1.0 + exp(( -0.1119570085 * var_chaste_interface__membrane__v) - 1.298701299));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][122] = pow(817.29999999999995 + (1.0 / ((0.00023259999999999999 * exp((0.056179775279999997 * var_chaste_interface__membrane__v) + 2.712359551)) + (0.001292 * exp(( -0.0043478260869565218 * var_chaste_interface__membrane__v) - 0.91304347826086951)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][123] = pow((0.00023259999999999999 * exp((0.056179775279999997 * var_chaste_interface__membrane__v) + 2.712359551)) + (0.001292 * exp(( -0.0043478260869565218 * var_chaste_interface__membrane__v) - 0.91304347826086951)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][124] = (1.306741573e-05 * exp((0.056179775279999997 * var_chaste_interface__membrane__v) + 2.712359551)) - (5.6173913039999996e-06 * exp(( -0.0043478260869565218 * var_chaste_interface__membrane__v) - 0.91304347826086951));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][125] = -((0.01 * exp((0.050000000000000003 * var_chaste_interface__membrane__v) - 2.5)) + (0.019300000000000001 * exp(( -0.032258064516129031 * var_chaste_interface__membrane__v) - 2.146451613)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][126] = (0.1119570085 * ((1.0 / pow(1.0 + exp(( -0.1119570085 * var_chaste_interface__membrane__v) - 1.298701299), 2.0)) * exp(( -0.1119570085 * var_chaste_interface__membrane__v) - 1.298701299))) * ((0.01 * exp((0.050000000000000003 * var_chaste_interface__membrane__v) - 2.5)) + (0.019300000000000001 * exp(( -0.032258064516129031 * var_chaste_interface__membrane__v) - 2.146451613)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][127] = (0.00050000000000000001 * exp((0.050000000000000003 * var_chaste_interface__membrane__v) - 2.5)) - (0.00062258064520000005 * exp(( -0.032258064516129031 * var_chaste_interface__membrane__v) - 2.146451613));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][128] = (( -0.13354700850000001 / pow(1.0 + exp((0.13354700850000001 * var_chaste_interface__membrane__v) + 11.700053410000001), 2.0)) * exp((0.13354700850000001 * var_chaste_interface__membrane__v) + 11.700053410000001)) * 0.0050000000000000001;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][129] = (( -0.044515669500000001 / pow(1.0 + exp((0.13354700850000001 * var_chaste_interface__membrane__v) + 12.52804487), 2.0)) * exp((0.13354700850000001 * var_chaste_interface__membrane__v) + 12.52804487)) * 0.0050000000000000001;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][130] = -((6.7649999999999997 * exp((var_chaste_interface__membrane__v + 11.640000000000001) * 0.02876042565429968)) + (8.5519999999999996 * exp(((-var_chaste_interface__membrane__v) - 77.420000000000002) * 0.16792611251049538)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][131] = ((0.18996960490000001 / pow(1.0 + exp(( -0.18996960490000001 * var_chaste_interface__membrane__v) - 8.1401975699999998), 2.0)) * exp(( -0.18996960490000001 * var_chaste_interface__membrane__v) - 8.1401975699999998)) * ((6.7649999999999997 * exp((var_chaste_interface__membrane__v + 11.640000000000001) * 0.02876042565429968)) + (8.5519999999999996 * exp(((-var_chaste_interface__membrane__v) - 77.420000000000002) * 0.16792611251049538)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][132] = 1.0 / (1.0 + exp(( -0.18996960490000001 * var_chaste_interface__membrane__v) - 8.1401975699999998));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][133] = (0.19456427955133732 * exp((var_chaste_interface__membrane__v + 11.640000000000001) * 0.02876042565429968)) - (1.4361041141897564 * exp(((-var_chaste_interface__membrane__v) - 77.420000000000002) * 0.16792611251049538));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][134] = -((1.432e-05 * exp(( -0.15910898970000001 * var_chaste_interface__membrane__v) - 0.1902943517)) + (6.149 * exp((0.049333991119999997 * var_chaste_interface__membrane__v) + 0.025140601870000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][135] = ((-((1.0 / pow(1.0 + exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381), 2.0)) * 0.16431153466973381)) * exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381)) * ((1.432e-05 * exp(( -0.15910898970000001 * var_chaste_interface__membrane__v) - 0.1902943517)) + (6.149 * exp((0.049333991119999997 * var_chaste_interface__membrane__v) + 0.025140601870000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][136] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][137] = ( -2.2784407329999999e-06 * exp(( -0.15910898970000001 * var_chaste_interface__membrane__v) - 0.1902943517)) + (0.30335471139999998 * exp((0.049333991119999997 * var_chaste_interface__membrane__v) + 0.025140601870000001));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][138] = -((0.0097940000000000006 * exp(( -0.035650623889999997 * var_chaste_interface__membrane__v) - 0.63992869880000003)) + (0.33429999999999999 * exp((0.017649135190000002 * var_chaste_interface__membrane__v) + 0.1011295446)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][139] = ((-((1.0 / pow(1.0 + exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381), 2.0)) * 0.16431153466973381)) * exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381)) * ((0.0097940000000000006 * exp(( -0.035650623889999997 * var_chaste_interface__membrane__v) - 0.63992869880000003)) + (0.33429999999999999 * exp((0.017649135190000002 * var_chaste_interface__membrane__v) + 0.1011295446)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][140] = ( -0.00034916221040000002 * exp(( -0.035650623889999997 * var_chaste_interface__membrane__v) - 0.63992869880000003)) + (0.005900105894 * exp((0.017649135190000002 * var_chaste_interface__membrane__v) + 0.1011295446));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][141] = ( -0.0032646666670000002 * exp(( -0.035650623889999997 * var_chaste_interface__membrane__v) - 0.63992869880000003)) - (0.11143333330000001 * exp((0.017649135190000002 * var_chaste_interface__membrane__v) + 0.1011295446));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][142] = (( -0.054770511569999999 / pow(1.0 + exp((0.16431153470000001 * var_chaste_interface__membrane__v) + 14.640157739999999), 2.0)) * exp((0.16431153470000001 * var_chaste_interface__membrane__v) + 14.640157739999999)) * ((0.0097940000000000006 * exp(( -0.035650623889999997 * var_chaste_interface__membrane__v) - 0.63992869880000003)) + (0.33429999999999999 * exp((0.017649135190000002 * var_chaste_interface__membrane__v) + 0.1011295446)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][143] = 1.0 / (1.0 + exp((0.16431153470000001 * var_chaste_interface__membrane__v) + 14.640157739999999));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][144] = -(1.0 / (2.0379999999999998 + (1.0 / ((0.021360000000000001 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.30520000000000003 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][145] = ((-((1.0 / pow(1.0 + exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381), 2.0)) * 0.16431153466973381)) * exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381)) * (1.0 / (2.0379999999999998 + (1.0 / ((0.021360000000000001 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.30520000000000003 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][146] = pow(2.0379999999999998 + (1.0 / ((0.021360000000000001 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.30520000000000003 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][147] = (1.0 / pow((0.021360000000000001 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.30520000000000003 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631)), 2.0)) * (( -0.0025793986229999998 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.0079375812740000006 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][148] = -(1.0 / (2.9754800000000001 + (1.46 * (1.0 / ((0.021360000000000001 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.30520000000000003 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][149] = ((-((1.0 / pow(1.0 + exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381), 2.0)) * 0.16431153466973381)) * exp((var_chaste_interface__membrane__v + 82.900000000000006) * 0.16431153466973381)) * (1.0 / (2.9754800000000001 + (1.46 * (1.0 / ((0.021360000000000001 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.30520000000000003 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631)))))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][150] = pow(2.9754800000000001 + (1.46 * (1.0 / ((0.021360000000000001 * exp(( -0.12075836249999999 * var_chaste_interface__membrane__v) - 12.14829127)) + (0.30520000000000003 * exp((0.02600780234 * var_chaste_interface__membrane__v) + 0.02585435631))))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][151] = (((1.0 / pow(1.0 + exp(((-var_chaste_interface__membrane__v) - 39.57) * 0.10130685847431871), 2.0)) * 0.10130685847431871) * exp(((-var_chaste_interface__membrane__v) - 39.57) * 0.10130685847431871)) * ((6.7649999999999997 * exp((var_chaste_interface__membrane__v + 11.640000000000001) * 0.02876042565429968)) + (8.5519999999999996 * exp(((-var_chaste_interface__membrane__v) - 77.420000000000002) * 0.16792611251049538)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][152] = 1.0 / (1.0 + exp(((-var_chaste_interface__membrane__v) - 39.57) * 0.10130685847431871));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][153] = ( -0.95102234900000004 * (1.0 / (1.2089000000000001 + (1.2089000000000001 * exp((-(0.034035137880000003 * var_chaste_interface__membrane__v)) + 0.62658348490000004))))) - (3.328578222 * (1.0 / (1.0 + exp((0.034035137880000003 * var_chaste_interface__membrane__v) + 3.4035137880000002))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][154] = ((0.064171548519999996 / pow(1.0 + exp((-(0.067476383269999995 * var_chaste_interface__membrane__v)) + 0.96761133610000005), 2.0)) * exp((-(0.067476383269999995 * var_chaste_interface__membrane__v)) + 0.96761133610000005)) * ((1.0 / (1.2089000000000001 + (1.2089000000000001 * exp((-(0.034035137880000003 * var_chaste_interface__membrane__v)) + 0.62658348490000004)))) + (3.5 * (1.0 / (1.0 + exp((0.034035137880000003 * var_chaste_interface__membrane__v) + 3.4035137880000002)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][155] = 1.0 / (1.0 + exp((-(0.067476383269999995 * var_chaste_interface__membrane__v)) + 0.96761133610000005));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][156] = ((0.041145078180000003 / pow(1.2089000000000001 + (1.2089000000000001 * exp((-(0.034035137880000003 * var_chaste_interface__membrane__v)) + 0.62658348490000004)), 2.0)) * exp((-(0.034035137880000003 * var_chaste_interface__membrane__v)) + 0.62658348490000004)) - ((0.1191229826 / pow(1.0 + exp((0.034035137880000003 * var_chaste_interface__membrane__v) + 3.4035137880000002), 2.0)) * exp((0.034035137880000003 * var_chaste_interface__membrane__v) + 3.4035137880000002));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][157] = ((0.064171548519999996 / pow(1.0 + exp((-(0.067476383269999995 * var_chaste_interface__membrane__v)) + 1.6423751689999999), 2.0)) * exp((-(0.067476383269999995 * var_chaste_interface__membrane__v)) + 1.6423751689999999)) * ((1.0 / (1.2089000000000001 + (1.2089000000000001 * exp((-(0.034035137880000003 * var_chaste_interface__membrane__v)) + 0.62658348490000004)))) + (3.5 * (1.0 / (1.0 + exp((0.034035137880000003 * var_chaste_interface__membrane__v) + 3.4035137880000002)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][158] = 1.0 / (1.0 + exp((-(0.067476383269999995 * var_chaste_interface__membrane__v)) + 1.6423751689999999));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][159] = -((1.0 / (4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998)))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][160] = ( -0.1751006829 * ((1.0 / pow(1.0 + exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997), 2.0)) * exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997))) * ((1.0 / (4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998)))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][161] = 1.0 / pow(4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][162] = 1.0 / pow((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][163] = ( -0.0039329999999999999 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.0048245931290000002 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][164] = 1.0 / (4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][165] = (-((1.0 / (1.3540000000000001 + (0.0001 / (exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763) + exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001))))) * (1.0 / (1.0 - (0.5 / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5))))))) * ((1.0 / (4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998)))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][166] = ((( -0.1751006829 * (((1.0 / pow(1.0 + exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997), 2.0)) * exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997)) * (1.0 / (1.3540000000000001 + (0.0001 / (exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763) + exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001))))))) * (1.0 / (1.0 - (0.5 / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5)))))) * (1.0 / (4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998))))))) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][167] = 1.0 / pow(1.3540000000000001 + (0.0001 / (exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763) + exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][168] = (1.0 / (4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp(( -0.01 * var_chaste_interface__membrane__v) - 1.0)) + (0.08004 * exp((0.060277275470000002 * var_chaste_interface__membrane__v) + 3.0138637739999998)))))) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][169] = (1.0 / pow(exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763) + exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001), 2.0)) * ((0.062932662050000004 * exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763)) - (4.6425255339999998 * exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][170] = 1.0 / pow(1.0 - (0.5 / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][171] = (1.0 / pow(1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5), 2.0)) * exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][172] = -((1.0 / (23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503)))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][173] = ( -0.1751006829 * ((1.0 / pow(1.0 + exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997), 2.0)) * exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997))) * ((1.0 / (23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503)))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][174] = 1.0 / pow(23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503)))), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][175] = 1.0 / pow((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503)), 2.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][176] = ( -2.3979678239999999e-05 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (2.2032429760000002e-09 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][177] = 1.0 / (23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][178] = (-((1.0 / (1.3540000000000001 + (0.0001 / (exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763) + exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001))))) * (1.0 / (1.0 - (0.5 / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5))))))) * ((1.0 / (23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503)))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][179] = ((( -0.1751006829 * (((1.0 / pow(1.0 + exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997), 2.0)) * exp((0.1751006829 * var_chaste_interface__membrane__v) + 7.6939240069999997)) * (1.0 / (1.3540000000000001 + (0.0001 / (exp((0.062932662050000004 * var_chaste_interface__membrane__v) - 10.53492763) + exp(( -4.6425255339999998 * var_chaste_interface__membrane__v) + 56.778087280000001))))))) * (1.0 / (1.0 - (0.5 / (1.0 + exp((0.050000000000000003 * var_chaste_interface__membrane__v) + 3.5)))))) * (1.0 / (23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503))))))) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][180] = (1.0 / (23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp(( -0.016934801020000001 * var_chaste_interface__membrane__v) - 1.6345469939999999)) + (1.7800000000000001e-08 * exp((0.1237776953 * var_chaste_interface__membrane__v) + 14.12303503)))))) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][181] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v - 213.59999999999999) * 0.0066137566137566143));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][182] = 1.0 - (1.0 / (1.0 + exp((var_chaste_interface__membrane__v - 213.59999999999999) * 0.0066137566137566143)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][183] = 0.29999999999999999 + (0.59999999999999998 / (1.0 + exp((var_chaste_interface__membrane__v - 10.0) * 0.10000000000000001)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][184] = 1.0 - (0.29999999999999999 + (0.59999999999999998 / (1.0 + exp((var_chaste_interface__membrane__v - 10.0) * 0.10000000000000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][185] = exp(2.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][186] = exp(1.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][187] = exp(1.0 * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][188] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 54.810000000000002) * 0.026171159382360639));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][189] = 1.0 - (1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 54.810000000000002) * 0.026171159382360639)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][190] = ((1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 55.0) * 0.013333333333333334))) * 1.0) / (1.0 + exp((var_chaste_interface__membrane__v - 10.0) * 0.033333333333333333));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][191] = 1.0 + exp((var_chaste_interface__membrane__v * 50403.763999999996) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][192] = exp((var_chaste_interface__membrane__v * 50403.763999999996) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][193] = 1.0 + (1.0 / exp((var_chaste_interface__membrane__v * 50403.763999999996) * 3.8799692706433766e-07));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][194] = exp((var_chaste_interface__membrane__v * 16112.995000000001) * 3.8799692706433766e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][195] = 9.0730000000000004 * exp((var_chaste_interface__membrane__v *  -14955.174999999999) * 1.2933230902144589e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][196] = 27.780000000000001 * exp((var_chaste_interface__membrane__v * 111440.175) * 1.2933230902144589e-07);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][197] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v - 14.48)) * 0.054525627044711013));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][198] = exp((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07) - 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][199] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v + 39.57)) * 0.10130685847431871));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][200] = 1.0 / ((6.7649999999999997 * exp((var_chaste_interface__membrane__v + 11.640000000000001) * 0.02876042565429968)) + (8.5519999999999996 * exp((-(var_chaste_interface__membrane__v + 77.420000000000002)) * 0.16792611251049538)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][201] = 1.0 / ((1.432e-05 * exp((-(var_chaste_interface__membrane__v + 1.196)) * 0.15910898965791567)) + (6.149 * exp((var_chaste_interface__membrane__v + 0.50960000000000005) * 0.049333991119881598)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][202] = 1.0 / ((0.0097940000000000006 * exp((-(var_chaste_interface__membrane__v + 17.949999999999999)) * 0.035650623885918005)) + (0.33429999999999999 * exp((var_chaste_interface__membrane__v + 5.7300000000000004) * 0.017649135192375574)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][203] = 2.0379999999999998 + (1.0 / ((0.021360000000000001 * exp((-(var_chaste_interface__membrane__v + 100.59999999999999)) * 0.12075836251660427)) + (0.30520000000000003 * exp((var_chaste_interface__membrane__v + 0.99409999999999998) * 0.02600780234070221))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][204] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 89.099999999999994) * 0.16431153466973381));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][205] = 3.0 * (1.0 / ((0.0097940000000000006 * exp((-(var_chaste_interface__membrane__v + 17.949999999999999)) * 0.035650623885918005)) + (0.33429999999999999 * exp((var_chaste_interface__membrane__v + 5.7300000000000004) * 0.017649135192375574))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][206] = 1.46 * (2.0379999999999998 + (1.0 / ((0.021360000000000001 * exp((-(var_chaste_interface__membrane__v + 100.59999999999999)) * 0.12075836251660427)) + (0.30520000000000003 * exp((var_chaste_interface__membrane__v + 0.99409999999999998) * 0.02600780234070221)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][207] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v + 42.850000000000001)) * 0.18996960486322187));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][208] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 87.609999999999999) * 0.13354700854700854));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][209] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 93.810000000000002) * 0.13354700854700854));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][210] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v - 14.34)) * 0.067476383265856948));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][211] = 1.0515000000000001 / ((1.0 / (1.2089000000000001 * (1.0 + exp((-(var_chaste_interface__membrane__v - 18.4099)) * 0.034035137876343539)))) + (3.5 / (1.0 + exp((var_chaste_interface__membrane__v + 100.0) * 0.034035137876343539))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][212] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 43.939999999999998) * 0.17510068289266328));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][213] = (4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp((-(var_chaste_interface__membrane__v + 100.0)) * 0.01)) + (0.08004 * exp((var_chaste_interface__membrane__v + 50.0) * 0.060277275467148887))))) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][214] = (23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp((-(var_chaste_interface__membrane__v + 96.519999999999996)) * 0.016934801016088061)) + (1.7800000000000001e-08 * exp((var_chaste_interface__membrane__v + 114.09999999999999) * 0.12377769525931426))))) * 1.0;
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][215] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v - 24.34)) * 0.067476383265856948));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][216] = (1.3540000000000001 + (0.0001 / (exp((var_chaste_interface__membrane__v - 167.40000000000001) * 0.062932662051604776) + exp((-(var_chaste_interface__membrane__v - 12.23)) * 4.6425255338904359)))) * (1.0 - (0.5 / (1.0 + exp((var_chaste_interface__membrane__v + 70.0) * 0.050000000000000003)))) * ((4.5620000000000003 + (1.0 / ((0.39329999999999998 * exp((-(var_chaste_interface__membrane__v + 100.0)) * 0.01)) + (0.08004 * exp((var_chaste_interface__membrane__v + 50.0) * 0.060277275467148887))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][217] = (1.3540000000000001 + (0.0001 / (exp((var_chaste_interface__membrane__v - 167.40000000000001) * 0.062932662051604776) + exp((-(var_chaste_interface__membrane__v - 12.23)) * 4.6425255338904359)))) * (1.0 - (0.5 / (1.0 + exp((var_chaste_interface__membrane__v + 70.0) * 0.050000000000000003)))) * ((23.620000000000001 + (1.0 / ((0.0014159999999999999 * exp((-(var_chaste_interface__membrane__v + 96.519999999999996)) * 0.016934801016088061)) + (1.7800000000000001e-08 * exp((var_chaste_interface__membrane__v + 114.09999999999999) * 0.12377769525931426))))) * 1.0);
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][218] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v + 3.9399999999999999)) * 0.23640661938534277));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][219] = 0.59999999999999998 + (1.0 / (exp( -0.050000000000000003 * (var_chaste_interface__membrane__v + 6.0)) + exp(0.089999999999999997 * (var_chaste_interface__membrane__v + 14.0))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][220] = 1.0 / (1.0 + exp((var_chaste_interface__membrane__v + 19.579999999999998) * 0.27056277056277056));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][221] = 7.0 + (1.0 / ((0.0044999999999999997 * exp((-(var_chaste_interface__membrane__v + 20.0)) * 0.10000000000000001)) + (0.0044999999999999997 * exp((var_chaste_interface__membrane__v + 20.0) * 0.10000000000000001))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][222] = 1000.0 + (1.0 / ((3.4999999999999997e-05 * exp((-(var_chaste_interface__membrane__v + 5.0)) * 0.25)) + (3.4999999999999997e-05 * exp((var_chaste_interface__membrane__v + 5.0) * 0.16666666666666666))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][223] = 7.0 + (1.0 / ((0.040000000000000001 * exp((-(var_chaste_interface__membrane__v - 4.0)) * 0.14285714285714285)) + (0.040000000000000001 * exp((var_chaste_interface__membrane__v - 4.0) * 0.14285714285714285))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][224] = 100.0 + (1.0 / ((0.00012 * exp((-var_chaste_interface__membrane__v) * 0.33333333333333331)) + (0.00012 * exp(var_chaste_interface__membrane__v * 0.14285714285714285))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][225] = 2.5 * (7.0 + (1.0 / ((0.0044999999999999997 * exp((-(var_chaste_interface__membrane__v + 20.0)) * 0.10000000000000001)) + (0.0044999999999999997 * exp((var_chaste_interface__membrane__v + 20.0) * 0.10000000000000001)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][226] = 2.5 * (7.0 + (1.0 / ((0.040000000000000001 * exp((-(var_chaste_interface__membrane__v - 4.0)) * 0.14285714285714285)) + (0.040000000000000001 * exp((var_chaste_interface__membrane__v - 4.0) * 0.14285714285714285)))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][227] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v + 8.3369999999999997)) * 0.14729709824716453));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][228] = 12.98 + (1.0 / ((0.36520000000000002 * exp((var_chaste_interface__membrane__v - 31.66) * 0.25846471956577927)) + (4.1230000000000003e-05 * exp((-(var_chaste_interface__membrane__v - 47.780000000000001)) * 0.049067713444553483))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][229] = 1.865 + (1.0 / ((0.066290000000000002 * exp((var_chaste_interface__membrane__v - 34.700000000000003) * 0.13596193065941536)) + (1.128e-05 * exp((-(var_chaste_interface__membrane__v - 29.739999999999998)) * 0.038550501156515031))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][230] = 1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v + 11.6)) * 0.11195700850873264));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][231] = 817.29999999999995 + (1.0 / ((0.00023259999999999999 * exp((var_chaste_interface__membrane__v + 48.280000000000001) * 0.056179775280898875)) + (0.001292 * exp((-(var_chaste_interface__membrane__v + 210.0)) * 0.0043478260869565218))));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][232] = 1.0 / ((0.01 * exp((var_chaste_interface__membrane__v - 50.0) * 0.050000000000000003)) + (0.019300000000000001 * exp((-(var_chaste_interface__membrane__v + 66.540000000000006)) * 0.032258064516129031)));
            }
            
            for (unsigned i=0 ; i<_table_size_0; i++)
            {
                const double var_chaste_interface__membrane__v = mTableMins[0] + i*mTableSteps[0];
                _lookup_table_0[i][233] = 122.2 / (exp((-(var_chaste_interface__membrane__v + 127.2)) * 0.049115913555992145) + exp((var_chaste_interface__membrane__v + 236.80000000000001) * 0.014423770373575654));
            }
            
            mNeedsRegeneration[0] = false;
        }
        
        AbstractLookupTableCollection::EventHandler::EndEvent(AbstractLookupTableCollection::EventHandler::GENERATE_TABLES);
    }
    
private:
    /** The single instance of the class */
    static std::auto_ptr<Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables> mpInstance;

    // Row lookup methods memory
    double _lookup_table_0_row[234];
    
    // Lookup tables
    double (*_lookup_table_0)[234];
    
};

std::auto_ptr<Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables> Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::mpInstance;

    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_ryr__Jrel()
    {
        return var_ryr__Jrel;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__INaCa_i__INaCa_ss()
    {
        return var_chaste_interface__INaCa_i__INaCa_ss;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__intracellular_ions__cai()
    {
        return var_chaste_interface__intracellular_ions__cai;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__intracellular_ions__ki()
    {
        return var_chaste_interface__intracellular_ions__ki;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__intracellular_ions__nai()
    {
        return var_chaste_interface__intracellular_ions__nai;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__fake_dt()
    {
        return var_chaste_interface__environment__fake_dt;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__i_ionic()
    {
        return var_chaste_interface__i_ionic;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__ICaL__ICaK()
    {
        return var_chaste_interface__ICaL__ICaK;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__ICaL__ICaNa()
    {
        return var_chaste_interface__ICaL__ICaNa;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__ICaL__ICaL()
    {
        return var_chaste_interface__ICaL__ICaL;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__ICab__ICab()
    {
        return var_chaste_interface__ICab__ICab;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__IKb__IKb()
    {
        return var_chaste_interface__IKb__IKb;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__INab__INab()
    {
        return var_chaste_interface__INab__INab;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__IpCa__IpCa()
    {
        return var_chaste_interface__IpCa__IpCa;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__INa__INa()
    {
        return var_chaste_interface__INa__INa;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_INa__h()
    {
        return var_INa__h;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__INa__j()
    {
        return var_chaste_interface__INa__j;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__IK1__IK1()
    {
        return var_chaste_interface__IK1__IK1;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__INaL__INaL()
    {
        return var_chaste_interface__INaL__INaL;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__IKr__IKr()
    {
        return var_chaste_interface__IKr__IKr;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__IKs__IKs()
    {
        return var_chaste_interface__IKs__IKs;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__INaCa_i__INaCa_i()
    {
        return var_chaste_interface__INaCa_i__INaCa_i;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__INaK__INaK()
    {
        return var_chaste_interface__INaK__INaK;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__Istim()
    {
        return var_chaste_interface__membrane__Istim;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__i_Stim_Amplitude()
    {
        return var_chaste_interface__membrane__i_Stim_Amplitude;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__i_Stim_PulseDuration()
    {
        return var_chaste_interface__membrane__i_Stim_PulseDuration;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__i_Stim_Start()
    {
        return var_chaste_interface__membrane__i_Stim_Start;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__i_Stim_Period()
    {
        return var_chaste_interface__membrane__i_Stim_Period;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__membrane__v()
    {
        return var_chaste_interface__membrane__v;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_chaste_interface__environment__time()
    {
        return var_chaste_interface__environment__time;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_SR_release_current_max_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 0);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_SR_uptake_current_max_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 1);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_extracellular_calcium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 2);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_extracellular_potassium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 3);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_extracellular_sodium_concentration_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 4);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_L_type_calcium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 5);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_background_calcium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 6);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_background_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 7);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_background_sodium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 8);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_calcium_pump_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 9);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_fast_sodium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 10);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_inward_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 11);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_persistent_sodium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 12);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_rapid_delayed_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 13);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_slow_delayed_rectifier_potassium_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 14);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_sodium_calcium_exchanger_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 15);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_sodium_potassium_pump_current_permeability_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 16);
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_amplitude_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__i_Stim_Amplitude =  -80.0 * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        return var_chaste_interface__membrane__i_Stim_Amplitude;
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_duration_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__i_Stim_PulseDuration = 0.5; // millisecond
        return var_chaste_interface__membrane__i_Stim_PulseDuration;
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_offset_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__i_Stim_Start = 10.0; // millisecond
        return var_chaste_interface__membrane__i_Stim_Start;
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_stimulus_current_period_constant()
    {
        // Constant value given in CellML
        var_chaste_interface__membrane__i_Stim_Period = 1000.0; // millisecond
        return var_chaste_interface__membrane__i_Stim_Period;
    }
    
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_transient_outward_current_conductance_constant()
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 17);
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Get_membrane_data_clamp_current_conductance_constant() // RJ
    {
        // Constant value given in CellML
        return NV_Ith_S(mParameters, 18);
    }

    
    boost::shared_ptr<RegularStimulus> Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::UseCellMLDefaultStimulus()
    {
        // Use the default stimulus specified by CellML metadata
        var_chaste_interface__membrane__i_Stim_Start = 10.0; // millisecond
        var_chaste_interface__membrane__i_Stim_Period = 1000.0; // millisecond
        var_chaste_interface__membrane__i_Stim_PulseDuration = 0.5; // millisecond
        var_chaste_interface__membrane__i_Stim_Amplitude =  -80.0 * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        boost::shared_ptr<RegularStimulus> p_cellml_stim(new RegularStimulus(
                -fabs(var_chaste_interface__membrane__i_Stim_Amplitude),
                var_chaste_interface__membrane__i_Stim_PulseDuration,
                var_chaste_interface__membrane__i_Stim_Period,
                var_chaste_interface__membrane__i_Stim_Start
                ));
        mpIntracellularStimulus = p_cellml_stim;
        return p_cellml_stim;
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::GetIntracellularCalciumConcentration()
    {
        return NV_Ith_S(mStateVariables, 9);
    }
    
    Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt(boost::shared_ptr<AbstractIvpOdeSolver> pOdeSolver /* unused; should be empty */, boost::shared_ptr<AbstractStimulusFunction> pIntracellularStimulus)
        : AbstractCvodeCellWithDataClamp(
                pOdeSolver,
                41,
                0,
                pIntracellularStimulus)
    {
        // Time units: millisecond
        // 
        this->mpSystemInfo = OdeSystemInformation<Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt>::Instance();
        Init();

        // We have a default stimulus specified in the CellML file metadata
        this->mHasDefaultStimulusFromCellML = true;
        NV_Ith_S(this->mParameters, 0) = 1.0; // (c,ryr__Jrel_scaling_factor) [dimensionless]
        NV_Ith_S(this->mParameters, 1) = 1.0; // (c,SERCA__Jup_b) [dimensionless]
        NV_Ith_S(this->mParameters, 2) = 1.8; // (c,extracellular__cao) [millimolar]
        NV_Ith_S(this->mParameters, 3) = 5.4; // (c,extracellular__ko) [millimolar]
        NV_Ith_S(this->mParameters, 4) = 140; // (c,extracellular__nao) [millimolar]
        NV_Ith_S(this->mParameters, 5) = 0.0001; // (c,ICaL__PCa_b) [dimensionless]
        NV_Ith_S(this->mParameters, 6) = 2.5e-8; // (c,ICab__PCab) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 7) = 0.003; // (c,IKb__GKb_b) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 8) = 3.75e-10; // (c,INab__PNab) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 9) = 0.0005; // (c,IpCa__GpCa) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 10) = 75; // (c,INa__GNa) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 11) = 0.1908; // (c,IK1__GK1_b) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 12) = 0.0075; // (c,INaL__GNaL_b) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 13) = 0.046; // (c,IKr__GKr_b) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 14) = 0.0034; // (c,IKs__GKs_b) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 15) = 0.0008; // (c,INaCa_i__Gncx_b) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 16) = 30; // (c,INaK__Pnak_b) [milliS_per_microF]
        NV_Ith_S(this->mParameters, 17) = 0.02; // (c,Ito__Gto_b) [milliS_per_microF]

        NV_Ith_S(this->mParameters, 18) = 0; // (c,data_clamp_current__g_data) [mS_per_mm2] RJ - start at 0 to generate data

        mUseAnalyticJacobian = true;
        mHasAnalyticJacobian = true;
    }
    
    Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::~Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt()
    {
    }
    
    AbstractLookupTableCollection* Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::GetLookupTableCollection()
    {
        return Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance();
    }
    
    double Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::GetIIonic(const std::vector<double>* pStateVariables)
    {
        // For state variable interpolation (SVI) we read in interpolated state variables,
        // otherwise for ionic current interpolation (ICI) we use the state variables of this model (node).
        N_Vector rY;
        bool made_new_cvode_vector = false;
        if (!pStateVariables)
        {
            rY = rGetStateVariables();
        }
        else
        {
            made_new_cvode_vector = true;
            rY = MakeNVector(*pStateVariables);
        }
        
        double var_chaste_interface__membrane__v = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -87
        double var_chaste_interface__CaMK__CaMKt = NV_Ith_S(rY, 1);
        // Units: millimolar; Initial value: 0
        double var_chaste_interface__intracellular_ions__nai = NV_Ith_S(rY, 2);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__nass = NV_Ith_S(rY, 3);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__ki = NV_Ith_S(rY, 4);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__kss = NV_Ith_S(rY, 5);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__cass = NV_Ith_S(rY, 6);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__intracellular_ions__cai = NV_Ith_S(rY, 9);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__INa__m = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INa__hf = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hs = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__j = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hsp = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__jp = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__mL = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INaL__hL = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__hLp = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__a = NV_Ith_S(rY, 19);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__Ito__iF = NV_Ith_S(rY, 20);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__iS = NV_Ith_S(rY, 21);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__ap = NV_Ith_S(rY, 22);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__Ito__iFp = NV_Ith_S(rY, 23);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__iSp = NV_Ith_S(rY, 24);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__d = NV_Ith_S(rY, 25);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__ICaL__ff = NV_Ith_S(rY, 26);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fs = NV_Ith_S(rY, 27);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcaf = NV_Ith_S(rY, 28);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcas = NV_Ith_S(rY, 29);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__jca = NV_Ith_S(rY, 30);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__ffp = NV_Ith_S(rY, 31);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcafp = NV_Ith_S(rY, 32);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__nca = NV_Ith_S(rY, 33);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrf = NV_Ith_S(rY, 34);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrs = NV_Ith_S(rY, 35);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs1 = NV_Ith_S(rY, 36);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs2 = NV_Ith_S(rY, 37);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IK1__xk1 = NV_Ith_S(rY, 38);
        // Units: dimensionless; Initial value: 1
        
        // Lookup table indexing
        const bool _oob_0 = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__v);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__v);
        
        const double var_INa__h = (0.98999999999999999 * var_chaste_interface__INa__hf) + (0.010000000000000009 * var_chaste_interface__INa__hs); // dimensionless
        const double var_reversal_potentials__ENa = 26.712338705498265 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__intracellular_ions__nai); // millivolt
        const double var_CaMK__CaMKb = (0.050000000000000003 * (1.0 - var_chaste_interface__CaMK__CaMKt)) / (1.0 + (0.0015 / var_chaste_interface__intracellular_ions__cass)); // millimolar
        const double var_CaMK__CaMKa = var_CaMK__CaMKb + var_chaste_interface__CaMK__CaMKt; // millimolar
        const double var_INa__fINap = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_INa__INa = NV_Ith_S(mParameters, 10) * (var_chaste_interface__membrane__v - var_reversal_potentials__ENa) * pow(var_chaste_interface__INa__m, 3.0) * (((1.0 - var_INa__fINap) * var_INa__h * var_chaste_interface__INa__j) + (var_INa__fINap * ((0.98999999999999999 * var_chaste_interface__INa__hf) + (0.010000000000000009 * var_chaste_interface__INa__hsp)) * var_chaste_interface__INa__jp)); // microA_per_microF
        const double var_INaL__fINaLp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_INaL__INaL = NV_Ith_S(mParameters, 12) * (var_chaste_interface__membrane__v - var_reversal_potentials__ENa) * var_chaste_interface__INaL__mL * (((1.0 - var_INaL__fINaLp) * var_chaste_interface__INaL__hL) + (var_INaL__fINaLp * var_chaste_interface__INaL__hLp)); // microA_per_microF
        const double var_reversal_potentials__EK = 26.712338705498265 * log(NV_Ith_S(mParameters, 3) / var_chaste_interface__intracellular_ions__ki); // millivolt
        const double var_Ito__fItop = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_Ito__Ito = NV_Ith_S(mParameters, 17) * (var_chaste_interface__membrane__v - var_reversal_potentials__EK) * (((1.0 - var_Ito__fItop) * var_chaste_interface__Ito__a * ((_lt_0_row[181] * var_chaste_interface__Ito__iF) + (_lt_0_row[182] * var_chaste_interface__Ito__iS))) + (var_Ito__fItop * var_chaste_interface__Ito__ap * ((_lt_0_row[181] * var_chaste_interface__Ito__iFp) + (_lt_0_row[182] * var_chaste_interface__Ito__iSp)))); // microA_per_microF
        const double var_ICaL__fICaLp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_ICaL__fcap = (_lt_0_row[183] * var_chaste_interface__ICaL__fcafp) + (_lt_0_row[184] * var_chaste_interface__ICaL__fcas); // dimensionless
        const double var_ICaL__PCa = NV_Ith_S(mParameters, 5); // dimensionless
        const double var_ICaL__PCap = 1.1000000000000001 * var_ICaL__PCa; // dimensionless
        const double var_ICaL__fp = (0.59999999999999998 * var_chaste_interface__ICaL__ffp) + (0.40000000000000002 * var_chaste_interface__ICaL__fs); // dimensionless
        const double var_ICaL__PhiCaL = (4.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__cass * _lt_0_row[2]) - (0.34100000000000003 * NV_Ith_S(mParameters, 2)))) / _lt_0_row[185]; // dimensionless
        const double var_ICaL__f = (0.59999999999999998 * var_chaste_interface__ICaL__ff) + (0.40000000000000002 * var_chaste_interface__ICaL__fs); // dimensionless
        const double var_ICaL__fca = (_lt_0_row[183] * var_chaste_interface__ICaL__fcaf) + (_lt_0_row[184] * var_chaste_interface__ICaL__fcas); // dimensionless
        const double var_ICaL__ICaL = ((1.0 - var_ICaL__fICaLp) * var_ICaL__PCa * var_ICaL__PhiCaL * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * var_ICaL__PCap * var_ICaL__PhiCaL * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_ICaL__PhiCaNa = (1.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((0.75 * var_chaste_interface__intracellular_ions__nass * _lt_0_row[186]) - (0.75 * NV_Ith_S(mParameters, 4)))) / _lt_0_row[187]; // dimensionless
        const double var_ICaL__ICaNa = ((1.0 - var_ICaL__fICaLp) * (0.00125 * var_ICaL__PCa) * var_ICaL__PhiCaNa * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * (0.00125 * var_ICaL__PCap) * var_ICaL__PhiCaNa * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_ICaL__PhiCaK = (1.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((0.75 * var_chaste_interface__intracellular_ions__kss * _lt_0_row[186]) - (0.75 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[187]; // dimensionless
        const double var_ICaL__ICaK = ((1.0 - var_ICaL__fICaLp) * (0.00035740000000000001 * var_ICaL__PCa) * var_ICaL__PhiCaK * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * (0.00035740000000000001 * var_ICaL__PCap) * var_ICaL__PhiCaK * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_IKr__IKr = NV_Ith_S(mParameters, 13) * sqrt(NV_Ith_S(mParameters, 3) * 0.18518518518518517) * ((_lt_0_row[188] * var_chaste_interface__IKr__xrf) + (_lt_0_row[189] * var_chaste_interface__IKr__xrs)) * _lt_0_row[190] * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_IKs__IKs = NV_Ith_S(mParameters, 14) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__intracellular_ions__cai, 1.3999999999999999)))) * var_chaste_interface__IKs__xs1 * var_chaste_interface__IKs__xs2 * (var_chaste_interface__membrane__v - (26.712338705498265 * log((NV_Ith_S(mParameters, 3) + (0.018329999999999999 * NV_Ith_S(mParameters, 4))) / (var_chaste_interface__intracellular_ions__ki + (0.018329999999999999 * var_chaste_interface__intracellular_ions__nai))))); // microA_per_microF
        const double var_IK1__IK1 = NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 3)) * (1.0 / (1.0 + exp(((var_chaste_interface__membrane__v + 105.8) - (2.6000000000000001 * NV_Ith_S(mParameters, 3))) * 0.10534077741493732))) * var_chaste_interface__IK1__xk1 * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_INaCa_i__h1_i = 1.0 + ((var_chaste_interface__intracellular_ions__nai * 0.011348161597821153) * _lt_0_row[191]); // dimensionless
        const double var_INaCa_i__h2_i = (var_chaste_interface__intracellular_ions__nai * _lt_0_row[192]) / (88.120000000000005 * var_INaCa_i__h1_i); // dimensionless
        const double var_INaCa_i__k4pp_i = var_INaCa_i__h2_i * 5000.0; // dimensionless
        const double var_INaCa_i__h4_i = 1.0 + ((var_chaste_interface__intracellular_ions__nai * 0.066666666666666666) * (1.0 + (var_chaste_interface__intracellular_ions__nai * 0.20000000000000001))); // dimensionless
        const double var_INaCa_i__k7_i = ((var_chaste_interface__intracellular_ions__nai * var_chaste_interface__intracellular_ions__nai) / (var_INaCa_i__h4_i * 75.0)) * var_INaCa_i__h2_i * 60000.0; // dimensionless
        const double var_INaCa_i__h7_i = 1.0 + ((NV_Ith_S(mParameters, 4) * 0.011348161597821153) * _lt_0_row[193]); // dimensionless
        const double var_INaCa_i__h8_i = NV_Ith_S(mParameters, 4) / (88.120000000000005 * _lt_0_row[192] * var_INaCa_i__h7_i); // dimensionless
        const double var_INaCa_i__k3pp_i = var_INaCa_i__h8_i * 5000.0; // dimensionless
        const double var_INaCa_i__h10_i = ((NV_Ith_S(mParameters, 4) * 0.066666666666666666) * (1.0 + (NV_Ith_S(mParameters, 4) * 0.20000000000000001))) + 13.5; // dimensionless
        const double var_INaCa_i__k8_i = var_INaCa_i__h8_i * ((NV_Ith_S(mParameters, 4) * NV_Ith_S(mParameters, 4)) / (var_INaCa_i__h10_i * 75.0)) * 60000.0; // dimensionless
        const double var_INaCa_i__k1_i = (1.0 / var_INaCa_i__h10_i) * NV_Ith_S(mParameters, 2) * 1500000.0; // dimensionless
        const double var_INaCa_i__k4_i = (((1.0 / var_INaCa_i__h1_i) * 60000.0) / _lt_0_row[194]) + var_INaCa_i__k4pp_i; // dimensionless
        const double var_INaCa_i__k3_i = ((1.0 / var_INaCa_i__h7_i) * 60000.0) + var_INaCa_i__k3pp_i; // dimensionless
        const double var_INaCa_i__x4_i = (5000.0 * var_INaCa_i__k8_i * (var_INaCa_i__k4_i + 5000.0)) + (var_INaCa_i__k3_i * 5000.0 * (var_INaCa_i__k1_i + var_INaCa_i__k8_i)); // dimensionless
        const double var_INaCa_i__k6_i = (1.0 / var_INaCa_i__h4_i) * var_chaste_interface__intracellular_ions__cai * 1500000.0; // dimensionless
        const double var_INaCa_i__x3_i = (var_INaCa_i__k1_i * var_INaCa_i__k3_i * (var_INaCa_i__k7_i + var_INaCa_i__k6_i)) + (var_INaCa_i__k8_i * var_INaCa_i__k6_i * (5000.0 + var_INaCa_i__k3_i)); // dimensionless
        const double var_INaCa_i__x2_i = (var_INaCa_i__k1_i * var_INaCa_i__k7_i * (var_INaCa_i__k4_i + 5000.0)) + (var_INaCa_i__k4_i * var_INaCa_i__k6_i * (var_INaCa_i__k1_i + var_INaCa_i__k8_i)); // dimensionless
        const double var_INaCa_i__x1_i = (5000.0 * var_INaCa_i__k4_i * (var_INaCa_i__k7_i + var_INaCa_i__k6_i)) + (5000.0 * var_INaCa_i__k7_i * (5000.0 + var_INaCa_i__k3_i)); // dimensionless
        const double var_INaCa_i__E1_i = var_INaCa_i__x1_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i); // dimensionless
        const double var_INaCa_i__E2_i = var_INaCa_i__x2_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i); // dimensionless
        const double var_INaCa_i__Gncx = NV_Ith_S(mParameters, 15); // milliS_per_microF
        const double var_INaCa_i__INaCa_i = 0.80000000000000004 * var_INaCa_i__Gncx * (1.0 / (1.0 + pow(0.00014999999999999999 / var_chaste_interface__intracellular_ions__cai, 2.0))) * ((1.0 * (((3.0 * (((var_INaCa_i__x4_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i)) * var_INaCa_i__k7_i) - (var_INaCa_i__E1_i * var_INaCa_i__k8_i))) + ((var_INaCa_i__x3_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i)) * var_INaCa_i__k4pp_i)) - (var_INaCa_i__E2_i * var_INaCa_i__k3pp_i))) + (2.0 * ((var_INaCa_i__E2_i * 5000.0) - (var_INaCa_i__E1_i * var_INaCa_i__k1_i)))); // microA_per_microF
        const double var_INaCa_i__h1_ss = 1.0 + ((var_chaste_interface__intracellular_ions__nass * 0.011348161597821153) * _lt_0_row[191]); // dimensionless
        const double var_INaCa_i__h2_ss = (var_chaste_interface__intracellular_ions__nass * _lt_0_row[192]) / (88.120000000000005 * var_INaCa_i__h1_ss); // dimensionless
        const double var_INaCa_i__k4pp_ss = var_INaCa_i__h2_ss * 5000.0; // dimensionless
        const double var_INaCa_i__k4_ss = (((1.0 / var_INaCa_i__h1_ss) * 60000.0) / _lt_0_row[194]) + var_INaCa_i__k4pp_ss; // dimensionless
        const double var_INaCa_i__h10_ss = ((NV_Ith_S(mParameters, 4) * 0.066666666666666666) * (1.0 + (NV_Ith_S(mParameters, 4) * 0.20000000000000001))) + 13.5; // dimensionless
        const double var_INaCa_i__h7_ss = 1.0 + ((NV_Ith_S(mParameters, 4) * 0.011348161597821153) * _lt_0_row[193]); // dimensionless
        const double var_INaCa_i__h8_ss = NV_Ith_S(mParameters, 4) / (88.120000000000005 * _lt_0_row[192] * var_INaCa_i__h7_ss); // dimensionless
        const double var_INaCa_i__k8_ss = var_INaCa_i__h8_ss * ((NV_Ith_S(mParameters, 4) * NV_Ith_S(mParameters, 4)) / (var_INaCa_i__h10_ss * 75.0)) * 60000.0; // dimensionless
        const double var_INaCa_i__h4_ss = 1.0 + ((var_chaste_interface__intracellular_ions__nass * 0.066666666666666666) * (1.0 + (var_chaste_interface__intracellular_ions__nass * 0.20000000000000001))); // dimensionless
        const double var_INaCa_i__k6_ss = (1.0 / var_INaCa_i__h4_ss) * var_chaste_interface__intracellular_ions__cass * 1500000.0; // dimensionless
        const double var_INaCa_i__k1_ss = (1.0 / var_INaCa_i__h10_ss) * NV_Ith_S(mParameters, 2) * 1500000.0; // dimensionless
        const double var_INaCa_i__k7_ss = ((var_chaste_interface__intracellular_ions__nass * var_chaste_interface__intracellular_ions__nass) / (var_INaCa_i__h4_ss * 75.0)) * var_INaCa_i__h2_ss * 60000.0; // dimensionless
        const double var_INaCa_i__x2_ss = (var_INaCa_i__k1_ss * var_INaCa_i__k7_ss * (var_INaCa_i__k4_ss + 5000.0)) + (var_INaCa_i__k4_ss * var_INaCa_i__k6_ss * (var_INaCa_i__k1_ss + var_INaCa_i__k8_ss)); // dimensionless
        const double var_INaCa_i__k3pp_ss = var_INaCa_i__h8_ss * 5000.0; // dimensionless
        const double var_INaCa_i__k3_ss = ((1.0 / var_INaCa_i__h7_ss) * 60000.0) + var_INaCa_i__k3pp_ss; // dimensionless
        const double var_INaCa_i__x3_ss = (var_INaCa_i__k1_ss * var_INaCa_i__k3_ss * (var_INaCa_i__k7_ss + var_INaCa_i__k6_ss)) + (var_INaCa_i__k8_ss * var_INaCa_i__k6_ss * (5000.0 + var_INaCa_i__k3_ss)); // dimensionless
        const double var_INaCa_i__x1_ss = (5000.0 * var_INaCa_i__k4_ss * (var_INaCa_i__k7_ss + var_INaCa_i__k6_ss)) + (5000.0 * var_INaCa_i__k7_ss * (5000.0 + var_INaCa_i__k3_ss)); // dimensionless
        const double var_INaCa_i__x4_ss = (5000.0 * var_INaCa_i__k8_ss * (var_INaCa_i__k4_ss + 5000.0)) + (var_INaCa_i__k3_ss * 5000.0 * (var_INaCa_i__k1_ss + var_INaCa_i__k8_ss)); // dimensionless
        const double var_INaCa_i__E2_ss = var_INaCa_i__x2_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss); // dimensionless
        const double var_INaCa_i__E1_ss = var_INaCa_i__x1_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss); // dimensionless
        const double var_INaCa_i__INaCa_ss = 0.20000000000000001 * var_INaCa_i__Gncx * (1.0 / (1.0 + pow(0.00014999999999999999 / var_chaste_interface__intracellular_ions__cass, 2.0))) * ((1.0 * (((3.0 * (((var_INaCa_i__x4_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss)) * var_INaCa_i__k7_ss) - (var_INaCa_i__E1_ss * var_INaCa_i__k8_ss))) + ((var_INaCa_i__x3_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss)) * var_INaCa_i__k4pp_ss)) - (var_INaCa_i__E2_ss * var_INaCa_i__k3pp_ss))) + (2.0 * ((var_INaCa_i__E2_ss * 5000.0) - (var_INaCa_i__E1_ss * var_INaCa_i__k1_ss)))); // microA_per_microF
        const double var_INaK__b3 = ((4.2000000000000002 / ((var_chaste_interface__intracellular_ions__nai * 0.004464285714285714) + (var_chaste_interface__intracellular_ions__ki * 0.0034246575342465752) + 1.5889281507656066)) * 0.0079299999999999995) * 1.732653031203624e-08; // dimensionless
        const double var_INaK__a3 = (1899.0 * pow(NV_Ith_S(mParameters, 3) * 2.7917364600781687, 2.0)) / ((pow(1.0 + (NV_Ith_S(mParameters, 4) / _lt_0_row[196]), 3.0) + pow(1.0 + (NV_Ith_S(mParameters, 3) * 2.7917364600781687), 2.0)) - 1.0); // dimensionless
        const double var_INaK__b2 = (39.399999999999999 * pow(NV_Ith_S(mParameters, 4) / _lt_0_row[196], 3.0)) / ((pow(1.0 + (NV_Ith_S(mParameters, 4) / _lt_0_row[196]), 3.0) + pow(1.0 + (NV_Ith_S(mParameters, 3) * 2.7917364600781687), 2.0)) - 1.0); // dimensionless
        const double var_INaK__x3 = (var_INaK__a3 * 439120.79239156022) + (var_INaK__b3 * var_INaK__b2 * 9.120000000000001) + (var_INaK__b2 * 5827.679899026527) + (var_INaK__a3 * 5827.679899026527); // dimensionless
        const double var_INaK__b4 = (40.0 * pow(var_chaste_interface__intracellular_ions__ki * 2.0, 2.0)) / ((pow(1.0 + (var_chaste_interface__intracellular_ions__nai / _lt_0_row[195]), 3.0) + pow(1.0 + (var_chaste_interface__intracellular_ions__ki * 2.0), 2.0)) - 1.0); // dimensionless
        const double var_INaK__a1 = (949.5 * pow(var_chaste_interface__intracellular_ions__nai / _lt_0_row[195], 3.0)) / ((pow(1.0 + (var_chaste_interface__intracellular_ions__nai / _lt_0_row[195]), 3.0) + pow(1.0 + (var_chaste_interface__intracellular_ions__ki * 2.0), 2.0)) - 1.0); // dimensionless
        const double var_INaK__x2 = (var_INaK__b2 * 9.120000000000001 * var_INaK__b4) + (var_INaK__a1 * 687.20000000000005 * var_INaK__a3) + (var_INaK__a3 * 9.120000000000001 * var_INaK__b4) + (687.20000000000005 * var_INaK__a3 * var_INaK__b4); // dimensionless
        const double var_INaK__x1 = (var_INaK__a1 * 439120.79239156022) + (var_INaK__b2 * var_INaK__b4 * var_INaK__b3) + (687.20000000000005 * var_INaK__b4 * var_INaK__b3) + (var_INaK__b3 * var_INaK__a1 * 687.20000000000005); // dimensionless
        const double var_INaK__x4 = (var_INaK__b4 * var_INaK__b3 * var_INaK__b2) + (var_INaK__a3 * 638.99998892834719 * var_INaK__a1) + (var_INaK__b2 * 638.99998892834719 * var_INaK__a1) + (var_INaK__b3 * var_INaK__b2 * var_INaK__a1); // dimensionless
        const double var_INaK__INaK = NV_Ith_S(mParameters, 16) * ((1.0 * (3.0 * (((var_INaK__x1 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__a3) - ((var_INaK__x2 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__b3)))) + (1.0 * (2.0 * (((var_INaK__x4 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * 9.120000000000001) - ((var_INaK__x3 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__a1))))); // microA_per_microF
        const double var_INab__INab = (NV_Ith_S(mParameters, 8) * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__nai * _lt_0_row[0]) - NV_Ith_S(mParameters, 4))) / _lt_0_row[198]; // microA_per_microF
        const double var_IKb__IKb = NV_Ith_S(mParameters, 7) * _lt_0_row[197] * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 9) * var_chaste_interface__intracellular_ions__cai) / (0.00050000000000000001 + var_chaste_interface__intracellular_ions__cai); // microA_per_microF
        const double var_ICab__ICab = (NV_Ith_S(mParameters, 6) * 4.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__cai * _lt_0_row[2]) - (0.34100000000000003 * NV_Ith_S(mParameters, 2)))) / _lt_0_row[185]; // microA_per_microF
        const double var_chaste_interface__ICaL__ICaL = var_ICaL__ICaL; // microA_per_microF
        const double var_chaste_interface__ICab__ICab = var_ICab__ICab; // microA_per_microF
        const double var_chaste_interface__INa__INa = var_INa__INa; // microA_per_microF
        const double var_chaste_interface__ICaL__ICaK = var_ICaL__ICaK; // microA_per_microF
        const double var_chaste_interface__INaL__INaL = var_INaL__INaL; // microA_per_microF
        const double var_chaste_interface__INaCa_i__INaCa_i = var_INaCa_i__INaCa_i; // microA_per_microF
        const double var_chaste_interface__INab__INab = var_INab__INab; // microA_per_microF
        const double var_chaste_interface__IKs__IKs = var_IKs__IKs; // microA_per_microF
        const double var_chaste_interface__INaK__INaK = var_INaK__INaK; // microA_per_microF
        const double var_chaste_interface__IKb__IKb = var_IKb__IKb; // microA_per_microF
        const double var_chaste_interface__ICaL__ICaNa = var_ICaL__ICaNa; // microA_per_microF
        const double var_chaste_interface__IK1__IK1 = var_IK1__IK1; // microA_per_microF
        const double var_chaste_interface__INaCa_i__INaCa_ss = var_INaCa_i__INaCa_ss; // microA_per_microF
        const double var_chaste_interface__IKr__IKr = var_IKr__IKr; // microA_per_microF
        const double var_chaste_interface__IpCa__IpCa = var_IpCa__IpCa; // microA_per_microF
        var_chaste_interface__i_ionic = (var_chaste_interface__INa__INa + var_chaste_interface__INaL__INaL + var_Ito__Ito + var_chaste_interface__ICaL__ICaL + var_chaste_interface__ICaL__ICaNa + var_chaste_interface__ICaL__ICaK + var_chaste_interface__IKr__IKr + var_chaste_interface__IKs__IKs + var_chaste_interface__IK1__IK1 + var_chaste_interface__INaCa_i__INaCa_i + var_chaste_interface__INaCa_i__INaCa_ss + var_chaste_interface__INaK__INaK + var_chaste_interface__INab__INab + var_chaste_interface__IKb__IKb + var_chaste_interface__IpCa__IpCa + var_chaste_interface__ICab__ICab) * HeartConfig::Instance()->GetCapacitance(); // uA_per_cm2
        
        const double i_ionic = var_chaste_interface__i_ionic;
        if (made_new_cvode_vector)
        {
            DeleteVector(rY);
        }
        EXCEPT_IF_NOT(!std::isnan(i_ionic));
        return i_ionic;
    }
    
    void Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::EvaluateYDerivatives(double var_chaste_interface__environment__time, const N_Vector rY, N_Vector rDY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__v = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -87
        double var_chaste_interface__CaMK__CaMKt = NV_Ith_S(rY, 1);
        // Units: millimolar; Initial value: 0
        double var_chaste_interface__intracellular_ions__nai = NV_Ith_S(rY, 2);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__nass = NV_Ith_S(rY, 3);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__ki = NV_Ith_S(rY, 4);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__kss = NV_Ith_S(rY, 5);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__cass = NV_Ith_S(rY, 6);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__intracellular_ions__cansr = NV_Ith_S(rY, 7);
        // Units: millimolar; Initial value: 1.2
        double var_chaste_interface__intracellular_ions__cajsr = NV_Ith_S(rY, 8);
        // Units: millimolar; Initial value: 1.2
        double var_chaste_interface__intracellular_ions__cai = NV_Ith_S(rY, 9);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__INa__m = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INa__hf = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hs = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__j = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hsp = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__jp = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__mL = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INaL__hL = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__hLp = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__a = NV_Ith_S(rY, 19);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__Ito__iF = NV_Ith_S(rY, 20);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__iS = NV_Ith_S(rY, 21);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__ap = NV_Ith_S(rY, 22);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__Ito__iFp = NV_Ith_S(rY, 23);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__iSp = NV_Ith_S(rY, 24);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__d = NV_Ith_S(rY, 25);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__ICaL__ff = NV_Ith_S(rY, 26);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fs = NV_Ith_S(rY, 27);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcaf = NV_Ith_S(rY, 28);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcas = NV_Ith_S(rY, 29);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__jca = NV_Ith_S(rY, 30);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__ffp = NV_Ith_S(rY, 31);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcafp = NV_Ith_S(rY, 32);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__nca = NV_Ith_S(rY, 33);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrf = NV_Ith_S(rY, 34);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrs = NV_Ith_S(rY, 35);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs1 = NV_Ith_S(rY, 36);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs2 = NV_Ith_S(rY, 37);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IK1__xk1 = NV_Ith_S(rY, 38);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ryr__Jrelnp = NV_Ith_S(rY, 39);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__ryr__Jrelp = NV_Ith_S(rY, 40);
        // Units: dimensionless; Initial value: 0
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__v);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__v);
        
        // Mathematics
        double d_dt_chaste_interface__membrane__v;
        const double var_INa__h = (0.98999999999999999 * var_chaste_interface__INa__hf) + (0.010000000000000009 * var_chaste_interface__INa__hs); // dimensionless
        const double var_reversal_potentials__ENa = 26.712338705498265 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__intracellular_ions__nai); // millivolt
        const double var_CaMK__CaMKb = (0.050000000000000003 * (1.0 - var_chaste_interface__CaMK__CaMKt)) / (1.0 + (0.0015 / var_chaste_interface__intracellular_ions__cass)); // millimolar
        const double var_CaMK__CaMKa = var_CaMK__CaMKb + var_chaste_interface__CaMK__CaMKt; // millimolar
        const double var_INa__fINap = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_INa__INa = NV_Ith_S(mParameters, 10) * (var_chaste_interface__membrane__v - var_reversal_potentials__ENa) * pow(var_chaste_interface__INa__m, 3.0) * (((1.0 - var_INa__fINap) * var_INa__h * var_chaste_interface__INa__j) + (var_INa__fINap * ((0.98999999999999999 * var_chaste_interface__INa__hf) + (0.010000000000000009 * var_chaste_interface__INa__hsp)) * var_chaste_interface__INa__jp)); // microA_per_microF
        const double var_INaL__fINaLp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_INaL__INaL = NV_Ith_S(mParameters, 12) * (var_chaste_interface__membrane__v - var_reversal_potentials__ENa) * var_chaste_interface__INaL__mL * (((1.0 - var_INaL__fINaLp) * var_chaste_interface__INaL__hL) + (var_INaL__fINaLp * var_chaste_interface__INaL__hLp)); // microA_per_microF
        const double var_reversal_potentials__EK = 26.712338705498265 * log(NV_Ith_S(mParameters, 3) / var_chaste_interface__intracellular_ions__ki); // millivolt
        const double var_Ito__fItop = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_Ito__Ito = NV_Ith_S(mParameters, 17) * (var_chaste_interface__membrane__v - var_reversal_potentials__EK) * (((1.0 - var_Ito__fItop) * var_chaste_interface__Ito__a * ((_lt_0_row[181] * var_chaste_interface__Ito__iF) + (_lt_0_row[182] * var_chaste_interface__Ito__iS))) + (var_Ito__fItop * var_chaste_interface__Ito__ap * ((_lt_0_row[181] * var_chaste_interface__Ito__iFp) + (_lt_0_row[182] * var_chaste_interface__Ito__iSp)))); // microA_per_microF
        const double var_ICaL__fICaLp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_ICaL__fcap = (_lt_0_row[183] * var_chaste_interface__ICaL__fcafp) + (_lt_0_row[184] * var_chaste_interface__ICaL__fcas); // dimensionless
        const double var_ICaL__PCa = NV_Ith_S(mParameters, 5); // dimensionless
        const double var_ICaL__PCap = 1.1000000000000001 * var_ICaL__PCa; // dimensionless
        const double var_ICaL__fp = (0.59999999999999998 * var_chaste_interface__ICaL__ffp) + (0.40000000000000002 * var_chaste_interface__ICaL__fs); // dimensionless
        const double var_ICaL__PhiCaL = (4.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__cass * _lt_0_row[2]) - (0.34100000000000003 * NV_Ith_S(mParameters, 2)))) / _lt_0_row[185]; // dimensionless
        const double var_ICaL__f = (0.59999999999999998 * var_chaste_interface__ICaL__ff) + (0.40000000000000002 * var_chaste_interface__ICaL__fs); // dimensionless
        const double var_ICaL__fca = (_lt_0_row[183] * var_chaste_interface__ICaL__fcaf) + (_lt_0_row[184] * var_chaste_interface__ICaL__fcas); // dimensionless
        const double var_ICaL__ICaL = ((1.0 - var_ICaL__fICaLp) * var_ICaL__PCa * var_ICaL__PhiCaL * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * var_ICaL__PCap * var_ICaL__PhiCaL * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_ICaL__PhiCaNa = (1.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((0.75 * var_chaste_interface__intracellular_ions__nass * _lt_0_row[186]) - (0.75 * NV_Ith_S(mParameters, 4)))) / _lt_0_row[187]; // dimensionless
        const double var_ICaL__ICaNa = ((1.0 - var_ICaL__fICaLp) * (0.00125 * var_ICaL__PCa) * var_ICaL__PhiCaNa * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * (0.00125 * var_ICaL__PCap) * var_ICaL__PhiCaNa * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_ICaL__PhiCaK = (1.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((0.75 * var_chaste_interface__intracellular_ions__kss * _lt_0_row[186]) - (0.75 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[187]; // dimensionless
        const double var_ICaL__ICaK = ((1.0 - var_ICaL__fICaLp) * (0.00035740000000000001 * var_ICaL__PCa) * var_ICaL__PhiCaK * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * (0.00035740000000000001 * var_ICaL__PCap) * var_ICaL__PhiCaK * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_IKr__IKr = NV_Ith_S(mParameters, 13) * sqrt(NV_Ith_S(mParameters, 3) * 0.18518518518518517) * ((_lt_0_row[188] * var_chaste_interface__IKr__xrf) + (_lt_0_row[189] * var_chaste_interface__IKr__xrs)) * _lt_0_row[190] * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_IKs__IKs = NV_Ith_S(mParameters, 14) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__intracellular_ions__cai, 1.3999999999999999)))) * var_chaste_interface__IKs__xs1 * var_chaste_interface__IKs__xs2 * (var_chaste_interface__membrane__v - (26.712338705498265 * log((NV_Ith_S(mParameters, 3) + (0.018329999999999999 * NV_Ith_S(mParameters, 4))) / (var_chaste_interface__intracellular_ions__ki + (0.018329999999999999 * var_chaste_interface__intracellular_ions__nai))))); // microA_per_microF
        const double var_IK1__IK1 = NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 3)) * (1.0 / (1.0 + exp(((var_chaste_interface__membrane__v + 105.8) - (2.6000000000000001 * NV_Ith_S(mParameters, 3))) * 0.10534077741493732))) * var_chaste_interface__IK1__xk1 * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_INaCa_i__h1_i = 1.0 + ((var_chaste_interface__intracellular_ions__nai * 0.011348161597821153) * _lt_0_row[191]); // dimensionless
        const double var_INaCa_i__h2_i = (var_chaste_interface__intracellular_ions__nai * _lt_0_row[192]) / (88.120000000000005 * var_INaCa_i__h1_i); // dimensionless
        const double var_INaCa_i__k4pp_i = var_INaCa_i__h2_i * 5000.0; // dimensionless
        const double var_INaCa_i__h4_i = 1.0 + ((var_chaste_interface__intracellular_ions__nai * 0.066666666666666666) * (1.0 + (var_chaste_interface__intracellular_ions__nai * 0.20000000000000001))); // dimensionless
        const double var_INaCa_i__k7_i = ((var_chaste_interface__intracellular_ions__nai * var_chaste_interface__intracellular_ions__nai) / (var_INaCa_i__h4_i * 75.0)) * var_INaCa_i__h2_i * 60000.0; // dimensionless
        const double var_INaCa_i__h7_i = 1.0 + ((NV_Ith_S(mParameters, 4) * 0.011348161597821153) * _lt_0_row[193]); // dimensionless
        const double var_INaCa_i__h8_i = NV_Ith_S(mParameters, 4) / (88.120000000000005 * _lt_0_row[192] * var_INaCa_i__h7_i); // dimensionless
        const double var_INaCa_i__k3pp_i = var_INaCa_i__h8_i * 5000.0; // dimensionless
        const double var_INaCa_i__h10_i = ((NV_Ith_S(mParameters, 4) * 0.066666666666666666) * (1.0 + (NV_Ith_S(mParameters, 4) * 0.20000000000000001))) + 13.5; // dimensionless
        const double var_INaCa_i__k8_i = var_INaCa_i__h8_i * ((NV_Ith_S(mParameters, 4) * NV_Ith_S(mParameters, 4)) / (var_INaCa_i__h10_i * 75.0)) * 60000.0; // dimensionless
        const double var_INaCa_i__k1_i = (1.0 / var_INaCa_i__h10_i) * NV_Ith_S(mParameters, 2) * 1500000.0; // dimensionless
        const double var_INaCa_i__k4_i = (((1.0 / var_INaCa_i__h1_i) * 60000.0) / _lt_0_row[194]) + var_INaCa_i__k4pp_i; // dimensionless
        const double var_INaCa_i__k3_i = ((1.0 / var_INaCa_i__h7_i) * 60000.0) + var_INaCa_i__k3pp_i; // dimensionless
        const double var_INaCa_i__x4_i = (5000.0 * var_INaCa_i__k8_i * (var_INaCa_i__k4_i + 5000.0)) + (var_INaCa_i__k3_i * 5000.0 * (var_INaCa_i__k1_i + var_INaCa_i__k8_i)); // dimensionless
        const double var_INaCa_i__k6_i = (1.0 / var_INaCa_i__h4_i) * var_chaste_interface__intracellular_ions__cai * 1500000.0; // dimensionless
        const double var_INaCa_i__x3_i = (var_INaCa_i__k1_i * var_INaCa_i__k3_i * (var_INaCa_i__k7_i + var_INaCa_i__k6_i)) + (var_INaCa_i__k8_i * var_INaCa_i__k6_i * (5000.0 + var_INaCa_i__k3_i)); // dimensionless
        const double var_INaCa_i__x2_i = (var_INaCa_i__k1_i * var_INaCa_i__k7_i * (var_INaCa_i__k4_i + 5000.0)) + (var_INaCa_i__k4_i * var_INaCa_i__k6_i * (var_INaCa_i__k1_i + var_INaCa_i__k8_i)); // dimensionless
        const double var_INaCa_i__x1_i = (5000.0 * var_INaCa_i__k4_i * (var_INaCa_i__k7_i + var_INaCa_i__k6_i)) + (5000.0 * var_INaCa_i__k7_i * (5000.0 + var_INaCa_i__k3_i)); // dimensionless
        const double var_INaCa_i__E1_i = var_INaCa_i__x1_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i); // dimensionless
        const double var_INaCa_i__E2_i = var_INaCa_i__x2_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i); // dimensionless
        const double var_INaCa_i__Gncx = NV_Ith_S(mParameters, 15); // milliS_per_microF
        const double var_INaCa_i__INaCa_i = 0.80000000000000004 * var_INaCa_i__Gncx * (1.0 / (1.0 + pow(0.00014999999999999999 / var_chaste_interface__intracellular_ions__cai, 2.0))) * ((1.0 * (((3.0 * (((var_INaCa_i__x4_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i)) * var_INaCa_i__k7_i) - (var_INaCa_i__E1_i * var_INaCa_i__k8_i))) + ((var_INaCa_i__x3_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i)) * var_INaCa_i__k4pp_i)) - (var_INaCa_i__E2_i * var_INaCa_i__k3pp_i))) + (2.0 * ((var_INaCa_i__E2_i * 5000.0) - (var_INaCa_i__E1_i * var_INaCa_i__k1_i)))); // microA_per_microF
        const double var_INaCa_i__h1_ss = 1.0 + ((var_chaste_interface__intracellular_ions__nass * 0.011348161597821153) * _lt_0_row[191]); // dimensionless
        const double var_INaCa_i__h2_ss = (var_chaste_interface__intracellular_ions__nass * _lt_0_row[192]) / (88.120000000000005 * var_INaCa_i__h1_ss); // dimensionless
        const double var_INaCa_i__k4pp_ss = var_INaCa_i__h2_ss * 5000.0; // dimensionless
        const double var_INaCa_i__k4_ss = (((1.0 / var_INaCa_i__h1_ss) * 60000.0) / _lt_0_row[194]) + var_INaCa_i__k4pp_ss; // dimensionless
        const double var_INaCa_i__h10_ss = ((NV_Ith_S(mParameters, 4) * 0.066666666666666666) * (1.0 + (NV_Ith_S(mParameters, 4) * 0.20000000000000001))) + 13.5; // dimensionless
        const double var_INaCa_i__h7_ss = 1.0 + ((NV_Ith_S(mParameters, 4) * 0.011348161597821153) * _lt_0_row[193]); // dimensionless
        const double var_INaCa_i__h8_ss = NV_Ith_S(mParameters, 4) / (88.120000000000005 * _lt_0_row[192] * var_INaCa_i__h7_ss); // dimensionless
        const double var_INaCa_i__k8_ss = var_INaCa_i__h8_ss * ((NV_Ith_S(mParameters, 4) * NV_Ith_S(mParameters, 4)) / (var_INaCa_i__h10_ss * 75.0)) * 60000.0; // dimensionless
        const double var_INaCa_i__h4_ss = 1.0 + ((var_chaste_interface__intracellular_ions__nass * 0.066666666666666666) * (1.0 + (var_chaste_interface__intracellular_ions__nass * 0.20000000000000001))); // dimensionless
        const double var_INaCa_i__k6_ss = (1.0 / var_INaCa_i__h4_ss) * var_chaste_interface__intracellular_ions__cass * 1500000.0; // dimensionless
        const double var_INaCa_i__k1_ss = (1.0 / var_INaCa_i__h10_ss) * NV_Ith_S(mParameters, 2) * 1500000.0; // dimensionless
        const double var_INaCa_i__k7_ss = ((var_chaste_interface__intracellular_ions__nass * var_chaste_interface__intracellular_ions__nass) / (var_INaCa_i__h4_ss * 75.0)) * var_INaCa_i__h2_ss * 60000.0; // dimensionless
        const double var_INaCa_i__x2_ss = (var_INaCa_i__k1_ss * var_INaCa_i__k7_ss * (var_INaCa_i__k4_ss + 5000.0)) + (var_INaCa_i__k4_ss * var_INaCa_i__k6_ss * (var_INaCa_i__k1_ss + var_INaCa_i__k8_ss)); // dimensionless
        const double var_INaCa_i__k3pp_ss = var_INaCa_i__h8_ss * 5000.0; // dimensionless
        const double var_INaCa_i__k3_ss = ((1.0 / var_INaCa_i__h7_ss) * 60000.0) + var_INaCa_i__k3pp_ss; // dimensionless
        const double var_INaCa_i__x3_ss = (var_INaCa_i__k1_ss * var_INaCa_i__k3_ss * (var_INaCa_i__k7_ss + var_INaCa_i__k6_ss)) + (var_INaCa_i__k8_ss * var_INaCa_i__k6_ss * (5000.0 + var_INaCa_i__k3_ss)); // dimensionless
        const double var_INaCa_i__x1_ss = (5000.0 * var_INaCa_i__k4_ss * (var_INaCa_i__k7_ss + var_INaCa_i__k6_ss)) + (5000.0 * var_INaCa_i__k7_ss * (5000.0 + var_INaCa_i__k3_ss)); // dimensionless
        const double var_INaCa_i__x4_ss = (5000.0 * var_INaCa_i__k8_ss * (var_INaCa_i__k4_ss + 5000.0)) + (var_INaCa_i__k3_ss * 5000.0 * (var_INaCa_i__k1_ss + var_INaCa_i__k8_ss)); // dimensionless
        const double var_INaCa_i__E2_ss = var_INaCa_i__x2_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss); // dimensionless
        const double var_INaCa_i__E1_ss = var_INaCa_i__x1_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss); // dimensionless
        const double var_INaCa_i__INaCa_ss = 0.20000000000000001 * var_INaCa_i__Gncx * (1.0 / (1.0 + pow(0.00014999999999999999 / var_chaste_interface__intracellular_ions__cass, 2.0))) * ((1.0 * (((3.0 * (((var_INaCa_i__x4_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss)) * var_INaCa_i__k7_ss) - (var_INaCa_i__E1_ss * var_INaCa_i__k8_ss))) + ((var_INaCa_i__x3_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss)) * var_INaCa_i__k4pp_ss)) - (var_INaCa_i__E2_ss * var_INaCa_i__k3pp_ss))) + (2.0 * ((var_INaCa_i__E2_ss * 5000.0) - (var_INaCa_i__E1_ss * var_INaCa_i__k1_ss)))); // microA_per_microF
        const double var_INaK__b3 = ((4.2000000000000002 / ((var_chaste_interface__intracellular_ions__nai * 0.004464285714285714) + (var_chaste_interface__intracellular_ions__ki * 0.0034246575342465752) + 1.5889281507656066)) * 0.0079299999999999995) * 1.732653031203624e-08; // dimensionless
        const double var_INaK__a3 = (1899.0 * pow(NV_Ith_S(mParameters, 3) * 2.7917364600781687, 2.0)) / ((pow(1.0 + (NV_Ith_S(mParameters, 4) / _lt_0_row[196]), 3.0) + pow(1.0 + (NV_Ith_S(mParameters, 3) * 2.7917364600781687), 2.0)) - 1.0); // dimensionless
        const double var_INaK__b2 = (39.399999999999999 * pow(NV_Ith_S(mParameters, 4) / _lt_0_row[196], 3.0)) / ((pow(1.0 + (NV_Ith_S(mParameters, 4) / _lt_0_row[196]), 3.0) + pow(1.0 + (NV_Ith_S(mParameters, 3) * 2.7917364600781687), 2.0)) - 1.0); // dimensionless
        const double var_INaK__x3 = (var_INaK__a3 * 439120.79239156022) + (var_INaK__b3 * var_INaK__b2 * 9.120000000000001) + (var_INaK__b2 * 5827.679899026527) + (var_INaK__a3 * 5827.679899026527); // dimensionless
        const double var_INaK__b4 = (40.0 * pow(var_chaste_interface__intracellular_ions__ki * 2.0, 2.0)) / ((pow(1.0 + (var_chaste_interface__intracellular_ions__nai / _lt_0_row[195]), 3.0) + pow(1.0 + (var_chaste_interface__intracellular_ions__ki * 2.0), 2.0)) - 1.0); // dimensionless
        const double var_INaK__a1 = (949.5 * pow(var_chaste_interface__intracellular_ions__nai / _lt_0_row[195], 3.0)) / ((pow(1.0 + (var_chaste_interface__intracellular_ions__nai / _lt_0_row[195]), 3.0) + pow(1.0 + (var_chaste_interface__intracellular_ions__ki * 2.0), 2.0)) - 1.0); // dimensionless
        const double var_INaK__x2 = (var_INaK__b2 * 9.120000000000001 * var_INaK__b4) + (var_INaK__a1 * 687.20000000000005 * var_INaK__a3) + (var_INaK__a3 * 9.120000000000001 * var_INaK__b4) + (687.20000000000005 * var_INaK__a3 * var_INaK__b4); // dimensionless
        const double var_INaK__x1 = (var_INaK__a1 * 439120.79239156022) + (var_INaK__b2 * var_INaK__b4 * var_INaK__b3) + (687.20000000000005 * var_INaK__b4 * var_INaK__b3) + (var_INaK__b3 * var_INaK__a1 * 687.20000000000005); // dimensionless
        const double var_INaK__x4 = (var_INaK__b4 * var_INaK__b3 * var_INaK__b2) + (var_INaK__a3 * 638.99998892834719 * var_INaK__a1) + (var_INaK__b2 * 638.99998892834719 * var_INaK__a1) + (var_INaK__b3 * var_INaK__b2 * var_INaK__a1); // dimensionless
        const double var_INaK__INaK = NV_Ith_S(mParameters, 16) * ((1.0 * (3.0 * (((var_INaK__x1 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__a3) - ((var_INaK__x2 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__b3)))) + (1.0 * (2.0 * (((var_INaK__x4 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * 9.120000000000001) - ((var_INaK__x3 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__a1))))); // microA_per_microF
        const double var_INab__INab = (NV_Ith_S(mParameters, 8) * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__nai * _lt_0_row[0]) - NV_Ith_S(mParameters, 4))) / _lt_0_row[198]; // microA_per_microF
        const double var_IKb__IKb = NV_Ith_S(mParameters, 7) * _lt_0_row[197] * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 9) * var_chaste_interface__intracellular_ions__cai) / (0.00050000000000000001 + var_chaste_interface__intracellular_ions__cai); // microA_per_microF
        const double var_ICab__ICab = (NV_Ith_S(mParameters, 6) * 4.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__cai * _lt_0_row[2]) - (0.34100000000000003 * NV_Ith_S(mParameters, 2)))) / _lt_0_row[185]; // microA_per_microF
        var_chaste_interface__membrane__Istim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_diff__JdiffNa = (var_chaste_interface__intracellular_ions__nass - var_chaste_interface__intracellular_ions__nai) * 0.5; // millimolar_per_millisecond
        const double var_diff__Jdiff = (var_chaste_interface__intracellular_ions__cass - var_chaste_interface__intracellular_ions__cai) * 5.0; // millimolar_per_millisecond
        const double var_SERCA__fJupp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_SERCA__Jup = NV_Ith_S(mParameters, 1) * ((((1.0 - var_SERCA__fJupp) * ((var_chaste_interface__intracellular_ions__cai * 0.0043750000000000004) / (var_chaste_interface__intracellular_ions__cai + 0.00092000000000000003))) + (var_SERCA__fJupp * ((var_chaste_interface__intracellular_ions__cai * 0.01203125) / ((var_chaste_interface__intracellular_ions__cai + 0.00092000000000000003) - 0.00017000000000000001)))) - ((0.0039375 * var_chaste_interface__intracellular_ions__cansr) * 0.066666666666666666)); // millimolar_per_millisecond
        const double var_diff__JdiffK = (var_chaste_interface__intracellular_ions__kss - var_chaste_interface__intracellular_ions__ki) * 0.5; // millimolar_per_millisecond
        const double var_ryr__fJrelp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_ryr__Jrel = NV_Ith_S(mParameters, 0) * (((1.0 - var_ryr__fJrelp) * var_chaste_interface__ryr__Jrelnp) + (var_ryr__fJrelp * var_chaste_interface__ryr__Jrelp)); // millimolar_per_millisecond
        const double var_trans_flux__Jtr = (var_chaste_interface__intracellular_ions__cansr - var_chaste_interface__intracellular_ions__cajsr) * 0.01; // millimolar_per_millisecond
        const double var_ICaL__km2n = var_chaste_interface__ICaL__jca * 1.0; // per_millisecond
        const double var_ryr__tau_rel_temp = 4.75 / (1.0 + (0.0123 / var_chaste_interface__intracellular_ions__cajsr)); // millisecond
        const double var_ryr__tau_relp_temp = 5.9375 / (1.0 + (0.0123 / var_chaste_interface__intracellular_ions__cajsr)); // millisecond
        const double d_dt_chaste_interface__CaMK__CaMKt = (0.050000000000000003 * var_CaMK__CaMKb * (var_CaMK__CaMKb + var_chaste_interface__CaMK__CaMKt)) - (0.00068000000000000005 * var_chaste_interface__CaMK__CaMKt); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__intracellular_ions__nai = (((-(var_INa__INa + var_INaL__INaL + (3.0 * var_INaCa_i__INaCa_i) + (3.0 * var_INaK__INaK) + var_INab__INab)) * 0.00015335760000000003) * 0.40115874845699667) + ((var_diff__JdiffNa * 7.5988000000000021e-07) * 38705.801844873327); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__intracellular_ions__nass = (((-(var_ICaL__ICaNa + (3.0 * var_INaCa_i__INaCa_ss))) * 0.00015335760000000003) * 13.639397447537888) - var_diff__JdiffNa; // 'millimole per litre per millisecond'
        //const double d_dt_chaste_interface__intracellular_ions__ki = (((-((var_Ito__Ito + var_IKr__IKr + var_IKs__IKs + var_IK1__IK1 + var_IKb__IKb + (var_chaste_interface__membrane__Istim / HeartConfig::Instance()->GetCapacitance())) - (2.0 * var_INaK__INaK))) * 0.00015335760000000003) * 0.40115874845699667) + ((var_diff__JdiffK * 7.5988000000000021e-07) * 38705.801844873327); // 'millimole per litre per millisecond' // RJ
        const double d_dt_chaste_interface__intracellular_ions__kss = (((-var_ICaL__ICaK) * 0.00015335760000000003) * 13.639397447537888) - var_diff__JdiffK; // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__intracellular_ions__cass = (1.0 / (1.0 + (4.0890000000000003e-05 / pow(0.00087000000000000001 + var_chaste_interface__intracellular_ions__cass, 2.0)) + (0.0097788000000000007 / pow(0.0086999999999999994 + var_chaste_interface__intracellular_ions__cass, 2.0)))) * (((((-(var_ICaL__ICaL - (2.0 * var_INaCa_i__INaCa_ss))) * 0.00015335760000000003) * 6.8196987237689441) + ((var_ryr__Jrel * 1.8237120000000002e-07) * 1315997.2627256932)) - var_diff__Jdiff); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__intracellular_ions__cansr = var_SERCA__Jup - ((var_trans_flux__Jtr * 1.8237120000000002e-07) * 476810.60243684537); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__intracellular_ions__cajsr = (1.0 / (1.0 + (8.0 / pow(0.80000000000000004 + var_chaste_interface__intracellular_ions__cajsr, 2.0)))) * (var_trans_flux__Jtr - var_ryr__Jrel); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__intracellular_ions__cai = (1.0 / (1.0 + (0.00011900000000000002 / pow(0.0023800000000000002 + var_chaste_interface__intracellular_ions__cai, 2.0)) + (3.5000000000000004e-05 / pow(0.00050000000000000001 + var_chaste_interface__intracellular_ions__cai, 2.0)))) * (((((-((var_IpCa__IpCa + var_ICab__ICab) - (2.0 * var_INaCa_i__INaCa_i))) * 0.00015335760000000003) * 0.20057937422849834) - ((var_SERCA__Jup * 2.0972688000000006e-06) * 38705.801844873327)) + ((var_diff__Jdiff * 7.5988000000000021e-07) * 38705.801844873327)); // 'millimole per litre per millisecond'
        const double d_dt_chaste_interface__INa__m = (_lt_0_row[199] - var_chaste_interface__INa__m) / _lt_0_row[200]; // per_millisecond
        const double d_dt_chaste_interface__INa__hf = (_lt_0_row[136] - var_chaste_interface__INa__hf) / _lt_0_row[201]; // per_millisecond
        const double d_dt_chaste_interface__INa__hs = (_lt_0_row[136] - var_chaste_interface__INa__hs) / _lt_0_row[202]; // per_millisecond
        const double d_dt_chaste_interface__INa__j = (_lt_0_row[136] - var_chaste_interface__INa__j) / _lt_0_row[203]; // per_millisecond
        const double d_dt_chaste_interface__INa__hsp = (_lt_0_row[204] - var_chaste_interface__INa__hsp) / _lt_0_row[205]; // per_millisecond
        const double d_dt_chaste_interface__INa__jp = (_lt_0_row[136] - var_chaste_interface__INa__jp) / _lt_0_row[206]; // per_millisecond
        const double d_dt_chaste_interface__INaL__mL = (_lt_0_row[207] - var_chaste_interface__INaL__mL) / _lt_0_row[200]; // per_millisecond
        const double d_dt_chaste_interface__INaL__hL = (_lt_0_row[208] - var_chaste_interface__INaL__hL) * 0.0050000000000000001; // per_millisecond
        const double d_dt_chaste_interface__INaL__hLp = (_lt_0_row[209] - var_chaste_interface__INaL__hLp) * 0.0016666666666666668; // per_millisecond
        const double d_dt_chaste_interface__Ito__a = (_lt_0_row[210] - var_chaste_interface__Ito__a) / _lt_0_row[211]; // per_millisecond
        const double d_dt_chaste_interface__Ito__iF = (_lt_0_row[212] - var_chaste_interface__Ito__iF) / _lt_0_row[213]; // per_millisecond
        const double d_dt_chaste_interface__Ito__iS = (_lt_0_row[212] - var_chaste_interface__Ito__iS) / _lt_0_row[214]; // per_millisecond
        const double d_dt_chaste_interface__Ito__ap = (_lt_0_row[215] - var_chaste_interface__Ito__ap) / _lt_0_row[211]; // per_millisecond
        const double d_dt_chaste_interface__Ito__iFp = (_lt_0_row[212] - var_chaste_interface__Ito__iFp) / _lt_0_row[216]; // per_millisecond
        const double d_dt_chaste_interface__Ito__iSp = (_lt_0_row[212] - var_chaste_interface__Ito__iSp) / _lt_0_row[217]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__d = (_lt_0_row[218] - var_chaste_interface__ICaL__d) / _lt_0_row[219]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__ff = (_lt_0_row[220] - var_chaste_interface__ICaL__ff) / _lt_0_row[221]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__fs = (_lt_0_row[220] - var_chaste_interface__ICaL__fs) / _lt_0_row[222]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__fcaf = (_lt_0_row[220] - var_chaste_interface__ICaL__fcaf) / _lt_0_row[223]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__fcas = (_lt_0_row[220] - var_chaste_interface__ICaL__fcas) / _lt_0_row[224]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__jca = (_lt_0_row[220] - var_chaste_interface__ICaL__jca) * 0.013333333333333334; // per_millisecond
        const double d_dt_chaste_interface__ICaL__ffp = (_lt_0_row[220] - var_chaste_interface__ICaL__ffp) / _lt_0_row[225]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__fcafp = (_lt_0_row[220] - var_chaste_interface__ICaL__fcafp) / _lt_0_row[226]; // per_millisecond
        const double d_dt_chaste_interface__ICaL__nca = ((1.0 / ((1000.0 / var_ICaL__km2n) + pow(1.0 + (0.002 / var_chaste_interface__intracellular_ions__cass), 4.0))) * 1000.0) - (var_chaste_interface__ICaL__nca * var_ICaL__km2n); // per_millisecond
        const double d_dt_chaste_interface__IKr__xrf = (_lt_0_row[227] - var_chaste_interface__IKr__xrf) / _lt_0_row[228]; // per_millisecond
        const double d_dt_chaste_interface__IKr__xrs = (_lt_0_row[227] - var_chaste_interface__IKr__xrs) / _lt_0_row[229]; // per_millisecond
        const double d_dt_chaste_interface__IKs__xs1 = (_lt_0_row[230] - var_chaste_interface__IKs__xs1) / _lt_0_row[231]; // per_millisecond
        const double d_dt_chaste_interface__IKs__xs2 = (_lt_0_row[230] - var_chaste_interface__IKs__xs2) / _lt_0_row[232]; // per_millisecond
        const double d_dt_chaste_interface__IK1__xk1 = ((1.0 / (1.0 + exp((-(var_chaste_interface__membrane__v + (2.5537999999999998 * NV_Ith_S(mParameters, 3)) + 144.59)) / ((1.5691999999999999 * NV_Ith_S(mParameters, 3)) + 3.8115000000000001)))) - var_chaste_interface__IK1__xk1) / _lt_0_row[233]; // per_millisecond
        const double d_dt_chaste_interface__ryr__Jrelnp = (((2.375 * (-var_ICaL__ICaL)) / (1.0 + (1.0 * pow(1.5 / var_chaste_interface__intracellular_ions__cajsr, 8.0)))) - var_chaste_interface__ryr__Jrelnp) / ((var_ryr__tau_rel_temp < 0.001) ? 0.001 : var_ryr__tau_rel_temp); // per_millisecond
        const double d_dt_chaste_interface__ryr__Jrelp = (((2.96875 * (-var_ICaL__ICaL)) / (1.0 + pow(1.5 / var_chaste_interface__intracellular_ions__cajsr, 8.0))) - var_chaste_interface__ryr__Jrelp) / ((var_ryr__tau_relp_temp < 0.001) ? 0.001 : var_ryr__tau_relp_temp); // per_millisecond
        
        double var_data_clamp_current__i_data = 0; // RJ
        if (mDataClampIsOn)
        {
            double interpolated_data_voltage = GetExperimentalVoltageAtTimeT(var_chaste_interface__environment__time);
            var_data_clamp_current__i_data = NV_Ith_S(mParameters, 18) * (var_chaste_interface__membrane__v - interpolated_data_voltage);
        }

        if (mSetVoltageDerivativeToZero)
        {
            d_dt_chaste_interface__membrane__v = 0.0;
        }
        else // RJ
        {
            d_dt_chaste_interface__membrane__v = -(var_data_clamp_current__i_data + var_INa__INa + var_INaL__INaL + var_Ito__Ito + var_ICaL__ICaL + var_ICaL__ICaNa + var_ICaL__ICaK + var_IKr__IKr + var_IKs__IKs + var_IK1__IK1 + var_INaCa_i__INaCa_i + var_INaCa_i__INaCa_ss + var_INaK__INaK + var_INab__INab + var_IKb__IKb + var_IpCa__IpCa + var_ICab__ICab + (var_chaste_interface__membrane__Istim / HeartConfig::Instance()->GetCapacitance())); // 'millivolt per millisecond'
        }
        
        NV_Ith_S(rDY, 0) = d_dt_chaste_interface__membrane__v;
        NV_Ith_S(rDY, 1) = d_dt_chaste_interface__CaMK__CaMKt;
        NV_Ith_S(rDY, 2) = d_dt_chaste_interface__intracellular_ions__nai;
        NV_Ith_S(rDY, 3) = d_dt_chaste_interface__intracellular_ions__nass;
        //NV_Ith_S(rDY, 4) = d_dt_chaste_interface__intracellular_ions__ki;
        NV_Ith_S(rDY, 4) = 0; // RJ
        NV_Ith_S(rDY, 5) = d_dt_chaste_interface__intracellular_ions__kss;
        NV_Ith_S(rDY, 6) = d_dt_chaste_interface__intracellular_ions__cass;
        NV_Ith_S(rDY, 7) = d_dt_chaste_interface__intracellular_ions__cansr;
        NV_Ith_S(rDY, 8) = d_dt_chaste_interface__intracellular_ions__cajsr;
        NV_Ith_S(rDY, 9) = d_dt_chaste_interface__intracellular_ions__cai;
        NV_Ith_S(rDY, 10) = d_dt_chaste_interface__INa__m;
        NV_Ith_S(rDY, 11) = d_dt_chaste_interface__INa__hf;
        NV_Ith_S(rDY, 12) = d_dt_chaste_interface__INa__hs;
        NV_Ith_S(rDY, 13) = d_dt_chaste_interface__INa__j;
        NV_Ith_S(rDY, 14) = d_dt_chaste_interface__INa__hsp;
        NV_Ith_S(rDY, 15) = d_dt_chaste_interface__INa__jp;
        NV_Ith_S(rDY, 16) = d_dt_chaste_interface__INaL__mL;
        NV_Ith_S(rDY, 17) = d_dt_chaste_interface__INaL__hL;
        NV_Ith_S(rDY, 18) = d_dt_chaste_interface__INaL__hLp;
        NV_Ith_S(rDY, 19) = d_dt_chaste_interface__Ito__a;
        NV_Ith_S(rDY, 20) = d_dt_chaste_interface__Ito__iF;
        NV_Ith_S(rDY, 21) = d_dt_chaste_interface__Ito__iS;
        NV_Ith_S(rDY, 22) = d_dt_chaste_interface__Ito__ap;
        NV_Ith_S(rDY, 23) = d_dt_chaste_interface__Ito__iFp;
        NV_Ith_S(rDY, 24) = d_dt_chaste_interface__Ito__iSp;
        NV_Ith_S(rDY, 25) = d_dt_chaste_interface__ICaL__d;
        NV_Ith_S(rDY, 26) = d_dt_chaste_interface__ICaL__ff;
        NV_Ith_S(rDY, 27) = d_dt_chaste_interface__ICaL__fs;
        NV_Ith_S(rDY, 28) = d_dt_chaste_interface__ICaL__fcaf;
        NV_Ith_S(rDY, 29) = d_dt_chaste_interface__ICaL__fcas;
        NV_Ith_S(rDY, 30) = d_dt_chaste_interface__ICaL__jca;
        NV_Ith_S(rDY, 31) = d_dt_chaste_interface__ICaL__ffp;
        NV_Ith_S(rDY, 32) = d_dt_chaste_interface__ICaL__fcafp;
        NV_Ith_S(rDY, 33) = d_dt_chaste_interface__ICaL__nca;
        NV_Ith_S(rDY, 34) = d_dt_chaste_interface__IKr__xrf;
        NV_Ith_S(rDY, 35) = d_dt_chaste_interface__IKr__xrs;
        NV_Ith_S(rDY, 36) = d_dt_chaste_interface__IKs__xs1;
        NV_Ith_S(rDY, 37) = d_dt_chaste_interface__IKs__xs2;
        NV_Ith_S(rDY, 38) = d_dt_chaste_interface__IK1__xk1;
        NV_Ith_S(rDY, 39) = d_dt_chaste_interface__ryr__Jrelnp;
        NV_Ith_S(rDY, 40) = d_dt_chaste_interface__ryr__Jrelp;
    }
    
    void Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::EvaluateAnalyticJacobian(long int N, double var_chaste_interface__environment__time, N_Vector rY, N_Vector rDY, CHASTE_CVODE_DENSE_MATRIX rJacobian, N_Vector rTmp1, N_Vector rTmp2, N_Vector rTmp3)
    {
        assert(false); // RJ
        double var_chaste_interface__membrane__v = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -87
        double var_chaste_interface__CaMK__CaMKt = NV_Ith_S(rY, 1);
        // Units: millimolar; Initial value: 0
        double var_chaste_interface__intracellular_ions__nai = NV_Ith_S(rY, 2);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__nass = NV_Ith_S(rY, 3);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__ki = NV_Ith_S(rY, 4);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__kss = NV_Ith_S(rY, 5);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__cass = NV_Ith_S(rY, 6);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__intracellular_ions__cansr = NV_Ith_S(rY, 7);
        // Units: millimolar; Initial value: 1.2
        double var_chaste_interface__intracellular_ions__cajsr = NV_Ith_S(rY, 8);
        // Units: millimolar; Initial value: 1.2
        double var_chaste_interface__intracellular_ions__cai = NV_Ith_S(rY, 9);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__INa__m = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INa__hf = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hs = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__j = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hsp = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__jp = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__mL = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INaL__hL = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__hLp = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__a = NV_Ith_S(rY, 19);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__Ito__iF = NV_Ith_S(rY, 20);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__iS = NV_Ith_S(rY, 21);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__ap = NV_Ith_S(rY, 22);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__Ito__iFp = NV_Ith_S(rY, 23);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__Ito__iSp = NV_Ith_S(rY, 24);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__d = NV_Ith_S(rY, 25);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__ICaL__ff = NV_Ith_S(rY, 26);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fs = NV_Ith_S(rY, 27);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcaf = NV_Ith_S(rY, 28);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcas = NV_Ith_S(rY, 29);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__jca = NV_Ith_S(rY, 30);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__ffp = NV_Ith_S(rY, 31);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcafp = NV_Ith_S(rY, 32);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__nca = NV_Ith_S(rY, 33);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrf = NV_Ith_S(rY, 34);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrs = NV_Ith_S(rY, 35);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs1 = NV_Ith_S(rY, 36);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs2 = NV_Ith_S(rY, 37);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IK1__xk1 = NV_Ith_S(rY, 38);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ryr__Jrelnp = NV_Ith_S(rY, 39);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__ryr__Jrelp = NV_Ith_S(rY, 40);
        // Units: dimensionless; Initial value: 0
        
        // Lookup table indexing
        const bool _oob_0 = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__v);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__v);
        
        var_chaste_interface__environment__fake_dt = 1.0; // millisecond
        const double var_t6 = pow(NV_Ith_S(mParameters, 3), 0.5); // dimensionless
        const double var_t7 = NV_Ith_S(mParameters, 11) * var_t6; // dimensionless
        const double var_t11 = exp(((0.1053407774 * var_chaste_interface__membrane__v) + 11.145054249999999) - (0.2738860212 * NV_Ith_S(mParameters, 3))); // dimensionless
        const double var_t12 = 1.0 + var_t11; // dimensionless
        const double var_t18 = 1.0 / var_chaste_interface__intracellular_ions__ki; // dimensionless
        const double var_t23 = var_chaste_interface__membrane__v - (26.712338705498265 * log(NV_Ith_S(mParameters, 3) * var_t18)); // dimensionless
        const double var_t27 = ((((0.1053407774 * var_t7) / pow(var_t12, 2.0)) * var_chaste_interface__IK1__xk1) * var_t23) * var_t11; // dimensionless
        const double var_t38 = (var_chaste_interface__intracellular_ions__nai * _lt_0_row[0]) - NV_Ith_S(mParameters, 4); // dimensionless
        const double var_t43 = ((((NV_Ith_S(mParameters, 8) * 9309355225.0) * 0.00012027904738994468) * 0.0032258064516129032) * var_t38) * _lt_0_row[1]; // dimensionless
        const double var_t49 = 0.34100000000000003 * NV_Ith_S(mParameters, 2); // dimensionless
        const double var_t50 = (var_chaste_interface__intracellular_ions__cai * _lt_0_row[2]) - var_t49; // dimensionless
        const double var_t56 = (((((4.0 * NV_Ith_S(mParameters, 6)) * 9309355225.0) * 0.00012027904738994468) * 0.0032258064516129032) * var_t50) * _lt_0_row[3]; // dimensionless
        const double var_t57 = 1.0 / var_t12; // dimensionless
        const double var_t59 = (var_t7 * var_t57) * var_chaste_interface__IK1__xk1; // dimensionless
        const double var_t61 = NV_Ith_S(mParameters, 14); // dimensionless
        const double var_t62 = 1.0 / var_chaste_interface__intracellular_ions__cai; // dimensionless
        const double var_t65 = 1.0 + (6.481821026e-07 * pow(var_t62, 1.3999999999999999)); // dimensionless
        const double var_t69 = var_t61 * (1.0 + (0.59999999999999998 / var_t65)); // dimensionless
        const double var_t71 = (var_t69 * var_chaste_interface__IKs__xs1) * var_chaste_interface__IKs__xs2; // dimensionless
        const double var_t73 = NV_Ith_S(mParameters, 7); // dimensionless
        const double var_t83 = (((0.054525627040000003 * var_t73) / _lt_0_row[4]) * var_t23) * _lt_0_row[5]; // dimensionless
        const double var_t85 = NV_Ith_S(mParameters, 17); // dimensionless
        const double var_t86 = 1.0 - var_chaste_interface__CaMK__CaMKt; // dimensionless
        const double var_t87 = 0.050000000000000003 * var_t86; // dimensionless
        const double var_t88 = 1.0 / var_chaste_interface__intracellular_ions__cass; // dimensionless
        const double var_t90 = 1.0 + (0.0015 * var_t88); // dimensionless
        const double var_t91 = 1.0 / var_t90; // dimensionless
        const double var_t93 = (var_t87 * var_t91) + var_chaste_interface__CaMK__CaMKt; // dimensionless
        const double var_t96 = 1.0 + (0.14999999999999999 / var_t93); // dimensionless
        const double var_t97 = 1.0 / var_t96; // dimensionless
        const double var_t98 = 1.0 - var_t97; // dimensionless
        const double var_t99 = var_t98 * var_chaste_interface__Ito__a; // dimensionless
        const double var_t108 = (_lt_0_row[6] * var_chaste_interface__Ito__iF) + (_lt_0_row[7] * var_chaste_interface__Ito__iS); // dimensionless
        const double var_t110 = var_t97 * var_chaste_interface__Ito__ap; // dimensionless
        const double var_t113 = (_lt_0_row[6] * var_chaste_interface__Ito__iFp) + (_lt_0_row[7] * var_chaste_interface__Ito__iSp); // dimensionless
        const double var_t115 = (var_t99 * var_t108) + (var_t110 * var_t113); // dimensionless
        const double var_t116 = var_t85 * var_t115; // dimensionless
        const double var_t119 = NV_Ith_S(mParameters, 16); // dimensionless
        const double var_t127 = pow(var_chaste_interface__intracellular_ions__nai, 2.0); // dimensionless
        const double var_t128 = var_t127 * var_chaste_interface__intracellular_ions__nai; // dimensionless
        const double var_t132 = var_t128 * 0.0013388973049288464; // dimensionless
        const double var_t133 = 1.645154053127841e-05 * var_t132; // dimensionless
        const double var_t145 = var_chaste_interface__intracellular_ions__nai * 0.11021712774165104; // dimensionless
        const double var_t148 = 1.0 + (var_t145 * _lt_0_row[8]); // dimensionless
        const double var_t149 = pow(var_t148, 2.0); // dimensionless
        const double var_t153 = 1.0 + (var_chaste_interface__intracellular_ions__ki * 2.0); // dimensionless
        const double var_t155 = ((var_t149 * var_t148) + pow(var_t153, 2.0)) - 1.0; // dimensionless
        const double var_t156 = 1.0 / var_t155; // dimensionless
        const double var_t157 = _lt_0_row[9] * var_t156; // dimensionless
        const double var_t158 = var_t157 * 687.20000000000005; // dimensionless
        const double var_t162 = ((36879858657.24382 * var_t133) * var_t158) *  -0.0058025619437094061; // dimensionless
        const double var_t163 = pow(var_t127, 2.0); // dimensionless
        const double var_t166 = var_t163 * 0.000147569415290295; // dimensionless
        const double var_t167 = 1.645154053127841e-05 * var_t166; // dimensionless
        const double var_t172 = 1.0 / pow(var_t155, 2.0); // dimensionless
        const double var_t173 = _lt_0_row[10] * var_t172; // dimensionless
        const double var_t176 = ((var_t173 * 687.20000000000005) * var_t149) *  -0.0058025619437094061; // dimensionless
        const double var_t177 = (36879858657.24382 * var_t167) * var_t176; // dimensionless
        const double var_t178 = pow(NV_Ith_S(mParameters, 4), 2.0); // dimensionless
        const double var_t179 = var_t178 * NV_Ith_S(mParameters, 4); // dimensionless
        const double var_t180 = 39.399999999999999 * var_t179; // dimensionless
        const double var_t193 = var_t180 * _lt_0_row[11]; // dimensionless
        const double var_t195 = NV_Ith_S(mParameters, 4) * 0.035997120230381568; // dimensionless
        const double var_t197 = var_t195 * _lt_0_row[12]; // dimensionless
        const double var_t198 = 1.0 + var_t197; // dimensionless
        const double var_t199 = pow(var_t198, 2.0); // dimensionless
        const double var_t205 = ((var_t199 * var_t198) + pow(1.0 + (NV_Ith_S(mParameters, 3) * 2.7917364600781687), 2.0)) - 1.0; // dimensionless
        const double var_t206 = 1.0 / var_t205; // dimensionless
        const double var_t207 = var_t206 * 40.0; // dimensionless
        const double var_t208 = pow(var_chaste_interface__intracellular_ions__ki, 2.0); // dimensionless
        const double var_t211 = var_t208 * 4.0; // dimensionless
        const double var_t212 = var_t211 * var_t156; // dimensionless
        const double var_t213 = var_t207 * var_t212; // dimensionless
        const double var_t222 = (1.5889281507656066 + (var_chaste_interface__intracellular_ions__nai * 0.004464285714285714)) + (var_chaste_interface__intracellular_ions__ki * 0.0034246575342465752); // dimensionless
        const double var_t223 = 1.0 / var_t222; // dimensionless
        const double var_t224 = var_t223 * 9.9999999999999995e-08; // dimensionless
        const double var_t225 = 333060.0 * var_t224; // dimensionless
        const double var_t229 = ((((var_t193 * var_t213) * var_t225) * 1.732653031203624e-08) * 1.155) * 0.037435883507802616; // dimensionless
        const double var_t230 = pow(var_t178, 2.0); // dimensionless
        const double var_t231 = 39.399999999999999 * var_t230; // dimensionless
        const double var_t237 = var_t231 * _lt_0_row[13]; // dimensionless
        const double var_t239 = 1.0 / pow(var_t205, 2.0); // dimensionless
        const double var_t240 = var_t239 * 40.0; // dimensionless
        const double var_t244 = (333060.0 * var_t224) * 1.732653031203624e-08; // dimensionless
        const double var_t246 = (var_t199 * 1.155) * 0.037435883507802616; // dimensionless
        const double var_t248 = (((var_t237 * var_t240) * var_t212) * var_t244) * var_t246; // dimensionless
        const double var_t250 = (var_t180 * _lt_0_row[11]) * var_t206; // dimensionless
        const double var_t251 = 40.0 * var_t208; // dimensionless
        const double var_t252 = var_t251 * 4.0; // dimensionless
        const double var_t253 = var_t172 * 79300.0; // dimensionless
        const double var_t257 = 1.732653031203624e-08 * var_t149; // dimensionless
        const double var_t264 = ((((((((var_t250 * var_t252) * var_t253) * 4.2000000000000002) * var_t224) * var_t257) * var_chaste_interface__intracellular_ions__nai) * _lt_0_row[14]) *  -0.155) * 0.037435883507802616; // dimensionless
        const double var_t267 = 4.2000000000000002 * var_t223; // dimensionless
        const double var_t268 = var_t267 * 9.9999999999999995e-08; // dimensionless
        const double var_t275 = (((((27488.0 * var_t211) * var_t253) * var_t268) * var_t257) * var_t145) * _lt_0_row[15]; // dimensionless
        const double var_t276 = 333060.0 * var_t223; // dimensionless
        const double var_t278 = 949.5 * var_t128; // dimensionless
        const double var_t282 = var_t156 * 687.20000000000005; // dimensionless
        const double var_t285 = ((((var_t276 * 1.732653031203624e-15) * var_t278) * _lt_0_row[16]) * var_t282) *  -0.0058025619437094061; // dimensionless
        const double var_t287 = (var_t225 * var_t167) * var_t176; // dimensionless
        const double var_t293 = (606730.4894874657 * var_t132) * var_t158; // dimensionless
        const double var_t294 = var_t180 * 4.6644804351351539e-05; // dimensionless
        const double var_t295 = _lt_0_row[17] * var_t206; // dimensionless
        const double var_t297 = (var_t294 * var_t295) * var_t251; // dimensionless
        const double var_t298 = 4.0 * var_t156; // dimensionless
        const double var_t300 = var_t267 * 1.732653031203624e-15; // dimensionless
        const double var_t301 = (var_t298 * 79300.0) * var_t300; // dimensionless
        const double var_t302 = var_t297 * var_t301; // dimensionless
        const double var_t304 = 27488.0 * var_t212; // dimensionless
        const double var_t305 = var_t304 * var_t244; // dimensionless
        const double var_t306 = var_t278 * 0.0013388973049288464; // dimensionless
        const double var_t308 = (var_t244 * var_t306) * var_t158; // dimensionless
        const double var_t312 = (var_t250 * 364.80000000000007) * var_t212; // dimensionless
        const double var_t313 = _lt_0_row[16] * var_t156; // dimensionless
        const double var_t314 = var_t278 * var_t313; // dimensionless
        const double var_t316 = pow(NV_Ith_S(mParameters, 3), 2.0); // dimensionless
        const double var_t319 = var_t316 * 7.7937924625297832; // dimensionless
        const double var_t320 = var_t319 * var_t206; // dimensionless
        const double var_t321 = 1304992.8 * var_t320; // dimensionless
        const double var_t322 = var_t314 * var_t321; // dimensionless
        const double var_t323 = 1899.0 * var_t316; // dimensionless
        const double var_t324 = 7.7937924625297832 * var_t206; // dimensionless
        const double var_t326 = (var_t323 * var_t324) * 182.40000000000001; // dimensionless
        const double var_t329 = (var_t326 * 2.0) * var_t212; // dimensionless
        const double var_t330 = 1304992.8 * var_t319; // dimensionless
        const double var_t331 = var_t330 * var_t213; // dimensionless
        const double var_t332 = var_t206 * 639.0; // dimensionless
        const double var_t334 = var_t332 * 0.99999998267346979; // dimensionless
        const double var_t335 = var_t330 * var_t334; // dimensionless
        const double var_t338 = var_t179 * 4.6644804351351539e-05; // dimensionless
        const double var_t339 = var_t338 * _lt_0_row[17]; // dimensionless
        const double var_t340 = var_t206 * 182.40000000000001; // dimensionless
        const double var_t341 = var_t340 * 0.050000000000000003; // dimensionless
        const double var_t343 = ((var_t276 * 6.8266529429422779e-14) * var_t339) * var_t341; // dimensionless
        const double var_t346 = ((var_t250 * 9.120000000000001) * 639.0) * 0.99999998267346979; // dimensionless
        const double var_t352 = (((((var_t323 * var_t324) * 639.0) * 57714958.775029451) * 1.732653031203624e-08) * 182.40000000000001) * 0.050000000000000003; // dimensionless
        const double var_t353 = var_t323 * 7.7937924625297832; // dimensionless
        const double var_t355 = (var_t353 * var_t332) * 9.8000000000000007; // dimensionless
        const double var_t356 = var_t132 * var_t157; // dimensionless
        const double var_t357 = 96.887753423312191 * var_t356; // dimensionless
        const double var_t358 = var_t355 * var_t357; // dimensionless
        const double var_t360 = (var_t294 * var_t295) * 6262.2000000000007; // dimensionless
        const double var_t361 = var_t360 * var_t357; // dimensionless
        const double var_t363 = (var_t276 * 1.732653031203624e-15) * var_t180; // dimensionless
        const double var_t364 = var_t206 * 949.5; // dimensionless
        const double var_t365 = _lt_0_row[11] * var_t364; // dimensionless
        const double var_t367 = (var_t363 * var_t365) * var_t356; // dimensionless
        const double var_t368 = (((((((((((((var_t293 + (2.0 * var_t302)) + var_t305) + var_t308) + var_t312) + var_t322) + var_t329) + var_t331) + var_t335) + var_t343) + var_t346) + var_t352) + var_t358) + var_t361) + var_t367; // dimensionless
        const double var_t369 = 1.0 / var_t368; // dimensionless
        const double var_t373 = ((var_t293 + var_t302) + var_t305) + var_t308; // dimensionless
        const double var_t375 = 1.0 / pow(var_t368, 2.0); // dimensionless
        const double var_t377 = (var_t373 * var_t375) * 1899.0; // dimensionless
        const double var_t381 = var_t295 * 9.120000000000001; // dimensionless
        const double var_t382 = var_t294 * var_t381; // dimensionless
        const double var_t387 = ((var_t382 * var_t251) * var_t298) * 0.04323844545151203; // dimensionless
        const double var_t388 = var_t239 * 182.40000000000001; // dimensionless
        const double var_t391 = var_t156 * var_t199; // dimensionless
        const double var_t394 = ((((var_t237 * var_t388) * 2.0) * var_t211) * var_t391) * 0.04323844545151203; // dimensionless
        const double var_t395 = 2.0 * var_t208; // dimensionless
        const double var_t398 = 4.0 * var_t172; // dimensionless
        const double var_t403 = ((((((var_t193 * var_t340) * var_t395) * var_t398) * var_t149) * var_chaste_interface__intracellular_ions__nai) * 0.11021712774165104) * _lt_0_row[15]; // dimensionless
        const double var_t407 = (((var_t306 * var_t157) * 1304992.8) * var_t320) *  -0.0058025619437094061; // dimensionless
        const double var_t408 = 949.5 * var_t163; // dimensionless
        const double var_t415 = ((((((var_t408 * 0.000147569415290295) * var_t173) * 1304992.8) * var_t319) * var_t206) * var_t149) *  -0.0058025619437094061; // dimensionless
        const double var_t416 = var_t278 * _lt_0_row[16]; // dimensionless
        const double var_t419 = var_t239 * var_t199; // dimensionless
        const double var_t424 = ((((var_t416 * var_t282) * var_t353) * var_t419) * var_t195) * _lt_0_row[18]; // dimensionless
        const double var_t425 = 7.7937924625297832 * var_t239; // dimensionless
        const double var_t426 = var_t323 * var_t425; // dimensionless
        const double var_t427 = 9.120000000000001 * var_t252; // dimensionless
        const double var_t430 = (var_t391 * var_t195) * _lt_0_row[18]; // dimensionless
        const double var_t431 = (var_t426 * var_t427) * var_t430; // dimensionless
        const double var_t432 = var_t323 * var_t324; // dimensionless
        const double var_t434 = var_t172 * var_t149; // dimensionless
        const double var_t436 = (var_t434 * var_t145) * _lt_0_row[15]; // dimensionless
        const double var_t437 = (var_t432 * var_t427) * var_t436; // dimensionless
        const double var_t440 = ((var_t330 * var_t240) * var_t211) * var_t430; // dimensionless
        const double var_t442 = var_t207 * var_t211; // dimensionless
        const double var_t444 = (var_t330 * var_t442) * var_t436; // dimensionless
        const double var_t445 = var_t239 * 639.0; // dimensionless
        const double var_t448 = 1.732653031203624e-08 * var_t199; // dimensionless
        const double var_t451 = ((((var_t330 * var_t445) * 57714958.775029451) * var_t448) * var_t195) * _lt_0_row[18]; // dimensionless
        const double var_t453 = 6.8266529429422784e-07 * var_t338; // dimensionless
        const double var_t454 = var_t225 * var_t453; // dimensionless
        const double var_t456 = (var_t454 * var_t381) * 0.04323844545151203; // dimensionless
        const double var_t463 = ((((((var_t225 * 6.8266529429422784e-07) * var_t230) * 1.6790786303582269e-06) * _lt_0_row[19]) * var_t239) * 9.120000000000001) * var_t246; // dimensionless
        const double var_t466 = (var_t382 * 638.99998892834719) * 0.04323844545151203; // dimensionless
        const double var_t472 = (((((var_t237 * var_t388) * 0.050000000000000003) * 639.0) * 57714958.775029451) * var_t448) * 0.04323844545151203; // dimensionless
        const double var_t479 = ((((((var_t426 * 6262.2000000000007) * 0.10204081455851731) * 182.40000000000001) * 0.050000000000000003) * var_t199) * var_t195) * _lt_0_row[18]; // dimensionless
        const double var_t482 = 1.645154053127841e-05 * var_t128; // dimensionless
        const double var_t491 = ((((((((((var_t323 * var_t425) * 639.0) * 57714958.775029451) * var_t482) * _lt_0_row[16]) * var_t391) * NV_Ith_S(mParameters, 4)) * 0.035997120230381568) * _lt_0_row[12]) * 1.155) * 0.037435883507802616; // dimensionless
        const double var_t494 = (var_t156 *  -0.155) * 0.037435883507802616; // dimensionless
        const double var_t495 = var_t416 * var_t494; // dimensionless
        const double var_t496 = (var_t432 * 638.99998892834719) * var_t495; // dimensionless
        const double var_t500 = (var_t149 *  -0.155) * 0.037435883507802616; // dimensionless
        const double var_t502 = (((var_t432 * 606730.4894874657) * var_t166) * var_t173) * var_t500; // dimensionless
        const double var_t503 = var_t193 * var_t334; // dimensionless
        const double var_t505 = (var_t156 * 1.155) * 0.037435883507802616; // dimensionless
        const double var_t507 = (var_t503 * var_t416) * var_t505; // dimensionless
        const double var_t510 = var_t314 * var_t246; // dimensionless
        const double var_t511 = ((var_t237 * var_t445) * 0.99999998267346979) * var_t510; // dimensionless
        const double var_t512 = var_t503 * var_t495; // dimensionless
        const double var_t514 = _lt_0_row[20] * var_t172; // dimensionless
        const double var_t516 = (var_t408 * var_t514) * var_t500; // dimensionless
        const double var_t517 = var_t503 * var_t516; // dimensionless
        const double var_t518 = 6.8266529429422784e-07 * var_t339; // dimensionless
        const double var_t519 = var_t225 * var_t518; // dimensionless
        const double var_t520 = var_t132 * _lt_0_row[9]; // dimensionless
        const double var_t521 = var_t364 * var_t520; // dimensionless
        const double var_t523 = (var_t519 * var_t521) * var_t505; // dimensionless
        const double var_t527 = (((var_t244 * var_t231) * _lt_0_row[13]) * var_t239) * var_t510; // dimensionless
        const double var_t529 = (var_t519 * var_t521) * var_t494; // dimensionless
        const double var_t531 = (var_t244 * var_t250) * var_t516; // dimensionless
        const double var_t533 = (((((((((((((((((-var_t162) + var_t177) - (2.0 * var_t229)) + (2.0 * var_t248)) + (2.0 * var_t264)) + var_t275) - var_t285) + var_t287) - var_t387) + var_t394) + var_t403) - var_t407) + var_t415) + var_t424) + var_t431) + var_t437) + var_t440) + (((((((((((((((((var_t444 + var_t451) - var_t456) + var_t463) - var_t466) + var_t472) + var_t479) + var_t491) - var_t496) + var_t502) - var_t507) + var_t511) - var_t512) + var_t517) - var_t523) + var_t527) - var_t529) + var_t531); // dimensionless
        const double var_t547 = ((var_t312 + var_t322) + var_t329) + var_t331; // dimensionless
        const double var_t549 = (var_t547 * var_t375) * 333060.0; // dimensionless
        const double var_t559 = (((var_t302 + var_t358) + var_t361) + var_t367) * var_t375; // dimensionless
        const double var_t566 = ((var_t335 + var_t343) + var_t346) + var_t352; // dimensionless
        const double var_t568 = (var_t566 * var_t375) * var_t278; // dimensionless
        const double var_t572 = var_t566 * var_t369; // dimensionless
        const double var_t577 = var_t572 * 949.5; // dimensionless
        const double var_t586 = var_t119 * ((3.0 * (((((((((((((((-var_t162) + var_t177) - var_t229) + var_t248) + var_t264) + var_t275) - var_t285) + var_t287) * var_t369) * 1899.0) * var_t320) - (((var_t377 * var_t319) * var_t206) * var_t533)) + ((((((var_t373 * var_t369) * 1899.0) * var_t319) * var_t419) * var_t197) * 0.04323844545151203)) - (((((((((((((-var_t387) + var_t394) + var_t403) - var_t407) + var_t415) + var_t424) + var_t431) + var_t437) + var_t440) + var_t444) * var_t369) * 79300.0) * var_t300)) + (((var_t549 * var_t224) * 1.732653031203624e-08) * var_t533))) + (2.0 * (((((((((((((((((((((-var_t229) + var_t248) + var_t264) + var_t491) - var_t496) + var_t502) - var_t507) + var_t511) - var_t512) + var_t517) - var_t523) + var_t527) - var_t529) + var_t531) * var_t369) * 9.120000000000001) - ((var_t559 * 9.120000000000001) * var_t533)) - ((((((((var_t451 - var_t456) + var_t463) - var_t466) + var_t472) + var_t479) * var_t369) * 949.5) * var_t356)) + (((var_t568 * _lt_0_row[16]) * var_t156) * var_t533)) + ((((var_t572 * var_t306) * var_t157) *  -0.155) * 0.037435883507802616)) - (((((var_t577 * var_t166) * _lt_0_row[10]) * var_t434) *  -0.155) * 0.037435883507802616)))); // dimensionless
        const double var_t588 = var_t73 / _lt_0_row[21]; // dimensionless
        const double var_t592 = NV_Ith_S(mParameters, 13) * var_t6; // dimensionless
        const double var_t601 = (_lt_0_row[22] * var_chaste_interface__IKr__xrf) + (_lt_0_row[23] * var_chaste_interface__IKr__xrs); // dimensionless
        const double var_t602 = var_t592 * var_t601; // dimensionless
        const double var_t618 = ((((0.005737753105 * var_t602) / _lt_0_row[24]) * _lt_0_row[25]) * var_t23) * _lt_0_row[26]; // dimensionless
        const double var_t631 = _lt_0_row[27] * var_t23; // dimensionless
        const double var_t633 = ((0.43033148290000001 * var_t592) * (((_lt_0_row[28] * var_chaste_interface__IKr__xrf) * _lt_0_row[29]) + (_lt_0_row[30] * var_chaste_interface__IKr__xrs))) * var_t631; // dimensionless
        const double var_t641 = ((((0.01434438276 * var_t602) * _lt_0_row[31]) / _lt_0_row[32]) * var_t23) * _lt_0_row[33]; // dimensionless
        const double var_t642 = var_t601 * _lt_0_row[31]; // dimensionless
        const double var_t645 = ((0.43033148290000001 * var_t592) * var_t642) * _lt_0_row[25]; // dimensionless
        const double var_t646 = var_t85 * var_t23; // dimensionless
        const double var_t665 = var_t646 * ((var_t99 * (((_lt_0_row[34] * var_chaste_interface__Ito__iF) * _lt_0_row[35]) + (_lt_0_row[36] * var_chaste_interface__Ito__iS))) + (var_t110 * (((_lt_0_row[34] * var_chaste_interface__Ito__iFp) * _lt_0_row[35]) + (_lt_0_row[36] * var_chaste_interface__Ito__iSp)))); // dimensionless
        const double var_t668 = NV_Ith_S(mParameters, 15); // dimensionless
        const double var_t670 = pow(var_chaste_interface__intracellular_ions__cai, 2.0); // dimensionless
        const double var_t671 = 1.0 / var_t670; // dimensionless
        const double var_t673 = 1.0 + (2.2499999999999996e-08 * var_t671); // dimensionless
        const double var_t674 = 1.0 / var_t673; // dimensionless
        const double var_t675 = var_t668 * var_t674; // dimensionless
        const double var_t676 = 5000.0 * var_t179; // dimensionless
        const double var_t683 = NV_Ith_S(mParameters, 4) * 0.011348161597821153; // dimensionless
        const double var_t686 = 1.0 + (var_t683 * _lt_0_row[37]); // dimensionless
        const double var_t687 = 1.0 / var_t686; // dimensionless
        const double var_t688 = _lt_0_row[38] * var_t687; // dimensionless
        const double var_t696 = 1.0 / (13.5 + ((NV_Ith_S(mParameters, 4) * 0.066666666666666666) * (1.0 + (NV_Ith_S(mParameters, 4) * 0.20000000000000001)))); // dimensionless
        const double var_t697 = var_t696 * 0.066666666666666666; // dimensionless
        const double var_t699 = ((var_t676 * 0.011348161597821153) * var_t688) * var_t697; // dimensionless
        const double var_t704 = 1.0 + ((var_chaste_interface__intracellular_ions__nai * 0.011348161597821153) * _lt_0_row[39]); // dimensionless
        const double var_t705 = 1.0 / var_t704; // dimensionless
        const double var_t711 = (var_t705 * 60000.0) * _lt_0_row[40]; // dimensionless
        const double var_t712 = var_chaste_interface__intracellular_ions__nai * _lt_0_row[41]; // dimensionless
        const double var_t713 = 0.011348161597821153 * var_t705; // dimensionless
        const double var_t714 = var_t713 * 5000.0; // dimensionless
        const double var_t715 = var_t712 * var_t714; // dimensionless
        const double var_t716 = (var_t711 + var_t715) + 5000.0; // dimensionless
        const double var_t717 = 12000.0 * var_t716; // dimensionless
        const double var_t720 = var_t717 * 0.019556505544476088; // dimensionless
        const double var_t721 = var_t699 * var_t720; // dimensionless
        const double var_t729 = 1.0 / pow(var_t686, 2.0); // dimensionless
        const double var_t730 = _lt_0_row[42] * var_t729; // dimensionless
        const double var_t732 = (((5000.0 * var_t230) * 0.00012878077165026273) * var_t730) * var_t697; // dimensionless
        const double var_t733 = var_t732 * var_t720; // dimensionless
        const double var_t735 = _lt_0_row[43] * var_t687; // dimensionless
        const double var_t736 = var_t676 * var_t735; // dimensionless
        const double var_t738 = 1.0 / pow(var_t704, 2.0); // dimensionless
        const double var_t739 = var_t738 * 60000.0; // dimensionless
        const double var_t749 = var_chaste_interface__intracellular_ions__nai * 0.52239999999999998; // dimensionless
        const double var_t754 = var_t127 * _lt_0_row[44]; // dimensionless
        const double var_t755 = 0.00012878077165026273 * var_t738; // dimensionless
        const double var_t760 = (((((((-var_t739) * _lt_0_row[40]) * var_chaste_interface__intracellular_ions__nai) * 0.011348161597821153) * _lt_0_row[45]) - (var_t711 * 0.0062517925458030381)) + (((var_t749 * 11.605123887418811) * _lt_0_row[46]) * var_t714)) - ((var_t754 * var_t755) * 97.782527722380436); // dimensionless
        const double var_t763 = ((var_t736 * var_t697) * 12000.0) * var_t760; // dimensionless
        const double var_t771 = var_t178 * 0.00012878077165026273; // dimensionless
        const double var_t774 = ((((((var_t729 * 60000.0) * var_t683) * _lt_0_row[38]) * 0.52239999999999998) * 0.037435883507802616) - ((var_t683 * var_t688) * 97.782527722380436)) + ((var_t771 * var_t730) * 97.782527722380436); // dimensionless
        const double var_t776 = var_t696 * NV_Ith_S(mParameters, 2); // dimensionless
        const double var_t777 = var_t776 * 1500000.0; // dimensionless
        const double var_t778 = var_t179 * 0.011348161597821153; // dimensionless
        const double var_t780 = var_t697 * 12000.0; // dimensionless
        const double var_t781 = (var_t778 * var_t688) * var_t780; // dimensionless
        const double var_t782 = var_t777 + var_t781; // dimensionless
        const double var_t783 = (var_t774 * 5000.0) * var_t782; // dimensionless
        const double var_t784 = var_t687 * 60000.0; // dimensionless
        const double var_t786 = (var_t683 * var_t688) * 5000.0; // dimensionless
        const double var_t787 = var_t784 + var_t786; // dimensionless
        const double var_t788 = var_t787 * 5000.0; // dimensionless
        const double var_t789 = var_t778 * _lt_0_row[38]; // dimensionless
        const double var_t790 = var_t687 * var_t696; // dimensionless
        const double var_t791 = var_t790 * 0.066666666666666666; // dimensionless
        const double var_t792 = var_t789 * var_t791; // dimensionless
        const double var_t796 = var_t230 * 0.00012878077165026273; // dimensionless
        const double var_t798 = var_t729 * var_t696; // dimensionless
        const double var_t802 = ((-var_t792) * 234.67806653371301) + ((((var_t796 * _lt_0_row[42]) * var_t798) * 0.066666666666666666) * 234.67806653371301); // dimensionless
        const double var_t803 = var_t788 * var_t802; // dimensionless
        const double var_t805 = var_t711 + var_t715; // dimensionless
        const double var_t806 = 5000.0 * var_t805; // dimensionless
        const double var_t807 = var_chaste_interface__intracellular_ions__nai * 0.066666666666666666; // dimensionless
        const double var_t809 = 1.0 + (var_chaste_interface__intracellular_ions__nai * 0.20000000000000001); // dimensionless
        const double var_t811 = 1.0 + (var_t807 * var_t809); // dimensionless
        const double var_t812 = 1.0 / var_t811; // dimensionless
        const double var_t813 = var_t128 * var_t812; // dimensionless
        const double var_t815 = var_t813 * 0.013333333333333334; // dimensionless
        const double var_t817 = var_t705 * 60000.0; // dimensionless
        const double var_t818 = _lt_0_row[47] * var_t817; // dimensionless
        const double var_t820 = var_t812 * var_chaste_interface__intracellular_ions__cai; // dimensionless
        const double var_t822 = (var_t815 * var_t818) + (var_t820 * 1500000.0); // dimensionless
        const double var_t823 = var_t806 * var_t822; // dimensionless
        const double var_t824 = 5000.0 * var_t128; // dimensionless
        const double var_t825 = var_t812 * 0.066666666666666666; // dimensionless
        const double var_t826 = var_t825 * 0.20000000000000001; // dimensionless
        const double var_t827 = var_t824 * var_t826; // dimensionless
        const double var_t828 = (5000.0 + var_t784) + var_t786; // dimensionless
        const double var_t830 = (_lt_0_row[47] * var_t817) * var_t828; // dimensionless
        const double var_t831 = var_t827 * var_t830; // dimensionless
        const double var_t832 = var_t813 * 0.066666666666666666; // dimensionless
        const double var_t833 = var_t777 * var_t832; // dimensionless
        const double var_t837 = (_lt_0_row[48] * var_t817) * var_t716; // dimensionless
        const double var_t838 = var_t833 * var_t837; // dimensionless
        const double var_t839 = var_t805 * var_t812; // dimensionless
        const double var_t840 = var_chaste_interface__intracellular_ions__cai * 1500000.0; // dimensionless
        const double var_t841 = var_t840 * var_t782; // dimensionless
        const double var_t842 = var_t839 * var_t841; // dimensionless
        const double var_t843 = 1500000.0 * var_t787; // dimensionless
        const double var_t845 = (var_t776 * var_t843) * var_t822; // dimensionless
        const double var_t846 = 12000.0 * var_t812; // dimensionless
        const double var_t849 = ((var_t792 * var_t846) * var_t840) * var_t828; // dimensionless
        const double var_t851 = (var_t736 * var_t697) * var_t717; // dimensionless
        const double var_t852 = var_t788 * var_t782; // dimensionless
        const double var_t853 = ((((((var_t823 + var_t831) + var_t838) + var_t842) + var_t845) + var_t849) + var_t851) + var_t852; // dimensionless
        const double var_t854 = 1.0 / var_t853; // dimensionless
        const double var_t857 = var_t713 * 60000.0; // dimensionless
        const double var_t858 = _lt_0_row[49] * var_t857; // dimensionless
        const double var_t861 = var_t851 + var_t852; // dimensionless
        const double var_t863 = 1.0 / pow(var_t853, 2.0); // dimensionless
        const double var_t865 = (var_t861 * var_t863) * var_t832; // dimensionless
        const double var_t867 = (5000.0 * var_t760) * var_t822; // dimensionless
        const double var_t878 = var_t738 * 60000.0; // dimensionless
        const double var_t882 = (((var_t832 * 10080.7528) * _lt_0_row[50]) * var_t857) - ((((((var_t163 * var_t812) * 0.066666666666666666) * _lt_0_row[51]) * var_t878) * 0.52239999999999998) * 0.037435883507802616); // dimensionless
        const double var_t883 = var_t806 * var_t882; // dimensionless
        const double var_t887 = 60000.0 * var_t828; // dimensionless
        const double var_t890 = ((((var_t824 * var_t812) * 672.0501866666666) * _lt_0_row[50]) * var_t713) * var_t887; // dimensionless
        const double var_t898 = (((((5000.0 * var_t163) * var_t812) * _lt_0_row[52]) * var_t878) * var_t828) * 0.019556505544476088; // dimensionless
        const double var_t901 = ((var_t827 * _lt_0_row[47]) * var_t817) * var_t774; // dimensionless
        const double var_t904 = var_t825 * 0.10448; // dimensionless
        const double var_t907 = 60000.0 * var_t716; // dimensionless
        const double var_t910 = (((((var_t776 * 1500000.0) * var_t128) * var_t904) * _lt_0_row[53]) * var_t713) * var_t907; // dimensionless
        const double var_t913 = var_t825 * _lt_0_row[54]; // dimensionless
        const double var_t917 = (((((var_t776 * 1500000.0) * var_t163) * var_t913) * var_t755) * var_t907) * 0.019556505544476088; // dimensionless
        const double var_t920 = ((var_t833 * _lt_0_row[48]) * var_t817) * var_t760; // dimensionless
        const double var_t922 = (var_t760 * var_t812) * var_t841; // dimensionless
        const double var_t924 = (var_t839 * var_t840) * var_t802; // dimensionless
        const double var_t925 = 1500000.0 * var_t774; // dimensionless
        const double var_t927 = (var_t776 * var_t925) * var_t822; // dimensionless
        const double var_t929 = (var_t776 * var_t843) * var_t882; // dimensionless
        const double var_t930 = 1500000.0 * var_t828; // dimensionless
        const double var_t932 = (var_t820 * var_t930) * 0.019556505544476088; // dimensionless
        const double var_t933 = var_t781 * var_t932; // dimensionless
        const double var_t935 = (var_t796 * var_t730) * var_t780; // dimensionless
        const double var_t936 = var_t935 * var_t932; // dimensionless
        const double var_t939 = ((var_t792 * var_t846) * var_t840) * var_t774; // dimensionless
        const double var_t940 = ((((((((((((((((((var_t867 + var_t883) + var_t890) - var_t898) + var_t901) + var_t910) - var_t917) + var_t920) + var_t922) + var_t924) + var_t927) + var_t929) - var_t933) + var_t936) + var_t939) - var_t721) + var_t733) + var_t763) + var_t783) + var_t803; // dimensionless
        const double var_t945 = var_t861 * var_t854; // dimensionless
        const double var_t958 = ((((var_t867 + var_t883) + var_t890) - var_t898) + var_t901) * var_t854; // dimensionless
        const double var_t961 = var_t790 * 800.0; // dimensionless
        const double var_t964 = var_t823 + var_t831; // dimensionless
        const double var_t965 = var_t964 * var_t863; // dimensionless
        const double var_t966 = var_t965 * var_t789; // dimensionless
        const double var_t971 = var_t964 * var_t854; // dimensionless
        const double var_t973 = _lt_0_row[43] * var_t790; // dimensionless
        const double var_t980 = _lt_0_row[55] * var_t798; // dimensionless
        const double var_t988 = (_lt_0_row[47] * var_t705) * 5000.0; // dimensionless
        const double var_t990 = var_t845 + var_t849; // dimensionless
        const double var_t992 = (var_t990 * var_t863) * var_t712; // dimensionless
        const double var_t993 = 5000.0 * var_t940; // dimensionless
        const double var_t996 = var_t990 * var_t854; // dimensionless
        const double var_t1003 = var_t738 * 5000.0; // dimensionless
        const double var_t1008 = ((((var_t910 - var_t917) + var_t920) + var_t922) + var_t924) * var_t854; // dimensionless
        const double var_t1010 = var_t687 * 5000.0; // dimensionless
        const double var_t1011 = _lt_0_row[43] * var_t1010; // dimensionless
        const double var_t1013 = var_t838 + var_t842; // dimensionless
        const double var_t1014 = var_t1013 * var_t863; // dimensionless
        const double var_t1015 = var_t1014 * var_t683; // dimensionless
        const double var_t1018 = var_t1013 * var_t854; // dimensionless
        const double var_t1019 = var_t683 * _lt_0_row[38]; // dimensionless
        const double var_t1022 = (var_t1010 * 0.52239999999999998) * 0.037435883507802616; // dimensionless
        const double var_t1024 = var_t771 * _lt_0_row[42]; // dimensionless
        const double var_t1028 = ((var_t729 * 5000.0) * 0.52239999999999998) * 0.037435883507802616; // dimensionless
        const double var_t1036 = var_t965 * var_t696; // dimensionless
        const double var_t1037 = NV_Ith_S(mParameters, 2) * 1500000.0; // dimensionless
        const double var_t1043 = var_t675 * ((1.0 * (((((((((((((((((((3.0 * (((((-var_t721) + var_t733) + var_t763) + var_t783) + var_t803)) * var_t854) * var_t832) * var_t858) - ((((3.0 * var_t865) * _lt_0_row[48]) * var_t817) * var_t940)) + (((((3.0 * var_t945) * var_t128) * var_t904) * 0.037435883507802616) * var_t818)) - ((((((3.0 * var_t945) * var_t163) * var_t913) * var_t755) * 60000.0) * 0.019556505544476088)) - (((3.0 * var_t958) * var_t789) * var_t961)) + ((((3.0 * var_t966) * var_t791) * 12000.0) * var_t940)) + ((((3.0 * var_t971) * var_t179) * var_t973) * 15.645204435580871)) - ((((3.0 * var_t971) * var_t230) * var_t980) * 15.645204435580871)) + (((((((var_t927 + var_t929) - var_t933) + var_t936) + var_t939) * var_t854) * var_chaste_interface__intracellular_ions__nai) * var_t988)) - ((var_t992 * var_t713) * var_t993)) + ((((var_t996 * var_t749) * 96485.0) * _lt_0_row[50]) * var_t714)) - (((((var_t996 * var_t754) * 0.00012878077165026273) * var_t1003) * 0.52239999999999998) * 0.037435883507802616)) - ((var_t1008 * NV_Ith_S(mParameters, 4)) * var_t1011)) + ((var_t1015 * var_t688) * var_t993)) + ((var_t1018 * var_t1019) * var_t1022)) - ((var_t1018 * var_t1024) * var_t1028))) + (2.0 * ((((var_t1008 * 5000.0) - ((var_t1014 * 5000.0) * var_t940)) - (var_t958 * var_t777)) + ((var_t1036 * var_t1037) * var_t940)))); // dimensionless
        const double var_t1045 = pow(var_chaste_interface__INa__m, 2.0); // dimensionless
        const double var_t1046 = var_t1045 * var_chaste_interface__INa__m; // dimensionless
        const double var_t1048 = 0.98999999999999999 * var_chaste_interface__INa__hf; // dimensionless
        const double var_t1051 = var_t1048 + (0.010000000000000009 * var_chaste_interface__INa__hs); // dimensionless
        const double var_t1055 = var_t1048 + (0.010000000000000009 * var_chaste_interface__INa__hsp); // dimensionless
        const double var_t1058 = ((var_t98 * var_t1051) * var_chaste_interface__INa__j) + ((var_t97 * var_t1055) * var_chaste_interface__INa__jp); // dimensionless
        const double var_t1059 = (NV_Ith_S(mParameters, 10) * var_t1046) * var_t1058; // dimensionless
        const double var_t1061 = NV_Ith_S(mParameters, 12); // dimensionless
        const double var_t1065 = (var_t98 * var_chaste_interface__INaL__hL) + (var_t97 * var_chaste_interface__INaL__hLp); // dimensionless
        const double var_t1066 = (var_t1061 * var_chaste_interface__INaL__mL) * var_t1065; // dimensionless
        const double var_t1067 = pow(var_chaste_interface__intracellular_ions__cass, 2.0); // dimensionless
        const double var_t1068 = 1.0 / var_t1067; // dimensionless
        const double var_t1070 = 1.0 + (2.2499999999999996e-08 * var_t1068); // dimensionless
        const double var_t1071 = 1.0 / var_t1070; // dimensionless
        const double var_t1072 = var_t668 * var_t1071; // dimensionless
        const double var_t1075 = 1.0 + ((var_chaste_interface__intracellular_ions__nass * 0.011348161597821153) * _lt_0_row[39]); // dimensionless
        const double var_t1076 = 1.0 / var_t1075; // dimensionless
        const double var_t1078 = (var_t1076 * 60000.0) * _lt_0_row[40]; // dimensionless
        const double var_t1079 = var_chaste_interface__intracellular_ions__nass * _lt_0_row[41]; // dimensionless
        const double var_t1080 = 0.011348161597821153 * var_t1076; // dimensionless
        const double var_t1081 = var_t1080 * 5000.0; // dimensionless
        const double var_t1082 = var_t1079 * var_t1081; // dimensionless
        const double var_t1083 = (var_t1078 + var_t1082) + 5000.0; // dimensionless
        const double var_t1084 = 12000.0 * var_t1083; // dimensionless
        const double var_t1085 = var_t1084 * 0.019556505544476088; // dimensionless
        const double var_t1086 = var_t699 * var_t1085; // dimensionless
        const double var_t1087 = var_t732 * var_t1085; // dimensionless
        const double var_t1089 = 1.0 / pow(var_t1075, 2.0); // dimensionless
        const double var_t1090 = var_t1089 * 60000.0; // dimensionless
        const double var_t1096 = var_chaste_interface__intracellular_ions__nass * 0.52239999999999998; // dimensionless
        const double var_t1100 = pow(var_chaste_interface__intracellular_ions__nass, 2.0); // dimensionless
        const double var_t1101 = var_t1100 * _lt_0_row[44]; // dimensionless
        const double var_t1102 = 0.00012878077165026273 * var_t1089; // dimensionless
        const double var_t1105 = (((((((-var_t1090) * _lt_0_row[40]) * var_chaste_interface__intracellular_ions__nass) * 0.011348161597821153) * _lt_0_row[45]) - (var_t1078 * 0.0062517925458030381)) + (((var_t1096 * 11.605123887418811) * _lt_0_row[46]) * var_t1081)) - ((var_t1101 * var_t1102) * 97.782527722380436); // dimensionless
        const double var_t1108 = ((var_t736 * var_t697) * 12000.0) * var_t1105; // dimensionless
        const double var_t1110 = var_t1078 + var_t1082; // dimensionless
        const double var_t1111 = 5000.0 * var_t1110; // dimensionless
        const double var_t1112 = var_t1100 * var_chaste_interface__intracellular_ions__nass; // dimensionless
        const double var_t1113 = var_chaste_interface__intracellular_ions__nass * 0.066666666666666666; // dimensionless
        const double var_t1115 = 1.0 + (var_chaste_interface__intracellular_ions__nass * 0.20000000000000001); // dimensionless
        const double var_t1117 = 1.0 + (var_t1113 * var_t1115); // dimensionless
        const double var_t1118 = 1.0 / var_t1117; // dimensionless
        const double var_t1119 = var_t1112 * var_t1118; // dimensionless
        const double var_t1120 = var_t1119 * 0.013333333333333334; // dimensionless
        const double var_t1121 = var_t1076 * 60000.0; // dimensionless
        const double var_t1122 = _lt_0_row[47] * var_t1121; // dimensionless
        const double var_t1124 = var_t1118 * var_chaste_interface__intracellular_ions__cass; // dimensionless
        const double var_t1126 = (var_t1120 * var_t1122) + (var_t1124 * 1500000.0); // dimensionless
        const double var_t1127 = var_t1111 * var_t1126; // dimensionless
        const double var_t1128 = 5000.0 * var_t1112; // dimensionless
        const double var_t1129 = var_t1118 * 0.066666666666666666; // dimensionless
        const double var_t1130 = var_t1129 * 0.20000000000000001; // dimensionless
        const double var_t1131 = var_t1128 * var_t1130; // dimensionless
        const double var_t1133 = (_lt_0_row[47] * var_t1121) * var_t828; // dimensionless
        const double var_t1134 = var_t1131 * var_t1133; // dimensionless
        const double var_t1135 = var_t1119 * 0.066666666666666666; // dimensionless
        const double var_t1136 = var_t777 * var_t1135; // dimensionless
        const double var_t1138 = (_lt_0_row[48] * var_t1121) * var_t1083; // dimensionless
        const double var_t1139 = var_t1136 * var_t1138; // dimensionless
        const double var_t1140 = var_t1110 * var_t1118; // dimensionless
        const double var_t1141 = var_chaste_interface__intracellular_ions__cass * 1500000.0; // dimensionless
        const double var_t1142 = var_t1141 * var_t782; // dimensionless
        const double var_t1143 = var_t1140 * var_t1142; // dimensionless
        const double var_t1145 = (var_t776 * var_t843) * var_t1126; // dimensionless
        const double var_t1146 = 12000.0 * var_t1118; // dimensionless
        const double var_t1149 = ((var_t792 * var_t1146) * var_t1141) * var_t828; // dimensionless
        const double var_t1151 = (var_t736 * var_t697) * var_t1084; // dimensionless
        const double var_t1152 = ((((((var_t1127 + var_t1134) + var_t1139) + var_t1143) + var_t1145) + var_t1149) + var_t1151) + var_t852; // dimensionless
        const double var_t1153 = 1.0 / var_t1152; // dimensionless
        const double var_t1156 = var_t1080 * 60000.0; // dimensionless
        const double var_t1157 = _lt_0_row[49] * var_t1156; // dimensionless
        const double var_t1160 = var_t1151 + var_t852; // dimensionless
        const double var_t1162 = 1.0 / pow(var_t1152, 2.0); // dimensionless
        const double var_t1164 = (var_t1160 * var_t1162) * var_t1135; // dimensionless
        const double var_t1166 = (5000.0 * var_t1105) * var_t1126; // dimensionless
        const double var_t1170 = pow(var_t1100, 2.0); // dimensionless
        const double var_t1174 = var_t1089 * 60000.0; // dimensionless
        const double var_t1178 = (((var_t1135 * 10080.7528) * _lt_0_row[50]) * var_t1156) - ((((((var_t1170 * var_t1118) * 0.066666666666666666) * _lt_0_row[51]) * var_t1174) * 0.52239999999999998) * 0.037435883507802616); // dimensionless
        const double var_t1179 = var_t1111 * var_t1178; // dimensionless
        const double var_t1184 = ((((var_t1128 * var_t1118) * 672.0501866666666) * _lt_0_row[50]) * var_t1080) * var_t887; // dimensionless
        const double var_t1190 = (((((5000.0 * var_t1170) * var_t1118) * _lt_0_row[52]) * var_t1174) * var_t828) * 0.019556505544476088; // dimensionless
        const double var_t1193 = ((var_t1131 * _lt_0_row[47]) * var_t1121) * var_t774; // dimensionless
        const double var_t1196 = var_t1129 * 0.10448; // dimensionless
        const double var_t1198 = 60000.0 * var_t1083; // dimensionless
        const double var_t1201 = (((((var_t776 * 1500000.0) * var_t1112) * var_t1196) * _lt_0_row[53]) * var_t1080) * var_t1198; // dimensionless
        const double var_t1204 = var_t1129 * _lt_0_row[54]; // dimensionless
        const double var_t1208 = (((((var_t776 * 1500000.0) * var_t1170) * var_t1204) * var_t1102) * var_t1198) * 0.019556505544476088; // dimensionless
        const double var_t1211 = ((var_t1136 * _lt_0_row[48]) * var_t1121) * var_t1105; // dimensionless
        const double var_t1213 = (var_t1105 * var_t1118) * var_t1142; // dimensionless
        const double var_t1215 = (var_t1140 * var_t1141) * var_t802; // dimensionless
        const double var_t1217 = (var_t776 * var_t925) * var_t1126; // dimensionless
        const double var_t1219 = (var_t776 * var_t843) * var_t1178; // dimensionless
        const double var_t1221 = (var_t1124 * var_t930) * 0.019556505544476088; // dimensionless
        const double var_t1222 = var_t781 * var_t1221; // dimensionless
        const double var_t1223 = var_t935 * var_t1221; // dimensionless
        const double var_t1226 = ((var_t792 * var_t1146) * var_t1141) * var_t774; // dimensionless
        const double var_t1227 = ((((((((((((((((((var_t1166 + var_t1179) + var_t1184) - var_t1190) + var_t1193) + var_t1201) - var_t1208) + var_t1211) + var_t1213) + var_t1215) + var_t1217) + var_t1219) - var_t1222) + var_t1223) + var_t1226) - var_t1086) + var_t1087) + var_t1108) + var_t783) + var_t803; // dimensionless
        const double var_t1232 = var_t1160 * var_t1153; // dimensionless
        const double var_t1245 = ((((var_t1166 + var_t1179) + var_t1184) - var_t1190) + var_t1193) * var_t1153; // dimensionless
        const double var_t1249 = var_t1127 + var_t1134; // dimensionless
        const double var_t1250 = var_t1249 * var_t1162; // dimensionless
        const double var_t1251 = var_t1250 * var_t789; // dimensionless
        const double var_t1256 = var_t1249 * var_t1153; // dimensionless
        const double var_t1269 = (_lt_0_row[47] * var_t1076) * 5000.0; // dimensionless
        const double var_t1271 = var_t1145 + var_t1149; // dimensionless
        const double var_t1273 = (var_t1271 * var_t1162) * var_t1079; // dimensionless
        const double var_t1274 = 5000.0 * var_t1227; // dimensionless
        const double var_t1277 = var_t1271 * var_t1153; // dimensionless
        const double var_t1284 = var_t1089 * 5000.0; // dimensionless
        const double var_t1289 = ((((var_t1201 - var_t1208) + var_t1211) + var_t1213) + var_t1215) * var_t1153; // dimensionless
        const double var_t1292 = var_t1139 + var_t1143; // dimensionless
        const double var_t1293 = var_t1292 * var_t1162; // dimensionless
        const double var_t1294 = var_t1293 * var_t683; // dimensionless
        const double var_t1297 = var_t1292 * var_t1153; // dimensionless
        const double var_t1308 = var_t1250 * var_t696; // dimensionless
        const double var_t1314 = var_t1072 * ((1.0 * (((((((((((((((((((3.0 * (((((-var_t1086) + var_t1087) + var_t1108) + var_t783) + var_t803)) * var_t1153) * var_t1135) * var_t1157) - ((((3.0 * var_t1164) * _lt_0_row[48]) * var_t1121) * var_t1227)) + (((((3.0 * var_t1232) * var_t1112) * var_t1196) * 0.037435883507802616) * var_t1122)) - ((((((3.0 * var_t1232) * var_t1170) * var_t1204) * var_t1102) * 60000.0) * 0.019556505544476088)) - (((3.0 * var_t1245) * var_t789) * var_t961)) + ((((3.0 * var_t1251) * var_t791) * 12000.0) * var_t1227)) + ((((3.0 * var_t1256) * var_t179) * var_t973) * 15.645204435580871)) - ((((3.0 * var_t1256) * var_t230) * var_t980) * 15.645204435580871)) + (((((((var_t1217 + var_t1219) - var_t1222) + var_t1223) + var_t1226) * var_t1153) * var_chaste_interface__intracellular_ions__nass) * var_t1269)) - ((var_t1273 * var_t1080) * var_t1274)) + ((((var_t1277 * var_t1096) * 96485.0) * _lt_0_row[50]) * var_t1081)) - (((((var_t1277 * var_t1101) * 0.00012878077165026273) * var_t1284) * 0.52239999999999998) * 0.037435883507802616)) - ((var_t1289 * NV_Ith_S(mParameters, 4)) * var_t1011)) + ((var_t1294 * var_t688) * var_t1274)) + ((var_t1297 * var_t1019) * var_t1022)) - ((var_t1297 * var_t1024) * var_t1028))) + (2.0 * ((((var_t1289 * 5000.0) - ((var_t1293 * 5000.0) * var_t1227)) - (var_t1245 * var_t777)) + ((var_t1308 * var_t1037) * var_t1227)))); // dimensionless
        const double var_t1316 = NV_Ith_S(mParameters, 6) * var_chaste_interface__membrane__v; // dimensionless
        const double var_t1321 = var_t1316 * 12994493.709179051; // dimensionless
        const double var_t1328 = (((8.0 * var_t1321) * 1.040582726326743e-05) * var_chaste_interface__intracellular_ions__cai) * _lt_0_row[56]; // dimensionless
        const double var_t1329 = NV_Ith_S(mParameters, 8) * var_chaste_interface__membrane__v; // dimensionless
        const double var_t1330 = var_t1329 * 12994493.709179051; // dimensionless
        const double var_t1334 = ((var_t1330 * 1.040582726326743e-05) * var_chaste_interface__intracellular_ions__nai) * _lt_0_row[57]; // dimensionless
        const double var_t1337 = NV_Ith_S(mParameters, 5); // dimensionless
        const double var_t1338 = var_t98 * var_t1337; // dimensionless
        const double var_t1339 = var_t1338 * var_chaste_interface__membrane__v; // dimensionless
        const double var_t1342 = var_t1339 * 3612.0012202503353; // dimensionless
        const double var_t1344 = (var_chaste_interface__intracellular_ions__cass * _lt_0_row[2]) - var_t49; // dimensionless
        const double var_t1345 = var_t1344 * _lt_0_row[3]; // dimensionless
        const double var_t1346 = var_t1345 * var_chaste_interface__ICaL__d; // dimensionless
        const double var_t1357 = _lt_0_row[58] * var_chaste_interface__ICaL__fcas; // dimensionless
        const double var_t1360 = (var_chaste_interface__ICaL__jca * ((_lt_0_row[59] * var_chaste_interface__ICaL__fcaf) + var_t1357)) * var_chaste_interface__ICaL__nca; // dimensionless
        const double var_t1363 = ((4.0 * var_t1342) * var_t1346) * var_t1360; // dimensionless
        const double var_t1369 = (((var_t1330 * 1.040582726326743e-05) * var_t38) * _lt_0_row[60]) * _lt_0_row[0]; // dimensionless
        const double var_t1370 = var_t97 * var_t1337; // dimensionless
        const double var_t1371 = var_t1370 * 1119720.378277604; // dimensionless
        const double var_t1375 = ((0.75 * var_chaste_interface__intracellular_ions__nass) * _lt_0_row[0]) - (0.75 * NV_Ith_S(mParameters, 4)); // dimensionless
        const double var_t1376 = 0.0032258064516129032 * var_t1375; // dimensionless
        const double var_t1377 = _lt_0_row[1] * var_chaste_interface__ICaL__d; // dimensionless
        const double var_t1379 = 0.40000000000000002 * var_chaste_interface__ICaL__fs; // dimensionless
        const double var_t1381 = 1.0 - var_chaste_interface__ICaL__nca; // dimensionless
        const double var_t1389 = _lt_0_row[61] * var_chaste_interface__ICaL__fcas; // dimensionless
        const double var_t1390 = (_lt_0_row[62] * var_chaste_interface__ICaL__fcafp) + var_t1389; // dimensionless
        const double var_t1391 = var_chaste_interface__ICaL__jca * var_t1390; // dimensionless
        const double var_t1393 = (((0.59999999999999998 * var_chaste_interface__ICaL__ffp) + var_t1379) * var_t1381) + (var_t1391 * var_chaste_interface__ICaL__nca); // dimensionless
        const double var_t1394 = var_t1377 * var_t1393; // dimensionless
        const double var_t1397 = ((0.0013749999999999999 * var_t1371) * var_t1376) * var_t1394; // dimensionless
        const double var_t1400 = var_t1370 * var_chaste_interface__membrane__v; // dimensionless
        const double var_t1401 = var_t1400 * 3612.0012202503353; // dimensionless
        const double var_t1405 = ((0.75 * var_chaste_interface__intracellular_ions__kss) * _lt_0_row[0]) - (0.75 * NV_Ith_S(mParameters, 3)); // dimensionless
        const double var_t1406 = var_t1405 * _lt_0_row[1]; // dimensionless
        const double var_t1407 = var_t1406 * var_chaste_interface__ICaL__d; // dimensionless
        const double var_t1412 = (var_chaste_interface__ICaL__jca * ((_lt_0_row[59] * var_chaste_interface__ICaL__fcafp) + var_t1357)) * var_chaste_interface__ICaL__nca; // dimensionless
        const double var_t1415 = ((0.00039313999999999999 * var_t1401) * var_t1407) * var_t1412; // dimensionless
        const double var_t1418 = var_t1370 * ((var_chaste_interface__membrane__v * 898213138884125.0) * 1.4467049241032556e-08); // dimensionless
        const double var_t1420 = (1.040582726326743e-05 * var_t1405) * _lt_0_row[60]; // dimensionless
        const double var_t1421 = var_chaste_interface__ICaL__d * var_t1393; // dimensionless
        const double var_t1422 = var_t1421 * _lt_0_row[0]; // dimensionless
        const double var_t1425 = ((0.00039313999999999999 * var_t1418) * var_t1420) * var_t1422; // dimensionless
        const double var_t1426 = var_t1338 * ((var_chaste_interface__membrane__v * 898213138884125.0) * 1.4467049241032556e-08); // dimensionless
        const double var_t1428 = (1.040582726326743e-05 * var_chaste_interface__intracellular_ions__cass) * _lt_0_row[2]; // dimensionless
        const double var_t1429 = _lt_0_row[3] * var_chaste_interface__ICaL__d; // dimensionless
        const double var_t1434 = (_lt_0_row[62] * var_chaste_interface__ICaL__fcaf) + var_t1389; // dimensionless
        const double var_t1435 = var_chaste_interface__ICaL__jca * var_t1434; // dimensionless
        const double var_t1437 = (((0.59999999999999998 * var_chaste_interface__ICaL__ff) + var_t1379) * var_t1381) + (var_t1435 * var_chaste_interface__ICaL__nca); // dimensionless
        const double var_t1438 = var_t1429 * var_t1437; // dimensionless
        const double var_t1441 = ((8.0 * var_t1426) * var_t1428) * var_t1438; // dimensionless
        const double var_t1443 = (1.040582726326743e-05 * var_chaste_interface__intracellular_ions__nass) * _lt_0_row[0]; // dimensionless
        const double var_t1446 = ((0.00103125 * var_t1418) * var_t1443) * var_t1394; // dimensionless
        const double var_t1448 = (1.040582726326743e-05 * var_chaste_interface__intracellular_ions__kss) * _lt_0_row[0]; // dimensionless
        const double var_t1451 = ((0.00029485500000000001 * var_t1418) * var_t1448) * var_t1394; // dimensionless
        const double var_t1452 = 0.0032258064516129032 * var_t1405; // dimensionless
        const double var_t1455 = ((0.00039313999999999999 * var_t1371) * var_t1452) * var_t1394; // dimensionless
        const double var_t1457 = (var_t1342 * var_t1407) * var_t1360; // dimensionless
        const double var_t1459 = var_chaste_interface__ICaL__d * var_t1437; // dimensionless
        const double var_t1460 = var_t1459 * _lt_0_row[0]; // dimensionless
        const double var_t1462 = (var_t1426 * var_t1420) * var_t1460; // dimensionless
        const double var_t1464 = var_t1377 * var_t1437; // dimensionless
        const double var_t1467 = ((0.00026804999999999998 * var_t1426) * var_t1448) * var_t1464; // dimensionless
        const double var_t1468 = var_t1338 * 1119720.378277604; // dimensionless
        const double var_t1469 = var_t1452 * var_t1464; // dimensionless
        const double var_t1470 = var_t1468 * var_t1469; // dimensionless
        const double var_t1472 = var_t1375 * _lt_0_row[1]; // dimensionless
        const double var_t1473 = var_t1472 * var_chaste_interface__ICaL__d; // dimensionless
        const double var_t1476 = ((0.0013749999999999999 * var_t1401) * var_t1473) * var_t1412; // dimensionless
        const double var_t1479 = (1.040582726326743e-05 * var_t1375) * _lt_0_row[60]; // dimensionless
        const double var_t1482 = ((0.0013749999999999999 * var_t1418) * var_t1479) * var_t1422; // dimensionless
        const double var_t1485 = ((0.00125 * var_t1342) * var_t1473) * var_t1360; // dimensionless
        const double var_t1488 = ((0.00125 * var_t1426) * var_t1479) * var_t1460; // dimensionless
        const double var_t1491 = ((0.00093749999999999997 * var_t1426) * var_t1443) * var_t1464; // dimensionless
        const double var_t1492 = var_t1376 * var_t1464; // dimensionless
        const double var_t1494 = (0.00125 * var_t1468) * var_t1492; // dimensionless
        const double var_t1497 = ((4.4000000000000004 * var_t1401) * var_t1346) * var_t1412; // dimensionless
        const double var_t1501 = (1.040582726326743e-05 * var_t1344) * _lt_0_row[63]; // dimensionless
        const double var_t1505 = (((8.8000000000000007 * var_t1418) * var_t1501) * var_t1421) * _lt_0_row[2]; // dimensionless
        const double var_t1506 = var_t1429 * var_t1393; // dimensionless
        const double var_t1509 = ((8.8000000000000007 * var_t1418) * var_t1428) * var_t1506; // dimensionless
        const double var_t1510 = 0.0032258064516129032 * var_t1344; // dimensionless
        const double var_t1511 = var_t1510 * var_t1506; // dimensionless
        const double var_t1513 = (4.4000000000000004 * var_t1371) * var_t1511; // dimensionless
        const double var_t1514 = var_t1510 * var_t1438; // dimensionless
        const double var_t1516 = (4.0 * var_t1468) * var_t1514; // dimensionless
        const double var_t1520 = (((8.0 * var_t1426) * var_t1501) * var_t1459) * _lt_0_row[2]; // dimensionless
        const double var_t1525 = ((((8.0 * var_t1321) * 1.040582726326743e-05) * var_t50) * _lt_0_row[63]) * _lt_0_row[2]; // dimensionless
        const double var_t1529 = 1.0 / var_chaste_interface__intracellular_ions__nai; // dimensionless
        const double var_t1534 = var_chaste_interface__membrane__v - (26.712338705498265 * log(NV_Ith_S(mParameters, 4) * var_t1529)); // dimensionless
        const double var_t1535 = NV_Ith_S(mParameters, 10) * var_t1534; // dimensionless
        const double var_t1537 = 1.0 / pow(var_t96, 2.0); // dimensionless
        const double var_t1538 = var_t1537 * 0.14999999999999999; // dimensionless
        const double var_t1540 = 1.0 / pow(var_t93, 2.0); // dimensionless
        const double var_t1541 = var_t1538 * var_t1540; // dimensionless
        const double var_t1543 = ( -0.050000000000000003 * var_t91) + 1.0; // dimensionless
        const double var_t1547 = var_t1537 * var_t1055; // dimensionless
        const double var_t1549 = 0.14999999999999999 * var_t1540; // dimensionless
        const double var_t1550 = var_t1549 * var_t1543; // dimensionless
        const double var_t1554 = (var_t1535 * var_t1046) * (((((-var_t1541) * var_t1543) * var_t1051) * var_chaste_interface__INa__j) + ((var_t1547 * var_chaste_interface__INa__jp) * var_t1550)); // dimensionless
        const double var_t1555 = var_t1061 * var_t1534; // dimensionless
        const double var_t1556 = var_t1540 * var_t1543; // dimensionless
        const double var_t1559 = var_t1537 * var_chaste_interface__INaL__hLp; // dimensionless
        const double var_t1563 = (var_t1555 * var_chaste_interface__INaL__mL) * ((((-var_t1538) * var_t1556) * var_chaste_interface__INaL__hL) + (var_t1559 * var_t1550)); // dimensionless
        const double var_t1567 = var_t1537 * var_chaste_interface__Ito__ap; // dimensionless
        const double var_t1570 = ((((-var_t1541) * var_t1543) * var_chaste_interface__Ito__a) * var_t108) + ((var_t1567 * var_t113) * var_t1550); // dimensionless
        const double var_t1574 = ((var_t1541 * var_t1543) * var_t1337) * var_chaste_interface__membrane__v; // dimensionless
        const double var_t1578 = (((4.0 * var_t1574) * 3612.0012202503353) * var_t1345) * var_t1459; // dimensionless
        const double var_t1579 = var_t1537 * var_t1337; // dimensionless
        const double var_t1581 = (var_t1579 * var_chaste_interface__membrane__v) * 3612.0012202503353; // dimensionless
        const double var_t1583 = (var_t1393 * 0.14999999999999999) * var_t1556; // dimensionless
        const double var_t1586 = ((4.4000000000000004 * var_t1581) * var_t1346) * var_t1583; // dimensionless
        const double var_t1590 = (((0.00125 * var_t1574) * 3612.0012202503353) * var_t1472) * var_t1459; // dimensionless
        const double var_t1593 = ((0.0013749999999999999 * var_t1581) * var_t1473) * var_t1583; // dimensionless
        const double var_t1596 = ((var_t1574 * 3612.0012202503353) * var_t1406) * var_t1459; // dimensionless
        const double var_t1600 = ((0.00039313999999999999 * var_t1581) * var_t1407) * var_t1583; // dimensionless
        const double var_t1604 = 1.0364305332435094e-05 * var_t1529; // dimensionless
        const double var_t1607 = ((((NV_Ith_S(mParameters, 10) * 8314.0) * 310.0) * var_t1604) * var_t1046) * var_t1058; // dimensionless
        const double var_t1612 = ((((var_t1061 * 8314.0) * 310.0) * var_t1604) * var_chaste_interface__INaL__mL) * var_t1065; // dimensionless
        const double var_t1615 = 1.0 / (var_chaste_interface__intracellular_ions__ki + (0.018329999999999999 * var_chaste_interface__intracellular_ions__nai)); // dimensionless
        const double var_t1616 = 1.0364305332435094e-05 * var_t1615; // dimensionless
        const double var_t1619 = ((var_t71 * 2577340.0) * var_t1616) * 0.018329999999999999; // dimensionless
        const double var_t1624 = ((var_t676 * 0.00012878077165026273) * var_t790) * 0.0044444444444444444; // dimensionless
        const double var_t1635 = (((-var_t739) * _lt_0_row[64]) + var_t988) - (((var_t712 * 0.00012878077165026273) * var_t1003) * _lt_0_row[39]); // dimensionless
        const double var_t1644 = (5000.0 * var_t1635) * var_t822; // dimensionless
        const double var_t1645 = var_t127 * var_t812; // dimensionless
        const double var_t1650 = 1.0 / pow(var_t811, 2.0); // dimensionless
        const double var_t1651 = var_t128 * var_t1650; // dimensionless
        const double var_t1655 = (0.066666666666666666 * var_t809) + (var_t807 * 0.20000000000000001); // dimensionless
        const double var_t1656 = var_t817 * var_t1655; // dimensionless
        const double var_t1660 = var_t878 * _lt_0_row[39]; // dimensionless
        const double var_t1666 = (((((3.0 * var_t1645) * 0.013333333333333334) * var_t818) - (((var_t1651 * 0.013333333333333334) * _lt_0_row[47]) * var_t1656)) - ((var_t815 * _lt_0_row[65]) * var_t1660)) - (((var_t1650 * var_chaste_interface__intracellular_ions__cai) * 1500000.0) * var_t1655); // dimensionless
        const double var_t1667 = var_t806 * var_t1666; // dimensionless
        const double var_t1671 = ((15000.0 * var_t127) * var_t826) * var_t830; // dimensionless
        const double var_t1678 = ((((((var_t824 * var_t1650) * 0.066666666666666666) * 0.20000000000000001) * _lt_0_row[47]) * var_t705) * var_t887) * var_t1655; // dimensionless
        const double var_t1680 = var_t887 * _lt_0_row[39]; // dimensionless
        const double var_t1682 = ((var_t827 * _lt_0_row[65]) * var_t738) * var_t1680; // dimensionless
        const double var_t1683 = var_t1645 * 0.066666666666666666; // dimensionless
        const double var_t1686 = ((3.0 * var_t777) * var_t1683) * var_t837; // dimensionless
        const double var_t1687 = var_t1651 * 0.066666666666666666; // dimensionless
        const double var_t1692 = ((((var_t777 * var_t1687) * _lt_0_row[48]) * var_t817) * var_t716) * var_t1655; // dimensionless
        const double var_t1697 = (((var_t833 * _lt_0_row[66]) * var_t878) * var_t716) * _lt_0_row[39]; // dimensionless
        const double var_t1700 = ((var_t833 * _lt_0_row[48]) * var_t817) * var_t1635; // dimensionless
        const double var_t1702 = (var_t1635 * var_t812) * var_t841; // dimensionless
        const double var_t1705 = 1500000.0 * var_t782; // dimensionless
        const double var_t1707 = (((var_t805 * var_t1650) * var_chaste_interface__intracellular_ions__cai) * var_t1705) * var_t1655; // dimensionless
        const double var_t1709 = (var_t776 * var_t843) * var_t1666; // dimensionless
        const double var_t1714 = ((((var_t792 * 12000.0) * var_t1650) * var_t840) * var_t828) * var_t1655; // dimensionless
        const double var_t1718 = ((((((((((((var_t1644 + var_t1667) + var_t1671) - var_t1678) - var_t1682) + var_t1686) - var_t1692) - var_t1697) + var_t1700) + var_t1702) - var_t1707) + var_t1709) - var_t1714) + (((var_t736 * var_t697) * 12000.0) * var_t1635); // dimensionless
        const double var_t1730 = var_t945 * var_t832; // dimensionless
        const double var_t1735 = ((((var_t1644 + var_t1667) + var_t1671) - var_t1678) - var_t1682) * var_t854; // dimensionless
        const double var_t1747 = 5000.0 * var_t1718; // dimensionless
        const double var_t1757 = (((((var_t1686 - var_t1692) - var_t1697) + var_t1700) + var_t1702) - var_t1707) * var_t854; // dimensionless
        const double var_t1772 = (1.0 * (((((((((((((((((((3.0 * var_t1624) * 144000000.0) * var_t1635) * var_t854) * var_t128) * var_t812) * var_t705) - ((((3.0 * var_t865) * _lt_0_row[48]) * var_t817) * var_t1718)) + (((9.0 * var_t945) * var_t1683) * var_t858)) - ((((3.0 * var_t945) * var_t1687) * _lt_0_row[48]) * var_t1656)) - (((3.0 * var_t1730) * _lt_0_row[66]) * var_t1660)) - (((3.0 * var_t1735) * var_t789) * var_t961)) + ((((3.0 * var_t966) * var_t791) * 12000.0) * var_t1718)) + ((((var_t1709 - var_t1714) * var_t854) * var_chaste_interface__intracellular_ions__nai) * var_t988)) - ((var_t992 * var_t713) * var_t1747)) + ((var_t996 * _lt_0_row[41]) * var_t714)) - (((var_t996 * var_t712) * var_t755) * _lt_0_row[67])) - ((var_t1757 * NV_Ith_S(mParameters, 4)) * var_t1011)) + ((var_t1015 * var_t688) * var_t1747))) + (2.0 * ((((var_t1757 * 5000.0) - ((var_t1014 * 5000.0) * var_t1718)) - (var_t1735 * var_t777)) + ((var_t1036 * var_t1037) * var_t1718))); // dimensionless
        const double var_t1773 = var_t675 * var_t1772; // dimensionless
        const double var_t1775 = var_t127 * 0.0013388973049288464; // dimensionless
        const double var_t1778 = (1820191.4684623971 * var_t1775) * var_t158; // dimensionless
        const double var_t1781 = var_t172 * 687.20000000000005; // dimensionless
        const double var_t1783 = (((var_t128 * 0.000147569415290295) * _lt_0_row[10]) * var_t1781) * var_t149; // dimensionless
        const double var_t1785 = 1820191.4684623971 * var_t1783; // dimensionless
        const double var_t1789 = (var_t149 * 0.11021712774165104) * _lt_0_row[8]; // dimensionless
        const double var_t1792 = ((((var_t193 * var_t442) * var_t253) * var_t267) * 1.732653031203624e-15) * var_t1789; // dimensionless
        const double var_t1793 = 3.0 * var_t1792; // dimensionless
        const double var_t1794 = var_t298 * 333060.0; // dimensionless
        const double var_t1796 = 1.0 / pow(var_t222, 2.0); // dimensionless
        const double var_t1797 = var_t1796 * 9.9999999999999995e-08; // dimensionless
        const double var_t1799 = (var_t1797 * 1.732653031203624e-08) * 0.004464285714285714; // dimensionless
        const double var_t1801 = (var_t297 * var_t1794) * var_t1799; // dimensionless
        const double var_t1808 = (((((82464.0 * var_t208) * var_t398) * 79300.0) * var_t268) * var_t257) * _lt_0_row[14]; // dimensionless
        const double var_t1809 = 333060.0 * var_t1796; // dimensionless
        const double var_t1812 = ((var_t304 * var_t1809) * 1.732653031203624e-15) * 0.004464285714285714; // dimensionless
        const double var_t1814 = var_t1809 * 1.6451540531278409e-12; // dimensionless
        const double var_t1817 = ((var_t1814 * var_t520) * var_t282) * 0.004464285714285714; // dimensionless
        const double var_t1818 = 949.5 * var_t127; // dimensionless
        const double var_t1822 = (((3.0 * var_t244) * var_t1818) * 0.0013388973049288464) * var_t158; // dimensionless
        const double var_t1823 = var_t276 * 1.6451540531278409e-12; // dimensionless
        const double var_t1825 = (3.0 * var_t1823) * var_t1783; // dimensionless
        const double var_t1833 = (var_t252 * var_t434) * _lt_0_row[14]; // dimensionless
        const double var_t1834 = var_t382 * var_t1833; // dimensionless
        const double var_t1837 = (var_t1818 * var_t313) * var_t321; // dimensionless
        const double var_t1841 = 1304992.8 * var_t316; // dimensionless
        const double var_t1844 = (((var_t278 * var_t514) * var_t1841) * var_t324) * var_t149; // dimensionless
        const double var_t1847 = (var_t353 * var_t341) * var_t1833; // dimensionless
        const double var_t1853 = ((((var_t1841 * var_t324) * 40.0) * var_t211) * var_t172) * var_t1789; // dimensionless
        const double var_t1855 = var_t1809 * 6.8266529429422779e-14; // dimensionless
        const double var_t1860 = var_t1775 * var_t157; // dimensionless
        const double var_t1861 = 96.887753423312191 * var_t1860; // dimensionless
        const double var_t1863 = (3.0 * var_t355) * var_t1861; // dimensionless
        const double var_t1864 = var_t332 * 57714958.775029451; // dimensionless
        const double var_t1865 = var_t353 * var_t1864; // dimensionless
        const double var_t1866 = _lt_0_row[20] * var_t434; // dimensionless
        const double var_t1869 = ((3.0 * var_t1865) * var_t482) * var_t1866; // dimensionless
        const double var_t1871 = (3.0 * var_t360) * var_t1861; // dimensionless
        const double var_t1875 = (((3.0 * var_t360) * 0.10204081455851731) * var_t278) * var_t1866; // dimensionless
        const double var_t1876 = 333060.0 * var_t1797; // dimensionless
        const double var_t1877 = var_t1876 * var_t453; // dimensionless
        const double var_t1878 = var_t295 * var_t278; // dimensionless
        const double var_t1882 = (((var_t1877 * var_t1878) * _lt_0_row[16]) * var_t156) * 0.004464285714285714; // dimensionless
        const double var_t1885 = ((3.0 * var_t363) * var_t365) * var_t1860; // dimensionless
        const double var_t1888 = ((3.0 * var_t454) * var_t1878) * var_t1866; // dimensionless
        const double var_t1890 = ((((((((((var_t1778 - var_t1785) - (6.0 * var_t1792)) - (2.0 * var_t1801)) - var_t1808) - var_t1812) - var_t1817) + var_t1822) - var_t1825) - (3.0 * var_t1834)) + (3.0 * var_t1837)) + ((((((((((( -3.0 * var_t1844) - (3.0 * var_t1847)) - (3.0 * var_t1853)) - (((var_t1855 * var_t339) * var_t340) * 0.00022321428571428571)) + var_t1863) - var_t1869) + var_t1871) - var_t1875) - var_t1882) + var_t1885) - var_t1888); // dimensionless
        const double var_t1902 = (var_t547 * var_t369) * 333060.0; // dimensionless
        const double var_t1913 = var_t1876 * var_t518; // dimensionless
        const double var_t1925 = var_t572 * var_t278; // dimensionless
        const double var_t1931 = var_t119 * ((3.0 * (((((((((((((((var_t1778 - var_t1785) - var_t1793) - var_t1801) - var_t1808) - var_t1812) - var_t1817) + var_t1822) - var_t1825) * var_t369) * 1899.0) * var_t320) - (((var_t377 * var_t319) * var_t206) * var_t1890)) - ((((3.0 * (((((-var_t1834) + var_t1837) - var_t1844) - var_t1847) - var_t1853)) * var_t369) * 79300.0) * var_t300)) + (((var_t549 * var_t224) * 1.732653031203624e-08) * var_t1890)) + (var_t1902 * var_t1799))) + (1.0 * ((((((((2.0 * (((((((((-var_t1793) - var_t1801) + var_t1863) - var_t1869) + var_t1871) - var_t1875) - var_t1882) + var_t1885) - var_t1888)) * var_t369) * 9.120000000000001) - (((2.0 * var_t559) * 9.120000000000001) * var_t1890)) + (((((2.0 * var_t1913) * var_t340) * 0.00022321428571428571) * var_t369) * var_t314)) + ((((2.0 * var_t568) * _lt_0_row[16]) * var_t156) * var_t1890)) - ((6.0 * var_t577) * var_t1860)) + ((6.0 * var_t1925) * var_t1866)))); // dimensionless
        const double var_t1934 = ((var_t1329 * 9309355225.0) * 3.8799692706433766e-07) * _lt_0_row[57]; // dimensionless
        const double var_t1938 = var_t1338 * ((var_chaste_interface__membrane__v * 9309355225.0) * 0.00012027904738994468); // dimensionless
        const double var_t1941 = (var_t1938 * _lt_0_row[68]) * var_t1464; // dimensionless
        const double var_t1942 = 0.00093749999999999997 * var_t1941; // dimensionless
        const double var_t1943 = var_t1370 * ((var_chaste_interface__membrane__v * 9309355225.0) * 0.00012027904738994468); // dimensionless
        const double var_t1945 = (var_t1943 * _lt_0_row[68]) * var_t1394; // dimensionless
        const double var_t1946 = 0.00103125 * var_t1945; // dimensionless
        const double var_t1951 = (((-var_t1090) * _lt_0_row[64]) + var_t1269) - (((var_t1079 * 0.00012878077165026273) * var_t1284) * _lt_0_row[39]); // dimensionless
        const double var_t1960 = (5000.0 * var_t1951) * var_t1126; // dimensionless
        const double var_t1961 = var_t1100 * var_t1118; // dimensionless
        const double var_t1966 = 1.0 / pow(var_t1117, 2.0); // dimensionless
        const double var_t1967 = var_t1112 * var_t1966; // dimensionless
        const double var_t1971 = (0.066666666666666666 * var_t1115) + (var_t1113 * 0.20000000000000001); // dimensionless
        const double var_t1972 = var_t1121 * var_t1971; // dimensionless
        const double var_t1975 = var_t1174 * _lt_0_row[39]; // dimensionless
        const double var_t1981 = (((((3.0 * var_t1961) * 0.013333333333333334) * var_t1122) - (((var_t1967 * 0.013333333333333334) * _lt_0_row[47]) * var_t1972)) - ((var_t1120 * _lt_0_row[65]) * var_t1975)) - (((var_t1966 * var_chaste_interface__intracellular_ions__cass) * 1500000.0) * var_t1971); // dimensionless
        const double var_t1982 = var_t1111 * var_t1981; // dimensionless
        const double var_t1986 = ((15000.0 * var_t1100) * var_t1130) * var_t1133; // dimensionless
        const double var_t1993 = ((((((var_t1128 * var_t1966) * 0.066666666666666666) * 0.20000000000000001) * _lt_0_row[47]) * var_t1076) * var_t887) * var_t1971; // dimensionless
        const double var_t1996 = ((var_t1131 * _lt_0_row[65]) * var_t1089) * var_t1680; // dimensionless
        const double var_t1997 = var_t1961 * 0.066666666666666666; // dimensionless
        const double var_t2000 = ((3.0 * var_t777) * var_t1997) * var_t1138; // dimensionless
        const double var_t2001 = var_t1967 * 0.066666666666666666; // dimensionless
        const double var_t2006 = ((((var_t777 * var_t2001) * _lt_0_row[48]) * var_t1121) * var_t1083) * var_t1971; // dimensionless
        const double var_t2010 = (((var_t1136 * _lt_0_row[66]) * var_t1174) * var_t1083) * _lt_0_row[39]; // dimensionless
        const double var_t2013 = ((var_t1136 * _lt_0_row[48]) * var_t1121) * var_t1951; // dimensionless
        const double var_t2015 = (var_t1951 * var_t1118) * var_t1142; // dimensionless
        const double var_t2019 = (((var_t1110 * var_t1966) * var_chaste_interface__intracellular_ions__cass) * var_t1705) * var_t1971; // dimensionless
        const double var_t2021 = (var_t776 * var_t843) * var_t1981; // dimensionless
        const double var_t2026 = ((((var_t792 * 12000.0) * var_t1966) * var_t1141) * var_t828) * var_t1971; // dimensionless
        const double var_t2030 = ((((((((((((var_t1960 + var_t1982) + var_t1986) - var_t1993) - var_t1996) + var_t2000) - var_t2006) - var_t2010) + var_t2013) + var_t2015) - var_t2019) + var_t2021) - var_t2026) + (((var_t736 * var_t697) * 12000.0) * var_t1951); // dimensionless
        const double var_t2042 = var_t1232 * var_t1135; // dimensionless
        const double var_t2047 = ((((var_t1960 + var_t1982) + var_t1986) - var_t1993) - var_t1996) * var_t1153; // dimensionless
        const double var_t2059 = 5000.0 * var_t2030; // dimensionless
        const double var_t2068 = (((((var_t2000 - var_t2006) - var_t2010) + var_t2013) + var_t2015) - var_t2019) * var_t1153; // dimensionless
        const double var_t2083 = (1.0 * (((((((((((((((((((3.0 * var_t1624) * 144000000.0) * var_t1951) * var_t1153) * var_t1112) * var_t1118) * var_t1076) - ((((3.0 * var_t1164) * _lt_0_row[48]) * var_t1121) * var_t2030)) + (((9.0 * var_t1232) * var_t1997) * var_t1157)) - ((((3.0 * var_t1232) * var_t2001) * _lt_0_row[48]) * var_t1972)) - (((3.0 * var_t2042) * _lt_0_row[66]) * var_t1975)) - (((3.0 * var_t2047) * var_t789) * var_t961)) + ((((3.0 * var_t1251) * var_t791) * 12000.0) * var_t2030)) + ((((var_t2021 - var_t2026) * var_t1153) * var_chaste_interface__intracellular_ions__nass) * var_t1269)) - ((var_t1273 * var_t1080) * var_t2059)) + ((var_t1277 * _lt_0_row[41]) * var_t1081)) - (((var_t1277 * var_t1079) * var_t1102) * _lt_0_row[67])) - ((var_t2068 * NV_Ith_S(mParameters, 4)) * var_t1011)) + ((var_t1294 * var_t688) * var_t2059))) + (2.0 * ((((var_t2068 * 5000.0) - ((var_t1293 * 5000.0) * var_t2030)) - (var_t2047 * var_t777)) + ((var_t1308 * var_t1037) * var_t2030))); // dimensionless
        const double var_t2084 = var_t1072 * var_t2083; // dimensionless
        const double var_t2089 = 1.0364305332435094e-05 * var_t18; // dimensionless
        const double var_t2091 = (((var_t85 * 8314.0) * 310.0) * var_t2089) * var_t115; // dimensionless
        const double var_t2095 = 0.003212934653054879 * var_t18; // dimensionless
        const double var_t2098 = ((((0.43033148290000001 * var_t592) * var_t642) * _lt_0_row[25]) * 8314.0) * var_t2095; // dimensionless
        const double var_t2100 = (var_t71 * 2577340.0) * var_t1616; // dimensionless
        const double var_t2102 = (var_t59 * 2577340.0) * var_t2089; // dimensionless
        const double var_t2109 = (((((73759717314.48764 * var_t482) * _lt_0_row[16]) * var_t172) * 687.20000000000005) * var_t153) * 2.0; // dimensionless
        const double var_t2113 = (((var_t294 * var_t295) * 40.0) * var_chaste_interface__intracellular_ions__ki) * var_t301; // dimensionless
        const double var_t2114 = 2.0 * var_t2113; // dimensionless
        const double var_t2117 = 8.0 * var_t172; // dimensionless
        const double var_t2122 = ((((var_t297 * var_t2117) * 333060.0) * var_t224) * 1.732653031203624e-08) * var_t153; // dimensionless
        const double var_t2123 = 2.0 * var_t2122; // dimensionless
        const double var_t2125 = (var_t1797 * 1.732653031203624e-08) * 0.0034246575342465752; // dimensionless
        const double var_t2127 = (var_t297 * var_t1794) * var_t2125; // dimensionless
        const double var_t2129 = (var_chaste_interface__intracellular_ions__ki * 4.0) * var_t156; // dimensionless
        const double var_t2132 = (54976.0 * var_t2129) * var_t244; // dimensionless
        const double var_t2139 = (((((54976.0 * var_t208) * 8.0) * var_t172) * var_t276) * 1.732653031203624e-15) * var_t153; // dimensionless
        const double var_t2142 = ((var_t304 * var_t1809) * 1.732653031203624e-15) * 0.0034246575342465752; // dimensionless
        const double var_t2145 = ((var_t1814 * var_t520) * var_t282) * 0.0034246575342465752; // dimensionless
        const double var_t2146 = var_t153 * 2.0; // dimensionless
        const double var_t2150 = (((2.0 * var_t1823) * var_t520) * var_t1781) * var_t2146; // dimensionless
        const double var_t2159 = (var_t250 * 364.80000000000007) * var_t2129; // dimensionless
        const double var_t2164 = var_t2117 * var_t153; // dimensionless
        const double var_t2165 = var_t395 * var_t2164; // dimensionless
        const double var_t2166 = ((var_t294 * var_t295) * 182.40000000000001) * var_t2165; // dimensionless
        const double var_t2168 = _lt_0_row[9] * var_t172; // dimensionless
        const double var_t2174 = (((((var_t306 * var_t2168) * 687.20000000000005) * var_t353) * var_t206) * var_t153) * 2.0; // dimensionless
        const double var_t2177 = (var_t326 * 2.0) * var_t2129; // dimensionless
        const double var_t2179 = var_t326 * var_t2165; // dimensionless
        const double var_t2182 = (var_t330 * var_t207) * var_t2129; // dimensionless
        const double var_t2185 = (var_t321 * var_t251) * var_t2164; // dimensionless
        const double var_t2192 = (var_t133 * var_t2168) * var_t2146; // dimensionless
        const double var_t2194 = (2.0 * var_t1865) * var_t2192; // dimensionless
        const double var_t2197 = ((2.0 * var_t193) * var_t1864) * var_t2192; // dimensionless
        const double var_t2201 = (((var_t1877 * var_t1878) * _lt_0_row[16]) * var_t156) * 0.0034246575342465752; // dimensionless
        const double var_t2204 = ((_lt_0_row[16] * var_t172) * var_t153) * 2.0; // dimensionless
        const double var_t2207 = ((2.0 * var_t454) * var_t1878) * var_t2204; // dimensionless
        const double var_t2209 = ((((((((((-var_t2109) + (4.0 * var_t2113)) - (4.0 * var_t2122)) - (2.0 * var_t2127)) + var_t2132) - var_t2139) - var_t2142) - var_t2145) - var_t2150) + (2.0 * var_t2159)) + ((((((((((( -2.0 * var_t2166) - (2.0 * var_t2174)) + (2.0 * var_t2177)) - (2.0 * var_t2179)) + (2.0 * var_t2182)) - (2.0 * var_t2185)) - (((var_t1855 * var_t339) * var_t340) * 0.00017123287671232877)) - var_t2194) - var_t2197) - var_t2201) - var_t2207); // dimensionless
        const double var_t2244 = var_t119 * ((3.0 * ((((((((((((((((-var_t2109) + var_t2114) - var_t2123) - var_t2127) + var_t2132) - var_t2139) - var_t2142) - var_t2145) - var_t2150) * var_t369) * 1899.0) * var_t320) - (((var_t377 * var_t319) * var_t206) * var_t2209)) - ((((2.0 * ((((((var_t2159 - var_t2166) - var_t2174) + var_t2177) - var_t2179) + var_t2182) - var_t2185)) * var_t369) * 79300.0) * var_t300)) + (((var_t549 * var_t224) * 1.732653031203624e-08) * var_t2209)) + (var_t1902 * var_t2125))) + (1.0 * (((((((2.0 * ((((((var_t2114 - var_t2123) - var_t2127) - var_t2194) - var_t2197) - var_t2201) - var_t2207)) * var_t369) * 9.120000000000001) - (((2.0 * var_t559) * 9.120000000000001) * var_t2209)) + (((((2.0 * var_t1913) * var_t340) * 0.00017123287671232877) * var_t369) * var_t314)) + ((((2.0 * var_t568) * _lt_0_row[16]) * var_t156) * var_t2209)) + ((4.0 * var_t1925) * var_t2204)))); // dimensionless
        const double var_t2246 = (var_t588 * 8314.0) * var_t2095; // dimensionless
        const double var_t2250 = ( -0.00026804999999999998 * var_t1941) - (0.00029485500000000001 * var_t1945); // dimensionless
        const double var_t2251 = var_t1540 * 0.050000000000000003; // dimensionless
        const double var_t2252 = var_t2251 * var_t86; // dimensionless
        const double var_t2253 = var_t1538 * var_t2252; // dimensionless
        const double var_t2254 = pow(var_t90, 2.0); // dimensionless
        const double var_t2255 = 1.0 / var_t2254; // dimensionless
        const double var_t2256 = var_t2255 * 0.0015; // dimensionless
        const double var_t2264 = var_t2256 * var_t1068; // dimensionless
        const double var_t2265 = var_t87 * var_t2264; // dimensionless
        const double var_t2269 = (var_t1535 * var_t1046) * ((((((-var_t2253) * var_t2256) * var_t1068) * var_t1051) * var_chaste_interface__INa__j) + ((((var_t1547 * var_chaste_interface__INa__jp) * 0.14999999999999999) * var_t1540) * var_t2265)); // dimensionless
        const double var_t2270 = var_t1538 * var_t2251; // dimensionless
        const double var_t2271 = var_t86 * var_t2255; // dimensionless
        const double var_t2272 = 0.0015 * var_t1068; // dimensionless
        const double var_t2280 = (var_t1555 * var_chaste_interface__INaL__mL) * (((((-var_t2270) * var_t2271) * var_t2272) * var_chaste_interface__INaL__hL) + ((var_t1559 * var_t1549) * var_t2265)); // dimensionless
        const double var_t2289 = (((((-var_t2253) * var_t2256) * var_t1068) * var_chaste_interface__Ito__a) * var_t108) + ((((var_t1567 * var_t113) * 0.14999999999999999) * var_t1540) * var_t2265); // dimensionless
        const double var_t2292 = (var_t2270 * var_t2271) * var_t2272; // dimensionless
        const double var_t2293 = var_t1337 * var_chaste_interface__membrane__v; // dimensionless
        const double var_t2294 = var_t2293 * 1119720.378277604; // dimensionless
        const double var_t2297 = ((4.0 * var_t2292) * var_t2294) * var_t1514; // dimensionless
        const double var_t2301 = ((4.0 * var_t1938) * _lt_0_row[69]) * var_t1438; // dimensionless
        const double var_t2302 = var_t1579 * (var_chaste_interface__membrane__v * 9309355225.0); // dimensionless
        const double var_t2306 = (var_t1421 * var_t1549) * var_t2265; // dimensionless
        const double var_t2308 = (((4.4000000000000004 * var_t2302) * 3.8799692706433766e-07) * var_t1345) * var_t2306; // dimensionless
        const double var_t2311 = ((4.4000000000000004 * var_t1943) * _lt_0_row[69]) * var_t1506; // dimensionless
        const double var_t2314 = ((0.00125 * var_t2292) * var_t2294) * var_t1492; // dimensionless
        const double var_t2315 = 3.8799692706433766e-07 * var_t1472; // dimensionless
        const double var_t2318 = ((0.0013749999999999999 * var_t2302) * var_t2315) * var_t2306; // dimensionless
        const double var_t2320 = (var_t2292 * var_t2294) * var_t1469; // dimensionless
        const double var_t2322 = 3.8799692706433766e-07 * var_t1406; // dimensionless
        const double var_t2325 = ((0.00039313999999999999 * var_t2302) * var_t2322) * var_t2306; // dimensionless
        const double var_t2344 = (1.0 * (((((3.0 * var_t2042) * var_t1157) - (((3.0 * var_t1256) * var_t789) * var_t961)) + ((var_t1277 * var_chaste_interface__intracellular_ions__nass) * var_t1269)) - ((var_t1297 * NV_Ith_S(mParameters, 4)) * var_t1011))) + (2.0 * ((var_t1297 * 5000.0) - (var_t1256 * var_t777))); // dimensionless
        const double var_t2349 = ((((var_t668 / pow(var_t1070, 2.0)) * var_t2344) * 2.2499999999999996e-08) / var_t1067) / var_chaste_interface__intracellular_ions__cass; // dimensionless
        const double var_t2351 = var_t1118 * 1500000.0; // dimensionless
        const double var_t2355 = 2250000000000.0 * var_t787; // dimensionless
        const double var_t2357 = (var_t776 * var_t2355) * var_t1118; // dimensionless
        const double var_t2359 = (var_t778 * var_t688) * var_t696; // dimensionless
        const double var_t2362 = ((var_t2359 * 800.0) * var_t2351) * var_t828; // dimensionless
        const double var_t2363 = (((var_t1111 * var_t2351) + (var_t1140 * var_t1705)) + var_t2357) + var_t2362; // dimensionless
        const double var_t2368 = var_t1111 * var_t1118; // dimensionless
        const double var_t2372 = var_t735 * var_t780; // dimensionless
        const double var_t2383 = 5000.0 * var_t2363; // dimensionless
        const double var_t2407 = var_t1072 * ((1.0 * (((((((((( -3.0 * var_t1164) * _lt_0_row[48]) * var_t1121) * var_t2363) - (((((3.0 * var_t2368) * 1500000.0) * var_t1153) * var_t179) * var_t2372)) + ((((3.0 * var_t1251) * var_t791) * 12000.0) * var_t2363)) + ((((var_t2357 + var_t2362) * var_t1153) * var_chaste_interface__intracellular_ions__nass) * var_t1269)) - ((var_t1273 * var_t1080) * var_t2383)) - (((var_t1140 * var_t1705) * var_t1153) * var_t786)) + ((var_t1294 * var_t688) * var_t2383))) + (2.0 * (((((((var_t1140 * 1500000.0) * var_t782) * var_t1153) * 5000.0) - ((var_t1293 * 5000.0) * var_t2363)) - (((var_t2368 * 2250000000000.0) * var_t1153) * var_t776)) + ((var_t1308 * var_t1037) * var_t2363)))); // dimensionless
        const double var_t2414 = (var_t61 / pow(var_t65, 2.0)) * pow(var_t62, 0.40000000000000002); // dimensionless
        const double var_t2415 = var_t671 * var_chaste_interface__IKs__xs1; // dimensionless
        const double var_t2422 = var_chaste_interface__membrane__v - (26.712338705498265 * log((NV_Ith_S(mParameters, 3) + (0.018329999999999999 * NV_Ith_S(mParameters, 4))) * var_t1615)); // dimensionless
        const double var_t2423 = var_chaste_interface__IKs__xs2 * var_t2422; // dimensionless
        const double var_t2445 = (1.0 * (((((3.0 * var_t1730) * var_t858) - (((3.0 * var_t971) * var_t789) * var_t961)) + ((var_t996 * var_chaste_interface__intracellular_ions__nai) * var_t988)) - ((var_t1018 * NV_Ith_S(mParameters, 4)) * var_t1011))) + (2.0 * ((var_t1018 * 5000.0) - (var_t971 * var_t777))); // dimensionless
        const double var_t2450 = ((((var_t668 / pow(var_t673, 2.0)) * var_t2445) * 2.2499999999999996e-08) / var_t670) / var_chaste_interface__intracellular_ions__cai; // dimensionless
        const double var_t2452 = var_t812 * 1500000.0; // dimensionless
        const double var_t2456 = (var_t776 * var_t2355) * var_t812; // dimensionless
        const double var_t2459 = ((var_t2359 * 800.0) * var_t2452) * var_t828; // dimensionless
        const double var_t2460 = (((var_t806 * var_t2452) + (var_t839 * var_t1705)) + var_t2456) + var_t2459; // dimensionless
        const double var_t2465 = var_t806 * var_t812; // dimensionless
        const double var_t2479 = 5000.0 * var_t2460; // dimensionless
        const double var_t2503 = var_t675 * ((1.0 * (((((((((( -3.0 * var_t865) * _lt_0_row[48]) * var_t817) * var_t2460) - (((((3.0 * var_t2465) * 1500000.0) * var_t854) * var_t179) * var_t2372)) + ((((3.0 * var_t966) * var_t791) * 12000.0) * var_t2460)) + ((((var_t2456 + var_t2459) * var_t854) * var_chaste_interface__intracellular_ions__nai) * var_t988)) - ((var_t992 * var_t713) * var_t2479)) - (((var_t839 * var_t1705) * var_t854) * var_t786)) + ((var_t1015 * var_t688) * var_t2479))) + (2.0 * (((((((var_t839 * 1500000.0) * var_t782) * var_t854) * 5000.0) - ((var_t1014 * 5000.0) * var_t2460)) - (((var_t2465 * 2250000000000.0) * var_t854) * var_t776)) + ((var_t1036 * var_t1037) * var_t2460)))); // dimensionless
        const double var_t2505 = 0.00050000000000000001 + var_chaste_interface__intracellular_ions__cai; // dimensionless
        const double var_t2506 = 1.0 / var_t2505; // dimensionless
        const double var_t2507 = NV_Ith_S(mParameters, 9) * var_t2506; // dimensionless
        const double var_t2508 = NV_Ith_S(mParameters, 9) * var_chaste_interface__intracellular_ions__cai; // dimensionless
        const double var_t2511 = var_t2508 / pow(var_t2505, 2.0); // dimensionless
        const double var_t2512 = var_t1316 * 9309355225.0; // dimensionless
        const double var_t2515 = ((4.0 * var_t2512) * 3.8799692706433766e-07) * _lt_0_row[56]; // dimensionless
        const double var_t2518 = (var_t1535 * var_t1045) * var_t1058; // dimensionless
        const double var_t2526 = (var_t1535 * var_t1046) * (((var_t98 * 0.98999999999999999) * var_chaste_interface__INa__j) + ((var_t97 * 0.98999999999999999) * var_chaste_interface__INa__jp)); // dimensionless
        const double var_t2527 = var_t1535 * var_t1046; // dimensionless
        const double var_t2531 = var_t1046 * var_t98; // dimensionless
        const double var_t2533 = (var_t1535 * var_t2531) * var_t1051; // dimensionless
        const double var_t2537 = var_t1046 * var_t97; // dimensionless
        const double var_t2539 = (var_t1535 * var_t2537) * var_t1055; // dimensionless
        const double var_t2542 = (var_t1555 * var_chaste_interface__INaL__mL) * var_t98; // dimensionless
        const double var_t2544 = (var_t1555 * var_chaste_interface__INaL__mL) * var_t97; // dimensionless
        const double var_t2546 = (var_t646 * var_t98) * var_t108; // dimensionless
        const double var_t2548 = (var_t646 * var_t99) * _lt_0_row[6]; // dimensionless
        const double var_t2550 = (var_t646 * var_t99) * _lt_0_row[7]; // dimensionless
        const double var_t2552 = (var_t646 * var_t97) * var_t113; // dimensionless
        const double var_t2554 = (var_t646 * var_t110) * _lt_0_row[6]; // dimensionless
        const double var_t2556 = (var_t646 * var_t110) * _lt_0_row[7]; // dimensionless
        const double var_t2557 = var_t1338 * (var_chaste_interface__membrane__v * 9309355225.0); // dimensionless
        const double var_t2561 = (((4.0 * var_t2557) * 3.8799692706433766e-07) * var_t1345) * var_t1437; // dimensionless
        const double var_t2562 = var_t1370 * (var_chaste_interface__membrane__v * 9309355225.0); // dimensionless
        const double var_t2566 = (((4.4000000000000004 * var_t2562) * 3.8799692706433766e-07) * var_t1345) * var_t1393; // dimensionless
        const double var_t2570 = (((0.00125 * var_t2557) * 3.8799692706433766e-07) * var_t1472) * var_t1437; // dimensionless
        const double var_t2574 = (((0.0013749999999999999 * var_t2562) * 3.8799692706433766e-07) * var_t1472) * var_t1393; // dimensionless
        const double var_t2577 = ((var_t2557 * 3.8799692706433766e-07) * var_t1406) * var_t1437; // dimensionless
        const double var_t2582 = (((0.00039313999999999999 * var_t2562) * 3.8799692706433766e-07) * var_t1406) * var_t1393; // dimensionless
        const double var_t2585 = 0.59999999999999998 - (0.59999999999999998 * var_chaste_interface__ICaL__nca); // dimensionless
        const double var_t2587 = (var_t1510 * var_t1429) * var_t2585; // dimensionless
        const double var_t2590 = var_t1377 * var_t2585; // dimensionless
        const double var_t2591 = var_t1376 * var_t2590; // dimensionless
        const double var_t2594 = var_t1452 * var_t2590; // dimensionless
        const double var_t2599 = 0.40000000000000002 - (0.40000000000000002 * var_chaste_interface__ICaL__nca); // dimensionless
        const double var_t2601 = (var_t1510 * var_t1429) * var_t2599; // dimensionless
        const double var_t2603 = (4.0 * var_t1938) * var_t2601; // dimensionless
        const double var_t2605 = (4.4000000000000004 * var_t1943) * var_t2601; // dimensionless
        const double var_t2606 = var_t1377 * var_t2599; // dimensionless
        const double var_t2607 = var_t1376 * var_t2606; // dimensionless
        const double var_t2609 = (0.00125 * var_t1938) * var_t2607; // dimensionless
        const double var_t2611 = (0.0013749999999999999 * var_t1943) * var_t2607; // dimensionless
        const double var_t2612 = var_t1452 * var_t2606; // dimensionless
        const double var_t2613 = var_t1938 * var_t2612; // dimensionless
        const double var_t2616 = (0.00039313999999999999 * var_t1943) * var_t2612; // dimensionless
        const double var_t2618 = var_chaste_interface__ICaL__jca * _lt_0_row[62]; // dimensionless
        const double var_t2619 = var_t2618 * var_chaste_interface__ICaL__nca; // dimensionless
        const double var_t2620 = var_t1346 * var_t2619; // dimensionless
        const double var_t2623 = var_t1473 * var_t2619; // dimensionless
        const double var_t2626 = var_t1407 * var_t2619; // dimensionless
        const double var_t2631 = (var_chaste_interface__ICaL__jca * _lt_0_row[61]) * var_chaste_interface__ICaL__nca; // dimensionless
        const double var_t2632 = var_t1346 * var_t2631; // dimensionless
        const double var_t2634 = (4.0 * var_t1342) * var_t2632; // dimensionless
        const double var_t2636 = (4.4000000000000004 * var_t1401) * var_t2632; // dimensionless
        const double var_t2637 = var_t1473 * var_t2631; // dimensionless
        const double var_t2639 = (0.00125 * var_t1342) * var_t2637; // dimensionless
        const double var_t2641 = (0.0013749999999999999 * var_t1401) * var_t2637; // dimensionless
        const double var_t2642 = var_t1407 * var_t2631; // dimensionless
        const double var_t2643 = var_t1342 * var_t2642; // dimensionless
        const double var_t2646 = (0.00039313999999999999 * var_t1401) * var_t2642; // dimensionless
        const double var_t2648 = var_t1510 * _lt_0_row[3]; // dimensionless
        const double var_t2650 = (var_chaste_interface__ICaL__d * var_t1434) * var_chaste_interface__ICaL__nca; // dimensionless
        const double var_t2653 = ((4.0 * var_t1938) * var_t2648) * var_t2650; // dimensionless
        const double var_t2655 = (var_chaste_interface__ICaL__d * var_t1390) * var_chaste_interface__ICaL__nca; // dimensionless
        const double var_t2658 = ((4.4000000000000004 * var_t1943) * var_t2648) * var_t2655; // dimensionless
        const double var_t2659 = var_t1376 * _lt_0_row[1]; // dimensionless
        const double var_t2662 = ((0.00125 * var_t1938) * var_t2659) * var_t2650; // dimensionless
        const double var_t2665 = ((0.0013749999999999999 * var_t1943) * var_t2659) * var_t2655; // dimensionless
        const double var_t2666 = var_t1452 * _lt_0_row[1]; // dimensionless
        const double var_t2668 = (var_t1938 * var_t2666) * var_t2650; // dimensionless
        const double var_t2672 = ((0.00039313999999999999 * var_t1943) * var_t2666) * var_t2655; // dimensionless
        const double var_t2689 = (( -0.59999999999999998 * var_chaste_interface__ICaL__ff) - var_t1379) + var_t1435; // dimensionless
        const double var_t2693 = (((4.0 * var_t1938) * var_t1510) * var_t1429) * var_t2689; // dimensionless
        const double var_t2695 = (( -0.59999999999999998 * var_chaste_interface__ICaL__ffp) - var_t1379) + var_t1391; // dimensionless
        const double var_t2699 = (((4.4000000000000004 * var_t1943) * var_t1510) * var_t1429) * var_t2695; // dimensionless
        const double var_t2700 = var_t1377 * var_t2689; // dimensionless
        const double var_t2703 = ((0.00125 * var_t1938) * var_t1376) * var_t2700; // dimensionless
        const double var_t2704 = var_t1377 * var_t2695; // dimensionless
        const double var_t2707 = ((0.0013749999999999999 * var_t1943) * var_t1376) * var_t2704; // dimensionless
        const double var_t2709 = (var_t1938 * var_t1452) * var_t2700; // dimensionless
        const double var_t2713 = ((0.00039313999999999999 * var_t1943) * var_t1452) * var_t2704; // dimensionless
        const double var_t2721 = var_t69 * var_t2423; // dimensionless
        const double var_t2723 = (var_t69 * var_chaste_interface__IKs__xs1) * var_t2422; // dimensionless
        const double var_t2725 = (var_t7 * var_t57) * var_t23; // dimensionless
        const double var_t2856 = 11.605123887418811 * var_t1376; // dimensionless
        const double var_t2859 = var_t2590 * 12674.18181818182; // dimensionless
        const double var_t2867 = var_t1338 * (var_chaste_interface__membrane__v * 96485.0); // dimensionless
        const double var_t2872 = (((var_chaste_interface__ICaL__d * var_chaste_interface__ICaL__jca) * _lt_0_row[62]) * var_chaste_interface__ICaL__nca) * 12674.18181818182; // dimensionless
        const double var_t2888 = var_t1370 * (var_chaste_interface__membrane__v * 96485.0); // dimensionless
        const double var_t2950 = ((var_t23 * 1.0) * 0.00015335760000000003) * 856.55415970537967; // dimensionless
        const double var_t2995 = 11.605123887418811 * var_t1452; // dimensionless
        const double var_t3033 = 0.00087000000000000001 + var_chaste_interface__intracellular_ions__cass; // dimensionless
        const double var_t3034 = pow(var_t3033, 2.0); // dimensionless
        const double var_t3038 = 0.0086999999999999994 + var_chaste_interface__intracellular_ions__cass; // dimensionless
        const double var_t3039 = pow(var_t3038, 2.0); // dimensionless
        const double var_t3042 = (1.0 + (4.0890000000000003e-05 / var_t3034)) + (0.0097788000000000007 / var_t3039); // dimensionless
        const double var_t3043 = 1.0 / var_t3042; // dimensionless
        const double var_t3050 = var_t1578 - var_t1586; // dimensionless
        const double var_t3056 = (var_t1538 * var_t1556) * var_chaste_interface__ryr__Jrelnp; // dimensionless
        const double var_t3058 = var_t1537 * var_chaste_interface__ryr__Jrelp; // dimensionless
        const double var_t3059 = var_t3058 * var_t1550; // dimensionless
        const double var_t3071 = (4.0 * var_t1938) * var_t1514; // dimensionless
        const double var_t3073 = (4.4000000000000004 * var_t1943) * var_t1511; // dimensionless
        const double var_t3081 = var_t98 * var_chaste_interface__ryr__Jrelnp; // dimensionless
        const double var_t3083 = var_t97 * var_chaste_interface__ryr__Jrelp; // dimensionless
        const double var_t3106 = ((var_t2270 * var_t2271) * var_t2272) * var_chaste_interface__ryr__Jrelnp; // dimensionless
        const double var_t3109 = (var_t3058 * var_t1549) * var_t2265; // dimensionless
        const double var_t3115 = (-var_t2561) - var_t2566; // dimensionless
        const double var_t3120 = var_t3043 * var_t98; // dimensionless
        const double var_t3123 = var_chaste_interface__ICaL__d * var_t2585; // dimensionless
        const double var_t3125 = (var_t1345 * var_t3123) * 12674.18181818182; // dimensionless
        const double var_t3128 = (-var_t2603) - var_t2605; // dimensionless
        const double var_t3134 = 11.605123887418811 * var_t1510; // dimensionless
        const double var_t3141 = (((((var_t1429 * var_t2618) * var_chaste_interface__ICaL__nca) * 1.0) * 0.00015335760000000003) * 826446.28099173552) * 100.0; // dimensionless
        const double var_t3144 = (-var_t2634) - var_t2636; // dimensionless
        const double var_t3149 = (-var_t2653) - var_t2658; // dimensionless
        const double var_t3154 = var_t3043 * var_t97; // dimensionless
        const double var_t3163 = (-var_t2693) - var_t2699; // dimensionless
        const double var_t3174 = var_chaste_interface__intracellular_ions__cai + 0.00092000000000000003; // dimensionless
        const double var_t3175 = 1.0 / var_t3174; // dimensionless
        const double var_t3176 = var_chaste_interface__intracellular_ions__cai * var_t3175; // dimensionless
        const double var_t3180 = var_t1537 * 1.0; // dimensionless
        const double var_t3182 = var_chaste_interface__intracellular_ions__cai + 0.00075000000000000002; // dimensionless
        const double var_t3183 = 1.0 / var_t3182; // dimensionless
        const double var_t3188 = (((( -0.0043750000000000004 * var_t1541) * var_t1543) * 1.0) * var_t3176) + (((((0.01203125 * var_t3180) * var_chaste_interface__intracellular_ions__cai) * var_t3183) * 0.14999999999999999) * var_t1556); // dimensionless
        const double var_t3195 = var_chaste_interface__intracellular_ions__cai * var_t3183; // dimensionless
        const double var_t3202 = NV_Ith_S(mParameters, 1) * (((((( -0.0043750000000000004 * var_t2253) * var_t2264) * 1.0) * var_chaste_interface__intracellular_ions__cai) * var_t3175) + (((((0.01203125 * var_t3180) * var_t3195) * 0.14999999999999999) * var_t2252) * var_t2264)); // dimensionless
        const double var_t3205 = var_t98 * 1.0; // dimensionless
        const double var_t3213 = var_t97 * 1.0; // dimensionless
        const double var_t3222 = NV_Ith_S(mParameters, 1) * (((((0.0043750000000000004 * var_t3205) * var_t3175) - (((0.0043750000000000004 * var_t3205) * var_chaste_interface__intracellular_ions__cai) / pow(var_t3174, 2.0))) + ((0.01203125 * var_t3213) * var_t3183)) - (((0.01203125 * var_t3213) * var_chaste_interface__intracellular_ions__cai) / pow(var_t3182, 2.0))); // dimensionless
        const double var_t3224 = 0.80000000000000004 + var_chaste_interface__intracellular_ions__cajsr; // dimensionless
        const double var_t3225 = pow(var_t3224, 2.0); // dimensionless
        const double var_t3228 = 1.0 + (8.0 / var_t3225); // dimensionless
        const double var_t3229 = 1.0 / var_t3228; // dimensionless
        const double var_t3234 = 0.01 * var_t3229; // dimensionless
        const double var_t3252 = 0.0023800000000000002 + var_chaste_interface__intracellular_ions__cai; // dimensionless
        const double var_t3253 = pow(var_t3252, 2.0); // dimensionless
        const double var_t3257 = 0.00050000000000000001 + var_chaste_interface__intracellular_ions__cai; // dimensionless
        const double var_t3258 = pow(var_t3257, 2.0); // dimensionless
        const double var_t3261 = (1.0 + (0.00011900000000000002 / var_t3253)) + (3.5000000000000004e-05 / var_t3258); // dimensionless
        const double var_t3262 = 1.0 / var_t3261; // dimensionless
        const double var_t3269 = var_t3262 * NV_Ith_S(mParameters, 1); // dimensionless
        const double var_t3556 = _lt_0_row[70] - var_chaste_interface__Ito__iF; // dimensionless
        const double var_t3594 = _lt_0_row[70] - var_chaste_interface__Ito__iS; // dimensionless
        const double var_t3646 = _lt_0_row[70] - var_chaste_interface__Ito__iFp; // dimensionless
        const double var_t3660 = var_t3646 * _lt_0_row[71]; // dimensionless
        const double var_t3670 = var_t3660 * _lt_0_row[72]; // dimensionless
        const double var_t3685 = _lt_0_row[70] - var_chaste_interface__Ito__iSp; // dimensionless
        const double var_t3691 = var_t3685 * _lt_0_row[71]; // dimensionless
        const double var_t3696 = var_t3691 * _lt_0_row[72]; // dimensionless
        const double var_t3870 = 1.0 + (0.002 * var_t88); // dimensionless
        const double var_t3871 = pow(var_t3870, 2.0); // dimensionless
        const double var_t3875 = 1.0 / pow((1000.0 / var_chaste_interface__ICaL__jca) + pow(var_t3871, 2.0), 2.0); // dimensionless
        const double var_t4002 = 1.0 / ((1.5691999999999999 * NV_Ith_S(mParameters, 3)) + 3.8115000000000001); // dimensionless
        const double var_t4004 = exp((((-var_chaste_interface__membrane__v) - (2.5537999999999998 * NV_Ith_S(mParameters, 3))) - 144.59) * var_t4002); // dimensionless
        const double var_t4005 = 1.0 + var_t4004; // dimensionless
        const double var_t4032 = pow(var_chaste_interface__intracellular_ions__cajsr, 2.0); // dimensionless
        const double var_t4034 = pow(pow(var_t4032, 2.0), 2.0); // dimensionless
        const double var_t4037 = 1.0 + (25.62890625 / var_t4034); // dimensionless
        const double var_t4038 = 1.0 / var_t4037; // dimensionless
        const double var_t4039 = (4.75 * (((((((var_t1516 + var_t1441) - var_t1520) + var_t1363) + var_t1513) + var_t1509) - var_t1505) + var_t1497)) * var_t4038; // dimensionless
        const double var_t4043 = 1.0 / var_chaste_interface__intracellular_ions__cajsr; // dimensionless
        const double var_t4047 = 4.75 / (1.0 + (0.0123 * var_t4043)); // dimensionless
        const double var_t4049 = (var_t4047 < 0.001) ? 0.001 : var_t4047; // dimensionless
        const double var_t4050 = 1.0 / var_t4049; // dimensionless
        const double var_t4053 = ( -4.75 * var_t3050) * var_t4038; // dimensionless
        const double var_t4060 = (4.75 * ((((-var_t2297) + var_t2301) + var_t2308) + var_t2311)) * var_t4038; // dimensionless
        const double var_t4066 = 4.75 * (var_t3071 + var_t3073); // dimensionless
        const double var_t4072 = ((var_t4066 / pow(var_t4037, 2.0)) / var_t4034) / var_chaste_interface__intracellular_ions__cajsr; // dimensionless
        const double var_t4077 = var_t4066 * var_t4038; // dimensionless
        const double var_t4091 = (4.75 / pow(1.0 + (0.0123 * var_t4043), 2.0)) / var_t4032; // dimensionless
        const double var_t4096 = ( -4.75 * var_t3115) * var_t4038; // dimensionless
        const double var_t4102 = (4.75 * var_t98) * var_t1337; // dimensionless
        const double var_t4105 = (var_t2648 * var_t3123) * var_t4038; // dimensionless
        const double var_t4106 = (var_t4102 * ((var_chaste_interface__membrane__v * 9309355225.0) * 0.00012027904738994468)) * var_t4105; // dimensionless
        const double var_t4112 = ( -4.75 * var_t3128) * var_t4038; // dimensionless
        const double var_t4121 = ((var_t1346 * var_t2618) * var_chaste_interface__ICaL__nca) * var_t4038; // dimensionless
        const double var_t4122 = (var_t4102 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07)) * var_t4121; // dimensionless
        const double var_t4128 = ( -4.75 * var_t3144) * var_t4038; // dimensionless
        const double var_t4134 = ( -4.75 * var_t3149) * var_t4038; // dimensionless
        const double var_t4140 = (4.75 * var_t97) * var_t1337; // dimensionless
        const double var_t4142 = (var_t4140 * ((var_chaste_interface__membrane__v * 9309355225.0) * 0.00012027904738994468)) * var_t4105; // dimensionless
        const double var_t4148 = (var_t4140 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07)) * var_t4121; // dimensionless
        const double var_t4154 = ( -4.75 * var_t3163) * var_t4038; // dimensionless
        const double var_t4162 = 1.25 * var_t4047; // dimensionless
        const double var_t4164 = (var_t4162 < 0.001) ? 0.001 : var_t4162; // dimensionless
        const double var_t4165 = 1.0 / var_t4164; // dimensionless
        
        // Matrix entries
        DENSE_ELEM(rJacobian, 0, 0) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((((((((((((var_t27 - var_t43) - var_t56) - var_t59) - var_t71) - var_t83) - var_t116) - var_t586) - var_t588) + var_t618) - var_t633) + (((((((((((var_t641 - var_t645) - var_t665) - (0.80000000000000004 * var_t1043)) - var_t1059) - var_t1066) - (0.20000000000000001 * var_t1314)) - var_t1328) - var_t1334) - var_t1363) + var_t1369) - var_t1397)) + (((((((((((-var_t1415) + var_t1425) - var_t1441) - var_t1446) - var_t1451) - var_t1455) - (0.00035740000000000001 * var_t1457)) + (0.00035740000000000001 * var_t1462)) - var_t1467) - (0.00035740000000000001 * var_t1470)) - var_t1476)) + (((((((((((var_t1482 - var_t1485) + var_t1488) - var_t1491) - var_t1494) - var_t1497) + var_t1505) - var_t1509) - var_t1513) - var_t1516) + var_t1520) + var_t1525)));
        DENSE_ELEM(rJacobian, 2, 0) = var_chaste_interface__environment__fake_dt * ((((0.00046834020230000003 * (((((((-var_t1059) - var_t1066) - (2.3999999999999999 * var_t1043)) - (3.0 * var_t586)) - var_t43) - var_t1334) + var_t1369)) * 0.00015335760000000003) * 1.0) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 3, 0) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * (((((((((-var_t1494) - var_t1491) + var_t1488) - var_t1485) - var_t1397) - var_t1446) + var_t1482) - var_t1476) - (0.59999999999999998 * var_t1314))) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 4, 0) = var_chaste_interface__environment__fake_dt * ((((0.00046834020230000003 * ((((((((((((-var_t116) - var_t665) - var_t633) + var_t618) + var_t641) - var_t645) - var_t71) + var_t27) - var_t59) - var_t83) - var_t588) + (2.0 * var_t586))) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 5, 0) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * ((((((((0.00035740000000000001 * var_t1470) + var_t1467) - (0.00035740000000000001 * var_t1462)) + (0.00035740000000000001 * var_t1457)) + var_t1455) + var_t1451) - var_t1425) + var_t1415)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 0) = var_chaste_interface__environment__fake_dt * ((((0.00796178344 * var_t3043) * (((((((((-var_t1516) - var_t1441) + var_t1520) - var_t1363) - var_t1513) - var_t1509) + var_t1505) - var_t1497) + (0.40000000000000002 * var_t1314))) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 9, 0) = var_chaste_interface__environment__fake_dt * ((((0.0002341701012 * var_t3262) * ((((-var_t56) - var_t1328) + var_t1525) + (1.6000000000000001 * var_t1043))) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 10, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[151] + ((_lt_0_row[152] - var_chaste_interface__INa__m) * _lt_0_row[133]));
        DENSE_ELEM(rJacobian, 11, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[135] + ((_lt_0_row[136] - var_chaste_interface__INa__hf) * _lt_0_row[137]));
        DENSE_ELEM(rJacobian, 12, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[139] + ((_lt_0_row[136] - var_chaste_interface__INa__hs) * _lt_0_row[140]));
        DENSE_ELEM(rJacobian, 13, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[145] + (((_lt_0_row[136] - var_chaste_interface__INa__j) / _lt_0_row[146]) * _lt_0_row[147]));
        DENSE_ELEM(rJacobian, 14, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[142] + ((0.33333333333333331 * (_lt_0_row[143] - var_chaste_interface__INa__hsp)) * _lt_0_row[140]));
        DENSE_ELEM(rJacobian, 15, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[149] + (((1.46 * (_lt_0_row[136] - var_chaste_interface__INa__jp)) / _lt_0_row[150]) * _lt_0_row[147]));
        DENSE_ELEM(rJacobian, 16, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[131] + ((_lt_0_row[132] - var_chaste_interface__INaL__mL) * _lt_0_row[133]));
        DENSE_ELEM(rJacobian, 17, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[128]);
        DENSE_ELEM(rJacobian, 18, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[129]);
        DENSE_ELEM(rJacobian, 19, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[154] + ((0.95102234900000004 * (_lt_0_row[155] - var_chaste_interface__Ito__a)) * _lt_0_row[156]));
        DENSE_ELEM(rJacobian, 20, 0) = var_chaste_interface__environment__fake_dt * ((_lt_0_row[160] + ((((var_t3556 * _lt_0_row[161]) * 1.0) * _lt_0_row[162]) * _lt_0_row[163])) - ((var_t3556 * _lt_0_row[164]) * 0.0));
        DENSE_ELEM(rJacobian, 21, 0) = var_chaste_interface__environment__fake_dt * ((_lt_0_row[173] + ((((var_t3594 * _lt_0_row[174]) * 1.0) * _lt_0_row[175]) * _lt_0_row[176])) - ((var_t3594 * _lt_0_row[177]) * 0.0));
        DENSE_ELEM(rJacobian, 22, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[157] + ((0.95102234900000004 * (_lt_0_row[158] - var_chaste_interface__Ito__ap)) * _lt_0_row[156]));
        DENSE_ELEM(rJacobian, 23, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[166] + (((((0.0001 * var_t3646) * _lt_0_row[167]) * _lt_0_row[72]) * _lt_0_row[168]) * _lt_0_row[169])) - ((((0.025000000000000001 * var_t3660) * _lt_0_row[170]) * _lt_0_row[168]) * _lt_0_row[171])) + ((((var_t3670 * _lt_0_row[161]) * 1.0) * _lt_0_row[162]) * _lt_0_row[163])) - (((var_t3670 * _lt_0_row[164]) * 1.0) * 0.0));
        DENSE_ELEM(rJacobian, 24, 0) = var_chaste_interface__environment__fake_dt * ((((_lt_0_row[179] + (((((0.0001 * var_t3685) * _lt_0_row[167]) * _lt_0_row[72]) * _lt_0_row[180]) * _lt_0_row[169])) - ((((0.025000000000000001 * var_t3691) * _lt_0_row[170]) * _lt_0_row[180]) * _lt_0_row[171])) + ((((var_t3696 * _lt_0_row[174]) * 1.0) * _lt_0_row[175]) * _lt_0_row[176])) - (((var_t3696 * _lt_0_row[177]) * 1.0) * 0.0));
        DENSE_ELEM(rJacobian, 25, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[74] + ((((_lt_0_row[75] - var_chaste_interface__ICaL__d) / _lt_0_row[76]) / _lt_0_row[77]) * _lt_0_row[78]));
        DENSE_ELEM(rJacobian, 26, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[93] + (((_lt_0_row[81] - var_chaste_interface__ICaL__ff) / _lt_0_row[94]) * _lt_0_row[95]));
        DENSE_ELEM(rJacobian, 27, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[100] + ((((_lt_0_row[81] - var_chaste_interface__ICaL__fs) / _lt_0_row[101]) / _lt_0_row[102]) * _lt_0_row[103]));
        DENSE_ELEM(rJacobian, 28, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[80] + (((_lt_0_row[81] - var_chaste_interface__ICaL__fcaf) / _lt_0_row[82]) * _lt_0_row[83]));
        DENSE_ELEM(rJacobian, 29, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[88] + ((((_lt_0_row[81] - var_chaste_interface__ICaL__fcas) / _lt_0_row[89]) / _lt_0_row[90]) * _lt_0_row[91]));
        DENSE_ELEM(rJacobian, 30, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[104]);
        DENSE_ELEM(rJacobian, 31, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[97] + (((2.5 * (_lt_0_row[81] - var_chaste_interface__ICaL__ffp)) / _lt_0_row[98]) * _lt_0_row[95]));
        DENSE_ELEM(rJacobian, 32, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[85] + (((2.5 * (_lt_0_row[81] - var_chaste_interface__ICaL__fcafp)) / _lt_0_row[86]) * _lt_0_row[83]));
        DENSE_ELEM(rJacobian, 34, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[109] + ((((_lt_0_row[110] - var_chaste_interface__IKr__xrf) / _lt_0_row[111]) / _lt_0_row[112]) * _lt_0_row[113]));
        DENSE_ELEM(rJacobian, 35, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[115] + ((((_lt_0_row[110] - var_chaste_interface__IKr__xrs) / _lt_0_row[116]) / _lt_0_row[117]) * _lt_0_row[118]));
        DENSE_ELEM(rJacobian, 36, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[120] + ((((_lt_0_row[121] - var_chaste_interface__IKs__xs1) / _lt_0_row[122]) / _lt_0_row[123]) * _lt_0_row[124]));
        DENSE_ELEM(rJacobian, 37, 0) = var_chaste_interface__environment__fake_dt * (_lt_0_row[126] + ((_lt_0_row[121] - var_chaste_interface__IKs__xs2) * _lt_0_row[127]));
        DENSE_ELEM(rJacobian, 38, 0) = var_chaste_interface__environment__fake_dt * (((((0.0081833060559999993 / pow(var_t4005, 2.0)) * var_t4002) * var_t4004) * _lt_0_row[106]) + ((0.0081833060559999993 * ((1.0 / var_t4005) - var_chaste_interface__IK1__xk1)) * _lt_0_row[107]));
        DENSE_ELEM(rJacobian, 39, 0) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4039) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 0) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4039) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 1) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((((((((-var_t1554) - var_t1563) - (var_t646 * var_t1570)) + var_t1578) - var_t1586) + var_t1590) - var_t1593) + (0.00035740000000000001 * var_t1596)) - var_t1600));
        DENSE_ELEM(rJacobian, 1, 1) = var_chaste_interface__environment__fake_dt * (((( -0.0025000000000000005 * var_t91) * var_t93) + (((0.0025000000000000005 * var_t86) * var_t91) * var_t1543)) - 0.00068000000000000005);
        DENSE_ELEM(rJacobian, 2, 1) = var_chaste_interface__environment__fake_dt * ((((0.00046834020230000003 * ((-var_t1554) - var_t1563)) * 0.00015335760000000003) * 1.0) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 3, 1) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * (var_t1590 - var_t1593)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 4, 1) = var_chaste_interface__environment__fake_dt * (((( -0.00046834020230000003 * var_t646) * var_t1570) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 5, 1) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * (( -0.00035740000000000001 * var_t1596) + var_t1600)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 1) = var_chaste_interface__environment__fake_dt * (var_t3043 * ((((((0.00796178344 * var_t3050) * 1.0) * 0.00015335760000000003) * 856.55415970537967) - (0.23999999999999999 * var_t3056)) + (0.23999999999999999 * var_t3059)));
        DENSE_ELEM(rJacobian, 7, 1) = var_chaste_interface__environment__fake_dt * (NV_Ith_S(mParameters, 1) * var_t3188);
        DENSE_ELEM(rJacobian, 8, 1) = var_chaste_interface__environment__fake_dt * (var_t3229 * (var_t3056 - var_t3059));
        DENSE_ELEM(rJacobian, 9, 1) = var_chaste_interface__environment__fake_dt * (( -0.081176470589999994 * var_t3269) * var_t3188);
        DENSE_ELEM(rJacobian, 39, 1) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4053) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 1) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4053) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 2) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t1607) - var_t1612) - var_t1619) - (0.80000000000000004 * var_t1773)) - var_t1931) - var_t1934));
        DENSE_ELEM(rJacobian, 2, 2) = var_chaste_interface__environment__fake_dt * (((((0.00046834020230000003 * (((((-var_t1607) - var_t1612) - (2.3999999999999999 * var_t1773)) - (3.0 * var_t1931)) - var_t1934)) * 0.00015335760000000003) * 1.0) * 856.55415970537967) - 0.01470588236);
        DENSE_ELEM(rJacobian, 3, 2) = var_chaste_interface__environment__fake_dt * (0.5);
        DENSE_ELEM(rJacobian, 4, 2) = var_chaste_interface__environment__fake_dt * ((((0.00046834020230000003 * ((-var_t1619) + (2.0 * var_t1931))) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 9, 2) = var_chaste_interface__environment__fake_dt * (((((0.00037467216190000002 * var_t3262) * var_t668) * var_t674) * var_t1772) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 0, 3) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((-var_t1942) - var_t1946) - (0.20000000000000001 * var_t2084)));
        DENSE_ELEM(rJacobian, 2, 3) = var_chaste_interface__environment__fake_dt * (0.01470588236);
        DENSE_ELEM(rJacobian, 3, 3) = var_chaste_interface__environment__fake_dt * (((((0.01592356688 * (((-var_t1942) - var_t1946) - (0.59999999999999998 * var_t2084))) * 1.0) * 0.00015335760000000003) * 856.55415970537967) - 0.5);
        DENSE_ELEM(rJacobian, 6, 3) = var_chaste_interface__environment__fake_dt * (((((0.0031847133759999998 * var_t3043) * var_t668) * var_t1071) * var_t2083) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 0, 4) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t2091) - var_t2098) - var_t2100) - var_t2102) - var_t2244) - var_t2246));
        DENSE_ELEM(rJacobian, 2, 4) = var_chaste_interface__environment__fake_dt * ((( -0.0014050206070000001 * var_t2244) * 0.00015335760000000003) * 856.55415970537956);
        DENSE_ELEM(rJacobian, 4, 4) = var_chaste_interface__environment__fake_dt * (((((0.00046834020230000003 * ((((((-var_t2091) - var_t2098) - var_t2100) - var_t2102) - var_t2246) + (2.0 * var_t2244))) * 1.0) * 0.00015335760000000003) * 856.55415970537967) - 0.01470588236);
        DENSE_ELEM(rJacobian, 5, 4) = var_chaste_interface__environment__fake_dt * (0.5);
        DENSE_ELEM(rJacobian, 0, 5) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : var_t2250);
        DENSE_ELEM(rJacobian, 4, 5) = var_chaste_interface__environment__fake_dt * (0.01470588236);
        DENSE_ELEM(rJacobian, 5, 5) = var_chaste_interface__environment__fake_dt * (((((0.01592356688 * var_t2250) * 1.0) * 0.00015335760000000003) * 856.55415970537967) - 0.5);
        DENSE_ELEM(rJacobian, 0, 6) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((((((((((((-var_t2269) - var_t2280) - (var_t646 * var_t2289)) + var_t2297) - var_t2301) - var_t2308) - var_t2311) + var_t2314) - var_t2318) + (0.00035740000000000001 * var_t2320)) - var_t2325) - (0.40000000000000002 * var_t2349)) - (0.20000000000000001 * var_t2407)));
        DENSE_ELEM(rJacobian, 1, 6) = var_chaste_interface__environment__fake_dt * (((((0.0025000000000000005 * var_t86) * var_t2255) * var_t93) * var_t2272) + (((((0.00012500000000000003 * pow(var_t86, 2.0)) / var_t2254) / var_t90) * 0.0015) * var_t1068));
        DENSE_ELEM(rJacobian, 2, 6) = var_chaste_interface__environment__fake_dt * ((((0.00046834020230000003 * ((-var_t2269) - var_t2280)) * 0.00015335760000000003) * 1.0) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 3, 6) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * (((var_t2314 - var_t2318) - (1.2 * var_t2349)) - (0.59999999999999998 * var_t2407))) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 4, 6) = var_chaste_interface__environment__fake_dt * (((( -0.00046834020230000003 * var_t646) * var_t2289) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 5, 6) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * (( -0.00035740000000000001 * var_t2320) + var_t2325)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 6) = var_chaste_interface__environment__fake_dt * (((( -2.0 / pow(var_t3042, 2.0)) * ((((((((0.00796178344 * (((-var_t3071) - var_t3073) + ((0.40000000000000002 * var_t1072) * var_t2344))) * 1.0) * 0.00015335760000000003) * 856.55415970537967) + (0.23999999999999999 * var_t3081)) + (0.23999999999999999 * var_t3083)) - (5.0 * var_chaste_interface__intracellular_ions__cass)) + (5.0 * var_chaste_interface__intracellular_ions__cai))) * ((( -4.0890000000000003e-05 / var_t3034) / var_t3033) - ((0.0097788000000000007 / var_t3039) / var_t3038))) + (var_t3043 * (((((((0.00796178344 * (((((var_t2297 - var_t2301) - var_t2308) - var_t2311) + (0.80000000000000004 * var_t2349)) + (0.40000000000000002 * var_t2407))) * 1.0) * 0.00015335760000000003) * 856.55415970537967) - (0.23999999999999999 * var_t3106)) + (0.23999999999999999 * var_t3109)) - 5.0)));
        DENSE_ELEM(rJacobian, 7, 6) = var_chaste_interface__environment__fake_dt * (var_t3202);
        DENSE_ELEM(rJacobian, 8, 6) = var_chaste_interface__environment__fake_dt * (var_t3229 * (var_t3106 - var_t3109));
        DENSE_ELEM(rJacobian, 9, 6) = var_chaste_interface__environment__fake_dt * (var_t3262 * (( -0.081176470589999994 * var_t3202) + 0.1470588236));
        DENSE_ELEM(rJacobian, 33, 6) = var_chaste_interface__environment__fake_dt * ((((((4.0 * var_t3875) * 1000.0) * var_t3871) * var_t3870) * 0.002) * var_t1068);
        DENSE_ELEM(rJacobian, 39, 6) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4060) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 6) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4060) * var_t4165);
        DENSE_ELEM(rJacobian, 7, 7) = var_chaste_interface__environment__fake_dt * (( -0.00026249999999999998 * NV_Ith_S(mParameters, 1)) - 0.00086956521740000001);
        DENSE_ELEM(rJacobian, 8, 7) = var_chaste_interface__environment__fake_dt * (var_t3234);
        DENSE_ELEM(rJacobian, 9, 7) = var_chaste_interface__environment__fake_dt * (2.1308823529999999e-05 * var_t3269);
        DENSE_ELEM(rJacobian, 7, 8) = var_chaste_interface__environment__fake_dt * (0.00086956521740000001);
        DENSE_ELEM(rJacobian, 8, 8) = var_chaste_interface__environment__fake_dt * ((((((2.0 / pow(var_t3228, 2.0)) * ((((0.01 * var_chaste_interface__intracellular_ions__cansr) - (0.01 * var_chaste_interface__intracellular_ions__cajsr)) - var_t3081) - var_t3083)) * 8.0) / var_t3225) / var_t3224) - var_t3234);
        DENSE_ELEM(rJacobian, 39, 8) = var_chaste_interface__environment__fake_dt * ((( -102.515625 * var_t4072) * var_t4050) - (((0.0123 * (( -0.5 * var_t4077) - var_chaste_interface__ryr__Jrelnp)) / pow(var_t4049, 2.0)) * var_t4091));
        DENSE_ELEM(rJacobian, 40, 8) = var_chaste_interface__environment__fake_dt * ((( -128.14453119999999 * var_t4072) * var_t4165) - (((0.015375 * (( -0.625 * var_t4077) - var_chaste_interface__ryr__Jrelp)) / pow(var_t4164, 2.0)) * var_t4091));
        DENSE_ELEM(rJacobian, 0, 9) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((((((( -5.4447296619999995e-07 * var_t2414) * var_t2415) * var_t2423) - (1.6000000000000001 * var_t2450)) - (0.80000000000000004 * var_t2503)) - var_t2507) + var_t2511) - var_t2515));
        DENSE_ELEM(rJacobian, 2, 9) = var_chaste_interface__environment__fake_dt * ((((0.00046834020230000003 * (( -4.7999999999999998 * var_t2450) - (2.3999999999999999 * var_t2503))) * 0.00015335760000000003) * 1.0) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 4, 9) = var_chaste_interface__environment__fake_dt * ((((((( -2.5499857910000002e-10 * var_t2414) * var_t2415) * var_chaste_interface__IKs__xs2) * var_t2422) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 9) = var_chaste_interface__environment__fake_dt * (5.0 * var_t3043);
        DENSE_ELEM(rJacobian, 7, 9) = var_chaste_interface__environment__fake_dt * (var_t3222);
        DENSE_ELEM(rJacobian, 9, 9) = var_chaste_interface__environment__fake_dt * (((( -2.0 / pow(var_t3261, 2.0)) * (((((((0.0002341701012 * ((((-var_t2508) * var_t2506) - ((((4.0 * var_t2512) * 3.8799692706433766e-07) * var_t50) * _lt_0_row[3])) + ((1.6000000000000001 * var_t675) * var_t2445))) * 1.0) * 0.00015335760000000003) * 856.55415970537967) - ((0.081176470589999994 * NV_Ith_S(mParameters, 1)) * ((((0.0043750000000000004 * var_t3205) * var_t3176) + ((0.01203125 * var_t3213) * var_t3195)) - (0.00026249999999999998 * var_chaste_interface__intracellular_ions__cansr)))) + (0.1470588236 * var_chaste_interface__intracellular_ions__cass)) - (0.1470588236 * var_chaste_interface__intracellular_ions__cai))) * ((( -0.00011900000000000002 / var_t3253) / var_t3252) - ((3.5000000000000004e-05 / var_t3258) / var_t3257))) + (var_t3262 * ((((((0.0002341701012 * (((((-var_t2507) + var_t2511) - var_t2515) + (3.2000000000000002 * var_t2450)) + (1.6000000000000001 * var_t2503))) * 1.0) * 0.00015335760000000003) * 856.55415970537967) - (0.081176470589999994 * var_t3222)) - 0.1470588236)));
        DENSE_ELEM(rJacobian, 0, 10) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ( -3.0 * var_t2518));
        DENSE_ELEM(rJacobian, 2, 10) = var_chaste_interface__environment__fake_dt * (( -0.0014050206070000001 * var_t2518) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 10, 10) = var_chaste_interface__environment__fake_dt * (_lt_0_row[130]);
        DENSE_ELEM(rJacobian, 0, 11) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2526));
        DENSE_ELEM(rJacobian, 2, 11) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2526) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 11, 11) = var_chaste_interface__environment__fake_dt * (_lt_0_row[134]);
        DENSE_ELEM(rJacobian, 0, 12) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((-var_t2527) * var_t98) * 0.010000000000000009) * var_chaste_interface__INa__j));
        DENSE_ELEM(rJacobian, 2, 12) = var_chaste_interface__environment__fake_dt * ((((((( -0.00046834020230000003 * var_t1535) * var_t2531) * 0.010000000000000009) * var_chaste_interface__INa__j) * 0.00015335760000000003) * 1.0) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 12, 12) = var_chaste_interface__environment__fake_dt * (_lt_0_row[138]);
        DENSE_ELEM(rJacobian, 0, 13) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2533));
        DENSE_ELEM(rJacobian, 2, 13) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2533) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 13, 13) = var_chaste_interface__environment__fake_dt * (_lt_0_row[144]);
        DENSE_ELEM(rJacobian, 0, 14) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((-var_t2527) * var_t97) * 0.010000000000000009) * var_chaste_interface__INa__jp));
        DENSE_ELEM(rJacobian, 2, 14) = var_chaste_interface__environment__fake_dt * ((((((( -0.00046834020230000003 * var_t1535) * var_t2537) * 0.010000000000000009) * var_chaste_interface__INa__jp) * 0.00015335760000000003) * 1.0) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 14, 14) = var_chaste_interface__environment__fake_dt * (_lt_0_row[141]);
        DENSE_ELEM(rJacobian, 0, 15) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2539));
        DENSE_ELEM(rJacobian, 2, 15) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2539) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 15, 15) = var_chaste_interface__environment__fake_dt * (_lt_0_row[148]);
        DENSE_ELEM(rJacobian, 0, 16) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((-var_t1555) * var_t1065));
        DENSE_ELEM(rJacobian, 2, 16) = var_chaste_interface__environment__fake_dt * (((( -0.00046834020230000003 * var_t1555) * var_t1065) * 0.00015335760000000003) * 856.55415970537956);
        DENSE_ELEM(rJacobian, 16, 16) = var_chaste_interface__environment__fake_dt * (_lt_0_row[130]);
        DENSE_ELEM(rJacobian, 0, 17) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2542));
        DENSE_ELEM(rJacobian, 2, 17) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2542) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 17, 17) = var_chaste_interface__environment__fake_dt * ( -0.0050000000000000001);
        DENSE_ELEM(rJacobian, 0, 18) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2544));
        DENSE_ELEM(rJacobian, 2, 18) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2544) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 18, 18) = var_chaste_interface__environment__fake_dt * ( -0.0016666666666666666);
        DENSE_ELEM(rJacobian, 0, 19) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2546));
        DENSE_ELEM(rJacobian, 4, 19) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2546) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 19, 19) = var_chaste_interface__environment__fake_dt * (_lt_0_row[153]);
        DENSE_ELEM(rJacobian, 0, 20) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2548));
        DENSE_ELEM(rJacobian, 4, 20) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2548) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 20, 20) = var_chaste_interface__environment__fake_dt * (_lt_0_row[159]);
        DENSE_ELEM(rJacobian, 0, 21) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2550));
        DENSE_ELEM(rJacobian, 4, 21) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2550) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 21, 21) = var_chaste_interface__environment__fake_dt * (_lt_0_row[172]);
        DENSE_ELEM(rJacobian, 0, 22) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2552));
        DENSE_ELEM(rJacobian, 4, 22) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2552) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 22, 22) = var_chaste_interface__environment__fake_dt * (_lt_0_row[153]);
        DENSE_ELEM(rJacobian, 0, 23) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2554));
        DENSE_ELEM(rJacobian, 4, 23) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2554) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 23, 23) = var_chaste_interface__environment__fake_dt * (_lt_0_row[165]);
        DENSE_ELEM(rJacobian, 0, 24) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2556));
        DENSE_ELEM(rJacobian, 4, 24) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2556) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 24, 24) = var_chaste_interface__environment__fake_dt * (_lt_0_row[178]);
        DENSE_ELEM(rJacobian, 0, 25) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t2561) - var_t2566) - var_t2570) - var_t2574) - (0.00035740000000000001 * var_t2577)) - var_t2582));
        DENSE_ELEM(rJacobian, 3, 25) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * ((-var_t2570) - var_t2574)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 5, 25) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * ((0.00035740000000000001 * var_t2577) + var_t2582)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 25) = var_chaste_interface__environment__fake_dt * ((((0.00796178344 * var_t3043) * var_t3115) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 25, 25) = var_chaste_interface__environment__fake_dt * (_lt_0_row[73]);
        DENSE_ELEM(rJacobian, 39, 25) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4096) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 25) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4096) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 26) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -4.0 * var_t1938) * var_t2587) - ((0.00125 * var_t1938) * var_t2591)) - ((0.00035740000000000001 * var_t1938) * var_t2594)));
        DENSE_ELEM(rJacobian, 3, 26) = var_chaste_interface__environment__fake_dt * ((( -1.99044586e-05 * var_t1339) * var_t2856) * var_t2859);
        DENSE_ELEM(rJacobian, 5, 26) = var_chaste_interface__environment__fake_dt * ((( -5.691082803e-06 * var_t1339) * var_t2995) * var_t2859);
        DENSE_ELEM(rJacobian, 6, 26) = var_chaste_interface__environment__fake_dt * (((( -0.03184713376 * var_t3120) * var_t1337) * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) * var_t3125);
        DENSE_ELEM(rJacobian, 26, 26) = var_chaste_interface__environment__fake_dt * (_lt_0_row[92]);
        DENSE_ELEM(rJacobian, 39, 26) = var_chaste_interface__environment__fake_dt * (( -2.0 * var_t4106) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 26) = var_chaste_interface__environment__fake_dt * (( -2.5 * var_t4106) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 27) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t2603) - var_t2605) - var_t2609) - var_t2611) - (0.00035740000000000001 * var_t2613)) - var_t2616));
        DENSE_ELEM(rJacobian, 3, 27) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * ((-var_t2609) - var_t2611)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 5, 27) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * ((0.00035740000000000001 * var_t2613) + var_t2616)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 27) = var_chaste_interface__environment__fake_dt * ((((0.00796178344 * var_t3043) * var_t3128) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 27, 27) = var_chaste_interface__environment__fake_dt * (_lt_0_row[99]);
        DENSE_ELEM(rJacobian, 39, 27) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4112) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 27) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4112) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 28) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -4.0 * var_t1342) * var_t2620) - ((0.00125 * var_t1342) * var_t2623)) - ((0.00035740000000000001 * var_t1342) * var_t2626)));
        DENSE_ELEM(rJacobian, 3, 28) = var_chaste_interface__environment__fake_dt * ((( -1.99044586e-05 * var_t2867) * var_t2315) * var_t2872);
        DENSE_ELEM(rJacobian, 5, 28) = var_chaste_interface__environment__fake_dt * ((( -5.691082803e-06 * var_t2867) * var_t2322) * var_t2872);
        DENSE_ELEM(rJacobian, 6, 28) = var_chaste_interface__environment__fake_dt * (((( -0.03184713376 * var_t3120) * var_t2293) * var_t3134) * var_t3141);
        DENSE_ELEM(rJacobian, 28, 28) = var_chaste_interface__environment__fake_dt * (_lt_0_row[79]);
        DENSE_ELEM(rJacobian, 39, 28) = var_chaste_interface__environment__fake_dt * (( -2.0 * var_t4122) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 28) = var_chaste_interface__environment__fake_dt * (( -2.5 * var_t4122) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 29) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t2634) - var_t2636) - var_t2639) - var_t2641) - (0.00035740000000000001 * var_t2643)) - var_t2646));
        DENSE_ELEM(rJacobian, 3, 29) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * ((-var_t2639) - var_t2641)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 5, 29) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * ((0.00035740000000000001 * var_t2643) + var_t2646)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 29) = var_chaste_interface__environment__fake_dt * ((((0.00796178344 * var_t3043) * var_t3144) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 29, 29) = var_chaste_interface__environment__fake_dt * (_lt_0_row[87]);
        DENSE_ELEM(rJacobian, 39, 29) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4128) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 29) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4128) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 30) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t2653) - var_t2658) - var_t2662) - var_t2665) - (0.00035740000000000001 * var_t2668)) - var_t2672));
        DENSE_ELEM(rJacobian, 3, 30) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * ((-var_t2662) - var_t2665)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 5, 30) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * ((0.00035740000000000001 * var_t2668) + var_t2672)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 30) = var_chaste_interface__environment__fake_dt * ((((0.00796178344 * var_t3043) * var_t3149) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 30, 30) = var_chaste_interface__environment__fake_dt * ( -0.013333333333333334);
        DENSE_ELEM(rJacobian, 33, 30) = var_chaste_interface__environment__fake_dt * (((var_t3875 * 1000000.0) / pow(var_chaste_interface__ICaL__jca, 2.0)) - var_chaste_interface__ICaL__nca);
        DENSE_ELEM(rJacobian, 39, 30) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4134) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 30) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4134) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 31) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -4.4000000000000004 * var_t1943) * var_t2587) - ((0.0013749999999999999 * var_t1943) * var_t2591)) - ((0.00039313999999999999 * var_t1943) * var_t2594)));
        DENSE_ELEM(rJacobian, 3, 31) = var_chaste_interface__environment__fake_dt * ((( -2.1894904459999999e-05 * var_t1400) * var_t2856) * var_t2859);
        DENSE_ELEM(rJacobian, 5, 31) = var_chaste_interface__environment__fake_dt * ((( -6.2601910829999997e-06 * var_t1400) * var_t2995) * var_t2859);
        DENSE_ELEM(rJacobian, 6, 31) = var_chaste_interface__environment__fake_dt * (((( -0.035031847140000003 * var_t3154) * var_t1337) * ((var_chaste_interface__membrane__v * 96485.0) * 3.8799692706433766e-07)) * var_t3125);
        DENSE_ELEM(rJacobian, 31, 31) = var_chaste_interface__environment__fake_dt * (_lt_0_row[96]);
        DENSE_ELEM(rJacobian, 39, 31) = var_chaste_interface__environment__fake_dt * (( -2.2000000000000002 * var_t4142) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 31) = var_chaste_interface__environment__fake_dt * (( -2.75 * var_t4142) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 32) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (((( -4.4000000000000004 * var_t1401) * var_t2620) - ((0.0013749999999999999 * var_t1401) * var_t2623)) - ((0.00039313999999999999 * var_t1401) * var_t2626)));
        DENSE_ELEM(rJacobian, 3, 32) = var_chaste_interface__environment__fake_dt * ((( -2.1894904459999999e-05 * var_t2888) * var_t2315) * var_t2872);
        DENSE_ELEM(rJacobian, 5, 32) = var_chaste_interface__environment__fake_dt * ((( -6.2601910829999997e-06 * var_t2888) * var_t2322) * var_t2872);
        DENSE_ELEM(rJacobian, 6, 32) = var_chaste_interface__environment__fake_dt * (((( -0.035031847140000003 * var_t3154) * var_t2293) * var_t3134) * var_t3141);
        DENSE_ELEM(rJacobian, 32, 32) = var_chaste_interface__environment__fake_dt * (_lt_0_row[84]);
        DENSE_ELEM(rJacobian, 39, 32) = var_chaste_interface__environment__fake_dt * (( -2.2000000000000002 * var_t4148) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 32) = var_chaste_interface__environment__fake_dt * (( -2.75 * var_t4148) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 33) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((((((-var_t2693) - var_t2699) - var_t2703) - var_t2707) - (0.00035740000000000001 * var_t2709)) - var_t2713));
        DENSE_ELEM(rJacobian, 3, 33) = var_chaste_interface__environment__fake_dt * ((((0.01592356688 * ((-var_t2703) - var_t2707)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 5, 33) = var_chaste_interface__environment__fake_dt * (((( -0.01592356688 * ((0.00035740000000000001 * var_t2709) + var_t2713)) * 1.0) * 0.00015335760000000003) * 856.55415970537967);
        DENSE_ELEM(rJacobian, 6, 33) = var_chaste_interface__environment__fake_dt * ((((0.00796178344 * var_t3043) * var_t3163) * 1.0) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 33, 33) = var_chaste_interface__environment__fake_dt * (-var_chaste_interface__ICaL__jca);
        DENSE_ELEM(rJacobian, 39, 33) = var_chaste_interface__environment__fake_dt * (( -0.5 * var_t4154) * var_t4050);
        DENSE_ELEM(rJacobian, 40, 33) = var_chaste_interface__environment__fake_dt * (( -0.625 * var_t4154) * var_t4165);
        DENSE_ELEM(rJacobian, 0, 34) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -0.43033148290000001 * var_t592) * _lt_0_row[22]) * var_t631));
        DENSE_ELEM(rJacobian, 4, 34) = var_chaste_interface__environment__fake_dt * ((((( -0.00020154153380000001 * var_t592) * _lt_0_row[22]) * _lt_0_row[31]) * _lt_0_row[25]) * var_t2950);
        DENSE_ELEM(rJacobian, 34, 34) = var_chaste_interface__environment__fake_dt * (_lt_0_row[108]);
        DENSE_ELEM(rJacobian, 0, 35) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : ((( -0.43033148290000001 * var_t592) * _lt_0_row[23]) * var_t631));
        DENSE_ELEM(rJacobian, 4, 35) = var_chaste_interface__environment__fake_dt * ((((( -0.00020154153380000001 * var_t592) * _lt_0_row[23]) * _lt_0_row[31]) * _lt_0_row[25]) * var_t2950);
        DENSE_ELEM(rJacobian, 35, 35) = var_chaste_interface__environment__fake_dt * (_lt_0_row[114]);
        DENSE_ELEM(rJacobian, 0, 36) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2721));
        DENSE_ELEM(rJacobian, 4, 36) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2721) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 36, 36) = var_chaste_interface__environment__fake_dt * (_lt_0_row[119]);
        DENSE_ELEM(rJacobian, 0, 37) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2723));
        DENSE_ELEM(rJacobian, 4, 37) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2723) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 37, 37) = var_chaste_interface__environment__fake_dt * (_lt_0_row[125]);
        DENSE_ELEM(rJacobian, 0, 38) = var_chaste_interface__environment__fake_dt * (mSetVoltageDerivativeToZero ? 0.0 : (-var_t2725));
        DENSE_ELEM(rJacobian, 4, 38) = var_chaste_interface__environment__fake_dt * (( -0.00046834020230000003 * var_t2725) * 0.13135909020243375);
        DENSE_ELEM(rJacobian, 38, 38) = var_chaste_interface__environment__fake_dt * (_lt_0_row[105]);
        DENSE_ELEM(rJacobian, 6, 39) = var_chaste_interface__environment__fake_dt * (var_t3043 * (0.23999999999999999 - (0.23999999999999999 * var_t97)));
        DENSE_ELEM(rJacobian, 8, 39) = var_chaste_interface__environment__fake_dt * ((-var_t3229) * var_t98);
        DENSE_ELEM(rJacobian, 39, 39) = var_chaste_interface__environment__fake_dt * (-var_t4050);
        DENSE_ELEM(rJacobian, 6, 40) = var_chaste_interface__environment__fake_dt * (0.23999999999999999 * var_t3154);
        DENSE_ELEM(rJacobian, 8, 40) = var_chaste_interface__environment__fake_dt * ((-var_t3229) * var_t97);
        DENSE_ELEM(rJacobian, 40, 40) = var_chaste_interface__environment__fake_dt * (-var_t4165);
    }
    
    N_Vector Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt::ComputeDerivedQuantities(double var_chaste_interface__environment__time, const N_Vector & rY)
    {
        // Inputs:
        // Time units: millisecond
        double var_chaste_interface__membrane__v = (mSetVoltageDerivativeToZero ? this->mFixedVoltage : NV_Ith_S(rY, 0));
        // Units: millivolt; Initial value: -87
        double var_chaste_interface__CaMK__CaMKt = NV_Ith_S(rY, 1);
        // Units: millimolar; Initial value: 0
        double var_chaste_interface__intracellular_ions__nai = NV_Ith_S(rY, 2);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__nass = NV_Ith_S(rY, 3);
        // Units: millimolar; Initial value: 7
        double var_chaste_interface__intracellular_ions__ki = NV_Ith_S(rY, 4);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__kss = NV_Ith_S(rY, 5);
        // Units: millimolar; Initial value: 145
        double var_chaste_interface__intracellular_ions__cass = NV_Ith_S(rY, 6);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__intracellular_ions__cai = NV_Ith_S(rY, 9);
        // Units: millimolar; Initial value: 1e-4
        double var_chaste_interface__INa__m = NV_Ith_S(rY, 10);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INa__hf = NV_Ith_S(rY, 11);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hs = NV_Ith_S(rY, 12);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__j = NV_Ith_S(rY, 13);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__hsp = NV_Ith_S(rY, 14);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INa__jp = NV_Ith_S(rY, 15);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__mL = NV_Ith_S(rY, 16);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__INaL__hL = NV_Ith_S(rY, 17);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__INaL__hLp = NV_Ith_S(rY, 18);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__d = NV_Ith_S(rY, 25);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__ICaL__ff = NV_Ith_S(rY, 26);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fs = NV_Ith_S(rY, 27);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcaf = NV_Ith_S(rY, 28);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcas = NV_Ith_S(rY, 29);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__jca = NV_Ith_S(rY, 30);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__ffp = NV_Ith_S(rY, 31);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__fcafp = NV_Ith_S(rY, 32);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ICaL__nca = NV_Ith_S(rY, 33);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrf = NV_Ith_S(rY, 34);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKr__xrs = NV_Ith_S(rY, 35);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs1 = NV_Ith_S(rY, 36);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IKs__xs2 = NV_Ith_S(rY, 37);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__IK1__xk1 = NV_Ith_S(rY, 38);
        // Units: dimensionless; Initial value: 1
        double var_chaste_interface__ryr__Jrelnp = NV_Ith_S(rY, 39);
        // Units: dimensionless; Initial value: 0
        double var_chaste_interface__ryr__Jrelp = NV_Ith_S(rY, 40);
        // Units: dimensionless; Initial value: 0
        
        
        // Lookup table indexing
        const bool _oob_0 = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->CheckIndex0(var_chaste_interface__membrane__v);
#define COVERAGE_IGNORE
        if (_oob_0)
            EXCEPTION(DumpState("membrane_voltage outside lookup table range", rY, var_chaste_interface__environment__time));
#undef COVERAGE_IGNORE
        const double* const _lt_0_row = Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt_LookupTables::Instance()->IndexTable0(var_chaste_interface__membrane__v);
        
        // Mathematics
        const double var_INa__h = (0.98999999999999999 * var_chaste_interface__INa__hf) + (0.010000000000000009 * var_chaste_interface__INa__hs); // dimensionless
        const double var_reversal_potentials__ENa = 26.712338705498265 * log(NV_Ith_S(mParameters, 4) / var_chaste_interface__intracellular_ions__nai); // millivolt
        const double var_CaMK__CaMKb = (0.050000000000000003 * (1.0 - var_chaste_interface__CaMK__CaMKt)) / (1.0 + (0.0015 / var_chaste_interface__intracellular_ions__cass)); // millimolar
        const double var_CaMK__CaMKa = var_CaMK__CaMKb + var_chaste_interface__CaMK__CaMKt; // millimolar
        const double var_INa__fINap = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_INa__INa = NV_Ith_S(mParameters, 10) * (var_chaste_interface__membrane__v - var_reversal_potentials__ENa) * pow(var_chaste_interface__INa__m, 3.0) * (((1.0 - var_INa__fINap) * var_INa__h * var_chaste_interface__INa__j) + (var_INa__fINap * ((0.98999999999999999 * var_chaste_interface__INa__hf) + (0.010000000000000009 * var_chaste_interface__INa__hsp)) * var_chaste_interface__INa__jp)); // microA_per_microF
        const double var_INaL__fINaLp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_INaL__INaL = NV_Ith_S(mParameters, 12) * (var_chaste_interface__membrane__v - var_reversal_potentials__ENa) * var_chaste_interface__INaL__mL * (((1.0 - var_INaL__fINaLp) * var_chaste_interface__INaL__hL) + (var_INaL__fINaLp * var_chaste_interface__INaL__hLp)); // microA_per_microF
        const double var_reversal_potentials__EK = 26.712338705498265 * log(NV_Ith_S(mParameters, 3) / var_chaste_interface__intracellular_ions__ki); // millivolt
        const double var_ICaL__fICaLp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_ICaL__fcap = (_lt_0_row[183] * var_chaste_interface__ICaL__fcafp) + (_lt_0_row[184] * var_chaste_interface__ICaL__fcas); // dimensionless
        const double var_ICaL__PCa = NV_Ith_S(mParameters, 5); // dimensionless
        const double var_ICaL__PCap = 1.1000000000000001 * var_ICaL__PCa; // dimensionless
        const double var_ICaL__fp = (0.59999999999999998 * var_chaste_interface__ICaL__ffp) + (0.40000000000000002 * var_chaste_interface__ICaL__fs); // dimensionless
        const double var_ICaL__PhiCaL = (4.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__cass * _lt_0_row[2]) - (0.34100000000000003 * NV_Ith_S(mParameters, 2)))) / _lt_0_row[185]; // dimensionless
        const double var_ICaL__f = (0.59999999999999998 * var_chaste_interface__ICaL__ff) + (0.40000000000000002 * var_chaste_interface__ICaL__fs); // dimensionless
        const double var_ICaL__fca = (_lt_0_row[183] * var_chaste_interface__ICaL__fcaf) + (_lt_0_row[184] * var_chaste_interface__ICaL__fcas); // dimensionless
        const double var_ICaL__ICaL = ((1.0 - var_ICaL__fICaLp) * var_ICaL__PCa * var_ICaL__PhiCaL * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * var_ICaL__PCap * var_ICaL__PhiCaL * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_ICaL__PhiCaNa = (1.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((0.75 * var_chaste_interface__intracellular_ions__nass * _lt_0_row[186]) - (0.75 * NV_Ith_S(mParameters, 4)))) / _lt_0_row[187]; // dimensionless
        const double var_ICaL__ICaNa = ((1.0 - var_ICaL__fICaLp) * (0.00125 * var_ICaL__PCa) * var_ICaL__PhiCaNa * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * (0.00125 * var_ICaL__PCap) * var_ICaL__PhiCaNa * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_ICaL__PhiCaK = (1.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((0.75 * var_chaste_interface__intracellular_ions__kss * _lt_0_row[186]) - (0.75 * NV_Ith_S(mParameters, 3)))) / _lt_0_row[187]; // dimensionless
        const double var_ICaL__ICaK = ((1.0 - var_ICaL__fICaLp) * (0.00035740000000000001 * var_ICaL__PCa) * var_ICaL__PhiCaK * var_chaste_interface__ICaL__d * ((var_ICaL__f * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fca * var_chaste_interface__ICaL__nca))) + (var_ICaL__fICaLp * (0.00035740000000000001 * var_ICaL__PCap) * var_ICaL__PhiCaK * var_chaste_interface__ICaL__d * ((var_ICaL__fp * (1.0 - var_chaste_interface__ICaL__nca)) + (var_chaste_interface__ICaL__jca * var_ICaL__fcap * var_chaste_interface__ICaL__nca))); // microA_per_microF
        const double var_IKr__IKr = NV_Ith_S(mParameters, 13) * sqrt(NV_Ith_S(mParameters, 3) * 0.18518518518518517) * ((_lt_0_row[188] * var_chaste_interface__IKr__xrf) + (_lt_0_row[189] * var_chaste_interface__IKr__xrs)) * _lt_0_row[190] * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_IKs__IKs = NV_Ith_S(mParameters, 14) * (1.0 + (0.59999999999999998 / (1.0 + pow(3.8000000000000002e-05 / var_chaste_interface__intracellular_ions__cai, 1.3999999999999999)))) * var_chaste_interface__IKs__xs1 * var_chaste_interface__IKs__xs2 * (var_chaste_interface__membrane__v - (26.712338705498265 * log((NV_Ith_S(mParameters, 3) + (0.018329999999999999 * NV_Ith_S(mParameters, 4))) / (var_chaste_interface__intracellular_ions__ki + (0.018329999999999999 * var_chaste_interface__intracellular_ions__nai))))); // microA_per_microF
        const double var_IK1__IK1 = NV_Ith_S(mParameters, 11) * sqrt(NV_Ith_S(mParameters, 3)) * (1.0 / (1.0 + exp(((var_chaste_interface__membrane__v + 105.8) - (2.6000000000000001 * NV_Ith_S(mParameters, 3))) * 0.10534077741493732))) * var_chaste_interface__IK1__xk1 * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_INaCa_i__h1_i = 1.0 + ((var_chaste_interface__intracellular_ions__nai * 0.011348161597821153) * _lt_0_row[191]); // dimensionless
        const double var_INaCa_i__h2_i = (var_chaste_interface__intracellular_ions__nai * _lt_0_row[192]) / (88.120000000000005 * var_INaCa_i__h1_i); // dimensionless
        const double var_INaCa_i__k4pp_i = var_INaCa_i__h2_i * 5000.0; // dimensionless
        const double var_INaCa_i__h4_i = 1.0 + ((var_chaste_interface__intracellular_ions__nai * 0.066666666666666666) * (1.0 + (var_chaste_interface__intracellular_ions__nai * 0.20000000000000001))); // dimensionless
        const double var_INaCa_i__k7_i = ((var_chaste_interface__intracellular_ions__nai * var_chaste_interface__intracellular_ions__nai) / (var_INaCa_i__h4_i * 75.0)) * var_INaCa_i__h2_i * 60000.0; // dimensionless
        const double var_INaCa_i__h7_i = 1.0 + ((NV_Ith_S(mParameters, 4) * 0.011348161597821153) * _lt_0_row[193]); // dimensionless
        const double var_INaCa_i__h8_i = NV_Ith_S(mParameters, 4) / (88.120000000000005 * _lt_0_row[192] * var_INaCa_i__h7_i); // dimensionless
        const double var_INaCa_i__k3pp_i = var_INaCa_i__h8_i * 5000.0; // dimensionless
        const double var_INaCa_i__h10_i = ((NV_Ith_S(mParameters, 4) * 0.066666666666666666) * (1.0 + (NV_Ith_S(mParameters, 4) * 0.20000000000000001))) + 13.5; // dimensionless
        const double var_INaCa_i__k8_i = var_INaCa_i__h8_i * ((NV_Ith_S(mParameters, 4) * NV_Ith_S(mParameters, 4)) / (var_INaCa_i__h10_i * 75.0)) * 60000.0; // dimensionless
        const double var_INaCa_i__k1_i = (1.0 / var_INaCa_i__h10_i) * NV_Ith_S(mParameters, 2) * 1500000.0; // dimensionless
        const double var_INaCa_i__k4_i = (((1.0 / var_INaCa_i__h1_i) * 60000.0) / _lt_0_row[194]) + var_INaCa_i__k4pp_i; // dimensionless
        const double var_INaCa_i__k3_i = ((1.0 / var_INaCa_i__h7_i) * 60000.0) + var_INaCa_i__k3pp_i; // dimensionless
        const double var_INaCa_i__x4_i = (5000.0 * var_INaCa_i__k8_i * (var_INaCa_i__k4_i + 5000.0)) + (var_INaCa_i__k3_i * 5000.0 * (var_INaCa_i__k1_i + var_INaCa_i__k8_i)); // dimensionless
        const double var_INaCa_i__k6_i = (1.0 / var_INaCa_i__h4_i) * var_chaste_interface__intracellular_ions__cai * 1500000.0; // dimensionless
        const double var_INaCa_i__x3_i = (var_INaCa_i__k1_i * var_INaCa_i__k3_i * (var_INaCa_i__k7_i + var_INaCa_i__k6_i)) + (var_INaCa_i__k8_i * var_INaCa_i__k6_i * (5000.0 + var_INaCa_i__k3_i)); // dimensionless
        const double var_INaCa_i__x2_i = (var_INaCa_i__k1_i * var_INaCa_i__k7_i * (var_INaCa_i__k4_i + 5000.0)) + (var_INaCa_i__k4_i * var_INaCa_i__k6_i * (var_INaCa_i__k1_i + var_INaCa_i__k8_i)); // dimensionless
        const double var_INaCa_i__x1_i = (5000.0 * var_INaCa_i__k4_i * (var_INaCa_i__k7_i + var_INaCa_i__k6_i)) + (5000.0 * var_INaCa_i__k7_i * (5000.0 + var_INaCa_i__k3_i)); // dimensionless
        const double var_INaCa_i__E1_i = var_INaCa_i__x1_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i); // dimensionless
        const double var_INaCa_i__E2_i = var_INaCa_i__x2_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i); // dimensionless
        const double var_INaCa_i__Gncx = NV_Ith_S(mParameters, 15); // milliS_per_microF
        const double var_INaCa_i__INaCa_i = 0.80000000000000004 * var_INaCa_i__Gncx * (1.0 / (1.0 + pow(0.00014999999999999999 / var_chaste_interface__intracellular_ions__cai, 2.0))) * ((1.0 * (((3.0 * (((var_INaCa_i__x4_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i)) * var_INaCa_i__k7_i) - (var_INaCa_i__E1_i * var_INaCa_i__k8_i))) + ((var_INaCa_i__x3_i / (var_INaCa_i__x1_i + var_INaCa_i__x2_i + var_INaCa_i__x3_i + var_INaCa_i__x4_i)) * var_INaCa_i__k4pp_i)) - (var_INaCa_i__E2_i * var_INaCa_i__k3pp_i))) + (2.0 * ((var_INaCa_i__E2_i * 5000.0) - (var_INaCa_i__E1_i * var_INaCa_i__k1_i)))); // microA_per_microF
        const double var_INaCa_i__h1_ss = 1.0 + ((var_chaste_interface__intracellular_ions__nass * 0.011348161597821153) * _lt_0_row[191]); // dimensionless
        const double var_INaCa_i__h2_ss = (var_chaste_interface__intracellular_ions__nass * _lt_0_row[192]) / (88.120000000000005 * var_INaCa_i__h1_ss); // dimensionless
        const double var_INaCa_i__k4pp_ss = var_INaCa_i__h2_ss * 5000.0; // dimensionless
        const double var_INaCa_i__k4_ss = (((1.0 / var_INaCa_i__h1_ss) * 60000.0) / _lt_0_row[194]) + var_INaCa_i__k4pp_ss; // dimensionless
        const double var_INaCa_i__h10_ss = ((NV_Ith_S(mParameters, 4) * 0.066666666666666666) * (1.0 + (NV_Ith_S(mParameters, 4) * 0.20000000000000001))) + 13.5; // dimensionless
        const double var_INaCa_i__h7_ss = 1.0 + ((NV_Ith_S(mParameters, 4) * 0.011348161597821153) * _lt_0_row[193]); // dimensionless
        const double var_INaCa_i__h8_ss = NV_Ith_S(mParameters, 4) / (88.120000000000005 * _lt_0_row[192] * var_INaCa_i__h7_ss); // dimensionless
        const double var_INaCa_i__k8_ss = var_INaCa_i__h8_ss * ((NV_Ith_S(mParameters, 4) * NV_Ith_S(mParameters, 4)) / (var_INaCa_i__h10_ss * 75.0)) * 60000.0; // dimensionless
        const double var_INaCa_i__h4_ss = 1.0 + ((var_chaste_interface__intracellular_ions__nass * 0.066666666666666666) * (1.0 + (var_chaste_interface__intracellular_ions__nass * 0.20000000000000001))); // dimensionless
        const double var_INaCa_i__k6_ss = (1.0 / var_INaCa_i__h4_ss) * var_chaste_interface__intracellular_ions__cass * 1500000.0; // dimensionless
        const double var_INaCa_i__k1_ss = (1.0 / var_INaCa_i__h10_ss) * NV_Ith_S(mParameters, 2) * 1500000.0; // dimensionless
        const double var_INaCa_i__k7_ss = ((var_chaste_interface__intracellular_ions__nass * var_chaste_interface__intracellular_ions__nass) / (var_INaCa_i__h4_ss * 75.0)) * var_INaCa_i__h2_ss * 60000.0; // dimensionless
        const double var_INaCa_i__x2_ss = (var_INaCa_i__k1_ss * var_INaCa_i__k7_ss * (var_INaCa_i__k4_ss + 5000.0)) + (var_INaCa_i__k4_ss * var_INaCa_i__k6_ss * (var_INaCa_i__k1_ss + var_INaCa_i__k8_ss)); // dimensionless
        const double var_INaCa_i__k3pp_ss = var_INaCa_i__h8_ss * 5000.0; // dimensionless
        const double var_INaCa_i__k3_ss = ((1.0 / var_INaCa_i__h7_ss) * 60000.0) + var_INaCa_i__k3pp_ss; // dimensionless
        const double var_INaCa_i__x3_ss = (var_INaCa_i__k1_ss * var_INaCa_i__k3_ss * (var_INaCa_i__k7_ss + var_INaCa_i__k6_ss)) + (var_INaCa_i__k8_ss * var_INaCa_i__k6_ss * (5000.0 + var_INaCa_i__k3_ss)); // dimensionless
        const double var_INaCa_i__x1_ss = (5000.0 * var_INaCa_i__k4_ss * (var_INaCa_i__k7_ss + var_INaCa_i__k6_ss)) + (5000.0 * var_INaCa_i__k7_ss * (5000.0 + var_INaCa_i__k3_ss)); // dimensionless
        const double var_INaCa_i__x4_ss = (5000.0 * var_INaCa_i__k8_ss * (var_INaCa_i__k4_ss + 5000.0)) + (var_INaCa_i__k3_ss * 5000.0 * (var_INaCa_i__k1_ss + var_INaCa_i__k8_ss)); // dimensionless
        const double var_INaCa_i__E2_ss = var_INaCa_i__x2_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss); // dimensionless
        const double var_INaCa_i__E1_ss = var_INaCa_i__x1_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss); // dimensionless
        const double var_INaCa_i__INaCa_ss = 0.20000000000000001 * var_INaCa_i__Gncx * (1.0 / (1.0 + pow(0.00014999999999999999 / var_chaste_interface__intracellular_ions__cass, 2.0))) * ((1.0 * (((3.0 * (((var_INaCa_i__x4_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss)) * var_INaCa_i__k7_ss) - (var_INaCa_i__E1_ss * var_INaCa_i__k8_ss))) + ((var_INaCa_i__x3_ss / (var_INaCa_i__x1_ss + var_INaCa_i__x2_ss + var_INaCa_i__x3_ss + var_INaCa_i__x4_ss)) * var_INaCa_i__k4pp_ss)) - (var_INaCa_i__E2_ss * var_INaCa_i__k3pp_ss))) + (2.0 * ((var_INaCa_i__E2_ss * 5000.0) - (var_INaCa_i__E1_ss * var_INaCa_i__k1_ss)))); // microA_per_microF
        const double var_INaK__b3 = ((4.2000000000000002 / ((var_chaste_interface__intracellular_ions__nai * 0.004464285714285714) + (var_chaste_interface__intracellular_ions__ki * 0.0034246575342465752) + 1.5889281507656066)) * 0.0079299999999999995) * 1.732653031203624e-08; // dimensionless
        const double var_INaK__a3 = (1899.0 * pow(NV_Ith_S(mParameters, 3) * 2.7917364600781687, 2.0)) / ((pow(1.0 + (NV_Ith_S(mParameters, 4) / _lt_0_row[196]), 3.0) + pow(1.0 + (NV_Ith_S(mParameters, 3) * 2.7917364600781687), 2.0)) - 1.0); // dimensionless
        const double var_INaK__b2 = (39.399999999999999 * pow(NV_Ith_S(mParameters, 4) / _lt_0_row[196], 3.0)) / ((pow(1.0 + (NV_Ith_S(mParameters, 4) / _lt_0_row[196]), 3.0) + pow(1.0 + (NV_Ith_S(mParameters, 3) * 2.7917364600781687), 2.0)) - 1.0); // dimensionless
        const double var_INaK__x3 = (var_INaK__a3 * 439120.79239156022) + (var_INaK__b3 * var_INaK__b2 * 9.120000000000001) + (var_INaK__b2 * 5827.679899026527) + (var_INaK__a3 * 5827.679899026527); // dimensionless
        const double var_INaK__b4 = (40.0 * pow(var_chaste_interface__intracellular_ions__ki * 2.0, 2.0)) / ((pow(1.0 + (var_chaste_interface__intracellular_ions__nai / _lt_0_row[195]), 3.0) + pow(1.0 + (var_chaste_interface__intracellular_ions__ki * 2.0), 2.0)) - 1.0); // dimensionless
        const double var_INaK__a1 = (949.5 * pow(var_chaste_interface__intracellular_ions__nai / _lt_0_row[195], 3.0)) / ((pow(1.0 + (var_chaste_interface__intracellular_ions__nai / _lt_0_row[195]), 3.0) + pow(1.0 + (var_chaste_interface__intracellular_ions__ki * 2.0), 2.0)) - 1.0); // dimensionless
        const double var_INaK__x2 = (var_INaK__b2 * 9.120000000000001 * var_INaK__b4) + (var_INaK__a1 * 687.20000000000005 * var_INaK__a3) + (var_INaK__a3 * 9.120000000000001 * var_INaK__b4) + (687.20000000000005 * var_INaK__a3 * var_INaK__b4); // dimensionless
        const double var_INaK__x1 = (var_INaK__a1 * 439120.79239156022) + (var_INaK__b2 * var_INaK__b4 * var_INaK__b3) + (687.20000000000005 * var_INaK__b4 * var_INaK__b3) + (var_INaK__b3 * var_INaK__a1 * 687.20000000000005); // dimensionless
        const double var_INaK__x4 = (var_INaK__b4 * var_INaK__b3 * var_INaK__b2) + (var_INaK__a3 * 638.99998892834719 * var_INaK__a1) + (var_INaK__b2 * 638.99998892834719 * var_INaK__a1) + (var_INaK__b3 * var_INaK__b2 * var_INaK__a1); // dimensionless
        const double var_INaK__INaK = NV_Ith_S(mParameters, 16) * ((1.0 * (3.0 * (((var_INaK__x1 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__a3) - ((var_INaK__x2 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__b3)))) + (1.0 * (2.0 * (((var_INaK__x4 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * 9.120000000000001) - ((var_INaK__x3 / (var_INaK__x1 + var_INaK__x2 + var_INaK__x3 + var_INaK__x4)) * var_INaK__a1))))); // microA_per_microF
        const double var_INab__INab = (NV_Ith_S(mParameters, 8) * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__nai * _lt_0_row[0]) - NV_Ith_S(mParameters, 4))) / _lt_0_row[198]; // microA_per_microF
        const double var_IKb__IKb = NV_Ith_S(mParameters, 7) * _lt_0_row[197] * (var_chaste_interface__membrane__v - var_reversal_potentials__EK); // microA_per_microF
        const double var_IpCa__IpCa = (NV_Ith_S(mParameters, 9) * var_chaste_interface__intracellular_ions__cai) / (0.00050000000000000001 + var_chaste_interface__intracellular_ions__cai); // microA_per_microF
        const double var_ICab__ICab = (NV_Ith_S(mParameters, 6) * 4.0 * ((var_chaste_interface__membrane__v * 9309355225.0) * 3.8799692706433766e-07) * ((var_chaste_interface__intracellular_ions__cai * _lt_0_row[2]) - (0.34100000000000003 * NV_Ith_S(mParameters, 2)))) / _lt_0_row[185]; // microA_per_microF
        var_chaste_interface__membrane__Istim = GetIntracellularAreaStimulus(var_chaste_interface__environment__time);
        const double var_ryr__fJrelp = 1.0 / (1.0 + (0.14999999999999999 / var_CaMK__CaMKa)); // dimensionless
        const double var_ryr__Jrel = NV_Ith_S(mParameters, 0) * (((1.0 - var_ryr__fJrelp) * var_chaste_interface__ryr__Jrelnp) + (var_ryr__fJrelp * var_chaste_interface__ryr__Jrelp)); // millimolar_per_millisecond
        const double var_chaste_interface__ICaL__ICaL = var_ICaL__ICaL; // microA_per_microF
        const double var_chaste_interface__ICab__ICab = var_ICab__ICab; // microA_per_microF
        const double var_chaste_interface__INa__INa = var_INa__INa; // microA_per_microF
        const double var_chaste_interface__ICaL__ICaK = var_ICaL__ICaK; // microA_per_microF
        const double var_chaste_interface__INaL__INaL = var_INaL__INaL; // microA_per_microF
        const double var_chaste_interface__INaCa_i__INaCa_i = var_INaCa_i__INaCa_i; // microA_per_microF
        const double var_chaste_interface__INab__INab = var_INab__INab; // microA_per_microF
        const double var_chaste_interface__IKs__IKs = var_IKs__IKs; // microA_per_microF
        const double var_chaste_interface__INaK__INaK = var_INaK__INaK; // microA_per_microF
        const double var_chaste_interface__IKb__IKb = var_IKb__IKb; // microA_per_microF
        const double var_chaste_interface__ICaL__ICaNa = var_ICaL__ICaNa; // microA_per_microF
        const double var_chaste_interface__IK1__IK1 = var_IK1__IK1; // microA_per_microF
        const double var_chaste_interface__INaCa_i__INaCa_ss = var_INaCa_i__INaCa_ss; // microA_per_microF
        const double var_chaste_interface__IKr__IKr = var_IKr__IKr; // microA_per_microF
        const double var_chaste_interface__IpCa__IpCa = var_IpCa__IpCa; // microA_per_microF
        
        N_Vector dqs = N_VNew_Serial(19);
        NV_Ith_S(dqs, 0) = var_ryr__Jrel;
        NV_Ith_S(dqs, 1) = var_chaste_interface__INaCa_i__INaCa_ss;
        NV_Ith_S(dqs, 2) = var_chaste_interface__ICaL__ICaK;
        NV_Ith_S(dqs, 3) = var_chaste_interface__ICaL__ICaNa;
        NV_Ith_S(dqs, 4) = var_chaste_interface__ICaL__ICaL;
        NV_Ith_S(dqs, 5) = var_chaste_interface__ICab__ICab;
        NV_Ith_S(dqs, 6) = var_chaste_interface__IKb__IKb;
        NV_Ith_S(dqs, 7) = var_chaste_interface__INab__INab;
        NV_Ith_S(dqs, 8) = var_chaste_interface__IpCa__IpCa;
        NV_Ith_S(dqs, 9) = var_chaste_interface__INa__INa;
        NV_Ith_S(dqs, 10) = var_INa__h;
        NV_Ith_S(dqs, 11) = var_chaste_interface__IK1__IK1;
        NV_Ith_S(dqs, 12) = var_chaste_interface__INaL__INaL;
        NV_Ith_S(dqs, 13) = var_chaste_interface__IKr__IKr;
        NV_Ith_S(dqs, 14) = var_chaste_interface__IKs__IKs;
        NV_Ith_S(dqs, 15) = var_chaste_interface__INaCa_i__INaCa_i;
        NV_Ith_S(dqs, 16) = var_chaste_interface__INaK__INaK;
        NV_Ith_S(dqs, 17) = var_chaste_interface__membrane__Istim;
        NV_Ith_S(dqs, 18) = var_chaste_interface__environment__time;
        return dqs;
    }
    
template<>
void OdeSystemInformation<Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt>::Initialise(void)
{
    this->mSystemName = "ohara_rudy_2011";
    this->mFreeVariableName = "time";
    this->mFreeVariableUnits = "millisecond";
    
    this->mVariableNames.push_back("membrane_voltage");
    this->mVariableUnits.push_back("millivolt");
    this->mInitialConditions.push_back(-87);

    this->mVariableNames.push_back("CaMK__CaMKt");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("cytosolic_sodium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(7);

    this->mVariableNames.push_back("intracellular_ions__nass");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(7);

    this->mVariableNames.push_back("cytosolic_potassium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(145);

    this->mVariableNames.push_back("intracellular_ions__kss");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(145);

    this->mVariableNames.push_back("intracellular_ions__cass");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(1e-4);

    this->mVariableNames.push_back("intracellular_ions__cansr");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(1.2);

    this->mVariableNames.push_back("intracellular_ions__cajsr");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(1.2);

    this->mVariableNames.push_back("cytosolic_calcium_concentration");
    this->mVariableUnits.push_back("millimolar");
    this->mInitialConditions.push_back(1e-4);

    this->mVariableNames.push_back("INa__m");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("INa__hf");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("INa__hs");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("membrane_fast_sodium_current_j_gate");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("INa__hsp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("INa__jp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("INaL__mL");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("INaL__hL");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("INaL__hLp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("Ito__a");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("Ito__iF");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("Ito__iS");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("Ito__ap");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("Ito__iFp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("Ito__iSp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__d");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("ICaL__ff");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__fs");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__fcaf");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__fcas");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__jca");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__ffp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__fcafp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ICaL__nca");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("IKr__xrf");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("IKr__xrs");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("IKs__xs1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("IKs__xs2");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("IK1__xk1");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(1);

    this->mVariableNames.push_back("ryr__Jrelnp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mVariableNames.push_back("ryr__Jrelp");
    this->mVariableUnits.push_back("dimensionless");
    this->mInitialConditions.push_back(0);

    this->mParameterNames.push_back("SR_release_current_max");
    this->mParameterUnits.push_back("dimensionless");
    
    this->mParameterNames.push_back("SR_uptake_current_max");
    this->mParameterUnits.push_back("dimensionless");
    
    this->mParameterNames.push_back("extracellular_calcium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("extracellular_potassium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("extracellular_sodium_concentration");
    this->mParameterUnits.push_back("millimolar");
    
    this->mParameterNames.push_back("membrane_L_type_calcium_current_conductance");
    this->mParameterUnits.push_back("dimensionless");
    
    this->mParameterNames.push_back("membrane_background_calcium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_background_potassium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_background_sodium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_calcium_pump_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_fast_sodium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_inward_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_persistent_sodium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_rapid_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_slow_delayed_rectifier_potassium_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_sodium_calcium_exchanger_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_sodium_potassium_pump_current_permeability");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_transient_outward_current_conductance");
    this->mParameterUnits.push_back("milliS_per_microF");
    
    this->mParameterNames.push_back("membrane_data_clamp_current_conductance"); // RJ
    this->mParameterUnits.push_back("mS_per_mm2");

    this->mDerivedQuantityNames.push_back("SR_release_current");
    this->mDerivedQuantityUnits.push_back("millimolar_per_millisecond");
    
    this->mDerivedQuantityNames.push_back("SR_sodium_calcium_exchanger_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_channel_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_channel_sodium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_L_type_calcium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_calcium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_background_sodium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_calcium_pump_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_fast_sodium_current_h_gate");
    this->mDerivedQuantityUnits.push_back("dimensionless");
    
    this->mDerivedQuantityNames.push_back("membrane_inward_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_persistent_sodium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_rapid_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_slow_delayed_rectifier_potassium_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_calcium_exchanger_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_sodium_potassium_pump_current");
    this->mDerivedQuantityUnits.push_back("microA_per_microF");
    
    this->mDerivedQuantityNames.push_back("membrane_stimulus_current");
    this->mDerivedQuantityUnits.push_back("uA_per_cm2");
    
    this->mDerivedQuantityNames.push_back("time");
    this->mDerivedQuantityUnits.push_back("millisecond");
    
    this->mInitialised = true;
}


// Serialization for Boost >= 1.36
#include "SerializationExportWrapperForCpp.hpp"
CHASTE_CLASS_EXPORT(Cellohara_rudy_2011_endo_data_clampFromCellMLCvodeOpt)
#endif // CHASTE_CVODE
